This is version 1.1 of aria routines for CNS; 22-09-1999, 07-01-2000; 21-08-2001

22-09-1999
**********

The following new features have been implemented over the CNS0.9 standard release:


1) I have started to separate the internal data bases for the NOE routine and ARIA 
2) a relaxation matrix correction for the target distances can be used
3) a problem with the countvio exclude command has been fixed 
4) a new "list" file format has been implemented, which allows for improved conversion of aria format to the original peak list format

Some known problems:

1) the noe_higher array is (intentionally) overwritten by the calibration
2) the noe print statement does not work from within the simulated annealing protocol. 
3) the relaxation matrix algorithm needs sometimes too much memory



07-01-2000 
**********
fixes: 

1) the print statement works again
2) the memory allocation for the relaxation algorithm has been modified


10-04-2000
**********
-use of compound parameters, obliterating two pages of parameters to be passed to run.cns

-refinement with residual dipolar couplings (up to 5 classes), either
with Tjandra's method (SANI statement in CNS) or Griesinger's method (VEAN
statement)

-relaxation matrix refinement for different spectra with different parameters (kind of useful)

-improved analysis scripts (writing their output to
 structures/it8/analysis and /structures/it8/water/analysis)

-some documentation has been added to the ARIA homepage (installation,
 dataformat, tutorial, etc.


********************************************************************************

      SUBROUTINE READDP
C
C command parser for dynamics reader
C
C For syntax see main parsing loop "HELP"
C
C variables between subsequent calls are saved.
C
C By Axel T. Brunger
C
      IMPLICIT NONE
C input/output
      INCLUDE 'cns.inc'
      INCLUDE 'comand.inc'
      INCLUDE 'coord.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'trtraj.inc'
C local
      INTEGER MXLIST
      PARAMETER (MXLIST=30)
      LOGICAL START, QFORM
      INTEGER NUNIT, FLIST(MXLIST), UNIT, BEGIN, STOP, SKIP
      LOGICAL TDONE, TEOF
      INTEGER ISTEP
      DOUBLE PRECISION DELTA
      CHARACTER*4 HDR
      DOUBLE PRECISION DPPLAC
      DOUBLE COMPLEX DCPLAC
C
      SAVE START, QFORM
      SAVE NUNIT, FLIST, UNIT, BEGIN, STOP, SKIP
      SAVE TDONE, TEOF
      SAVE ISTEP
      SAVE DELTA
      SAVE HDR
C begin
      CALL PUSEND('READ-TRAJectory>')
      CALL NEXTWD('READ-TRAJectory>')
      IF (WD(1:4).EQ.'NEXT') THEN
      IF (.NOT.TDONE) THEN
      IF (TRIZ.NE.0) THEN
C
C subsequent call
      CALL READDC(NATOM,X,Y,Z,
     &           START,TDONE,TEOF,ERROR,
     &           NUNIT,FLIST,UNIT,BEGIN,STOP,SKIP,
     &           ISTEP,DELTA,HDR,QFORM)
      WRITE(6,'(A,I8,A)') ' READCP: trajectory number ',ISTEP,
     &              ' has been copied to the main coordinate set'
      IF (TDONE) THEN
         CALL DECLAR( 'STATUS', 'ST', 'COMPLETE', DCPLAC, DPPLAC )
      ENDIF
      ELSE
      WRITE(6,'(A)')' %READCP-ERR: coordinate database was deleted.'
      END IF
      ELSE
      WRITE(6,'(A)')' %READCP-ERR: EOF reached - coordinates unchanged'
      END IF
      CALL NEXTWD('READ-TRAJectory>')
      CALL CHKEND('READ-TRAJectory>',DONE)
      DONE=.FALSE.
      ELSE
      CALL SAVEWD
C
C initial call
C
C defaults
      CALL DYNSET('INIT',USED,BEGIN,SKIP,STOP,NUNIT,
     &                  MXLIST,FLIST,QFORM)
C
      CALL DECLAR( 'STATUS', 'ST', 'READ', DCPLAC, DPPLAC )
      START=.TRUE.
      DO WHILE (.NOT.DONE)
      CALL NEXTWD('READ-TRAJectory>')
C
      CALL DYNSET('PARSE',USED,BEGIN,SKIP,STOP,NUNIT,
     &                  MXLIST,FLIST,QFORM)
      IF (.NOT.USED) THEN
C
      IF (WD(1:4).EQ.'HELP') THEN
C
      CALL CNSHELP('cns-read-trajectory')
C
      ELSE
      CALL CHKEND('READ-TRAJectory',DONE)
      END IF
      END IF
      END DO
      DONE=.FALSE.
      CALL READDC(NATOM,X,Y,Z,
     &           START,TDONE,TEOF,ERROR,
     &           NUNIT,FLIST,UNIT,BEGIN,STOP,SKIP,
     &           ISTEP,DELTA,HDR,QFORM)
      IF (TDONE) THEN
         CALL DECLAR( 'STATUS', 'ST', 'COMPLETE', DCPLAC, DPPLAC )
      ENDIF
      WRITE(6,'(A,I8,A)') ' READ-TRAJectory: frame # ',ISTEP,
     &              ' has been copied to the main coordinate set.'
      END IF
      RETURN
      END
C====================================================================
      SUBROUTINE DYNSET(MODE,LUSED,BEGIN,SKIP,STOP,NUNIT,
     &                  MXLIST,FLIST,QFORM)
C
C parses the dynamics I/O specifications
C For syntax see main parsing loop "HELP"
C
      IMPLICIT NONE
C input/output
      INCLUDE 'cns.inc'
      INCLUDE 'comand.inc'
      INCLUDE 'funct.inc'
      CHARACTER*(*) MODE
      LOGICAL LUSED
      INTEGER BEGIN, SKIP, STOP, NUNIT, MXLIST, FLIST(*)
      LOGICAL QFORM
C local
      INTEGER UNIT
C begin
      IF (MODE.EQ.'INIT') THEN
      BEGIN=1
      SKIP=1
      STOP=999999
      QFORM=.FALSE.
      NUNIT=0
C
      ELSE IF (MODE.EQ.'PARSE') THEN
      LUSED=.TRUE.
C
      IF (WD(1:4).EQ.'BEGI') THEN
      CALL NEXTI('BEGIn=',BEGIN)
      ELSE IF (WD(1:4).EQ.'SKIP') THEN
      CALL NEXTI('SKIP=',SKIP)
      ELSE IF (WD(1:4).EQ.'STOP') THEN
      CALL NEXTI('STOP=',STOP)
      ELSE IF (WD(1:4).EQ.'ASCI') THEN
      CALL NEXTLO('ASCIi=',QFORM)
      ELSE IF (WD(1:4).EQ.'INPU') THEN
      CALL NEXTFI('INPUt=',IFILE)
      IF (QFORM) THEN
      CALL ASSFIL(IFILE,UNIT,'READ','FORMATTED',ERROR)
      ELSE
      CALL ASSFIL(IFILE,UNIT,'READ','UNFORMATTED',ERROR)
      END IF
      IF (.NOT.ERROR) THEN
      IF (NUNIT.GT.MXLIST) THEN
      WRITE(6,'(A)') ' %DYNSET-ERR: MXLIST=(maximum number of'//
     &  ' trajectory files) exceeded.'
      ELSE
      NUNIT=NUNIT+1
      END IF
      FLIST(NUNIT)=UNIT
      END IF
      ELSE
      LUSED=.FALSE.
      END IF
      END IF
C
      RETURN
      END
C====================================================================
      SUBROUTINE READDC(NATOM,X,Y,Z,
     &                  START,DONE,EOF,ERROR,
     &                  NUNIT,FLIST,UNIT,BEGIN,STOP,SKIP,
     &                  ISTEP,DELTA,HDR,QFORM)
C
C "Intelligent" trajectory reader;
C Routine reads dynamics trajectories written by WRITEC;
C if EOF encoutered tries to read next file given by list
C FLIST(1...NUNIT).
C features automatic correction of mismatches between files (if
C possible). Mismatches can occur when restarts and trajectories
C are not synchronized (e.g. after system crash's).
C Reading error and end-of-file handling.
C Condition for passing a new set to calling routine:
C      MOD(ISTEP-BEGIN,SKIP)=0 and BEGIN<=ISTEP<=STOP
C
C Variables:
C
C START (I/O) if .TRUE. start reading information on UNIT
C             if .FALSE. subsequent call to routine
C DONE (on exit) if .TRUE. reading done
C EOF (on exit) encountered EOF before reading done
C ERROR (on exit) encountered ERROR before reading done
C NATOM (on input) number of atoms (for checking purposes)
C NUNIT number of units
C FLIST(*) list of units
C UNIT (I/O) current unit number
C BEGIN (I/O) number of first coordinate set; modified if incompatible
C SKIP (I/O) number to be skipped between sets;  - " -       - " -
C STOP (I/O) number of last coordinate set;      - " -       - " -
C
C ISTEP (on exit) current step number
C DELTA (on exit) time-step size between steps
C                  => current time = ISTEP * DELTA
C HDR (on exit) header
C QFORM: logical flag indicating whether to read formatted or unformatted file
C
C X(*), Y(*), Z(*) (on exit) coordinate set at step ISTEP
C
C Author: Axel T. Brunger
C =======================
C
      IMPLICIT NONE
C input/output
      INCLUDE 'cns.inc'
      INCLUDE 'heap.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'trtraj.inc'
      INTEGER NATOM
      DOUBLE PRECISION  X(*), Y(*), Z(*)
      LOGICAL START,DONE,EOF,ERROR
      INTEGER NUNIT, FLIST(*)
      INTEGER UNIT, BEGIN, STOP, SKIP
      INTEGER ISTEP
      DOUBLE PRECISION    DELTA
      CHARACTER*4 HDR
      LOGICAL QFORM
C local
      INTEGER NFREAT
      INTEGER NSAVC, NSAVCX, NFIXEX, PASSED
      DOUBLE PRECISION DELTAX
      LOGICAL QFIRST, ENSEMB
      DOUBLE PRECISION SCALE, OFFSET
      CHARACTER*10 FORM
      CHARACTER*4 HDRX
C
      SAVE NFREAT
      SAVE NSAVC, NSAVCX, NFIXEX, PASSED
      SAVE DELTAX
      SAVE QFIRST, ENSEMB
      SAVE SCALE, OFFSET
      SAVE FORM
      SAVE HDRX
C
C begin
      IF (START) THEN
      IF (TRIZ.NE.0) CALL FREHP(TRIZ,INTEG4(TRNAT))
      IF (TRIY.NE.0) CALL FREHP(TRIY,INTEG4(TRNAT))
      IF (TRIX.NE.0) CALL FREHP(TRIX,INTEG4(TRNAT))
      IF (TRTEMP.NE.0) CALL FREHP(TRTEMP,IREAL4(TRNAT))
      IF (TRFREEAT.NE.0) CALL FREHP(TRFREEAT,INTEG4(TRNAT))
      TRFREEAT=ALLHP(INTEG4(NATOM))
      TRTEMP=ALLHP(IREAL4(NATOM))
      TRIX=ALLHP(INTEG4(NATOM))
      TRIY=ALLHP(INTEG4(NATOM))
      TRIZ=ALLHP(INTEG4(NATOM))
      TRNAT=NATOM
      END IF
      CALL READC2(NATOM,X,Y,Z,
     &            START,DONE,EOF,ERROR,
     &            NUNIT,FLIST,UNIT,BEGIN,STOP,SKIP,
     &            ISTEP,DELTA,HDR,HEAP(TRTEMP),
     &            HEAP(TRFREEAT),NFREAT,
     &            NSAVC,NSAVCX,NFIXEX,DELTAX,HDRX,PASSED,QFIRST,
     &            ENSEMB,QFORM,FORM,SCALE,OFFSET,HEAP(TRIX),
     &            HEAP(TRIY),HEAP(TRIZ))
      IF (DONE) THEN
      CALL FREHP(TRIZ,INTEG4(NATOM))
      CALL FREHP(TRIY,INTEG4(NATOM))
      CALL FREHP(TRIX,INTEG4(NATOM))
      CALL FREHP(TRTEMP,IREAL4(NATOM))
      CALL FREHP(TRFREEAT,INTEG4(NATOM))
      TRIZ=0
      TRIY=0
      TRIX=0
      TRTEMP=0
      TRFREEAT=0
      END IF
      RETURN
      END
C==================================================================
      SUBROUTINE READC2(NATOM,X,Y,Z,
     &                  START,DONE,EOF,ERROR,
     &                  NUNIT,FLIST,UNIT,BEGIN,STOP,SKIP,
     &                  ISTEP,DELTA,HDR,TEMP,FREEAT,NFREAT,
     &                  NSAVC,NSAVCX,NFIXEX,DELTAX,HDRX,PASSED,QFIRST,
     &                  ENSEMB,QFORM,FORM,SCALE,OFFSET,IX,IY,IZ)
C see READC above
C
      IMPLICIT NONE
C input/output
      INCLUDE 'consta.inc'
      INTEGER NATOM
      DOUBLE PRECISION X(*), Y(*), Z(*)
      LOGICAL START, DONE, EOF, ERROR
      INTEGER NUNIT, FLIST(*), UNIT, BEGIN, STOP, SKIP
      INTEGER ISTEP
      DOUBLE PRECISION DELTA
      REAL TEMP(*)
      CHARACTER*4 HDR
      INTEGER NFREAT, FREEAT(*)
      INTEGER NSAVC, NSAVCX, NFIXEX, PASSED
      DOUBLE PRECISION DELTAX
      CHARACTER*4 HDRX
      LOGICAL QFIRST, ENSEMB, QFORM
      CHARACTER*10 FORM
      DOUBLE PRECISION SCALE,OFFSET
      INTEGER IX(*), IY(*), IZ(*)
C local
      INTEGER NFIXED, ISTART, NATOMX
      LOGICAL NEXT, COND
C
C begin
      IF (NUNIT.LE.0) THEN
      WRITE(6,'(A)') ' %READC-ERR: NUNIt=0'
      ERROR=.TRUE.
      DONE=.TRUE.
      ELSE
C
C the following test is a kluge - I did not want to modify the
C calling sequence to include a new passed variable.
      IF (.NOT.START) ENSEMB=HDR.EQ.'ENSE'
C
      IF (START) THEN
      PASSED=0
      QFIRST=.FALSE.
      DONE=.FALSE.
      EOF=.FALSE.
      ERROR=.FALSE.
      ENSEMB=.FALSE.
      UNIT=1
      REWIND(UNIT=FLIST(UNIT))
      CALL READCH(FLIST,UNIT,NFREAT,FREEAT,ISTART,NSAVC,NFIXED,
     &           NATOM,NSAVCX,NFIXEX,NATOMX,DELTA,DELTAX,
     &           HDR,HDRX,START,QFIRST,EOF,ERROR,QFORM,FORM,
     &           SCALE,OFFSET)
      ISTEP=ISTART-NSAVC
      START=.FALSE.
      IF (.NOT. (ERROR .OR. EOF)) THEN
C
C check BEGIN, STOP, SKIP parameters
      IF (MOD(BEGIN-ISTART,NSAVC).NE.0.OR.BEGIN.LT.ISTART) THEN
      BEGIN= MAX(BEGIN,ISTART)
      BEGIN= ISTART+((BEGIN-ISTART)/NSAVC) * NSAVC
      WRITE(6,'(A)') ' READC: BEGIN not compatible. Modified'
      END IF
      IF (MOD(SKIP,NSAVC).NE.0.OR.SKIP.LE.0) THEN
      SKIP=MAX(NSAVC,SKIP)
      SKIP= (SKIP/NSAVC) * NSAVC
      WRITE(6,'(A)') ' READC: SKIP not compatible. Modified'
      END IF
      IF (MOD(STOP-BEGIN,SKIP).NE.0.OR.STOP.LT.BEGIN) THEN
      STOP=MAX(BEGIN,STOP)
      STOP=BEGIN+((STOP-BEGIN)/SKIP) * SKIP
      WRITE(6,'(A)') ' READC: STOP not compatible. Modified'
      END IF
      WRITE(6,9010)
     1' READC: NUNIt=',NUNIT,
     2' READC: BEGIn=',BEGIN,'  SKIP=',SKIP,'  STOP=',STOP,
     3' READC: TIMEstep=',DELTA*TIMFAC,' ps    header= ',HDR
9010  FORMAT(A,I4,/,A,I8,A,I8,A,I8,/,A,F12.8,A,A)
      END IF
      END IF
C
      NEXT = .FALSE.
      DO WHILE (.NOT. (NEXT .OR. EOF .OR. ERROR))
      COND = .FALSE.
      DO WHILE (.NOT. (COND .OR. EOF .OR. ERROR))
      ISTEP=ISTEP+NSAVC
      COND=ISTEP.GE.BEGIN.AND.MOD(ISTEP-BEGIN,SKIP).EQ.0
      CALL READCN(FLIST,UNIT,NATOM,NFREAT,ISTEP,FREEAT,
     &                  X,Y,Z,TEMP,QFIRST,EOF,ERROR,QFORM,FORM,SCALE,
     &                  OFFSET,IX,IY,IZ)
      END DO
      NEXT=(.NOT.EOF.AND..NOT.ERROR)
      DO WHILE (EOF .AND. .NOT.ERROR .AND. UNIT.LT.NUNIT)
C open next file and read header
      ISTEP=ISTEP-NSAVC
      UNIT=UNIT+1
      EOF=.FALSE.
      REWIND(UNIT=FLIST(UNIT))
      CALL READCH(FLIST,UNIT,NFREAT,FREEAT,ISTART,NSAVC,NFIXED,
     &           NATOM,NSAVCX,NFIXEX,NATOMX,DELTA,DELTAX,
     &           HDR,HDRX,START,QFIRST,EOF,ERROR,QFORM,FORM,SCALE,
     &           OFFSET)
      IF (.NOT.EOF.AND..NOT.ERROR) THEN
      IF (ISTART-ISTEP.LT.NSAVC.AND..NOT.ENSEMB) THEN
C do correction: read until ISTEP is reached
      WRITE(6,'(A,I4)') ' READC: mismatch correction; file-number=',UNIT
      DO WHILE (ISTEP.GT.(ISTART-NSAVC) .AND. .NOT. (EOF.OR.ERROR))
      ISTART=ISTART+NSAVC
      CALL READCN(FLIST,UNIT,NATOM,NFREAT,ISTEP,FREEAT,
     &                  X,Y,Z,TEMP,QFIRST,EOF,ERROR,QFORM,FORM,
     &                  SCALE,OFFSET,IX,IY,IZ)
      END DO
      END IF
C
      IF (ISTART-ISTEP.NE.NSAVC.AND..NOT.ENSEMB) THEN
      WRITE(6,'(A,I4)') ' READC: mismatch error; file-number=',UNIT
      WRITE(6,'(A,I8)')
     & ' READC: missing coordinate sets skipped.  Now at step',ISTART
      ISTEP=ISTART-NSAVC
      END IF
      END IF
      END DO
C
      END DO
C
      IF (NEXT) PASSED=PASSED+1
      IF(EOF)WRITE(6,9000)  ' %READC-EOF file ',UNIT,' at step',ISTEP
      IF(ERROR)WRITE(6,9000)' %READC-ERROR file ',UNIT,' at step',ISTEP
      DONE=(ISTEP.GE.STOP .OR. EOF .OR. ERROR)
      IF (DONE) THEN
      WRITE(6,'(A,I8,A)') ' READC: complete. ',PASSED,
     1              ' coordinate sets were passed to calling routine'
      END IF
      END IF
9000  FORMAT(A,I4,A,I8)
C
      RETURN
      END
C
      SUBROUTINE READCH(FLIST,UNIT,NFREAT,FREEAT,ISTART,NSAVC,NFIXED,
     &           NATOM,NSAVCX,NFIXEX,NATOMX,DELTA,DELTAX,
     &           HDR,HDRX,START,QFIRST,EOF,ERROR,QFORM,FORM,SCALE,
     &           OFFSET)
C
C reads header from trajectory file UNIT
C (see routine READC2 above)
      IMPLICIT NONE
C I/O
      INCLUDE 'consta.inc'
      INTEGER FLIST(*), UNIT, NFREAT, FREEAT(*)
      INTEGER ISTART, NSAVC, NFIXED, NATOM, NSAVCX, NFIXEX, NATOMX
      DOUBLE PRECISION DELTA, DELTAX
      CHARACTER*4 HDR, HDRX
      LOGICAL START, QFIRST, EOF, ERROR
      LOGICAL QFORM
      CHARACTER*10 FORM
      DOUBLE PRECISION SCALE, OFFSET
C local
      INTEGER I
C begin
      QFIRST=.TRUE.
C
      IF (QFORM) THEN
cccc
      FORM = "XYZ       "
cccc
      IF (FORM.EQ."XYZ       ") THEN
      READ (FLIST(UNIT),'(I)') NATOMX
CCCC
      ISTART = 1
      NSAVC = 1
      I = 1      
      NFREAT = NATOMX
c      READ(FLIST(UNIT),'(1X,A)',ERR=999,END=888) HDR
CCCC
      ELSE
      CALL RDTITB(FLIST(UNIT),'FORMATTED')
      READ(FLIST(UNIT),'(1X,A,1X,4I7,G14.6)',ERR=999,END=888)
     &     HDR, ISTART, NSAVC, I, NATOMX, DELTA
      READ(FLIST(UNIT),'(G14.6,G14.6,A)',ERR=999,END=888)
     &     SCALE, OFFSET, FORM
      READ(FLIST(UNIT),'(10I7)',ERR=999,END=888)
     &      NFREAT, (FREEAT(I),I=1,NFREAT)
      READ(FLIST(UNIT),'(A)',ERR=999,END=888) HDR
C
      NFIXED=NATOMX-NFREAT
      END IF
C
      ELSE
      READ(FLIST(UNIT),ERR=999,END=888) HDR,I,ISTART,NSAVC,I,I,
     &                            I,I,I,NFIXED,DELTA,
     &                            I,I,I,I,I,I,I,I,I
      CALL RDTITB(FLIST(UNIT),'BINARY')
      READ(FLIST(UNIT)) NATOMX
      NFREAT=NATOM-NFIXED
      IF (NFREAT.NE.NATOMX) THEN
      READ(FLIST(UNIT),ERR=999,END=888) (FREEAT(I),I=1,NFREAT)
      ELSE
      DO I=1,NATOMX
      FREEAT(I)=I
      END DO
      END IF
      END IF
C
      IF (NATOM.NE.NATOMX) THEN
      WRITE(6,'(A)') ' READC: number of atoms do not match'
      write(6,*) natom, natomx
      ERROR=.TRUE.
      END IF
      WRITE(6,'(A,I4,A,I8)')
     & ' READC: reading file=',UNIT,'   ISTART=',ISTART
      IF (.NOT.START) THEN
      ERROR=(NSAVC.NE.NSAVCX.OR.NFIXED.NE.NFIXEX
     &       .OR.ABS(DELTA-DELTAX).GT.R4SMAL.OR.HDR.NE.HDRX)
      IF(ERROR) WRITE(6,'(A,I4)')' READC: header mismatch on file',UNIT
      END IF
      NSAVCX=NSAVC
      NFIXEX=NFIXED
      DELTAX=DELTA
      HDRX=HDR
C
      WRITE(6,'(A,I8,A)') ' READC: ',NFREAT,' atoms were "free"'
      GOTO 777
999   ERROR=.TRUE.
      GOTO 777
888   EOF=.TRUE.
777   CONTINUE
      RETURN
      END
C
      SUBROUTINE READCN(FLIST,UNIT,NATOM,NFREAT,ISTEP,FREEAT,
     &                  X,Y,Z,TEMP,QFIRST,EOF,ERROR,QFORM,FORM,SCALE,
     &                  OFFSET,IX,IY,IZ)
C
C read next coordinate set from trajectory file UNIT
C (see routine READC2 above)
      IMPLICIT NONE
C I/O
      INTEGER FLIST(*), UNIT, NATOM, NFREAT, ISTEP, FREEAT(*)
      DOUBLE PRECISION X(*), Y(*), Z(*)
      REAL TEMP(*)
      LOGICAL QFIRST, EOF, ERROR
      LOGICAL QFORM
      CHARACTER*10 FORM
      DOUBLE PRECISION SCALE, OFFSET
      INTEGER IX(*), IY(*), IZ(*)
      CHARACTER*1 CHEM
      CHARACTER*80 XYZHEADER
C local
      INTEGER I
      CHARACTER*4 HDR
C begin
      IF (QFIRST) THEN
      QFIRST=.FALSE.
      IF (QFORM) THEN
      IF (FORM.EQ."XYZ       ") THEN
      READ(FLIST(UNIT),'(A)') XYZHEADER
      READ(FLIST(UNIT),'(1X,A4,3F14.6)') 
     &    (CHEM,X(I),Y(I),Z(I), I=1,NATOM)
      ELSE
      READ(FLIST(UNIT),'('//FORM//')',END=666,ERR=555)
     &      (IX(I),IY(I),IZ(I), I=1,NATOM)
      DO I=1,NATOM
      X(I)=IX(I)/SCALE-OFFSET
      Y(I)=IY(I)/SCALE-OFFSET
      Z(I)=IZ(I)/SCALE-OFFSET
      END DO
      END IF
      ELSE
      READ(FLIST(UNIT),END=666,ERR=555) (TEMP(I),I=1,NATOM)
      DO I=1,NATOM
      X(I)=TEMP(I)
      END DO
      READ(FLIST(UNIT),END=666,ERR=555) (TEMP(I),I=1,NATOM)
      DO I=1,NATOM
      Y(I)=TEMP(I)
      END DO
      READ(FLIST(UNIT),END=666,ERR=555) (TEMP(I),I=1,NATOM)
      DO I=1,NATOM
      Z(I)=TEMP(I)
      END DO
      END IF
      ELSE
      IF (QFORM) THEN
      IF (FORM.EQ."XYZ       ") THEN
      READ(FLIST(UNIT),'(I)') I
      READ(FLIST(UNIT),'(A)') XYZHEADER
      READ(FLIST(UNIT),'(1X,A4,3F14.6)') 
     &    (CHEM,X(I),Y(I),Z(I), I=1,NATOM)
      ELSE
      READ(FLIST(UNIT),'(A)',END=666,ERR=555) HDR
      READ(FLIST(UNIT),'('//FORM//')',END=666,ERR=555)
     &     (IX(I),IY(I),IZ(I), I=1,NFREAT)
      DO I=1,NFREAT
      X(FREEAT(I))=IX(I)/SCALE-OFFSET
      Y(FREEAT(I))=IY(I)/SCALE-OFFSET
      Z(FREEAT(I))=IZ(I)/SCALE-OFFSET
      END DO
      END IF
      ELSE
      READ(FLIST(UNIT),END=666,ERR=555) (TEMP(I),I=1,NFREAT)
      DO I=1,NFREAT
      X(FREEAT(I))=TEMP(I)
      END DO
      READ(FLIST(UNIT),END=666,ERR=555) (TEMP(I),I=1,NFREAT)
      DO I=1,NFREAT
      Y(FREEAT(I))=TEMP(I)
      END DO
      READ(FLIST(UNIT),END=666,ERR=555) (TEMP(I),I=1,NFREAT)
      DO I=1,NFREAT
      Z(FREEAT(I))=TEMP(I)
      END DO
      END IF
      END IF
C
      GOTO 444
666   EOF=.TRUE.
      GOTO 444
555   ERROR=.TRUE.
444   CONTINUE
      IF (EOF) THEN
      WRITE(6,'(A,I4,A,I8)')
     &' READC: EOF on file=',UNIT,'  while trying to read step=',ISTEP
      END IF
      RETURN
      END
C====================================================================
      SUBROUTINE WRITTC(HDR,NATOM,X,Y,Z,
     &                  NFREAT,FREEAT,ISTART,QFIRST,
     &                  DELTA,NSAVC,UNIT,
     &                  QFORM,FORM,SCALE,OFFSET)
C
C Writes a set of coordinates/velocities for a single dynamics step;
C if NFREAT unequal NATOM the output is compressed using FREEAT;
C ISTART should be the number of the first set written on file UNIT;
C if the flag QFIRST is true a new file with a header is created;
C NSAVC is the coordinate set writing period;
C
C Author: Axel T. Brunger
C
      IMPLICIT NONE
C input/output
      INCLUDE 'cns.inc'
      INCLUDE 'heap.inc'
      INCLUDE 'funct.inc'
      CHARACTER*4 HDR
      INTEGER NATOM
      DOUBLE PRECISION  X(*), Y(*), Z(*)
      INTEGER FREEAT(*), NFREAT, ISTART
      LOGICAL QFIRST
      DOUBLE PRECISION    DELTA
      INTEGER NSAVC
      INTEGER UNIT
      LOGICAL QFORM
      CHARACTER*10 FORM
      DOUBLE PRECISION SCALE, OFFSET
C pointer
      INTEGER IX, IY, IZ
C local
      IX=ALLHP(INTEG4(NATOM))
      IY=ALLHP(INTEG4(NATOM))
      IZ=ALLHP(INTEG4(NATOM))
      CALL WRITT2(HDR,NATOM,X,Y,Z,
     &                  NFREAT,FREEAT,ISTART,QFIRST,
     &                  DELTA,NSAVC,UNIT,
     &                  QFORM,FORM,SCALE,OFFSET,HEAP(IX),HEAP(IY),
     &                  HEAP(IZ))
      CALL FREHP(IZ,INTEG4(NATOM))
      CALL FREHP(IY,INTEG4(NATOM))
      CALL FREHP(IX,INTEG4(NATOM))
      RETURN
      END
C====================================================================
      SUBROUTINE WRITT2(HDR,NATOM2,X,Y,Z,
     &                  NFREAT,FREEAT,ISTART,QFIRST,
     &                  DELTA,NSAVC,UNIT,
     &                  QFORM,FORM,SCALE,OFFSET,IX,IY,IZ)
C
C See routine WRITTC above
C
C Author: Axel T. Brunger
C
      IMPLICIT NONE
C input/output
      INCLUDE 'cns.inc'
      INCLUDE 'mtf.inc'
      CHARACTER*4 HDR
      INTEGER NATOM2
      DOUBLE PRECISION  X(*), Y(*), Z(*)
      INTEGER FREEAT(*), NFREAT, ISTART
      LOGICAL QFIRST
      DOUBLE PRECISION    DELTA
      INTEGER NSAVC
      INTEGER UNIT
      LOGICAL QFORM
      CHARACTER*10 FORM
      DOUBLE PRECISION SCALE, OFFSET
      INTEGER IX(*), IY(*), IZ(*)
C local
      INTEGER I0, I
      PARAMETER (I0=0)
C begin
      IF (UNIT.LT.0) CALL WRNDIE(-3,'WRITEV','invalid logical unit')
      IF (QFIRST) THEN
      WRITE(6,'(3A,I8,A,I5,A)')
     & ' WRITEC: ',HDR,' sets starting from step ',ISTART,
     & ' are written every ',NSAVC,'  steps'
      WRITE(6,'(A,I8,A)') ' WRITEC: where ',NFREAT,' atoms are "free"'
C
      IF (QFORM) THEN
      IF (FORM.EQ."XYZ       ") THEN
      WRITE(UNIT, '(I10)') NATOM
      WRITE(UNIT, '(1X,A)') "CORD generated by CNS"
      ELSE
      CALL WRTITL(UNIT,2)
      WRITE(UNIT,'(1X,A,1X,4I7,G14.6)')
     &      HDR(1:4), ISTART, NSAVC, I0, NATOM, DELTA
      WRITE(UNIT,'(G14.6,G14.6,A)') SCALE, OFFSET, FORM
      WRITE(UNIT,'(10I7)') NFREAT, (FREEAT(I),I=1,NFREAT)
      WRITE(UNIT,'(A)') HDR
      END IF
      ELSE
      WRITE(UNIT) HDR,I0,ISTART,NSAVC,I0,I0,
     &              I0,I0,I0,NATOM-NFREAT,DELTA,
     &              I0,I0,I0,I0,I0,I0,I0,I0,I0,I0
      CALL WRTITL(UNIT,-1)
      WRITE(UNIT) NATOM
      IF (NFREAT.NE.NATOM) WRITE(UNIT) (FREEAT(I),I=1,NFREAT)
      END IF
      END IF
C
      IF (QFIRST) THEN
      IF (QFORM) THEN
      IF (FORM.EQ."XYZ       ") THEN
      WRITE(UNIT,'(1X,A4,3F14.6)') 
     &   (IAC(I)(1:1),X(I),Y(I),Z(I),I=1,NATOM)
      ELSE
      DO I=1,NATOM
      IX(I)=INT((X(I)+OFFSET)*SCALE)
      IY(I)=INT((Y(I)+OFFSET)*SCALE)
      IZ(I)=INT((Z(I)+OFFSET)*SCALE)
      END DO
      WRITE(UNIT,'('//FORM//')') (IX(I),IY(I),IZ(I),I=1,NATOM)
      END IF
      ELSE
C write coordinates in single precision
      WRITE (UNIT) (REAL(X(I)),I=1,NATOM)
      WRITE (UNIT) (REAL(Y(I)),I=1,NATOM)
      WRITE (UNIT) (REAL(Z(I)),I=1,NATOM)
      END IF
      ELSE
      IF (QFORM) THEN
      IF (FORM.EQ."XYZ       ") THEN
      WRITE(UNIT, '(I10)') NATOM
      WRITE(UNIT, '(1X,A)') "CORD generated by CNS"
      WRITE(UNIT,'(1X,A4,3F14.6)') 
     &   (IAC(I)(1:1),X(I),Y(I),Z(I),I=1,NATOM)
      ELSE
      DO I=1,NFREAT
      IX(I)=INT((X(FREEAT(I))+OFFSET)*SCALE)
      IY(I)=INT((Y(FREEAT(I))+OFFSET)*SCALE)
      IZ(I)=INT((Z(FREEAT(I))+OFFSET)*SCALE)
      END DO
      WRITE(UNIT,'(A)') HDR
      WRITE(UNIT,'('//FORM//')') (IX(I),IY(I),IZ(I),I=1,NFREAT)
      END IF
      ELSE
      WRITE (UNIT) (REAL(X(FREEAT(I))),I=1,NFREAT)
      WRITE (UNIT) (REAL(Y(FREEAT(I))),I=1,NFREAT)
      WRITE (UNIT) (REAL(Z(FREEAT(I))),I=1,NFREAT)
      END IF
      END IF
C
      QFIRST=.FALSE.
C
      RETURN
      END
C
      SUBROUTINE TRJMERGE
C
C reads in specified sections of a trajectory on files
C FILEs and writes them onto the single file OUTPUT;
C optionally a orientation with respect to the main coordinate set is
C applied.
C
C For syntax see main parsing loop "HELP"
C
C By Axel T. Brunger
C
      IMPLICIT NONE
C input/ouput
      INCLUDE 'cns.inc'
      INCLUDE 'comand.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'heap.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'coord.inc'
C local
      INTEGER MXLIST
      PARAMETER (MXLIST=20)
      INTEGER FLIST(MXLIST), UNIT
      INTEGER XX, YY, ZZ, FREEAT, NFREAT, FLAGS, PAIR
      INTEGER PMASS, NPAIR, NSELCT
      INTEGER NUNIT, OUTPUT, SKIP, BEGIN, STOP, ISTEP
      DOUBLE PRECISION    DELTA
      LOGICAL QFIRST, START, ORIENT, LMASS, LWEIG
      LOGICAL LNORO, TDONE, TEOF, ENSEMB, QFORM, OQFORM
      CHARACTER*10 OFORM
      DOUBLE PRECISION OSCALE, OOFFST
      CHARACTER*4 HDR
C begin
C
C defaults
C
      CALL DYNSET('INIT',USED,BEGIN,SKIP,STOP,NUNIT,
     &                  MXLIST,FLIST,QFORM)
      ORIENT=.FALSE.
      ENSEMB=.FALSE.
      OFILE='OUTPUT'
      OQFORM=QFORM
      OOFFST=800.0D0
      OSCALE=10000.0D0
      OFORM='12Z6'
C
C parsing
      CALL PUSEND('MERGE>')
      DO WHILE (.NOT.DONE)
      CALL NEXTWD('MERGE>')
      CALL DYNSET('PARSE',USED,BEGIN,SKIP,STOP,NUNIT,
     &                  MXLIST,FLIST,QFORM)
      IF (.NOT.USED) THEN
C
      IF (WD(1:4).EQ.'HELP') THEN
C
      CALL CNSHELP('cns-dynamics-merge')
C
      ELSE IF (WD(1:4).EQ.'OUTP') THEN
      CALL NEXTFI('OUTPut-file=',OFILE)
      ELSE IF (WD(1:4).EQ.'OASC') THEN
      CALL NEXTLO('OASCii=',OQFORM)
      ELSE IF (WD(1:4).EQ.'FORM') THEN
      CALL NEXTST('OFORmat=',OFORM)
      ELSE IF (WD(1:4).EQ.'SCAL') THEN
      CALL NEXTF('SCALe=',OSCALE)
      ELSE IF (WD(1:4).EQ.'OFFS') THEN
      CALL NEXTF('OFFSet=',OOFFST)
      ELSE IF (WD(1:4).EQ.'ENSE') THEN
      CALL NEXTLO('ENSEmble=',ENSEMB)
      ELSE IF (WD(1:4).EQ.'ORIE') THEN
      FLAGS=ALLHP(INTEG4(NATOM))
      PAIR=ALLHP(INTEG4(2*NATOM))
      PMASS=ALLHP(IREAL8(NATOM))
C
C defaults
      ORIENT=.TRUE.
      LMASS=.FALSE.
      LNORO=.FALSE.
      LWEIG=.FALSE.
      CALL FILL4(HEAP(FLAGS),NATOM,1)
      NSELCT=NATOM
C
C parsing
      CALL PUSEND('ORIENT>')
      DO WHILE (.NOT.DONE)
      CALL NEXTWD('ORIENT>')
      IF (WD(1:4).EQ.'HELP') THEN
      CALL CNSHELP('cns-dynamics-merge-orient')
      ELSE IF (WD(1:4).EQ.'SELE') THEN
      CALL SELCTA(HEAP(FLAGS),NSELCT,X,Y,Z,.TRUE.)
      ELSE IF (WD(1:4).EQ.'MASS') THEN
      CALL NEXTLO('MASS=',LMASS)
      ELSE IF (WD(1:4).EQ.'NORO') THEN
      CALL NEXTLO('NOROtation=',LNORO)
      ELSE IF (WD(1:4).EQ.'WEIG') THEN
      CALL NEXTLO('WEIGthing=',LWEIG)
      ELSE
      CALL CHKEND('ORIENT>',DONE)
      END IF
      END DO
      DONE=.FALSE.
C
      ELSE
      CALL CHKEND('MERGE>',DONE)
      END IF
      END IF
      END DO
      DONE=.FALSE.
C
      IF (OQFORM) THEN
      CALL ASSFIL(OFILE,OUTPUT,'WRITE','FORMATTED',ERROR)
      ELSE
      CALL ASSFIL(OFILE,OUTPUT,'WRITE','UNFORMATTED',ERROR)
      END IF
C
      IF (ENSEMB) THEN
      WRITE(6,'(A)')
     & ' MERGE: ensemble merging of several trajectory files'
      END IF
      IF (ORIENT.AND.NSELCT.GT.0) THEN
      WRITE(6,'(A,A,/,A,L1,A,L1,A,L1)')
     &' MERGE: output-trajectory oriented with respect to main ',
     &         'coordinate set',
     &' MERGE: MASSweighting=',LMASS,'  NO-ROtation=',LNORO,
     &'  wmainWEIGhting=',LWEIG
      CALL MKPAIR(NATOM,HEAP(FLAGS),HEAP(PAIR),NPAIR,X,Y,Z)
      CALL PKMASS(AMASS,AMASS,HEAP(PMASS),HEAP(PAIR),NPAIR,LMASS,
     &            LWEIG,WMAIN)
      END IF
C
      XX=ALLHP(IREAL8(NATOM))
      YY=ALLHP(IREAL8(NATOM))
      ZZ=ALLHP(IREAL8(NATOM))
      FREEAT=ALLHP(INTEG4(NATOM))
C set up the free atom array for output
      CALL MKFRAT(IMOVE,NATOM,HEAP(FREEAT),NFREAT)
C
      QFIRST=.TRUE.
      START=.TRUE.
      TDONE=.FALSE.
      TEOF=.FALSE.
      ERROR=.FALSE.
      DO WHILE (.NOT. (TDONE.OR.TEOF.OR.ERROR))
      IF (ENSEMB) HDR='ENSE'
      CALL READDC(NATOM,HEAP(XX),HEAP(YY),HEAP(ZZ),
     &           START,TDONE,TEOF,ERROR,
     &           NUNIT,FLIST,UNIT,BEGIN,STOP,SKIP,
     &           ISTEP,DELTA,HDR,QFORM)
      IF (ORIENT) THEN
C do orientation with respect to the main coordinate set
      CALL ROTLS1(X,Y,Z,NATOM,HEAP(XX),HEAP(YY),HEAP(ZZ),
     &     NATOM,HEAP(PAIR),NPAIR,HEAP(PMASS),.FALSE.,LNORO)
      END IF
C
      IF (.NOT.(TEOF.OR.ERROR)) THEN
      CALL WRITTC(HDR,NATOM,HEAP(XX),HEAP(YY),HEAP(ZZ),
     &                  NFREAT,HEAP(FREEAT),BEGIN,QFIRST,
     &                  DELTA,SKIP,OUTPUT,
     &                  OQFORM,OFORM,OSCALE,OOFFST)
      END IF
      END DO
C
      CALL VCLOSE(OUTPUT,'KEEP',ERROR)
C
      CALL FREHP(FREEAT,INTEG4(NATOM))
      CALL FREHP(ZZ,IREAL8(NATOM))
      CALL FREHP(YY,IREAL8(NATOM))
      CALL FREHP(XX,IREAL8(NATOM))
C
      IF (ORIENT) THEN
      CALL FREHP(PMASS,IREAL8(NATOM))
      CALL FREHP(PAIR,INTEG4(2*NATOM))
      CALL FREHP(FLAGS,INTEG4(NATOM))
      END IF
C
      RETURN
      END
C=====================================================================
      SUBROUTINE MKPAIR(NATOM,FLAGS,PAIR,NPAIR,X,Y,Z)
C
C routine makes pair list based on FLAGS; checks for initialized
C coordinates.
C
      IMPLICIT NONE
C input/output
      INCLUDE 'funct.inc'
      INTEGER NATOM
      INTEGER FLAGS(*)
      INTEGER PAIR(2,*), NPAIR
      DOUBLE PRECISION  X(*), Y(*), Z(*)
C local
      INTEGER I, NMISS
C begin
      NMISS=0
      DO I=1,NATOM
      IF (FLAGS(I).EQ.1) THEN
      IF (.NOT.INITIA(I,X,Y,Z)) THEN
      FLAGS(I)=0
      NMISS=NMISS+1
      END IF
      END IF
      END DO
      NPAIR=0
      DO I=1,NATOM
      IF (FLAGS(I).EQ.1) THEN
      NPAIR=NPAIR+1
      PAIR(1,NPAIR)=I
      PAIR(2,NPAIR)=I
      END IF
      END DO
      IF (NMISS.GT.0) THEN
      CALL WRNDIE(0,'<MKPAIR>','some selected atoms unkown')
      END IF
      RETURN
      END
C======================================================================
      SUBROUTINE TRTDYN
C
C creates a trajectory file
C
C For syntax see main parsing loop "HELP"
C
C Author: Axel T. Brunger
C
      IMPLICIT NONE
C input/ouput
      INCLUDE 'cns.inc'
      INCLUDE 'comand.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'coord.inc'
      INCLUDE 'trtraj.inc'
      INCLUDE 'heap.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'consta.inc'
C local
      INTEGER SKIP, BEGIN
      DOUBLE PRECISION DELTA
      LOGICAL QSKIP
C begin
C
      IF (TRINIT) THEN
C
C the initialization flag is set ===> set the defaults
      TRINIT=.FALSE.
C defaults
      IF (TRIND.NE.0) THEN
      CALL FREHP(TRIND,INTEG4(LTRIN))
      TRIND=0
      LTRIN=0
      END IF
      IF (NATOM.GT.0) THEN
      LTRIN=NATOM
      TRIND=ALLHP(INTEG4(LTRIN))
      TRNUM=NATOM
      CALL FILL4(HEAP(TRIND),NATOM,1)
      END IF
      TRFIRS=.TRUE.
C
      OFILE='OUTPUT'
      TRUNIT=6
      TRQFOR=.FALSE.
      TROFFS=800.0D0
      TRSCAL=10000.0D0
      TRFORM='12Z6'
      END IF
C parsing
      QSKIP=.FALSE.
      CALL PUSEND('WRITe-DYNAmics>')
      DO WHILE (.NOT.DONE)
      CALL NEXTWD('WRITe-DYNAmics>')
      CALL MISCOM('WRITe-DYNAmics>',USED)
      IF (.NOT.USED) THEN
C
      IF (WD(1:4).EQ.'HELP') THEN
C
      CALL CNSHELP('cns-write-trajectory')
C
      ELSE IF (WD(1:4).EQ.'OUTP'.AND.TRFIRS) THEN
      CALL NEXTFI('OUTPut-file=',OFILE)
      QSKIP=.FALSE.
      ELSE IF (WD(1:4).EQ.'ASCI'.AND.TRFIRS) THEN
      CALL NEXTLO('ASCIi=',TRQFOR)
      QSKIP=.FALSE.
      ELSE IF (WD(1:4).EQ.'FORM'.AND.TRFIRS) THEN
      CALL NEXTST('FORMat=',TRFORM)
      QSKIP=.FALSE.
      ELSE IF (WD(1:4).EQ.'SCAL'.AND.TRFIRS) THEN
      CALL NEXTF('SCALe=',TRSCAL)
      QSKIP=.FALSE.
      ELSE IF (WD(1:4).EQ.'OFFS'.AND.TRFIRS) THEN
      CALL NEXTF('OFFSet=',TROFFS)
      QSKIP=.FALSE.
      ELSE IF (WD(1:4).EQ.'SELE'.AND.TRFIRS) THEN
      CALL SELCTA(HEAP(TRIND),TRNUM,X,Y,Z,.TRUE.)
      QSKIP=.FALSE.
      ELSE IF (WD(1:4).EQ.'NEXT') THEN
      IF (TRFIRS) THEN
      CALL WRNDIE(-5,'WRTDYN',
     &    'initialization call to WRITe DYNAmics missing')
      ELSE
C this is for the subsequent call to WRITE DYNAMICS
      BEGIN=1
      SKIP=1
      DELTA=1./TIMFAC
      CALL WRITTC('CORD',NATOM,X,Y,Z,
     &                  TRNUM,HEAP(TRIND),BEGIN,TRFIRS,
     &                  DELTA,SKIP,TRUNIT,
     &                  TRQFOR,TRFORM,TRSCAL,TROFFS)
      QSKIP=.TRUE.
      END IF
      ELSE IF (WD(1:4).EQ.'RESE') THEN
C set the initialization flag
      TRINIT=.FALSE.
      TRUNIT=6
      IF (TRIND.NE.0) THEN
      CALL FREHP(TRIND,INTEG4(LTRIN))
      TRIND=0
      LTRIN=0
      END IF
      IF (NATOM.GT.0) THEN
      LTRIN=NATOM
      TRIND=ALLHP(INTEG4(LTRIN))
      TRNUM=NATOM
      CALL FILL4(HEAP(TRIND),NATOM,1)
      END IF
      TRFIRS=.TRUE.
C
      QSKIP=.TRUE.
      OFILE='OUTPUT'
      TRUNIT=6
      TRQFOR=.FALSE.
      TROFFS=800.0D0
      TRSCAL=10000.0D0
      TRFORM='12Z6'
      ELSE
      CALL CHKEND('WRITe-DYNAmics>',DONE)
      END IF
      END IF
      END DO
      DONE=.FALSE.
C
      IF (NATOM.GT.0.AND..NOT.QSKIP) THEN
      IF (TRQFOR) THEN
      CALL ASSFIL(OFILE,TRUNIT,'WRITE','FORMATTED',ERROR)
      ELSE
      CALL ASSFIL(OFILE,TRUNIT,'WRITE','UNFORMATTED',ERROR)
      END IF
C
C
C set up the trajectory index lists
      CALL MAKIND(HEAP(TRIND),NATOM,TRNUM)
C
      IF (.NOT.ERROR) THEN
      TRFIRS=.TRUE.
      BEGIN=1
      SKIP=1
      DELTA=1./TIMFAC
      CALL WRITTC('CORD',NATOM,X,Y,Z,
     &                  TRNUM,HEAP(TRIND),BEGIN,TRFIRS,
     &                  DELTA,SKIP,TRUNIT,
     &                  TRQFOR,TRFORM,TRSCAL,TROFFS)
      END IF
      END IF
      RETURN
      END
C======================================================================
      SUBROUTINE TRTINI
C
C initializes the trajectory file writing routine
C
C Author: Axel T. Brunger
C
      IMPLICIT NONE
C I/O
      INCLUDE 'trtraj.inc'
C local
C begin
C
C set the initialization flag
      TRINIT=.TRUE.
C
      TRUNIT=6
      TRIND=0
C
      TRFREEAT=0
      TRTEMP=0
      TRIX=0
      TRIY=0
      TRIZ=0
      RETURN
      END
C======================================================================
      SUBROUTINE TRTFRE
C
C resets trajectory read/write variables.
C
C Author: Axel T. Brunger
C
      IMPLICIT NONE
C I/O
      INCLUDE 'trtraj.inc'
      INCLUDE 'funct.inc'
C local
      LOGICAL ERROR
C begin
C
C reset "read dynamics"
      IF (TRIND.NE.0) CALL FREHP(TRIND,INTEG4(LTRIN))
      IF (TRUNIT.NE.6) CALL VCLOSE(TRUNIT,'KEEP',ERROR)
      IF (TRIZ.NE.0) CALL FREHP(TRIZ,INTEG4(TRNAT))
      IF (TRIY.NE.0) CALL FREHP(TRIY,INTEG4(TRNAT))
      IF (TRIX.NE.0) CALL FREHP(TRIX,INTEG4(TRNAT))
      IF (TRTEMP.NE.0) CALL FREHP(TRTEMP,IREAL4(TRNAT))
      IF (TRFREEAT.NE.0) CALL FREHP(TRFREEAT,INTEG4(TRNAT))
C
C reset "write dynamics"
      TRINIT=.TRUE.
      TRUNIT=6
      TRIND=0
      TRFIRS=.TRUE.
C
      RETURN
      END

C=====================================================================
C==========assignment of ambiguous NOEs ==============================
C=====================================================================
      SUBROUTINE ANALRS(NOEHGL,ISLCT,JSLCT)
C     
C     **********************************************
C     * Author and copyright: Michael Nilges, EMBL *
C     * No warranty implied or expressed           *
C     * All rights reserved                        *
C     **********************************************
C     
C     
      IMPLICIT NONE
C     I/O
      INCLUDE 'cns.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'noe.inc'
      INCLUDE 'aria.inc'
      INCLUDE 'comand.inc'
      INCLUDE 'coord.inc'
      INCLUDE 'consta.inc'
      INCLUDE 'heap.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'numbers.inc'
      INTEGER NOEHGL(*),ISLCT(*),JSLCT(*)
C     local
      INTEGER I, NISLCT, NJSLCT, ICL1, ICL2, NHG2,MATDIM2
      CHARACTER*4 CLASS, CLASS2
      CHARACTER*4 DISPO, ACTION, ACCMOD
      DOUBLE PRECISION DELPP1, DELPP2, DELHP1, DELHP2
      LOGICAL MATCH, QSORT, QSEGID
      INTEGER HPNDDD, HPNDII, HPNDJJ, HPNDD2, HPNDI2, HPNDJ2
      INTEGER HPNFRW, HPNFR2
      INTEGER NLAYER, NJMAX, NTAUP1
      INTEGER HPSUMT, HPABSZ, HPCALV
      DOUBLE PRECISION ZLEAK, OMEGA, TAUISO, TAUMIX, CUTOFF

C     functions
      LOGICAL FRSTEL
      EXTERNAL FRSTEL
C     
C     begin
C     
      CALL FILL4(ISLCT,NATOM,1)
      CALL FILL4(JSLCT,NATOM,1)
      DISPO = 'SATI'
      DELPP2 = ZERO
      DELPP1 = ZERO
      DELHP2 = ZERO
      DELHP1 = ZERO
      ACTION = 'PARA'
      ACCMOD = 'PARA'
      QSORT=.FALSE.
      QSEGID = .TRUE.
C     
C     
      CALL PUSEND('ANALyse_restraints>')
C     
      DO WHILE (.NOT.DONE)
         CALL NEXTWD('ANALyse_restraints>')
C     
C     
         IF (WD(1:4).EQ.'HELP') THEN
C     
            CALL CNSHELP('cns-aria-analyse')
C     
         ELSE IF ((WD(1:4).EQ.'EQUI').OR.(WD(1:4).EQ.'UNRE')) THEN
C     
            CALL EQVGRP(NATOM,NOEHGL)
C     scrap old data list if necessary
            CALL ARIHP(0,0,NATOM)
C     determine space requirements
            CALL CNTGRP(NATOM,NOEHGL,NHG2,NHY)
            NHG=NHG2
            CALL ALLDSP (NOEHGL,MATDIM2,
     &           HEAP(HPNORR),HEAP(HPNIPR),HEAP(HPNILS),HEAP(HPNJPR),
     &           HEAP(HPNJLS),HEAP(HPNCND),HEAP(HPNRAV),HEAP(HPNRRV),
     &           HEAP(HPNDIS),HEAP(HPNLOW),HEAP(HPNHIG),HEAP(HPNVOL),
     &           HEAP(HPNPP1),HEAP(HPNPP2),HEAP(HPNHP1),HEAP(HPNHP2),
     $           HEAP(HPNWGH),HEAP(HPNVIO),
     &           HEAP(HPNNSP),HEAP(HPNCV), HEAP(HPNPID),HEAP(HPNEXC))
C     assign space and initialize
            CALL ARIHP(MATDIM2,0,NATOM)
            MATDIM=MATDIM2
            WRITE (6,'(A)') ' ARIASS: initializing distance list'
            CALL FILLR8(HEAP(HPNMAT),MATDIM,ZERO)
            CALL FILL4(HEAP(HPNMA2),MATDIM,1)
            WRITE (6,'(A)') ' ARIASS: setting up population array'

            CALL GRFPOP(NATOM,NOEHGL,HEAP(HPPOPU))
C     
         ELSE IF (WD(1:4).EQ.'LEVE') THEN
            CALL NEXTF('assignment-LEVEl: ',AMBLEV)
C     
         ELSE IF (WD(1:4).EQ.'CUTO') THEN
            CALL NEXTF('CUTOff: ',AMBCUT)
C     
         ELSE IF (WD(1:4).EQ.'DEL1') THEN
            CALL NEXTF('DEL1 (F1): ',DELPP1)
C     
         ELSE IF (WD(1:4).EQ.'DEL2') THEN
            CALL NEXTF('DEL2 (F2): ',DELPP2)
C     
         ELSE IF (WD(1:5).EQ.'HDEL1') THEN
            CALL NEXTF('DEL1 (F1): ',DELHP1)
C     
         ELSE IF (WD(1:5).EQ.'HDEL2') THEN
            CALL NEXTF('DEL2 (F2): ',DELHP2)
C     
         ELSE IF (WD(1:4).EQ.'DISP') THEN
            CALL NEXTA4('DISPosition (SATI/VIOL/ALL): ',DISPO)
C     
         ELSE IF (WD(1:4).EQ.'MODE') THEN
            CALL NEXTA4('MODE: ',AMBMOD)
C     
         ELSE IF (WD(1:4).EQ.'MINN') THEN
            CALL NEXTI('Minimum number of possibilities: ',AMBMIN)
         ELSE IF (WD(1:4).EQ.'MAXN') THEN
            CALL NEXTI('Maximum number of possibilities: ',AMBMAX)
C     
         ELSE IF (WD(1:4).EQ.'SEGI') THEN
            CALL NEXTLO('qSEGID: ',QSEGID)
C     
C     
            DONE=.FALSE.
C     
         ELSE IF ((WD(1:4).EQ.'RANG')) THEN
            CALL PUSEND('residueRANGe>')
C     
            DO WHILE (.NOT.DONE)
               CALL NEXTWD('residueRANGe>')
C     
               IF (WD(1:4).EQ.'MINI') THEN
                  CALL NEXTI('MINImum residue range: ',RNGMIN)
               ELSE IF (WD(1:4).EQ.'MAXI') THEN
                  CALL NEXTI('MAXImum residue range: ',RNGMAX)
               ELSE IF (WD(1:4).EQ.'NUMB') THEN
                  CALL NEXTI('Residue range: ',RNGMAX)
                  RNGMIN=RNGMAX
               ELSE
                  CALL CHKEND('residueRANGe>',DONE)
               END IF
C     
            END DO
C     
            DONE=.FALSE.
C     
         ELSE IF (WD(1:4).EQ.'FROM') THEN
            CALL SELCTA(ISLCT,NISLCT,X,Y,Z,.TRUE.)
         ELSE IF (WD(1:4).EQ.'TO  ') THEN
            CALL SELCTA(JSLCT,NJSLCT,X,Y,Z,.TRUE.)
C     
         ELSE IF (WD(1:4).EQ.'RESE') THEN
C     this sets all the parameters to default values
C     and sets the structure counter to 0.
C     it does not scrap the data list.
C     
            AMBSTR=0
            AMBLEV=ONE
            AMBMAX=1
            AMBMIN=1
            AMBMOD='ALL '
            CALL FILL4(ISLCT,NATOM,1)
            CALL FILL4(JSLCT,NATOM,1)
C     
         ELSE IF (WD(1:4).EQ.'ACCU') THEN
            AMBSTR=AMBSTR+1
            AVEMOD='R-6 '
            ACCMOD='ACCU'
            ACTION='ACCU'
C     
         ELSE IF (WD(1:4).EQ.'AVER') THEN
            AMBSTR=AMBSTR+1
            AVEMOD='AVER'
            ACCMOD='AVER'
            ACTION='ACCU'
C     
         ELSE IF (WD(1:4).EQ.'MINI') THEN
            AMBSTR=AMBSTR+1
            AVEMOD='MINI'
            ACCMOD='MINI'
            ACTION='ACCU'
C     
         ELSE IF (WD(1:4).EQ.'SING') THEN
            AMBSTR=1
            AVEMOD='AVER'
            ACCMOD='SING'
            ACTION='ACCU'
C     
         ELSE IF (WD(1:4).EQ.'FREQ') THEN
            AMBSTR=1
            AVEMOD='AVER'
            ACCMOD='FREQ'
            ACTION='ACCU'
C     
         ELSE IF (WD(1:4).EQ.'FRQU') THEN
            CALL NEXTA4('class-name=',CLASS)
C     
            DO I=1,NOECCN
               CALL EQSTWC(NOECNM(I),4,CLASS,4,1,1,MATCH)
C     
               IF (MATCH) THEN
                  HPNDDD=ALLHP(IREAL8(MAXSEL))
                  HPNDII=ALLHP(INTEG4(MAXSEL))
                  HPNDJJ=ALLHP(INTEG4(MAXSEL))
                  HPNFRW=ALLHP(IREAL8(NATOM))
                  CALL FRQUPD(NOEHGL,HEAP(HPNMAT),HEAP(HPNDDD),
     $                 HEAP(HPNDII), HEAP(HPNDJJ),HEAP(HPNFRW),
     $                 HEAP(HPNORR),HEAP(HPNIPR),HEAP(HPNILS),
     $                 HEAP(HPNJPR), HEAP(HPNJLS),HEAP(HPNCND),
     $                 HEAP(HPNRAV),HEAP(HPNRRV), HEAP(HPNDIS),
     $                 HEAP(HPNLOW),HEAP(HPNHIG),HEAP(HPNVOL),
     $                 HEAP(HPNPP1),HEAP(HPNPP2),HEAP(HPNHP1),
     $                 HEAP(HPNHP2), HEAP(HPNWGH),HEAP(HPNVIO),
     $                 HEAP(HPNNSP),HEAP(HPNCV), HEAP(HPNPID),
     $                 HEAP(HPNEXC))
                  CALL FREHP(HPNDJJ,INTEG4(MAXSEL))
                  CALL FREHP(HPNDII,INTEG4(MAXSEL))
                  CALL FREHP(HPNFRW,IREAL8(NATOM))
                  CALL FREHP(HPNDDD,IREAL8(MAXSEL))
               END IF
C     
            END DO
C     
C     
         ELSE IF (WD(1:4).EQ.'VSTA') THEN
            CALL NEXTA4('class-name=',CLASS)
C     
            DO I=1,NOECCN
               CALL EQSTWC(NOECNM(I),4,CLASS,4,1,1,MATCH)
               IF (MATCH) THEN
                  HPNDDD=ALLHP(IREAL8(MAXSEL))
                  HPNDII=ALLHP(INTEG4(MAXSEL))
                  HPNDJJ=ALLHP(INTEG4(MAXSEL))
                  HPNFRW=ALLHP(IREAL8(NATOM))
                  CALL VISTAT(NOEHGL,HEAP(HPNMAT),HEAP(HPNDDD),
     $                 HEAP(HPNDII), HEAP(HPNDJJ),HEAP(HPNFRW),
     $                 HEAP(HPNORR),HEAP(HPNIPR),HEAP(HPNILS),
     $                 HEAP(HPNJPR), HEAP(HPNJLS),HEAP(HPNCND),
     $                 HEAP(HPNRAV),HEAP(HPNRRV), HEAP(HPNDIS),
     $                 HEAP(HPNLOW),HEAP(HPNHIG),HEAP(HPNVOL),
     $                 HEAP(HPNPP1),HEAP(HPNPP2),HEAP(HPNHP1),
     $                 HEAP(HPNHP2), HEAP(HPNWGH),HEAP(HPNVIO),
     $                 HEAP(HPNNSP),HEAP(HPNCV), HEAP(HPNPID),
     $                 HEAP(HPNEXC))
                  CALL FREHP(HPNFRW,IREAL8(NATOM))
                  CALL FREHP(HPNDJJ,INTEG4(MAXSEL))
                  CALL FREHP(HPNDII,INTEG4(MAXSEL))
                  CALL FREHP(HPNDDD,IREAL8(MAXSEL))
               END IF
C     
            END DO
C     
         ELSE IF (WD(1:4).EQ.'RSTA') THEN
            CALL NEXTA4('class-name=',CLASS)
C     
            DO I=1,NOECCN
               CALL EQSTWC(NOECNM(I),4,CLASS,4,1,1,MATCH)
               IF (MATCH) THEN
                  HPNDDD=ALLHP(IREAL8(MAXSEL))
                  HPNDII=ALLHP(INTEG4(MAXSEL))
                  HPNDJJ=ALLHP(INTEG4(MAXSEL))
                  HPNFRW=ALLHP(IREAL8(NATOM))
                  CALL RESTAT(NOEHGL,HEAP(HPNMAT),HEAP(HPNDDD),
     $                 HEAP(HPNDII), HEAP(HPNDJJ),HEAP(HPNFRW),
     $                 HEAP(HPNORR),HEAP(HPNIPR),HEAP(HPNILS),
     $                 HEAP(HPNJPR), HEAP(HPNJLS),HEAP(HPNCND),
     $                 HEAP(HPNRAV),HEAP(HPNRRV), HEAP(HPNDIS),
     $                 HEAP(HPNLOW),HEAP(HPNHIG),HEAP(HPNVOL),
     $                 HEAP(HPNPP1),HEAP(HPNPP2),HEAP(HPNHP1),
     $                 HEAP(HPNHP2), HEAP(HPNWGH),HEAP(HPNVIO),
     $                 HEAP(HPNNSP),HEAP(HPNCV), HEAP(HPNPID),
     $                 HEAP(HPNEXC))
                  CALL FREHP(HPNFRW,IREAL8(NATOM))
                  CALL FREHP(HPNDJJ,INTEG4(MAXSEL))
                  CALL FREHP(HPNDII,INTEG4(MAXSEL))
                  CALL FREHP(HPNDDD,IREAL8(MAXSEL))
               END IF
C     
            END DO
C     
         ELSE IF (WD(1:4).EQ.'CHEC') THEN
C     get the class name:
            CALL NEXTA4('class-name=',CLASS)
            HPNDDD=ALLHP(IREAL8(MAXSEL))
            HPNDII=ALLHP(INTEG4(MAXSEL))
            HPNDJJ=ALLHP(INTEG4(MAXSEL))
            HPNDD2=ALLHP(IREAL8(MAXSEL))
            HPNDI2=ALLHP(INTEG4(MAXSEL))
            HPNDJ2=ALLHP(INTEG4(MAXSEL))
C     
            DO I=1,NOECCN
               CALL EQSTWC(NOECNM(I),4,CLASS,4,1,1,MATCH)
               IF (MATCH) THEN
                  CALL NOECHK(NOEHGL,HEAP(HPNMAT),
     $                 HEAP(HPNDDD),HEAP(HPNDII),HEAP(HPNDJJ),
     $                 HEAP(HPNDD2),HEAP(HPNDI2),HEAP(HPNDJ2),
     $                 AVEMOD,
     $                 HEAP(HPNORR),HEAP(HPNIPR),HEAP(HPNILS),
     $                 HEAP(HPNJPR), HEAP(HPNJLS),HEAP(HPNCND),
     $                 HEAP(HPNRAV),HEAP(HPNRRV), HEAP(HPNDIS),
     $                 HEAP(HPNLOW),HEAP(HPNHIG),HEAP(HPNVOL),
     $                 HEAP(HPNPP1),HEAP(HPNPP2),HEAP(HPNHP1),
     $                 HEAP(HPNHP2), HEAP(HPNWGH),HEAP(HPNVIO),
     $                 HEAP(HPNNSP),HEAP(HPNCV), HEAP(HPNPID),
     $                 HEAP(HPNEXC))
               END IF
C     
            END DO
C     
            CALL FREHP(HPNDJ2,INTEG4(MAXSEL))
            CALL FREHP(HPNDI2,INTEG4(MAXSEL))
            CALL FREHP(HPNDD2,IREAL8(MAXSEL))
            CALL FREHP(HPNDJJ,INTEG4(MAXSEL))
            CALL FREHP(HPNDII,INTEG4(MAXSEL))
            CALL FREHP(HPNDDD,IREAL8(MAXSEL))
C     
C     
         ELSE IF (WD(1:4).EQ.'PURG') THEN
C     get the class name:
            CALL NEXTA4('class-name=',CLASS)
            CALL NEXTA4('class-name=',CLASS2)
            ICL1=0
            ICL2=0
            DO I=1,NOECCN
               CALL EQSTWC(NOECNM(I),4,CLASS,4,1,1,MATCH)
               IF (MATCH) ICL1=I
               CALL EQSTWC(NOECNM(I),4,CLASS2,4,1,1,MATCH)
               IF (MATCH) ICL2=I
            END DO
            HPNDDD=ALLHP(IREAL8(MAXSEL))
            HPNDII=ALLHP(INTEG4(MAXSEL))
            HPNDJJ=ALLHP(INTEG4(MAXSEL))
            HPNDD2=ALLHP(IREAL8(MAXSEL))
            HPNDI2=ALLHP(INTEG4(MAXSEL))
            HPNDJ2=ALLHP(INTEG4(MAXSEL))
C     
            DO I=1,NOECCN
               CALL EQSTWC(NOECNM(I),4,CLASS,4,1,1,MATCH)
C     
               IF (MATCH) THEN
                  CALL NOEPRG
     &                 (ICL1,ICL2,NOEHGL,HEAP(HPNMA2),HEAP(HPNMAT),
     &                 HEAP(HPNDDD),HEAP(HPNDII),HEAP(HPNDJJ),
     &                 HEAP(HPNDD2),HEAP(HPNDI2),HEAP(HPNDJ2),
     &                 AVEMOD,
     &                 HEAP(HPNORR),HEAP(HPNIPR),HEAP(HPNILS),
     +                 HEAP(HPNJPR), HEAP(HPNJLS),HEAP(HPNCND),
     +                 HEAP(HPNRAV),HEAP(HPNRRV), HEAP(HPNDIS),
     +                 HEAP(HPNLOW),HEAP(HPNHIG),HEAP(HPNVOL),
     &                 HEAP(HPNPP1),HEAP(HPNPP2),HEAP(HPNHP1),
     +                 HEAP(HPNHP2), HEAP(HPNWGH),HEAP(HPNVIO),
     &                 HEAP(HPNNSP),HEAP(HPNCV), HEAP(HPNPID),
     $                 HEAP(HPNEXC))
               END IF
C     
            END DO
C     
            CALL FREHP(HPNDJ2,INTEG4(MAXSEL))
            CALL FREHP(HPNDI2,INTEG4(MAXSEL))
            CALL FREHP(HPNDD2,IREAL8(MAXSEL))
            CALL FREHP(HPNDJJ,INTEG4(MAXSEL))
            CALL FREHP(HPNDII,INTEG4(MAXSEL))
            CALL FREHP(HPNDDD,IREAL8(MAXSEL))

         ELSE IF (WD(1:4).EQ.'TRAN') THEN
C     get the class name:
            CALL NEXTA4('class-name=',CLASS)
            CALL NEXTA4('class-name=',CLASS2)
            ICL1=0
            ICL2=0
            DO I=1,NOECCN
               CALL EQSTWC(NOECNM(I),4,CLASS,4,1,1,MATCH)
               IF (MATCH) ICL1=I
               CALL EQSTWC(NOECNM(I),4,CLASS2,4,1,1,MATCH)
               IF (MATCH) ICL2=I
            END DO
            HPNDDD=ALLHP(IREAL8(MAXSEL))
            HPNDII=ALLHP(INTEG4(MAXSEL))
            HPNDJJ=ALLHP(INTEG4(MAXSEL))
            HPNDD2=ALLHP(IREAL8(MAXSEL))
            HPNDI2=ALLHP(INTEG4(MAXSEL))
            HPNDJ2=ALLHP(INTEG4(MAXSEL))
C     
            DO I=1,NOECCN
               CALL EQSTWC(NOECNM(I),4,CLASS,4,1,1,MATCH)
C     
               IF (MATCH) THEN
                  CALL NOETRF
     &                 (ICL1,ICL2,NOEHGL,HEAP(HPNMA2),HEAP(HPNMAT),
     &                 HEAP(HPNDDD),HEAP(HPNDII),HEAP(HPNDJJ),
     &                 HEAP(HPNDD2),HEAP(HPNDI2),HEAP(HPNDJ2),
     &                 AVEMOD,
     &                 HEAP(HPNORR),HEAP(HPNIPR),HEAP(HPNILS),
     +                 HEAP(HPNJPR), HEAP(HPNJLS),HEAP(HPNCND),
     +                 HEAP(HPNRAV),HEAP(HPNRRV), HEAP(HPNDIS),
     +                 HEAP(HPNLOW),HEAP(HPNHIG),HEAP(HPNVOL),
     &                 HEAP(HPNPP1),HEAP(HPNPP2),HEAP(HPNHP1),
     +                 HEAP(HPNHP2), HEAP(HPNWGH),HEAP(HPNVIO),
     &                 HEAP(HPNNSP),HEAP(HPNCV), HEAP(HPNPID),
     $                 HEAP(HPNEXC))
               END IF
C     
            END DO
C     
            CALL FREHP(HPNDJ2,INTEG4(MAXSEL))
            CALL FREHP(HPNDI2,INTEG4(MAXSEL))
            CALL FREHP(HPNDD2,IREAL8(MAXSEL))
            CALL FREHP(HPNDJJ,INTEG4(MAXSEL))
            CALL FREHP(HPNDII,INTEG4(MAXSEL))
            CALL FREHP(HPNDDD,IREAL8(MAXSEL))
C     
         ELSE IF (WD(1:4).EQ.'ASSI') THEN
            CALL NEXTA4('class-name=',CLASS)
            AMBFRM='NONE'
            QSORT=.FALSE.
            ACTION='ASSI'
C     
         ELSE IF (WD(1:4).EQ.'LIST') THEN
            CALL NEXTA4('class-name=',CLASS)
            AMBFRM='LIST'
            QSORT=.FALSE.
            ACTION='ASSI'
C     
         ELSE IF (WD(1:4).EQ.'SORT') THEN
            CALL NEXTA4('class-name=',CLASS)
            AMBFRM='LIST'
            QSORT=.TRUE.
            ACTION='ASSI'
C     
         ELSE IF (WD(1:4).EQ.'REST') THEN
            CALL NEXTA4('class-name=',CLASS)
            AMBFRM='REST'
            QSORT=.TRUE.
            ACTION='ASSI'
C     
         ELSE IF (WD(1:4).EQ.'OR-R') THEN
            CALL NEXTA4('class-name=',CLASS)
            AMBFRM='OR-R'
            QSORT=.TRUE.
            ACTION='ASSI'
C     
         ELSE IF (WD(1:4).EQ.'BACK') THEN
            CALL NEXTA4('class-name=',CLASS)
            ZLEAK=ZERO
            OMEGA=500.0D6
            TAUISO=10.0D-9
            TAUMIX=0.050D0
            NLAYER=3
            CUTOFF=4.0D0
            NTAUP1=10
C
            CALL PUSEND('BACK-calculation>')
            DO WHILE (.NOT.DONE)
               CALL NEXTWD('BACK-calculation>')
               IF (WD(1:4).EQ.'FREQ') THEN
                  CALL NEXTF('spectrometer FREQuency [Hz]: ',OMEGA)
               ELSE IF (WD(1:4).EQ.'TCOR') THEN
                  CALL NEXTF('correlation time [s]=', TAUISO)
               ELSE IF (WD(1:4).EQ.'TMIX') THEN
                  CALL NEXTF('mixing time [s]=', TAUMIX)
               ELSE IF (WD(1:4).EQ.'NLAY') THEN
                  CALL NEXTI('N. layers=',NLAYER)
               ELSE IF (WD(1:4).EQ.'CUTO') THEN
                  CALL NEXTF('cutoff=',CUTOFF)
               ELSE IF (WD(1:4).EQ.'MDOU') THEN
                  CALL NEXTI('matrix doublings=', NTAUP1)
               ELSE
                  CALL CHKEND('BACK-calculation>',DONE)
               END IF
            END DO
C     
            DONE=.FALSE.
C
C allocate space if necessary
            CALL ARIHP(MATDIM,NHG,NATOM)
C
            CALL CHPR(HEAP(HPCDIS),HEAP(HPCVOL),HEAP(HPNDIS))
            CALL GRAT(NATOM,NOEHGL,HEAP(HPIGR))
            HPSUMT = ALLHP(IREAL8(NATOM))
            CALL RXPAIR3(NHG, NLAYER, NOEHGL, HEAP(HPIGR),
     $           HEAP(HPNPR), HEAP(HPHHPR), CUTOFF, 
     $           HEAP(HPDMAT), SIX, NJMAX)
            CALL CHPR(HEAP(HPCDIS),HEAP(HPCVOL),HEAP(HPNDIS))
            CALL RMATRIX(NHG, NATOM, NOEHGL, HEAP(HPPOPU),
     $           HEAP(HPSUMT), HEAP(HPRATE),HEAP(HPDMAT),HEAP(HPHHPR),
     $           HEAP(HPNPR), OMEGA, ZLEAK,TAUISO)
            CALL FREHP(HPSUMT,IREAL8(NATOM))
C     
            HPABSZ = ALLHP(IREAL8(NATOM))
            HPCALV = ALLHP(IREAL8(NHG*NHG*NTAUP1))
            CALL RXIBLQ(NHG, NJMAX, NTAUP1, HEAP(HPABSZ),
     $           HEAP(HPPOPU), HEAP(HPDMAT), HEAP(HPRATE),
     $           HEAP(HPCALV),
     $           HEAP(HPIMAT), HEAP(HPHHPR), HEAP(HPNPR), TAUMIX)
            CALL CHPR(HEAP(HPCDIS),HEAP(HPCVOL),HEAP(HPNDIS))
            CALL FREHP(HPCALV,IREAL8(NHG*NHG*NTAUP1))
            CALL FREHP(HPABSZ,IREAL8(NATOM))
C     
            AVEMOD='R-6 '
            ACCMOD='ACCU'
            ACTION='BACK'
            CALL ATGR(NATOM,NOEHGL,HEAP(HPIGR))
            CALL AMBVAC(NHG,NOEHGL,HEAP(HPIGR),HEAP(HPPOPU),
     $           HEAP(HPIMAT),HEAP(HPDMAT),
     $           HEAP(HPNMAT),ACCMOD,HEAP(HPCDIS),HEAP(HPCVOL),
     &           HEAP(HPNORR),HEAP(HPNIPR),HEAP(HPNILS),HEAP(HPNJPR),
     &           HEAP(HPNJLS),HEAP(HPNCND),HEAP(HPNRAV),HEAP(HPNRRV),
     &           HEAP(HPNDIS),HEAP(HPNLOW),HEAP(HPNHIG),HEAP(HPNVOL),
     &           HEAP(HPNPP1),HEAP(HPNPP2),HEAP(HPNHP1),HEAP(HPNHP2),
     $           HEAP(HPNWGH),HEAP(HPNVIO),
     &           HEAP(HPNNSP),HEAP(HPNPID),HEAP(HPNCV))

            CALL CHPR(HEAP(HPCDIS),HEAP(HPCVOL),HEAP(HPNDIS))

         ELSE
            CALL CHKEND('ANALyse_restraints>',DONE)
         END IF
C     
      END DO
C     
      DONE=.FALSE.
C     
C     
      IF (ACTION.EQ.'ASSI') THEN
C     
         DO I=1,NOECCN
            CALL EQSTWC(NOECNM(I),4,CLASS,4,1,1,MATCH)
C     
            IF (MATCH) THEN
               HPNDDD=ALLHP(IREAL8(MAXSEL))
               HPNDII=ALLHP(INTEG4(MAXSEL))
               HPNDJJ=ALLHP(INTEG4(MAXSEL))
               HPNFR2=ALLHP(IREAL8(MAXSEL))
               CALL CHPR(HEAP(HPCDIS),HEAP(HPCVOL),HEAP(HPNDIS))

               CALL AMBLIS(ISLCT,JSLCT,NOEHGL,HEAP(HPNMA2),
     $              HEAP(HPNMAT), HEAP(HPNDDD),HEAP(HPNFR2),
     $              HEAP(HPNDII), HEAP(HPNDJJ),
     $              QSORT,AMBFRM,DISPO,I,QSEGID,
     $              DELPP1,DELPP2,DELHP1,DELHP2,
     $              HEAP(HPNORR),HEAP(HPNIPR),HEAP(HPNILS),
     $              HEAP(HPNJPR),HEAP(HPNJLS),HEAP(HPNCND),
     $              HEAP(HPNRAV),HEAP(HPNRRV),HEAP(HPCDIS),
     $              HEAP(HPCVOL), HEAP(HPNDIS),HEAP(HPNLOW),
     $              HEAP(HPNHIG),HEAP(HPNVOL), HEAP(HPNPP1),
     $              HEAP(HPNPP2),HEAP(HPNHP1),HEAP(HPNHP2),
     $              HEAP(HPNWGH),HEAP(HPNVIO), HEAP(HPNNSP),
     $              HEAP(HPNCV), HEAP(HPNPID),HEAP(HPNSPC),
     $              HEAP(HPNEXC))

               CALL CHPR(HEAP(HPCDIS),HEAP(HPCVOL),HEAP(HPNDIS))
               CALL FREHP(HPNFR2,IREAL8(MAXSEL))
               CALL FREHP(HPNDJJ,INTEG4(MAXSEL))
               CALL FREHP(HPNDII,INTEG4(MAXSEL))
               CALL FREHP(HPNDDD,IREAL8(MAXSEL))
            END IF
C     
         END DO
C     
      ELSEIF (ACTION.EQ.'ACCU') THEN
C     
C allocate space if necessary
         CALL ARIHP(MATDIM,NHG,NATOM)
C
         CALL GRAT(NATOM,NOEHGL,HEAP(HPIGR))
         CALL DISACC(ACCMOD,NOEHGL,HEAP(HPPOPU), HEAP(HPIGR),
     $        HEAP(HPDMAT),
     $        HEAP(HPIMAT),NHG,SIX,X,Y,Z)
C     
         AVEMOD='R-6 '
         ACCMOD='ACCU'
         ACTION='BACK'
         CALL ATGR(NATOM,NOEHGL,HEAP(HPIGR))
         CALL AMBVAC(NHG,NOEHGL,HEAP(HPIGR),HEAP(HPPOPU),
     $        HEAP(HPIMAT),HEAP(HPDMAT),
     $        HEAP(HPNMAT),ACCMOD,HEAP(HPCDIS),HEAP(HPCVOL),
     &        HEAP(HPNORR),HEAP(HPNIPR),HEAP(HPNILS),HEAP(HPNJPR),
     &        HEAP(HPNJLS),HEAP(HPNCND),HEAP(HPNRAV),HEAP(HPNRRV),
     &        HEAP(HPNDIS),HEAP(HPNLOW),HEAP(HPNHIG),HEAP(HPNVOL),
     &        HEAP(HPNPP1),HEAP(HPNPP2),HEAP(HPNHP1),HEAP(HPNHP2),
     $        HEAP(HPNWGH),HEAP(HPNVIO),
     &        HEAP(HPNNSP), HEAP(HPNPID),HEAP(HPNCV))
         
      END IF
C     
      RETURN
      END
C     
C=====================================================================
C     
      SUBROUTINE DISACC
     &     (AVETYP,NOEHGL,GRPOP,IGRAT,DMAT,IMAT,DIM,RXAVEX,X,Y,Z)
C     
C     routine accumulates distance matrix
C     
C     **********************************************
C     * Author and copyright: Michael Nilges, EMBL *
C     * No warranty implied or expressed           *
C     * All rights reserved                        *
C     **********************************************
C     
      IMPLICIT NONE
C     I/O
      INCLUDE 'cns.inc'
      INCLUDE 'aria.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'numbers.inc'
C
      INTEGER DIM
      CHARACTER*4 AVETYP
      INTEGER NOEHGL(*),IGRAT(*)
      DOUBLE PRECISION DMAT(DIM,DIM),IMAT(DIM,DIM),GRPOP(*)
      DOUBLE PRECISION X(*),Y(*),Z(*)
      DOUBLE PRECISION RXAVEX,DISIJ
C  
      INTEGER IG,JG,IAT,JAT

      WRITE (6,'(A,I5)') 
     $  'DISACC: accumulating distance matrix with dimension', DIM

C     
      DO IG=1,DIM
         DO JG=1,DIM
            JAT=IGRAT(JG)
            IAT=IGRAT(IG)
            CALL RM6DIS(IAT,JAT,NOEHGL,X,Y,Z,RXAVEX,DISIJ)
C            write (6,'(2i5,e20.5)') iat,jat,disij
C
            IF (AMBSTR.EQ.1) THEN
               DMAT(IG,JG)=DISIJ
            END IF
C
            IF (AVETYP.EQ.'FREQ') THEN
               DMAT(IG,JG)=THREE
            ELSEIF (AVETYP.EQ.'SING') THEN
               DMAT(IG,JG)=DISIJ
            ELSEIF (AVETYP.EQ.'MINI') THEN
               DMAT(IG,JG)=MIN(DMAT(IG,JG),DISIJ)
            ELSEIF (AVETYP.EQ.'ACCU') THEN
               IF (DMAT(IG,JG).GT.ZERO) THEN
                 DMAT(IG,JG)=(((DMAT(IG,JG)**(-RXAVEX))*(AMBSTR-1)
     +              +DISIJ**(-RXAVEX))/(AMBSTR))**(-ONE/RXAVEX)
               ELSE
                 DMAT(IG,JG)=DISIJ
               END IF
            ELSEIF (AVETYP.EQ.'AVER') THEN
               DMAT(IG,JG)=(DMAT(IG,JG)*(AMBSTR-1)+DISIJ)/AMBSTR
            ELSE
               WRITE(6,'(A,A)')
     +              ' DISACC: unknown mode: ', AVETYP
            END IF
         END DO
      END DO
C
C initialize the intensity matrix by inverse sixth powers
      DO IG=1,DIM
        DO JG=1,DIM
          IF (IG.EQ.JG) THEN 
            IMAT(IG,JG)=ONE
          ELSE
            IMAT(IG,JG)=GRPOP(IG)*DMAT(IG,JG)**(-RXAVEX)*GRPOP(JG)
          END IF
        END DO
      END DO
C
      RETURN
      END
C     
C=====================================================================
C     
      SUBROUTINE AMBVAC
     &     (DIM,NOEHGL,IATGR,GRPOP,INTMAT,DMAT,NOEMAT,MODE,
     $     NOECDI,NOECVO,
     &     NOEORR,NOEIPR,NOEILS,NOEJPR,NOEJLS,NOECND,
     &     NOERAV,NOERRV,NOEDIS,NOELOW,NOEHIG,NOEVOL,
     &     NOEPP1,NOEPP2,NOEHP1,NOEHP2,NOEWGH,NOEVIO,
     &     NOESTP,NOEPID,NOECV)
C     
      IMPLICIT NONE
C     I/O
      INCLUDE 'cns.inc'
      INCLUDE 'noe.inc'
      INCLUDE 'aria.inc'
      INCLUDE 'coord.inc'
      INCLUDE 'consta.inc'
      INCLUDE 'comand.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'numbers.inc'
      INCLUDE 'funct.inc'
      INTEGER DIM,NOEHGL(*),IATGR(*)
      DOUBLE PRECISION GRPOP(*)
      DOUBLE PRECISION INTMAT(DIM,*), DMAT(DIM,*), NOEMAT(*)
      CHARACTER*4 MODE
C     
C     global NOE arrays on HEAP
C     restraint and atom pointers
      INTEGER NOEORR(*),NOEIPR(*),NOEILS(*),NOEJPR(*),NOEJLS(*)
C     classes
      INTEGER NOECND(*)
C     
      DOUBLE PRECISION NOECDI(*),NOECVO(*)
C     averages
      DOUBLE PRECISION NOERAV(*),NOERRV(*)
C     target distance and errors
      DOUBLE PRECISION NOEDIS(*),NOELOW(*),NOEHIG(*)
C     volume, chemical shifts
      DOUBLE PRECISION NOEVOL(*),NOEPP1(*),NOEPP2(*),NOEHP1(*),
     +     NOEHP2(*)
C     weights
      DOUBLE PRECISION NOEWGH(*)
C     number of violations
      INTEGER NOEVIO(*)
C     time average pointer, test set, restraint number
      INTEGER NOESTP(*), NOECV(*), NOEPID(*)
C     local
      DOUBLE PRECISION DISIJ
      DOUBLE PRECISION SAVEXP
      INTEGER I, J, N, NSTART, NSTOP, II, JJ, NI, NJ
      LOGICAL QNEXT, QNEXT1, QNEXT2
C     for printing 'assignments' of ambiguous NOEs
      INTEGER IAT, JAT, NMAT, NORR, IG, JG
      DOUBLE PRECISION RNL, TOTPRB, TOTINT, TOTDIS, SUMVOL, SUMCVO
C     parameter
C     functions
      LOGICAL FRSTEL
      EXTERNAL FRSTEL
C     
C     begin
C     
      NSTART=1
      NSTOP=NOENUM
      NMAT=0
      SUMVOL=ZERO
      SUMCVO=ZERO
C     
      DO N=NSTART,NSTOP
         SAVEXP=NAVEXP(NOECND(N))
         TOTINT=ZERO
         TOTDIS=ZERO
         IF (NOECV(N).NE.NOEICV) THEN
            DO NORR=NOEORR(N)+1, NOEORR(N+1)
C     
C     loop over all pairs of groups of atoms belonging to restraint N
               DO II=NOEIPR(NORR)+1,NOEIPR(NORR+1)
                  IAT=NOEILS(II)
                  IF (FRSTEL(IAT,NOEHGL)) THEN 
                     IG=IATGR(IAT)
                     DO JJ=NOEJPR(NORR)+1,NOEJPR(NORR+1)
                        JAT=NOEJLS(JJ)
                        IF (FRSTEL(JAT,NOEHGL)) THEN
                           JG=IATGR(JAT)
C     
                           RNL=INTMAT(IG,JG)
                           IF (RNL.LE.ZERO) THEN
                              RNL=GRPOP(IG)*GRPOP(JG)
     $                             *DMAT(IG,JG)**(-SIX)
                           END IF
                           NMAT=NMAT+1
                           TOTINT=TOTINT+RNL
                           TOTDIS=TOTDIS
     $                          +GRPOP(IG)*GRPOP(JG)
     $                          *DMAT(IG,JG)**(-SIX)
C     
                           IF (NMAT.GT.MATDIM) THEN
                              WRITE(6,'(A,2I8)')
     +                             ' AMBVAC: array dimensions:',
     +                             NMAT,MATDIM
                           ELSE
                              NOEMAT(NMAT)=RNL
                           END IF
                        END IF
                     END DO
                  END IF
               END DO
            END DO
            SUMCVO=SUMCVO+TOTINT
            SUMVOL=SUMVOL+NOEVOL(N)
            NOECVO(N)=TOTINT
            NOECDI(N)=TOTDIS
         END IF
      END DO
      IF (SUMVOL.GT.ZERO) THEN
         DO N=NSTART,NSTOP
            NOEVOL(N)=NOEVOL(N)*SUMCVO/SUMVOL
         END DO
      END IF
C     WRITE(6,'(A,2E15.5)') ' AMBVAC: d^-6, int '
C     $     , NOECDI(1), NOECVO(1)
C     
      WRITE(6,'(A,I5,A,A)') ' AMBVAC: read in ', NMAT,
     &     ' distances in mode ', MODE
C     
      RETURN
      END
C====================================================================
      SUBROUTINE AMBLIS
     &     (ISLCT,JSLCT,NOEHGL,NOEFLG,NOEMAT,
     &     ASPROB,FRQWGT,SELI,SELJ,SORT,FORM,DISPO,ICL,QSEGID,
     &     DELPP1,DELPP2,DELHP1,DELHP2,
     &     NOEORR,NOEIPR,NOEILS,NOEJPR,NOEJLS,NOECND,
     &     NOERAV,NOERRV,NOECDI,NOECVO,NOEDIS,NOELOW,NOEHIG,NOEVOL,
     &     NOEPP1,NOEPP2,NOEHP1,NOEHP2,NOEWGH,NOEVIO,
     &     NOESTP,NOECV,NOEPID,NOESPC,NOEXCL)
C     
      IMPLICIT NONE
C     I/O
      INCLUDE 'cns.inc'
      INCLUDE 'noe.inc'
      INCLUDE 'aria.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'comand.inc'
      INCLUDE 'consta.inc'
      INCLUDE 'coord.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'numbers.inc'
      INCLUDE 'mtf.inc'
      INTEGER ISLCT(*),JSLCT(*),NOEHGL(*)
      INTEGER NOEFLG(*)
      DOUBLE PRECISION NOEMAT(*)
      DOUBLE PRECISION ASPROB(*)
      DOUBLE PRECISION FRQWGT(*)
      INTEGER SELI(*),SELJ(*)
      LOGICAL SORT
      CHARACTER*4 FORM,DISPO
      INTEGER ICL
      LOGICAL QSEGID
      DOUBLE PRECISION DELPP1,DELPP2,DELHP1,DELHP2
C     
C     global NOE arrays on HEAP
C     restraint and atom pointers
      INTEGER NOEORR(*),NOEIPR(*),NOEILS(*),NOEJPR(*),NOEJLS(*)
C     classes
      INTEGER NOECND(*)
C     averages
      DOUBLE PRECISION NOERAV(*),NOERRV(*),NOECDI(*),NOECVO(*)
C     target distance and errors
      DOUBLE PRECISION NOEDIS(*),NOELOW(*),NOEHIG(*)
C     chemical shifts
      DOUBLE PRECISION NOEPP1(*),NOEPP2(*),NOEHP1(*),NOEHP2(*)
C     volume, weights
      DOUBLE PRECISION NOEVOL(*),NOEWGH(*)
C     number of violations
      INTEGER NOEVIO(*)
C     time average pointer, test set, restraint number
      INTEGER NOESTP(*), NOECV(*), NOEPID(*), NOEXCL(*)
      INTEGER NOESPC(*)
C     local
      DOUBLE PRECISION SAVEXP
      INTEGER I, J, K, N, L, NSTART, NSTOP, II, JJ
      INTEGER LSEL, NCV, PTYPE
C     for printing 'assignments' of ambiguous NOEs
      INTEGER IAT, JAT, NMAT, IAMB, TEMPI, TEMPJ, NORR
      INTEGER NRESPR,NAMB,NDEFINED
      DOUBLE PRECISION RNL, TOTPRB, ACCLEV
      DOUBLE PRECISION TEMPD, TEMPF
      DOUBLE PRECISION FRQDI1, FRQDI2, FRQDI3, FRQDI4
      DOUBLE PRECISION F1, F2, F3, F4
      DOUBLE PRECISION FMER,RNT,DELRNT
      CHARACTER*3 TSTRNG
      CHARACTER*4 PSNAMI,PSNAMJ,SEGI,SEGJ
      CHARACTER*256 OUTLINE
      LOGICAL FIRSTI, FIRSTJ, MATCH, QISLCT, QJSLCT, QWRITE, FWRITE
      LOGICAL PSOK
C     functions
      LOGICAL FRSTEL
      EXTERNAL FRSTEL
      INTEGER BONDED
      EXTERNAL BONDED
C     
C     begin
C     
      NSTART=1
      NSTOP=NOENUM
      NMAT=0
      FMER=0.0D0
      RNT=0.0D0
      DELRNT=0.0D0
C     WRITE(6,'(A,2E15.5)') ' AMBLIS: d^-6, int ',
C     $     NOECDI(1), NOECVO(1)
C     
      FWRITE=.TRUE.
      DO N=NSTART,NSTOP
         SAVEXP=NAVEXP(NOECND(N))
C     
C     loop over all pairs of atoms belonging to restraint N
         L=0
         LSEL=0
         DO NORR=NOEORR(N)+1, NOEORR(N+1)
            DO II=NOEIPR(NORR)+1,NOEIPR(NORR+1)
               IAT=NOEILS(II)
               IF (FRSTEL(IAT,NOEHGL)) THEN
                  DO JJ=NOEJPR(NORR)+1,NOEJPR(NORR+1)
                     JAT=NOEJLS(JJ)
                     IF (FRSTEL(JAT,NOEHGL)) THEN
                        NMAT=NMAT+1
                        IF (NMAT.GT.MATDIM) THEN
                           CALL WRNDIE(-5,'AMBLIS',
     &                          'programming error: MATDIM')
                        END IF
                        L=L+1
                        IF (NOEFLG(NMAT).GT.0) THEN
                           LSEL=LSEL+1
                           IF (LSEL.GT.MAXSEL) THEN
                              CALL WRNDIE(-5,'AMBLIS',
     &                             'programming error: MAXSEL')
                           END IF
                           ASPROB(LSEL)=NOEMAT(NMAT)
     $                          /NMONO(NOECND(N))
                           FRQWGT(LSEL)=ONE
                           SELI(LSEL)=IAT
                           SELJ(LSEL)=JAT
                        END IF
                     END IF
                  END DO
               END IF
            END DO
         END DO
C     
         IF (LSEL.EQ.0) THEN
            WRITE (6, '(A, 2I8)')
     &           ' %AMBLIS-ERR: problem with restraint ',
     &           N, NOEPID(N)
         ELSE
C     
C     calculate frequency weighting
C     if no peak width is given, the factor is one.
            DO I=1,LSEL
               IF ((DELPP1.EQ.ZERO)
     $              .OR.(NOEPP1(N).LE.(-999.0)) 
     $              .OR.(RMSD(SELI(I)).LE.(-999.0))) THEN 
                  F1= ONE
               ELSE
                  F1= EXP(-(RMSD(SELI(I))-NOEPP1(N))**2/DELPP1**2)
               END IF
               IF ((DELPP2.EQ.ZERO)
     $              .OR.(NOEPP2(N).LE.(-999.0))
     $              .OR.(RMSD(SELJ(I)).LE.(-999.0))) THEN 
                  F2= ONE
               ELSE
                  F2= EXP(-(RMSD(SELJ(I))-NOEPP2(N))**2/DELPP2**2)
               END IF
               IF ((DELHP1.EQ.ZERO)
     $              .OR.(NOEHP1(N).LE.(-999.0)) 
     $              .OR.(RMSD(BONDED(SELI(I))).LE.(-999.0))) THEN 
                  F3= ONE
               ELSE
                  F3= EXP(-(RMSD(BONDED(SELI(I)))-NOEHP1(N))**2
     $                 /DELHP1**2)
               END IF
               IF ((DELHP2.EQ.ZERO)
     $              .OR.(NOEHP2(N).LE.(-999.0)) 
     $              .OR.(RMSD(BONDED(SELJ(I))).LE.(-999.0))) THEN 
                  F4= ONE
               ELSE
                  F4= EXP(-(RMSD(BONDED(SELJ(I)))-NOEHP2(N))**2
     $                 /DELHP2**2)
               END IF
            END DO
C     
C     calculate total probability to normalize
            TOTPRB=ZERO
            DO I=1,LSEL
               TOTPRB=TOTPRB+ASPROB(I)*FRQWGT(I)
            END DO
C     
C     sort the ASPROB, frequency and atom pointer arrays
            IF (SORT) THEN
               DO I=1,LSEL-1
                  DO J=I+1,LSEL
                     IF ((ASPROB(J)*FRQWGT(J))
     $                    .GT.(ASPROB(I)*FRQWGT(I)))
     +                    THEN
                        TEMPD=ASPROB(I)
                        ASPROB(I)=ASPROB(J)
                        ASPROB(J)=TEMPD
                        TEMPF=FRQWGT(I)
                        FRQWGT(I)=FRQWGT(J)
                        FRQWGT(J)=TEMPF
                        TEMPI=SELI(I)
                        SELI(I)=SELI(J)
                        SELI(J)=TEMPI
                        TEMPJ=SELJ(I)
                        SELJ(I)=SELJ(J)
                        SELJ(J)=TEMPJ
                     END IF
                     IF (FORM.EQ.'DUMP') THEN
                        WRITE(PUNIT,
     &                       '(I5,I5,8(1X,A),F6.2,2F9.3,2E10.3)')
     &                       I,J,SEGID(SELI(I)),RESID(SELI(I)),
     &                       RES(SELI(I)),TYPE(SELI(I)),
     &                       SEGID(SELJ(I)),RESID(SELJ(I)),
     $                       RES(SELJ(I)),
     &                       TYPE(SELJ(I)),RNL,
     &                       RMSD(SELI(I)), RMSD(SELJ(I)),
     &                       ASPROB(I)*FRQWGT(I)/TOTPRB,FRQWGT(I)
                     END IF
                  END DO
               END DO
            END IF
C     
C     calculate weighted ideal frequency
            FRQDI1=ZERO
            FRQDI2=ZERO
            FRQDI3=ZERO
            FRQDI4=ZERO
            NDEFINED=0
            DO I=1,LSEL
               IF ((DELPP1.EQ.ZERO)
     $           .OR.(NOEPP1(N).LE.(-999.0)) 
     $           .OR.(RMSD(SELI(I)).LE.(-999.0))) THEN 
               ELSE
                  NDEFINED=NDEFINED+1
                  FRQDI1=FRQDI1+ASPROB(I)*FRQWGT(I)/
     $               TOTPRB*RMSD(SELI(I))
               END IF
            END DO
            IF (NDEFINED.LT.LSEL) THEN
               FRQDI1=NOEPP1(N)
            END IF
C
            NDEFINED=0
            DO I=1,LSEL
               IF ((DELPP2.EQ.ZERO)
     $           .OR.(NOEPP2(N).LE.(-999.0)) 
     $           .OR.(RMSD(SELJ(I)).LE.(-999.0))) THEN 
               ELSE
                  NDEFINED=NDEFINED+1
                  FRQDI2=FRQDI2+ASPROB(I)*FRQWGT(I)/
     $               TOTPRB*RMSD(SELJ(I))
               END IF
            END DO
            IF (NDEFINED.LT.LSEL) THEN
               FRQDI2=NOEPP2(N)
            END IF
C
            NDEFINED=0
            DO I=1,LSEL
               IF ((DELHP1.EQ.ZERO)
     $           .OR.(NOEHP1(N).LE.(-999.0)) 
     $           .OR.(RMSD(BONDED(SELI(I))).LE.(-999.0))) THEN 
               ELSE
                  NDEFINED=NDEFINED+1
                  FRQDI3=FRQDI3+ASPROB(I)*FRQWGT(I)/
     $               TOTPRB*RMSD(BONDED(SELI(I)))
               END IF
            END DO
            IF (NDEFINED.LT.LSEL) THEN
               FRQDI3=NOEHP1(N)
            END IF
C
            NDEFINED=0
            DO I=1,LSEL
               IF ((DELHP2.EQ.ZERO)
     $           .OR.(NOEHP2(N).LE.(-999.0)) 
     $           .OR.(RMSD(BONDED(SELJ(I))).LE.(-999.0))) THEN 
               ELSE
                  NDEFINED=NDEFINED+1
                  FRQDI4=FRQDI4+ASPROB(I)*FRQWGT(I)/
     $               TOTPRB*RMSD(BONDED(SELJ(I)))
               END IF
            END DO
            IF (NDEFINED.LT.LSEL) THEN
               FRQDI4=NOEHP2(N)
            END IF
C
C now we calculate an overall figure of merit and store it in noerav
C
            NOERAV(N)=EXP(
     $           -(FRQDI1-NOEPP1(N))**2/MAX(RSMALL,DELPP1**2)
     $           -(FRQDI2-NOEPP2(N))**2/MAX(RSMALL,DELPP2**2)
     $           -(FRQDI3-NOEHP1(N))**2/MAX(RSMALL,DELHP1**2)
     $           -(FRQDI4-NOEHP2(N))**2/MAX(RSMALL,DELHP2**2) )
C            WRITE(6,'(5E15.5)') frqdi1,
C     $           frqdi2,frqdi3,
C     $           frqdi4,NOERAV(N)
C            WRITE(6,'(5E15.5)') noepp1(N),noepp2(N),
C     $           noehp1(N),noehp2(N),NOERAV(N)
C     
C     establish how many restraints one needs to exceed acclev or ambcut
C     ambcut is a simple distance cutoff
C     amblev is the r-6 sum over the accumulated average or min distances
            IAMB=0
            ACCLEV=ZERO
            RNL=ZERO
            RNT=ZERO
            DO WHILE ((ACCLEV.LT.AMBLEV)
     &           .AND.(IAMB.LT.LSEL)
     &           .AND.(RNL.LE.AMBCUT))
               IAMB=IAMB+1
               ACCLEV=ACCLEV+ASPROB(IAMB)*FRQWGT(IAMB)/TOTPRB
               RNL=MAX(ASPROB(IAMB),RSMALL)**(-ONE/SAVEXP)
               RNT=RNT+ASPROB(IAMB)
            END DO
            IF (RNL.GT.AMBCUT) IAMB=IAMB-1
C     RNT=MAX(RNT,RSMALL)**(-ONE/SAVEXP)
C     
            IF ((IAMB.LE.0).AND.(NOEXCL(N).GT.0)) THEN
               WRITE (6, '(A, 2I8)')
     &              ' %AMBLIS-ERR: no distance < ambcut at ',
     &              N, NOEPID(N)
               IAMB=1
            END IF
C     
C     count how many different residue pairs are involved
            IF ((AMBMOD.EQ.'ALL ').OR.(IAMB.LE.1)) THEN
               NAMB=IAMB
            ELSE
               NRESPR=1
               DO K=1,IAMB-1
                  MATCH=.FALSE.
                  DO LSEL=K+1,IAMB
                     IF ((   (SEGID(SELI(K)).EQ.SEGID(SELI(LSEL)))
     &                    .AND.(RESID(SELI(K)).EQ.RESID(SELI(LSEL)))
     &                    .AND.(SEGID(SELJ(K)).EQ.SEGID(SELJ(LSEL)))
     &                    .AND.(RESID(SELJ(K)).EQ.RESID(SELJ(LSEL))))
     &                    .OR.(  (SEGID(SELI(K)).EQ.SEGID(SELJ(LSEL)))
     &                    .AND.(RESID(SELI(K)).EQ.RESID(SELJ(LSEL)))
     &                    .AND.(SEGID(SELJ(K)).EQ.SEGID(SELI(LSEL)))
     &                    .AND.(RESID(SELJ(K)).EQ.RESID(SELI(LSEL)))))
     $                    THEN
                        MATCH=.TRUE.
                     END IF
                  END DO
                  IF (.NOT.MATCH) NRESPR=NRESPR+1
               END DO
               NAMB=NRESPR
            END IF
C     
C     check how many residues lie between I and J
C     this is done only for the first assignment
C     
C     IF (SELI(1).LE.SELJ(1)) THEN
C     ITER=1
C     ELSE
C     ITER=-1
C     END IF
C     
C     NRANGE=0
C     IRESID=RESID(SELI(1))
C     ISEGID=SEGID(SELI(1))
C     
C     
C     DO K=SELI(1),SELJ(1),ITER
C     
C     IF ((SEGID(SELI(K)).NE.ISEGID)
C     1    .OR.(RESID(SELI(K)).NE.IRESID)) THEN
C     IRESID=RESID(SELI(K))
C     ISEGID=SEGID(SELI(K))
C     NRANGE=NRANGE+1
C     END IF
C     
C     END DO
C     
C     WRITE (6,'(A,I5)') ' AMBLIS: nrange ', Nrange

C     
C     check if the restraint is selected
            QISLCT=.FALSE.
            QJSLCT=.FALSE.
            DO I=1, IAMB
               IF ((ISLCT(SELI(I)).GT.0)) QISLCT=.TRUE.
               IF ((JSLCT(SELJ(I)).GT.0)) QJSLCT=.TRUE.
            END DO
            IF (.NOT.(QISLCT.AND.QJSLCT)) THEN
               QISLCT=.FALSE.
               QJSLCT=.FALSE.
               DO I=1, IAMB
                  IF ((ISLCT(SELJ(I)).GT.0)) QISLCT=.TRUE.
                  IF ((JSLCT(SELI(I)).GT.0)) QJSLCT=.TRUE.
               END DO
            END IF
C     
            IF      ((NOEXCL(N).EQ.1).AND.(NAMB.EQ.1)) THEN
               TSTRNG=' + '
               PTYPE=1
            ELSE IF ((NOEXCL(N).EQ.0).AND.(NAMB.EQ.1)) THEN 
               TSTRNG=' - '
               PTYPE=3
            ELSE IF ((NOEXCL(N).EQ.1).AND.(NAMB.GT.1)) THEN 
               TSTRNG=' + '
               PTYPE=2
            ELSE IF ((NOEXCL(N).EQ.0).AND.(NAMB.GT.1)) THEN 
               TSTRNG=' - '
               PTYPE=4
            ELSE
               TSTRNG=' - '
               PTYPE=5
            END IF
C     
C     write a distance restraint with ambiguous atom selections
C     here the inter mode does not make much sense (yet?)
            IF ((FORM.EQ.'REST')) THEN
               QWRITE =
     &              (((DISPO.EQ.'ALL ').OR.
     &              ((NOEXCL(N).NE.0).AND.(DISPO.EQ.'SATI')).OR.
     &              ((NOEXCL(N).EQ.0).AND.(DISPO.EQ.'VIOL')))
     &              .AND.QISLCT.AND.QJSLCT
     &              .AND.(NAMB.LE.AMBMAX).AND.(NAMB.GE.AMBMIN)
     &              .AND.(ICL.EQ.NOECND(N)))

c     3    .AND.(NRANGE.LE.RNGMAX).AND.(NRANGE.GE.RNGMIN))
C     
C     sort the seli and selj arrays until iamb
               IF (QWRITE) THEN
C     
                  DO I=1,IAMB-1
                     DO J=I+1,IAMB
                        IF (SELI(J).GT.SELI(I)) THEN
                           TEMPI=SELI(I)
                           SELI(I)=SELI(J)
                           SELI(J)=TEMPI
                        END IF
                        IF (SELJ(J).GT.SELJ(I)) THEN
                           TEMPJ=SELJ(I)
                           SELJ(I)=SELJ(J)
                           SELJ(J)=TEMPJ
                        END IF
                     END DO
                  END DO
C     
                  TEMPI=-9999
                  TEMPJ=-9999
                  FIRSTI=.TRUE.
                  FIRSTJ=.TRUE.
C     write I atoms
                  WRITE(PUNIT,'(1X,A)') 'ASSI ('
                  DO I=1,IAMB
                     IF (SELI(I).NE.TEMPI) THEN
                        TEMPI=SELI(I)
                        IF (.NOT.FIRSTI) THEN
                           WRITE(PUNIT,'(1X,A)') ' OR '
                        END IF
                        CALL RXWRA2(PUNIT,(SELI(I)),NOEHGL,
     $                       'PSEU',QSEGID)
                        FIRSTI=.FALSE.
                     END IF
                  END DO
C     
C     write J atoms
                  WRITE(PUNIT,'(1X,A)') ')('
                  DO I=1,IAMB
                     IF (SELJ(I).NE.TEMPJ) THEN
                        TEMPJ=SELJ(I)
                        IF (.NOT.FIRSTJ) THEN
                           WRITE(PUNIT,'(1X,A)') ' OR '
                        END IF
                        CALL RXWRA2(PUNIT,(SELJ(I)),NOEHGL,
     $                       'PSEU',QSEGID)
                        FIRSTJ=.FALSE.
                     END IF
                  END DO
                  WRITE(PUNIT,'(1X,A)') ')'
C     
C     write restraint
                  WRITE(PUNIT,
     $                 '(1X,3F10.3,A,I5,A,I4,2(A,E12.5),
     $                 2(A,F10.3),A,I5)')
     &                 NOEDIS(N),NOELOW(N),NOEHIG(N),
     &                 ' peak ',NOEPID(N),' spectrum ', NOESPC(N),
     $                 ' weight ',NOEWGH(N), ' volume ',NOEVOL(N),
     &                 ' ppm1 ', NOEPP1(N), ' ppm2 ', NOEPP2(N),
     $                 ' CV ', NOECV(N)
               END IF
C     
C     write an ambiguous distance restraint in "OR" format
            ELSE IF ((FORM.EQ.'OR-R')) THEN
               QWRITE =
     &              (((DISPO.EQ.'ALL ').OR.
     &              ((NOEXCL(N).NE.0).AND.(DISPO.EQ.'SATI')).OR.
     &              ((NOEXCL(N).EQ.0).AND.(DISPO.EQ.'VIOL')))
     &              .AND.QISLCT.AND.QJSLCT
     &              .AND.(NAMB.LE.AMBMAX).AND.(NAMB.GE.AMBMIN)
     &              .AND.(ICL.EQ.NOECND(N)))

c     3    .AND.(NRANGE.LE.RNGMAX).AND.(NRANGE.GE.RNGMIN))
C     
               IF (QWRITE) THEN
                  FIRSTI=.TRUE.
                  WRITE(PUNIT,'(1X,A, I5, A)') 'ASSI {', NOEPID(N),
     $                 '}'
                  DO I=1,IAMB
                     IF (FIRSTI) THEN
                        CALL RXWRA2(PUNIT,(SELI(I)),NOEHGL,
     $                       'PSEU',QSEGID)
                        CALL RXWRA2(PUNIT,(SELJ(I)),NOEHGL,
     $                       'PSEU',QSEGID)
                        WRITE(PUNIT,'(1X,3F10.3,A,I5,
     +                       A,I4,2(A,E12.5),2(A,F10.3),A,I5)')
     &                       NOEDIS(N),NOELOW(N),NOEHIG(N),
     &                       ' peak ',NOEPID(N),' spectrum ',
     $                       NOESPC(N),' weight ',NOEWGH(N),
     &                       ' volume ',NOEVOL(N),
     &                       ' ppm1 ', NOEPP1(N), ' ppm2 ',
     $                       NOEPP2(N), ' CV ', NOECV(N)
                        FIRSTI=.FALSE.
                     ELSE
                        WRITE(PUNIT,'(1X,A, I5, A)') 'OR {',
     $                       NOEPID(N), '}'
                        CALL RXWRA2(PUNIT,(SELI(I)),NOEHGL,
     $                       'PSEU',QSEGID)
                        CALL RXWRA2(PUNIT,(SELJ(I)),NOEHGL,
     $                       'PSEU',QSEGID)
                     END IF
                  END DO
               END IF
C     
            ELSEIF (FORM.EQ.'OLIS') THEN
C     
               QWRITE = (QISLCT.AND.QJSLCT
     &              .AND.(NAMB.LE.AMBMAX).AND.(NAMB.GE.AMBMIN)
     &              .AND.(ICL.EQ.NOECND(N)))
c     3    .AND.(NRANGE.LE.RNGMAX).AND.(NRANGE.GE.RNGMIN))
C     
               IF (FWRITE) THEN
                  WRITE(PUNIT,'(A,A,A,A,A,A,A,A,A,A,A,A,A,A,A)')
     &                 ' X ', 'peakno', '     assignment 1   ',
     +                 '     assignment 2   ',
     &                 'd_ave ', '   volume ', 'lower ', 'upper ',
     +                 '   Hppm1 ', '   Hppm2 ', '   Pppm1 ',
     $                 '   Pppm2 ',
     +                 '   Contr', '  FMer', ' Nps'
                  FWRITE=.FALSE.
               END IF
               IF (QWRITE) THEN
                  DO I=1,IAMB
                     CALL PSUNAM((SELI(I)),NOEHGL,PSNAMI,PSOK)
                     IF (.NOT.PSOK) PSNAMI=TYPE(SELI(I))
                     CALL PSUNAM((SELJ(I)),NOEHGL,PSNAMJ,PSOK)
                     IF (.NOT.PSOK) PSNAMJ=TYPE(SELJ(I))
                     RNL=MAX(ASPROB(I),RSMALL)**(-ONE/SAVEXP)
                     WRITE
     $                    (PUNIT,
     $                    '(A,I5,8(1X,A),F6.2,E10.3,2F6.2
     $                    ,4F9.3,2E10.3,I4)')
     &                    TSTRNG,NOEPID(N),SEGID(SELI(I)),
     $                    RESID(SELI(I)),
     &                    RES(SELI(I)),PSNAMI,
     &                    SEGID(SELJ(I)),RESID(SELJ(I)),RES(SELJ(I)),
     &                    PSNAMJ,RNL,NOEVOL(N),
     &                    NOEDIS(N)-NOELOW(N),NOEDIS(N)+NOEHIG(N),
     &                    RMSD(SELI(I)), RMSD(SELJ(I)),NOEPP1(N),
     $                    NOEPP2(N),
     &                    ASPROB(I)*FRQWGT(I)/TOTPRB,FRQWGT(I), NAMB
                  END DO
               END IF
C     
            ELSEIF (FORM.EQ.'LIST') Then
C     
               QWRITE = (QISLCT.AND.QJSLCT
     &              .AND.(NAMB.LE.AMBMAX).AND.(NAMB.GE.AMBMIN)
     &              .AND.(ICL.EQ.NOECND(N)))
c     3    .AND.(NRANGE.LE.RNGMAX).AND.(NRANGE.GE.RNGMIN))
C     
C     
               IF (QWRITE) THEN
C     
C     first, write the information from the original peak list
                  WRITE(OUTLINE(1:22),'(A,X,I4,X,I5,I3,2F6.2)')
     &                 ' p', NOESPC(N), NOEPID(N), NOECV(N),
     &                 NOEWGH(N)
C     fields 5,6: volume
                  IF (NOEVOL(N).GT.RSMALL) THEN
                     WRITE(OUTLINE(23:33),'(X,E10.3)')
     $                    NOEVOL(N)**(-SIXTH)
                  ELSE 
                     WRITE(OUTLINE(23:33),'(A)') '     -     '
                  END IF
C     IF (NOEVER(N).GT.-1.0D99) THEN
C     WRITE((OUTLINE(34:44),'(X,E10.3)') NOEVER(N)
C     ELSE 
                  WRITE(OUTLINE(34:44),'(A)') '     -     '
C     END IF
C     fields 7,8: intensity
C     IF (NOEINT(N).GT.-1.0D99) THEN
C     WRITE(OUTLINE(45:55),'(X,E10.3)') NOEINT(N)
C     ELSE 
                  WRITE(OUTLINE(45:55),'(A)') '     -     '
C     END IF
C     IF (NOEVER(N).GT.-1.0D99) THEN
C     WRITE((OUTLINE(56:66),'(X,E10.3)') NOEIER(N)
C     ELSE 
                  WRITE(OUTLINE(56:66),'(A)') '     -     '
C     END IF
C     fields 9,10: heteroshift 1
                  IF (NOEHP1(N).GT.-999.0) THEN
                     WRITE(OUTLINE(67:77),'(X,F10.3)') NOEHP1(N)
                  ELSE 
                     WRITE(OUTLINE(67:77),'(A)') '     -     '
                  END IF
                  WRITE(OUTLINE(78:88),'(X,F10.3)') DELHP1
C     fields 11,12: proton shift 1
                  IF (NOEPP1(N).GT.-999.0) THEN
                     WRITE(OUTLINE(89:99),'(X,F10.3)') NOEPP1(N)
                  ELSE 
                     WRITE(OUTLINE(89:99),'(A)') '     -     '
                  END IF
                  WRITE(OUTLINE(100:110),'(X,F10.3)') DELPP1
C     fields 13,14: proton shift 2
                  IF (NOEHP2(N).GT.-999.0) THEN
                     WRITE(OUTLINE(111:121),'(X,F10.3)') NOEHP2(N)
                  ELSE 
                     WRITE(OUTLINE(111:121),'(A)') '     -     '
                  END IF
                  WRITE(OUTLINE(122:132),'(X,F10.3)') DELPP2
C     fields 15,16: hetero shift 2
                  IF (NOEPP2(N).GT.-999.0) THEN
                     WRITE(OUTLINE(133:143),'(X,F10.3)') NOEPP2(N)
                  ELSE 
                     WRITE(OUTLINE(133:143),'(A)') '     -     '
                  END IF
                  WRITE(OUTLINE(144:154),'(X,F10.3)') DELHP2
C     write the line to disk
                  WRITE(PUNIT,'(A)') OUTLINE(1:154)
C     
C     then, write the overal parameters of ARIA assignments
                  WRITE(OUTLINE(1:53),
     $                 '(A,X,I3,X,4F6.2,X,E10.3,X,E10.3)')
     &                 ' a', PTYPE, FMER, NOEWGH(N), 
     &                 NOEDIS(N)-NOELOW(N),NOEDIS(N)+NOEHIG(N),
     $                 NOECDI(N)**(-ONE/SIX),DELRNT
                  WRITE (OUTLINE(54:75),'(X,E10.3,X,E10.3)')
     $                 NOECVO(N)**(-ONE/SIX), ZERO
C     WRITE (OUTLINE(44:63),'(2A)') '     -    ','     -    '
                  WRITE (OUTLINE(76:82),'(2I3)') IAMB,NAMB
                  WRITE(PUNIT,'(A)') OUTLINE(1:82)
C     
C     now write the contribution
                  DO I=1,IAMB
                     CALL PSUNAM((SELI(I)),NOEHGL,PSNAMI,PSOK)
                     IF (.NOT.PSOK) PSNAMI=TYPE(SELI(I))
                     CALL PSUNAM((SELJ(I)),NOEHGL,PSNAMJ,PSOK)
                     IF (.NOT.PSOK) PSNAMJ=TYPE(SELJ(I))
                     RNL=MAX(ASPROB(I),RSMALL)**(-ONE/SAVEXP)
                     IF (SEGID(SELI(I)).EQ.'    ') THEN 
                        SEGI = '  - ' 
                     ELSE 
                        SEGI = SEGID(SELI(I))
                     END IF
                     IF (SEGID(SELJ(I)).EQ.'    ') THEN 
                        SEGJ = '  - ' 
                     ELSE 
                        SEGJ = SEGID(SELJ(I))
                     END IF
C     
                     WRITE(PUNIT,
     &                    '(A,6F6.2,4(1X,A),2F9.3,X,A,2F9.3,4(1X,A),
     +                    2F9.3,X,A,2F9.3)')
     &                    ' c',FRQWGT(I),ASPROB(I)/RNT,RNL,
     $                    0.0D0,0.0D0, 0.0D0,
     +                    SEGI,RESID(SELI(I)),RES(SELI(I)),
     +                    TYPE(BONDED(SELI(I))),RMSD(BONDED(SELI(I))),
     +                    0.0D0,PSNAMI,RMSD(SELI(I)),0.0D0,
     +                    SEGJ,RESID(SELJ(I)),RES(SELJ(I)),
     +                    TYPE(BONDED(SELJ(I))),RMSD(BONDED(SELJ(I))),
     +                    0.0D0,PSNAMJ,RMSD(SELJ(I)),0.0D0
                  END DO
               END IF
            ELSE
            END IF
         END IF
      END DO

C     
      RETURN
      END
C     
C=====================================================================
C     
      SUBROUTINE FRQUPD
     & (NOEHGL,NOEMAT,ASPROB,SELI,SELJ,FRQWHT,
     & NOEORR,NOEIPR,NOEILS,NOEJPR,NOEJLS,NOECND,
     & NOERAV,NOERRV,NOEDIS,NOELOW,NOEHIG,NOEVOL,
     & NOEPP1,NOEPP2,NOEHP1,NOEHP2,NOEWGH,NOEVIO,
     & NOESTP,NOECV,NOEPID,NOEXCL)
C     
      IMPLICIT NONE
C     I/O
      INCLUDE 'cns.inc'
      INCLUDE 'noe.inc'
      INCLUDE 'aria.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'comand.inc'
      INCLUDE 'consta.inc'
      INCLUDE 'coord.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'numbers.inc'
      INCLUDE 'mtf.inc'
      DOUBLE PRECISION NOEMAT(*), ASPROB(*)
      INTEGER NOEHGL(*)
      INTEGER SELI(*),SELJ(*)
      DOUBLE PRECISION FRQWHT(*)
C     
C     global NOE arrays on HEAP
C     restraint and atom pointers
      INTEGER NOEORR(*),NOEIPR(*),NOEILS(*),NOEJPR(*),NOEJLS(*)
C     classes
      INTEGER NOECND(*)
C     averages
      DOUBLE PRECISION NOERAV(*),NOERRV(*)
C     target distance and errors
      DOUBLE PRECISION NOEDIS(*),NOELOW(*),NOEHIG(*)
C     chemical shifts
      DOUBLE PRECISION NOEPP1(*),NOEPP2(*),NOEHP1(*),NOEHP2(*)
C     volume, weights
      DOUBLE PRECISION NOEVOL(*),NOEWGH(*)
C     number of violations
      INTEGER NOEVIO(*)
C     time average pointer, test set, restraint number
      INTEGER NOESTP(*), NOECV(*), NOEPID(*), NOEXCL(*)
      INTEGER I,II,IAT,JJ,JAT,L,N,NORR,NSTART,NSTOP,NMAT
      DOUBLE PRECISION RN,RNL,TOTPRB,SAVEXP
C     functions
      LOGICAL FRSTEL
      EXTERNAL FRSTEL
C     
C     begin
C     
      NSTART=1
      NSTOP=NOENUM
      NMAT=0
C     
C     now we update the RMSD array
C     at a later stage, this will be a PPM array
C     
      DO I=1,NATOM
         RMSD(I)=ZERO
         FRQWHT(I)=ZERO
      END DO
C     
      DO N=NSTART,NSTOP
         SAVEXP=NAVEXP(NOECND(N))
C     
C     loop over all pairs of atoms belonging to restraint N
         L=0
C     
         DO NORR=NOEORR(N)+1, NOEORR(N+1)
C     
            DO II=NOEIPR(NORR)+1,NOEIPR(NORR+1)
               IAT=NOEILS(II)
               IF (FRSTEL(IAT,NOEHGL)) THEN
                  DO JJ=NOEJPR(NORR)+1,NOEJPR(NORR+1)
                     JAT=NOEJLS(JJ)
                     IF (FRSTEL(JAT,NOEHGL)) THEN
                        NMAT=NMAT+1
                        L=L+1
                        ASPROB(L)=NOEMAT(NMAT)/NMONO(NOECND(N))
                        SELI(L)=IAT
                        SELJ(L)=JAT
                     END IF
                  END DO
               END IF
            END DO
         END DO
C
         IF (L.EQ.0) THEN
            WRITE (6, '(A, 2I8)')
     +       ' %AMBLIS-ERR: problem with restraint ',
     &       N, NOEPID(N)
         ELSE
C     calculate the r-6 summed distance^-6
            RN=ZERO
            DO I=1,L
               RN=RN+ASPROB(I)
            END DO
            TOTPRB=MAX(RN**(-ONE/SAVEXP),RSMALL)
C     calculate new set of ideal frequencies
            IF ((NOEXCL(N).GT.0)
     &       .AND.(NOEPP1(N).GT.(-9999.0))
     &       .AND.(NOEPP2(N).GT.(-9999.0))) THEN
               DO I=1,L
                  RNL=MAX(ASPROB(I)**(-ONE/SAVEXP),RSMALL)
                  RMSD(SELI(I))=RMSD(SELI(I))
     +             +(TOTPRB/RNL)**SAVEXP*NOEPP1(N)
                  FRQWHT(SELI(I))=FRQWHT(SELI(I))
     +             +(TOTPRB/RNL)**SAVEXP
                  RMSD(SELJ(I))=RMSD(SELJ(I))
     +             +(TOTPRB/RNL)**SAVEXP*NOEPP2(N)
                  FRQWHT(SELJ(I))=FRQWHT(SELJ(I))
     +             +(TOTPRB/RNL)**SAVEXP
               END DO
            END IF
         END IF
      END DO
C     
      DO I=1,NATOM
         IF (FRQWHT(I).GT.RSMALL) THEN
            RMSD(I)=RMSD(I)/FRQWHT(I)
         ELSE
            RMSD(I)=-9999.0D0
         END IF
      END DO
C     
      RETURN
      END
C     
C=====================================================================
C     
      SUBROUTINE RESTAT
     & (NOEHGL,NOEMAT,ASPROB,SELI,SELJ,FRQWHT,
     & NOEORR,NOEIPR,NOEILS,NOEJPR,NOEJLS,NOECND,
     & NOERAV,NOERRV,NOEDIS,NOELOW,NOEHIG,NOEVOL,
     & NOEPP1,NOEPP2,NOEHP1,NOEHP2,NOEWGH,NOEVIO,
     & NOESTP,NOECV,NOEPID,NOEXCL)
C     
      IMPLICIT NONE
C     I/O
      INCLUDE 'cns.inc'
      INCLUDE 'noe.inc'
      INCLUDE 'aria.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'comand.inc'
      INCLUDE 'consta.inc'
      INCLUDE 'coord.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'numbers.inc'
      INCLUDE 'mtf.inc'
      DOUBLE PRECISION NOEMAT(*), ASPROB(*)
      INTEGER NOEHGL(*)
      INTEGER SELI(*),SELJ(*)
      DOUBLE PRECISION FRQWHT(*)
C     
C     global NOE arrays on HEAP
C     restraint and atom pointers
      INTEGER NOEORR(*),NOEIPR(*),NOEILS(*),NOEJPR(*),NOEJLS(*)
C     classes
      INTEGER NOECND(*)
C     averages
      DOUBLE PRECISION NOERAV(*),NOERRV(*)
C     target distance and errors
      DOUBLE PRECISION NOEDIS(*),NOELOW(*),NOEHIG(*)
C     chemical shifts
      DOUBLE PRECISION NOEPP1(*),NOEPP2(*),NOEHP1(*),NOEHP2(*)
C     volume, weights
      DOUBLE PRECISION NOEVOL(*),NOEWGH(*)
C     number of violations
      INTEGER NOEVIO(*)
C     time average pointer, test set, restraint number
      INTEGER NOESTP(*), NOECV(*), NOEPID(*), NOEXCL(*)
      INTEGER I,II,IAT,JJ,JAT,L,N,NORR,NSTART,NSTOP,NMAT
      DOUBLE PRECISION RN,RNL,TOTPRB,SAVEXP
C     functions
      LOGICAL FRSTEL
      EXTERNAL FRSTEL
C     
C     begin
C     
      NSTART=1
      NSTOP=NOENUM
      NMAT=0
C     
C     now we update the RMSD array
C     at a later stage, this will be a PPM array
C     
      DO I=1,NATOM
         RMSD(I)=ZERO
         FRQWHT(I)=ZERO
      END DO
C     
      DO N=NSTART,NSTOP
         SAVEXP=NAVEXP(NOECND(N))
C     loop over all pairs of atoms belonging to restraint N
         L=0
         DO NORR=NOEORR(N)+1, NOEORR(N+1)
            DO II=NOEIPR(NORR)+1,NOEIPR(NORR+1)
               IAT=NOEILS(II)
               IF (FRSTEL(IAT,NOEHGL)) THEN
                  DO JJ=NOEJPR(NORR)+1,NOEJPR(NORR+1)
                     JAT=NOEJLS(JJ)
                     IF (FRSTEL(JAT,NOEHGL)) THEN
                        NMAT=NMAT+1
                        L=L+1
                        ASPROB(L)=NOEMAT(NMAT)/NMONO(NOECND(N))
                        SELI(L)=IAT
                        SELJ(L)=JAT
                     END IF
                  END DO
               END IF
            END DO
         END DO
C     
         IF (L.EQ.0) THEN
            WRITE (6, '(A, 2I8)')
     +       ' %AMBLIS-ERR: problem with restraint ',
     &       N, NOEPID(N)
         ELSE
C     calculate the r-6 summed distance^-6
            RN=ZERO
            DO I=1,L
               RN=RN+ASPROB(I)
            END DO
            TOTPRB=MAX(RN**(-ONE/SAVEXP),RSMALL)
C     
C     calculate new set of ideal frequencies
            IF ((NOEXCL(N).NE.0)) THEN
               DO I=1,L
                  RNL=MAX(ASPROB(I)**(-ONE/SAVEXP),RSMALL)
                  RMSD(SELI(I))=RMSD(SELI(I))
     +             +(TOTPRB/RNL)**SAVEXP
                  FRQWHT(SELI(I))=FRQWHT(SELI(I))
     +             +(TOTPRB/RNL)**SAVEXP
                  RMSD(SELJ(I))=RMSD(SELJ(I))
     +             +(TOTPRB/RNL)**SAVEXP
                  FRQWHT(SELJ(I))=FRQWHT(SELJ(I))
     +             +(TOTPRB/RNL)**SAVEXP
               END DO
            END IF
         END IF
      END DO
C
      RETURN
      END
C     
C=====================================================================
C     
      SUBROUTINE VISTAT
     & (NOEHGL,NOEMAT,ASPROB,SELI,SELJ,FRQWHT,
     & NOEORR,NOEIPR,NOEILS,NOEJPR,NOEJLS,NOECND,
     & NOERAV,NOERRV,NOEDIS,NOELOW,NOEHIG,NOEVOL,
     & NOEPP1,NOEPP2,NOEHP1,NOEHP2,NOEWGH,NOEVIO,
     & NOESTP,NOECV,NOEPID,NOEXCL)
C     
      IMPLICIT NONE
C     I/O
      INCLUDE 'cns.inc'
      INCLUDE 'noe.inc'
      INCLUDE 'aria.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'comand.inc'
      INCLUDE 'consta.inc'
      INCLUDE 'coord.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'numbers.inc'
      INCLUDE 'mtf.inc'
      DOUBLE PRECISION NOEMAT(*), ASPROB(*)
      INTEGER NOEHGL(*)
      INTEGER SELI(*),SELJ(*)
      DOUBLE PRECISION FRQWHT(*)
C     
C     global NOE arrays on HEAP
C     restraint and atom pointers
      INTEGER NOEORR(*),NOEIPR(*),NOEILS(*),NOEJPR(*),NOEJLS(*)
C     classes
      INTEGER NOECND(*)
C     averages
      DOUBLE PRECISION NOERAV(*),NOERRV(*)
C     target distance and errors
      DOUBLE PRECISION NOEDIS(*),NOELOW(*),NOEHIG(*)
C     chemical shifts
      DOUBLE PRECISION NOEPP1(*),NOEPP2(*),NOEHP1(*),NOEHP2(*)
C     volume, weights
      DOUBLE PRECISION NOEVOL(*),NOEWGH(*)
C     number of violations
      INTEGER NOEVIO(*)
C     time average pointer, test set, restraint number
      INTEGER NOESTP(*), NOECV(*), NOEPID(*), NOEXCL(*)
      INTEGER I,II,IAT,JJ,JAT,L,N,NORR,NSTART,NSTOP,NMAT
      DOUBLE PRECISION RN,RNL,TOTPRB,SAVEXP
C     functions
      LOGICAL FRSTEL
      EXTERNAL FRSTEL
C     
C     begin
C     
      NSTART=1
      NSTOP=NOENUM
      NMAT=0
C     
C     now we update the RMSD array
C     at a later stage, this will be a PPM array
C     
      DO I=1,NATOM
         RMSD(I)=ZERO
         FRQWHT(I)=ZERO
      END DO
C     
      DO N=NSTART,NSTOP
         SAVEXP=NAVEXP(NOECND(N))
C     
C     loop over all pairs of atoms belonging to restraint N
         L=0
         DO NORR=NOEORR(N)+1, NOEORR(N+1)
            DO II=NOEIPR(NORR)+1,NOEIPR(NORR+1)
               IAT=NOEILS(II)
               IF (FRSTEL(IAT,NOEHGL)) THEN
                  DO JJ=NOEJPR(NORR)+1,NOEJPR(NORR+1)
                     JAT=NOEJLS(JJ)
                     IF (FRSTEL(JAT,NOEHGL)) THEN
                        NMAT=NMAT+1
                        L=L+1
                        ASPROB(L)=NOEMAT(NMAT)/NMONO(NOECND(N))
                        SELI(L)=IAT
                        SELJ(L)=JAT
                     END IF
                  END DO
               END IF
            END DO
         END DO
C     
         IF (L.EQ.0) THEN
            WRITE (6, '(A, 2I8)')
     +       ' %AMBLIS-ERR: problem with restraint ',
     &       N, NOEPID(N)
         ELSE
C     calculate the r-6 summed distance^-6
            RN=ZERO
C     
            DO I=1,L
               RN=RN+ASPROB(I)
            END DO
            TOTPRB=MAX(RN**(-ONE/SAVEXP),RSMALL)
C     calculate new set of ideal frequencies
            IF ((NOEXCL(N).EQ.0)) THEN
               DO I=1,L
                  RNL=MAX(ASPROB(I)**(-ONE/SAVEXP),RSMALL)
                  RMSD(SELI(I))=RMSD(SELI(I))+(TOTPRB/RNL)**SAVEXP
                  FRQWHT(SELI(I))=FRQWHT(SELI(I))+(TOTPRB/RNL)**SAVEXP
                  RMSD(SELJ(I))=RMSD(SELJ(I))+(TOTPRB/RNL)**SAVEXP
                  FRQWHT(SELJ(I))=FRQWHT(SELJ(I))+(TOTPRB/RNL)**SAVEXP
               END DO
            END IF
         END IF
      END DO
C     
      RETURN
      END
C     
C====================================================================
C     
      SUBROUTINE ALLDSP(NOEHGL,NMAT,
     & NOEORR,NOEIPR,NOEILS,NOEJPR,NOEJLS,NOECND,
     & NOERAV,NOERRV,NOEDIS,NOELOW,NOEHIG,NOEVOL,
     & NOEPP1,NOEPP2,NOEHP1,NOEHP2,NOEWGH,NOEVIO,
     & NOESTP,NOECV,NOEPID,NOEXCL)
C     
      IMPLICIT NONE
C     I/O
      INCLUDE 'cns.inc'
      INCLUDE 'noe.inc'
      INCLUDE 'aria.inc'
      INCLUDE 'coord.inc'
      INCLUDE 'consta.inc'
      INCLUDE 'comand.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'funct.inc'
C     
      INTEGER NOEHGL(*), NMAT
C     
C     global NOE arrays on HEAP
C     restraint and atom pointers
      INTEGER NOEORR(*),NOEIPR(*),NOEILS(*),NOEJPR(*),NOEJLS(*)
C     classes
      INTEGER NOECND(*)
C     averages
      DOUBLE PRECISION NOERAV(*),NOERRV(*)
C     target distance and errors
      DOUBLE PRECISION NOEDIS(*),NOELOW(*),NOEHIG(*)
C     chemical shifts
      DOUBLE PRECISION NOEPP1(*),NOEPP2(*),NOEHP1(*),NOEHP2(*)
C     volume, weights
      DOUBLE PRECISION NOEVOL(*),NOEWGH(*)
C     number of violations
      INTEGER NOEVIO(*)
C     time average pointer, test set, restraint number
      INTEGER NOESTP(*), NOECV(*), NOEPID(*), NOEXCL(*)
C     local
      DOUBLE PRECISION SIX, SEVEN,ZERO, ONE
      DOUBLE PRECISION TWO, THREE, FOUR
      INTEGER N, NSTART, NSTOP, II, JJ
C     for printing 'assignments' of ambiguous NOEs
      INTEGER IAT, JAT, NSEL, NORR
C     parameter
      PARAMETER (SIX=6.0D0, SEVEN=7.0D0, ONE=1.0D0, TWO=2.0D0)
      PARAMETER (THREE=3.0D0, FOUR=4.0D0, ZERO=0.0D0)
C     
C     function
      LOGICAL FRSTEL
      EXTERNAL FRSTEL
C     
C     begin
C     
      NSTART=1
      NSTOP=NOENUM
      NMAT=0
      MAXSEL=0
C     
      DO N=NSTART,NSTOP
C     
C     loop over all pairs of atoms belonging to restraint N
         NSEL=0
         DO NORR=NOEORR(N)+1, NOEORR(N+1)
            DO II=NOEIPR(NORR)+1,NOEIPR(NORR+1)
               IAT=NOEILS(II)
               IF (FRSTEL(IAT,NOEHGL)) THEN
                  DO JJ=NOEJPR(NORR)+1,NOEJPR(NORR+1)
                     JAT=NOEJLS(JJ)
                     IF (FRSTEL(JAT,NOEHGL)) THEN
                        NMAT=NMAT+1
                        NSEL=NSEL+1
                        MAXSEL=MAX(MAXSEL,NSEL)
                     END IF
                  END DO
               END IF
            END DO
         END DO
      END DO
C     
      WRITE(6,'(A,I5,A)') ' ALLDSP: making space for ',
     & NMAT,' distances'
      WRITE(6,'(A,I5,A)') ' ALLDSP: maximum number of selections ',
     & MAXSEL
C     
      RETURN
      END
C     
C=====================================================================
C==========checking of NOE list ======================================
C=====================================================================
C     
      SUBROUTINE NOECHK
     & (NOEHGL,NOEMAT,
     & ASPROB,SELI,SELJ,SELDI2,SELI2,SELJ2,
     & MODE,
     & NOEORR,NOEIPR,NOEILS,NOEJPR,NOEJLS,NOECND,
     & NOERAV,NOERRV,NOEDIS,NOELOW,NOEHIG,NOEVOL,
     & NOEPP1,NOEPP2,NOEHP1,NOEHP2,NOEWGH,NOEVIO,
     & NOESTP,NOECV,NOEPID,NOEXCL)
c     new noechec
c     ideas:
c     comparison of involved atom pairs
c     use basically amblis code
c     first accumulate ensemble into noemat array
c     then compare all pairs of restraints (this may take a while)
c     sort the restraints wrt distance
c     cutoff at specified cutoff
c     then compare the two sets of atom pairs for equality
C     
      IMPLICIT NONE
C     I/O
      INCLUDE 'noe.inc'
      INCLUDE 'aria.inc'
      INCLUDE 'consta.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'numbers.inc'
      DOUBLE PRECISION NOEMAT(*)
      DOUBLE PRECISION ASPROB(*), SELDI2(*)
      INTEGER NOEHGL(*)
      INTEGER SELI(*),SELJ(*),SELI2(*),SELJ2(*)
      CHARACTER*4 MODE
C     
C     global NOE arrays on HEAP
C     restraint and atom pointers
      INTEGER NOEORR(*),NOEIPR(*),NOEILS(*),NOEJPR(*),NOEJLS(*)
C     classes
      INTEGER NOECND(*)
C     averages
      DOUBLE PRECISION NOERAV(*),NOERRV(*)
C     target distance and errors
      DOUBLE PRECISION NOEDIS(*),NOELOW(*),NOEHIG(*)
C     chemical shifts
      DOUBLE PRECISION NOEPP1(*),NOEPP2(*),NOEHP1(*),NOEHP2(*)
C     volume, weights
      DOUBLE PRECISION NOEVOL(*),NOEWGH(*)
C     number of violations
      INTEGER NOEVIO(*)
C     time average pointer, test set, restraint number
      INTEGER NOESTP(*), NOECV(*), NOEPID(*), NOEXCL(*)

C     local
      DOUBLE PRECISION SAVEXP, RN
      INTEGER I, J, N, L, NSTART, NSTOP, II, JJ
      INTEGER IAT, JAT, NMAT, IAMB, TEMPI, TEMPJ, NORR
      INTEGER NMAT2, N2, I1, I2, IAMB2, NEQUAL
      DOUBLE PRECISION RNL, TOTPRB, ACCLEV, TEMPD
      LOGICAL QDIFF
C     functions
      LOGICAL FRSTEL
      EXTERNAL FRSTEL
C     
C     begin
C     
      NSTART=1
      NSTOP=NOENUM
      NMAT=0
C     
      DO N=NSTART,NSTOP-1
         SAVEXP=NAVEXP(NOECND(N))
C     
C     loop over all pairs of atoms belonging to restraint N
         L=0
         DO NORR=NOEORR(N)+1, NOEORR(N+1)
            DO II=NOEIPR(NORR)+1,NOEIPR(NORR+1)
               IAT=NOEILS(II)
               IF (FRSTEL(IAT,NOEHGL)) THEN
                  DO JJ=NOEJPR(NORR)+1,NOEJPR(NORR+1)
                     JAT=NOEJLS(JJ)
                     IF (FRSTEL(JAT,NOEHGL)) THEN
                        NMAT=NMAT+1
                        L=L+1
                        IF (NMAT.GT.MATDIM) THEN
                           CALL WRNDIE(-5,'NOECHK',
     &                      'programming error: MATDIM')
                        END IF
                        IF (L.GT.MAXSEL) THEN
                           CALL WRNDIE(-5,'NOECHK',
     &                      'programming error: MAXSEL')
                        END IF
                        ASPROB(L)=NOEMAT(NMAT)/NMONO(NOECND(N))
                        SELI(L)=IAT
                        SELJ(L)=JAT
                     END IF
                  END DO
               END IF
            END DO
         END DO
C     
         DO I=1,L-1
            DO J=I+1,L
               IF (ASPROB(J).GT.ASPROB(I)) THEN
                  TEMPD=ASPROB(I)
                  TEMPI=SELI(I)
                  TEMPJ=SELJ(I)
                  ASPROB(I)=ASPROB(J)
                  SELI(I)=SELI(J)
                  SELJ(I)=SELJ(J)
                  ASPROB(J)=TEMPD
                  SELI(J)=TEMPI
                  SELJ(J)=TEMPJ
               END IF
            END DO
         END DO
C     
C     calculate the r-6 summed distance^-6
         RN=ZERO
         DO I=1,L
            RN=RN+ASPROB(I)
         END DO
         TOTPRB=MAX(RN**(-ONE/SAVEXP),RSMALL)
C     
C     establish how many one needs to exceed acclev or ambcut
C     ambcut is a simple distance cutoff
C     amblev is the r-6 sum over the accumulated ave or mini distances
         IAMB=0
         ACCLEV=ZERO
         RNL=ZERO
         DO WHILE ((ACCLEV.LT.AMBLEV)
     &    .AND.(IAMB.LT.L)
     &    .AND.(RNL.LE.AMBCUT))
            IAMB=IAMB+1
            RNL=MAX(ASPROB(IAMB)**(-ONE/SAVEXP),RSMALL)
            ACCLEV=ACCLEV+(TOTPRB/RNL)**SAVEXP
         END DO
         IF (RNL.GT.AMBCUT) IAMB=IAMB-1
         IF (IAMB.EQ.0) THEN
            WRITE (6, '(A, 2I8)')
     +       ' no distance < ambcut, one kept, at ',
     &       N, NOEPID(N)
            IAMB=1
         END IF
C     
C     now we loop over the whole matrix again
C     only if the restraint is active
C     
         NMAT2=NMAT
         DO N2=N+1,NSTOP
            IF ((NOEXCL(N2).GT.0).AND.(NOEXCL(N).GT.0)) THEN
               SAVEXP=NAVEXP(NOECND(N2))
C     
C     loop over all pairs of atoms belonging to restraint N
               L=0
               DO NORR=NOEORR(N2)+1, NOEORR(N2+1)
                  DO II=NOEIPR(NORR)+1,NOEIPR(NORR+1)
                     IAT=NOEILS(II)
                     IF (FRSTEL(IAT,NOEHGL)) THEN
                        DO JJ=NOEJPR(NORR)+1,NOEJPR(NORR+1)
                           JAT=NOEJLS(JJ)
                           IF (FRSTEL(JAT,NOEHGL)) THEN
                              NMAT2=NMAT2+1
                              L=L+1
                              IF (NMAT2.GT.MATDIM) THEN
                                 CALL WRNDIE(-5,'NOECHK',
     &                            'programming error: MATDIM')
                              END IF
                              IF (L.GT.MAXSEL) THEN
                                 CALL WRNDIE(-5,'NOECHK',
     &                            'programming error: MAXSEL')
                              END IF
                              SELDI2(L)=
     +                         NOEMAT(NMAT2)/NMONO(NOECND(N2))
                              SELI2(L)=IAT
                              SELJ2(L)=JAT
                           END IF
                        END DO
                     END IF
                  END DO
               END DO
C     
               DO I=1,L-1
                  DO J=I+1,L
                     IF (SELDI2(J).GT.SELDI2(I)) THEN
                        TEMPD=SELDI2(I)
                        TEMPI=SELI2(I)
                        TEMPJ=SELJ2(I)
                        SELDI2(I)=SELDI2(J)
                        SELI2(I)=SELI2(J)
                        SELJ2(I)=SELJ2(J)
                        SELDI2(J)=TEMPD
                        SELI2(J)=TEMPI
                        SELJ2(J)=TEMPJ
                     END IF
                  END DO
               END DO
C     
C     calculate the r-6 summed distance^-6
               RN=ZERO
               DO I=1,L
                  RN=RN+SELDI2(I)
               END DO
               TOTPRB=MAX(RN**(-ONE/SAVEXP),RSMALL)
C     
C     establish how many one needs to exceed acclev or ambcut
C     ambcut is a simple distance cutoff
C     amblev is the r-6 sum over the accumulated ave or mini distances
               IAMB2=0
               ACCLEV=ZERO
               RNL=ZERO
               DO WHILE ((ACCLEV.LT.AMBLEV)
     &          .AND.(IAMB2.LT.L)
     &          .AND.(RNL.LE.AMBCUT))
                  IAMB2=IAMB2+1
                  RNL=MAX(SELDI2(IAMB2)**(-ONE/SAVEXP),RSMALL)
                  ACCLEV=ACCLEV+(TOTPRB/RNL)**SAVEXP
               END DO
               IF (RNL.GT.AMBCUT) IAMB2=IAMB2-1
               IF (IAMB2.EQ.0) THEN
                  IAMB2=1
               END IF
C     
C     now compare the two sets of SEL arrays
C     if they differ in at least one position, we accept both
               QDIFF=.FALSE.
               IF (IAMB.NE.IAMB2) THEN
                  QDIFF=.TRUE.
               ELSE
                  NEQUAL=0
                  DO I1=1,IAMB
                     DO I2=1,IAMB
                        IF (((SELI(I1).EQ.SELI2(I2))
     &                   .AND.(SELJ(I1).EQ.SELJ2(I2)))
     &                   .OR.((SELI(I1).EQ.SELJ2(I2))
     &                   .AND.(SELJ(I1).EQ.SELI2(I2))))
     &                   THEN
                           NEQUAL=NEQUAL+1
                        END IF
                     END DO
                  END DO
                  IF (NEQUAL.LT.IAMB) QDIFF=.TRUE.
               END IF
C     
C     if qdiff, we accept both restraints
C     otherwise we have to decide which one to keep
C     ideas:
C     we keep the more restraining one of the two
               IF (.NOT.QDIFF) THEN
                  IF ((NOEHIG(N)+NOELOW(N))
     &             .GT.(NOEHIG(N2)+NOELOW(N2))) THEN
                     NOEXCL(N)=0
                     WRITE (6,'(A,2I8, 2X, 2I8)')
     &                ' Duplicate restraint removed (1): ',
     &                N, NOEPID(N), N2, NOEPID(N2)
                  ELSE
                     NOEXCL(N2)=0
                     WRITE (6,'(A,2I8, 2X, 2I8)')
     &                ' Duplicate restraint removed (2): ',
     &                N, NOEPID(N), N2, NOEPID(N2)
                  END IF
               END IF
            END IF
         END DO
      END DO
c     
C     
      RETURN
      END
C     
C=====================================================================
C     
      SUBROUTINE NOEPRG
     & (ICL1,ICL2,NOEHGL,NOEFLG,NOEMAT,
     & ASPROB,SELI,SELJ,SELDI2,SELI2,SELJ2,
     & MODE,
     & NOEORR,NOEIPR,NOEILS,NOEJPR,NOEJLS,NOECND,
     & NOERAV,NOERRV,NOEDIS,NOELOW,NOEHIG,NOEVOL,
     & NOEPP1,NOEPP2,NOEHP1,NOEHP2,NOEWGH,NOEVIO,
     & NOESTP,NOECV,NOEPID,NOEXCL)
C     
C     removes any occurances of an unambiguous assignment
C     in class icl1
C     from the list of possibilities in class icl2
C     
      IMPLICIT NONE
C     I/O
      INCLUDE 'noe.inc'
      INCLUDE 'aria.inc'
      INCLUDE 'consta.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'numbers.inc'
      INTEGER ICL1,ICL2
      INTEGER NOEFLG(*)
      DOUBLE PRECISION NOEMAT(*)
      DOUBLE PRECISION ASPROB(*), SELDI2(*)
      INTEGER NOEHGL(*)
      INTEGER SELI(*),SELJ(*),SELI2(*),SELJ2(*)
      CHARACTER*4 MODE
C     
C     global NOE arrays on HEAP
C     restraint and atom pointers
      INTEGER NOEORR(*),NOEIPR(*),NOEILS(*),NOEJPR(*),NOEJLS(*)
C     classes
      INTEGER NOECND(*)
C     averages
      DOUBLE PRECISION NOERAV(*),NOERRV(*)
C     target distance and errors
      DOUBLE PRECISION NOEDIS(*),NOELOW(*),NOEHIG(*)
C     chemical shifts
      DOUBLE PRECISION NOEPP1(*),NOEPP2(*),NOEHP1(*),NOEHP2(*)
C     volume, weights
      DOUBLE PRECISION NOEVOL(*),NOEWGH(*)
C     number of violations
      INTEGER NOEVIO(*)
C     time average pointer, test set, restraint number
      INTEGER NOESTP(*), NOECV(*), NOEPID(*), NOEXCL(*)

C     local
      DOUBLE PRECISION SAVEXP, RN
      INTEGER I, J, N, L, NSTART, NSTOP, II, JJ
      INTEGER IAT, JAT, NMAT, IAMB, TEMPI, TEMPJ, NORR
      INTEGER NMAT2, N2, I2
      DOUBLE PRECISION RNL, TOTPRB, ACCLEV, TEMPD
C     functions
      LOGICAL FRSTEL
      EXTERNAL FRSTEL
C     
C     begin
C     
      NSTART=1
      NSTOP=NOENUM
      NMAT=0
C     
      DO N=NSTART,NSTOP-1
         SAVEXP=NAVEXP(NOECND(N))
C     
C     loop over all pairs of atoms belonging to restraint N
         L=0
         DO NORR=NOEORR(N)+1, NOEORR(N+1)
            DO II=NOEIPR(NORR)+1,NOEIPR(NORR+1)
               IAT=NOEILS(II)
               IF (FRSTEL(IAT,NOEHGL)) THEN
                  DO JJ=NOEJPR(NORR)+1,NOEJPR(NORR+1)
                     JAT=NOEJLS(JJ)
                     IF (FRSTEL(JAT,NOEHGL)) THEN
                        NMAT=NMAT+1
                        L=L+1
                        ASPROB(L)=NOEMAT(NMAT)/NMONO(NOECND(N))
                        SELI(L)=IAT
                        SELJ(L)=JAT
                     END IF
                  END DO
               END IF
            END DO
         END DO
C     
C     sort the sel arrayS
         DO I=1,L-1
            DO J=I+1,L
               IF (ASPROB(J).GT.ASPROB(I)) THEN
                  TEMPD=ASPROB(I)
                  TEMPI=SELI(I)
                  TEMPJ=SELJ(I)
                  ASPROB(I)=ASPROB(J)
                  SELI(I)=SELI(J)
                  SELJ(I)=SELJ(J)
                  ASPROB(J)=TEMPD
                  SELI(J)=TEMPI
                  SELJ(J)=TEMPJ
               END IF
            END DO
         END DO
C     
C     calculate the r-6 summed distance^-6
         RN=ZERO
         DO I=1,L
            RN=RN+ASPROB(I)
         END DO
         TOTPRB=MAX(RN**(-ONE/SAVEXP),RSMALL)
C     
C     establish how many one needs to exceed acclev or ambcut
C     ambcut is a simple distance cutoff
C     amblev is the r-6 sum over the accumul. aver or mini distances
         IAMB=0
         ACCLEV=ZERO
         RNL=ZERO
         DO WHILE ((ACCLEV.LT.AMBLEV)
     &    .AND.(IAMB.LT.L)
     &    .AND.(RNL.LE.AMBCUT))
            IAMB=IAMB+1
            RNL=MAX(ASPROB(IAMB)**(-ONE/SAVEXP),RSMALL)
            ACCLEV=ACCLEV+(TOTPRB/RNL)**SAVEXP
         END DO
         IF (RNL.GT.AMBCUT) IAMB=IAMB-1
         IF (IAMB.EQ.0) THEN
            WRITE (6, '(A, 2I8)')
     +       ' no distance < ambcut, one kept, at ',
     &       N, NOEPID(N)
            IAMB=1
         END IF
C     
C     now we loop over the whole matrix again
C     only if the restraint is active
C     
         NMAT2=NMAT
         DO N2=N+1,NSTOP
            SAVEXP=NAVEXP(NOECND(N2))
C     
C     loop over all pairs of atoms belonging to restraint N2
            L=0
            DO NORR=NOEORR(N2)+1, NOEORR(N2+1)
               DO II=NOEIPR(NORR)+1,NOEIPR(NORR+1)
                  IAT=NOEILS(II)
                  IF (FRSTEL(IAT,NOEHGL)) THEN
                     DO JJ=NOEJPR(NORR)+1,NOEJPR(NORR+1)
                        JAT=NOEJLS(JJ)
                        IF (FRSTEL(JAT,NOEHGL)) THEN
                           NMAT2=NMAT2+1
                           L=L+1
                           SELDI2(L)=NOEMAT(NMAT2)/NMONO(NOECND(N2))
                           SELI2(L)=IAT
                           SELJ2(L)=JAT
                        END IF
                     END DO
                  END IF
               END DO
            END DO
C     
C     we remove a possibility under the following conditions
C     1- the fist restraint is from class icl1, the second from icl2
C     2- both restraints are active (noecnd > 0)
C     3- restraint 1 is unambiguous (iamb = 1)
C     4- the unambiguous restraint 1 is a possibility in a
C        restraint from icl2
C     5- restraint 2 is ambiguous (L>1)
            IF ((NOECND(N).EQ.ICL1).AND.(NOECND(N2).EQ.ICL2)
     &       .AND.(NOEXCL(N).GT.0).AND.(NOEXCL(N2).GT.0)
     &       .AND.(IAMB.EQ.1).AND.(L.GT.1)) THEN
               DO I2=1,L
                  IF (((SELI(1).EQ.SELI2(I2))
     &             .AND.(SELJ(1).EQ.SELJ2(I2)))
     &             .OR.((SELI(1).EQ.SELJ2(I2))
     &             .AND.(SELJ(1).EQ.SELI2(I2))))
     &             THEN
                     NOEFLG(NMAT2-L+I2)=0
                     WRITE (6, '(A, 2I8,A, 2I8)')
     &                ' NOEPRG: ', N, NOEPID(N), ' FROM ',
     +                N2, NOEPID(N2)
                  END IF
               END DO
            END IF
         END DO
      END DO
C     
      RETURN
      END
C     
C=====================================================================
C     
      SUBROUTINE NOETRF
     & (ICL1,ICL2,NOEHGL,NOEFLG,NOEMAT,
     & ASPROB,SELI,SELJ,SELDI2,SELI2,SELJ2,
     & MODE,
     & NOEORR,NOEIPR,NOEILS,NOEJPR,NOEJLS,NOECND,
     & NOERAV,NOERRV,NOEDIS,NOELOW,NOEHIG,NOEVOL,
     & NOEPP1,NOEPP2,NOEHP1,NOEHP2,NOEWGH,NOEVIO,
     & NOESTP,NOECV,NOEPID,NOEXCL)
C     
C     transfers an ambiguity from a better resolved spectrum
c     (class icl1) to
C     a spectrum of less resolution (class icl2)
C     this is not working yet
C     
      IMPLICIT NONE
C     I/O
      INCLUDE 'noe.inc'
      INCLUDE 'aria.inc'
      INCLUDE 'consta.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'numbers.inc'
      INTEGER ICL1,ICL2
      INTEGER NOEFLG(*)
      DOUBLE PRECISION NOEMAT(*)
      DOUBLE PRECISION ASPROB(*), SELDI2(*)
      INTEGER NOEHGL(*)
      INTEGER SELI(*),SELJ(*),SELI2(*),SELJ2(*)
      CHARACTER*4 MODE
C     
C     global NOE arrays on HEAP
C     restraint and atom pointers
      INTEGER NOEORR(*),NOEIPR(*),NOEILS(*),NOEJPR(*),NOEJLS(*)
C     classes
      INTEGER NOECND(*)
C     averages
      DOUBLE PRECISION NOERAV(*),NOERRV(*)
C     target distance and errors
      DOUBLE PRECISION NOEDIS(*),NOELOW(*),NOEHIG(*)
C     chemical shifts
      DOUBLE PRECISION NOEPP1(*),NOEPP2(*),NOEHP1(*),NOEHP2(*)
C     volume, weights
      DOUBLE PRECISION NOEVOL(*),NOEWGH(*)
C     number of violations
      INTEGER NOEVIO(*) 
C     time average pointer, test set, restraint number
      INTEGER NOESTP(*), NOECV(*), NOEPID(*), NOEXCL(*)
      
C     local
      DOUBLE PRECISION SAVEXP, RN
      INTEGER I, J, N, L, NSTART, NSTOP, II, JJ
      INTEGER IAT, JAT, NMAT, IAMB, TEMPI, TEMPJ, NORR
      INTEGER NMAT2, N2, I2
      DOUBLE PRECISION RNL, TOTPRB, ACCLEV, TEMPD
      LOGICAL QDIFF
C     functions
      LOGICAL FRSTEL
      EXTERNAL FRSTEL
C     
C     begin
C     
      NSTART=1
      NSTOP=NOENUM
      NMAT=0
C     
      DO N=NSTART,NSTOP-1
         SAVEXP=NAVEXP(NOECND(N))
C     
C     loop over all pairs of atoms belonging to restraint N
         L=0
C     
         DO NORR=NOEORR(N)+1, NOEORR(N+1)
            DO II=NOEIPR(NORR)+1,NOEIPR(NORR+1)
               IAT=NOEILS(II)
               IF (FRSTEL(IAT,NOEHGL)) THEN
                  DO JJ=NOEJPR(NORR)+1,NOEJPR(NORR+1)
                     JAT=NOEJLS(JJ)
                     IF (FRSTEL(JAT,NOEHGL)) THEN
                        NMAT=NMAT+1
                        L=L+1
                        ASPROB(L)=NOEMAT(NMAT)/NMONO(NOECND(N))
                        SELI(L)=IAT
                        SELJ(L)=JAT
                     END IF
                  END DO
               END IF
            END DO
         END DO
C     sort the sel arrayS
         DO I=1,L-1
            DO J=I+1,L
               IF (ASPROB(J).GT.ASPROB(I)) THEN
                  TEMPD=ASPROB(I)
                  TEMPI=SELI(I)
                  TEMPJ=SELJ(I)
                  ASPROB(I)=ASPROB(J)
                  SELI(I)=SELI(J)
                  SELJ(I)=SELJ(J)
                  ASPROB(J)=TEMPD
                  SELI(J)=TEMPI
                  SELJ(J)=TEMPJ
               END IF
            END DO
         END DO
C     calculate the r-6 summed distance^-6
         RN=ZERO
         DO I=1,L
            RN=RN+ASPROB(I)
         END DO
         TOTPRB=MAX(RN**(-ONE/SAVEXP),RSMALL)
C     establish how many one needs to exceed acclev or ambcut
C     ambcut is a simple distance cutoff
C     amblev is the r-6 sum over the accumu. aver or mini distances
         IAMB=0
         ACCLEV=ZERO
         RNL=ZERO
C     
         DO WHILE ((ACCLEV.LT.AMBLEV)
     &    .AND.(IAMB.LT.L) 
     &    .AND.(RNL.LE.AMBCUT))
            IAMB=IAMB+1
            RNL=MAX(ASPROB(IAMB)**(-ONE/SAVEXP),RSMALL)
            ACCLEV=ACCLEV+(TOTPRB/RNL)**SAVEXP
         END DO
C     
         IF (RNL.GT.AMBCUT) IAMB=IAMB-1
         IF (IAMB.EQ.0) THEN
            WRITE (6, '(A, 2I8)')
     +       ' no distance < ambcut, one kept, at ',
     &       N, NOEPID(N)
            IAMB=1
         END IF
C     now we loop over the whole matrix again
C     only if the restraint is active
C     
         NMAT2=NMAT
         DO N2=N+1,NSTOP
            IF ((NOECND(N).EQ.ICL1).AND.(NOECND(N2).EQ.ICL2)
     &       .AND.(NOEXCL(N2).GT.0).AND.(NOEXCL(N).GT.0)
     &       .AND.(IAMB.EQ.1)) THEN
               SAVEXP=NAVEXP(NOECND(N2))
C     loop over all pairs of atoms belonging to restraint N
               L=0
               DO NORR=NOEORR(N2)+1, NOEORR(N2+1)
                  DO II=NOEIPR(NORR)+1,NOEIPR(NORR+1)
                     IAT=NOEILS(II)
                     IF (FRSTEL(IAT,NOEHGL)) THEN
                        DO JJ=NOEJPR(NORR)+1,NOEJPR(NORR+1)
                           JAT=NOEJLS(JJ)
                           IF (FRSTEL(JAT,NOEHGL)) THEN
                              NMAT2=NMAT2+1
                              L=L+1
                              SELDI2(L)=NOEMAT(NMAT2)
     +                         /NMONO(NOECND(N2))
                              SELI2(L)=IAT
                              SELJ2(L)=JAT
                           END IF
                        END DO
                     END IF
                  END DO
               END DO
               QDIFF=.TRUE.
               DO I2=1,L
                  IF (((SELI(1).EQ.SELI2(I2))
     +             .AND.(SELJ(1).EQ.SELJ2(I2)))
     &             .OR.((SELI(1).EQ.SELJ2(I2))
     +             .AND.(SELJ(1).EQ.SELI2(I2))))
     &             THEN
                     QDIFF=.FALSE.
                  END IF
C     
               END DO
               IF (.NOT.QDIFF) THEN
                  DO I2=1,L
                     NOEFLG(NMAT2-L+I2)=0
                     IF (.NOT.(((SELI(1).EQ.SELI2(I2))
     +                .AND.(SELJ(1).EQ.SELJ2(I2)))
     &                .OR.((SELI(1).EQ.SELJ2(I2))
     +                .AND.(SELJ(1).EQ.SELI2(I2)))))
     &                THEN
                        NOEFLG(NMAT2-L+I2)=1
                     END IF
                  END DO
               END IF
            END IF
         END DO
      END DO
C     
      RETURN
      END
C     
C==== 6====1=========2=========3=========4=========5=========6======72
C     
      SUBROUTINE RXWRA2(UNIT,IAT,HGLNK,MODE,QSEGID)
C     
C     writes an unresolved group in NOE ASSIgn format.
C     Author: M. Nilges
C     
      IMPLICIT NONE
C     
C     global
      INCLUDE 'cns.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'funct.inc'
C     
C     input/ output
      INTEGER UNIT, IAT, HGLNK(*)
      CHARACTER*4 MODE
      LOGICAL QSEGID
C     
C     local
      INTEGER I1, I2
      CHARACTER*6 PARAN
      CHARACTER*4 PSNAME
      LOGICAL PSOK, QNEXT
C     
C     functions
      LOGICAL FRSTEL
      EXTERNAL FRSTEL
C     
C     begin
C     
      IF (MODE.EQ.'PSEU') THEN
         CALL PSUNAM(IAT,HGLNK,PSNAME,PSOK)
         IF (PSOK) THEN
            IF (QSEGID) THEN
               WRITE(UNIT,'(8A)')
     &              '   (  ','segid "', SEGID(IAT), '" and resid ',
     $              RESID(IAT),' and name ', PSNAME,')'
            ELSE    
               WRITE(UNIT,'(6A)')
     &              '(resid ', RESID(IAT),' and name ', PSNAME,')'

            END IF
         END IF
      END IF
C     
      I1=IAT
      I2=I1
      PARAN='   (( '
      IF ((.NOT.PSOK).OR.(MODE.EQ.'ALL ')) THEN
         CALL NEXTHY(I1, HGLNK,QNEXT)
         IF (QSEGID) THEN
            DO WHILE (QNEXT) 
               CALL NEXTHY(I1, HGLNK,QNEXT)
               WRITE(UNIT,'(8A)')
     &              PARAN,'segid "', SEGID(I2),
     &              '" and resid ', RESID(I2),' and name ',
     $              TYPE(I2),')'
               WRITE(UNIT,'(A)') '     OR '
               PARAN='    ( '
               I2=I1
            END DO
            WRITE(UNIT,'(8A)')
     &           PARAN,'segid "', SEGID(I2), '" and resid ',
     $           RESID(IAT),' and name ', TYPE(I2),'))'
         ELSE
            DO WHILE (QNEXT) 
               CALL NEXTHY(I1, HGLNK,QNEXT)
               WRITE(UNIT,'(6A)')
     &              PARAN,'resid ', RESID(I2),' and name ',
     $              TYPE(I2),')'
               WRITE(UNIT,'(A)') '     OR '
               PARAN='    ( '
               I2=I1
            END DO
            WRITE(UNIT,'(6A)')
     &           PARAN,'resid ', RESID(I2),' and name ', TYPE(I2),'))'
         END IF
      END IF
C     
      RETURN
      END
C     
C==== 6====1=========2=========3=========4=========5=========6======72
C     
      SUBROUTINE PSUNAM(IAT,HGLNK,PSNAME,PSOK)
C     
C     writes an unresolved group in NOE ASSIgn format.
C     Author: M. Nilges
C     
      IMPLICIT NONE
C     
C     global
      INCLUDE 'cns.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'funct.inc'
C     
C     input/ output
      INTEGER IAT, HGLNK(*)
      CHARACTER*4 PSNAME
C     
C     local
      INTEGER I1, I2, C, POSC, POSB1
      CHARACTER*4 PSUNA1,PSUNA2
      LOGICAL PSOK, QNEXT
C     functions
      LOGICAL FRSTEL
      EXTERNAL FRSTEL
C     
C     begin
C     
      PSOK=.TRUE.
      I1=IAT
      I2=I1
      PSUNA2=TYPE(I2)
      PSNAME=PSUNA2
      POSC=0
C     find first position that is different
      CALL NEXTHY(I1,HGLNK,QNEXT)
      DO WHILE (QNEXT)
         PSUNA1=TYPE(I1)
         DO C=1,LEN(PSUNA1)
            IF ((POSC.EQ.0).AND.(PSUNA2(1:C).NE.PSUNA1(1:C))) THEN
               POSC=C
            END IF
         END DO
         CALL NEXTHY(I1,HGLNK,QNEXT)
      END DO
C     do we have a difference at all? we should!
      IF (POSC.EQ.0) PSOK=.FALSE.
C     look if the position is a blank
      I1=IAT
      IF (PSOK) THEN
         IF (PSUNA2(POSC:POSC).EQ.' ') PSOK=.FALSE.
         CALL NEXTHY(I1,HGLNK,QNEXT)
         DO WHILE (QNEXT)
            PSUNA1=TYPE(I1)
            IF (PSUNA1(POSC:POSC).EQ.' ') PSOK=.FALSE.
            CALL NEXTHY(I1,HGLNK,QNEXT)
         END DO
      END IF
C     make sure it is the last position
      IF (POSC.LT.LEN(PSUNA2)) THEN
         POSB1=POSC+1
         IF (PSUNA2(POSB1:POSB1).NE.' ') PSOK=.FALSE.
      END IF
C     change atom name to pseudo
      IF (PSOK) THEN
         PSNAME(POSC:POSC)='%'
      END IF
      RETURN
      END
C     
C=====================================================================
C     
      SUBROUTINE CHPR(NOECDI,NOECVO,NOEDIS)
      DOUBLE PRECISION NOECDI(*),NOECVO(*),NOEDIS(*)
      WRITE(6,'(A,3E15.5)') ' CHPR: d^-6, int ',
     $     NOECDI(1), NOECVO(1), NOEDIS(1)
      RETURN
      END

      FUNCTION BONDED (IATOM)
C returns name of the last atom bonded to iatom
C Michael Nilges, EMBL
C
      IMPLICIT NONE
C include files
      INCLUDE 'cns.inc'
      INCLUDE 'mtf.inc'
C i/o
      INTEGER IATOM
      INTEGER BONDED
C local
      INTEGER I,BATOM,IBT,JBT
C
C begin
C
      BATOM = 0
C
      DO I=1,NBOND
        IBT=IB(I)
        JBT=JB(I)
        IF (IBT.GT.0.AND.JBT.GT.0) THEN
          IF (IBT.EQ.IATOM) THEN
            BATOM = JBT
          ELSEIF (JBT.EQ.IATOM) THEN
            BATOM = IBT
          END IF
        END IF
      END DO
      BONDED=BATOM
      END

C     
C=====================================================================
C     
      SUBROUTINE NOEEXC
     1     (ICL,NOENUM,VIOEXC,NSTRUC,MODE,VIOLOL,VIOUPL,
     1     NOEORR,NOEIPR,NOEILS,NOEJPR,NOEJLS,NOECND,
     1     NOERAV,NOERRV,NOEDIS,NOELOW,NOEHIG,NOEVOL,
     1     NOEPP1,NOEPP2,NOEHP1,NOEHP2,NOEWGH,NOEVIO,NUMNOE,
     1     NOESTP,NOECV,NOEXCL,NOEPID,NOECDI)
C     
C     plan: get frequency differences into the scheme
C     1) calculate all exp(frequency differences) and store
C     (e.g. NOEWGT = NOEWGT * ...)
C     this might be done in ariass somewhere.
C     need to use standard distance-weighted frequency of assignment
C     2) normalize such that the smallest difference gets weight 1
C     3) exclude if probability is > 0.5
C     or cumulative figure of merit < 0.5
C     P(Nviol,DelFreq) = Nviol/Nstruct  / (F(DelFreq) * InitWeight)
C     
C     excludes datapoints for which NOEVIO exceeds threshold
C     VIOEXC*NSTRUC by setting NOEXCL to 0
C     
C     Author: Michael Nilges
C     
      IMPLICIT NONE
C     I/O
C     
      INCLUDE 'numbers.inc'
      INCLUDE 'consta.inc'
C     
      INTEGER NOENUM,ICL,NSTRUC
      DOUBLE PRECISION VIOEXC,VIOLOL,VIOUPL
      CHARACTER*4 MODE
C     
C     global NOE arrays on HEAP:
C     restraint and atom pointers
      INTEGER NOEORR(*),NOEIPR(*),NOEILS(*),NOEJPR(*),NOEJLS(*)
C     classes
      INTEGER NOECND(*)
C     averages
      DOUBLE PRECISION NOERAV(*),NOERRV(*)
C     target distance and errors
      DOUBLE PRECISION NOEDIS(*),NOELOW(*),NOEHIG(*)
C     chemical shifts
      DOUBLE PRECISION NOEPP1(*),NOEPP2(*),NOEHP1(*),NOEHP2(*)
C     volume, weights
      DOUBLE PRECISION NOEVOL(*),NOEWGH(*)
C     number of violations
      INTEGER NOEVIO(*),NUMNOE(*)
C     time average pointer, test set, restraint number
      INTEGER NOESTP(*), NOECV(*), NOEXCL(*), NOEPID(*)
      DOUBLE PRECISION NOECDI(*)
C     
C     local
      INTEGER N, NEXC
      DOUBLE PRECISION AWEIGH,AFIGME,FIGMER
      INTEGER NAVE, NFIX
      CHARACTER*4 CEXCL
C     begin
C     
      IF (NOENUM.EQ.0) THEN
         WRITE(6,'(A)') ' ARIVIO-ERR: no restraints'
         RETURN
      END IF
C     
      IF (MODE.EQ.'INIT') THEN
         DO N=1,NOENUM
            NOEXCL(N)=1
            NOEVIO(N)=0
            NUMNOE(N)=0
            NOERRV(N)=ZERO
            NOERAV(N)=ZERO
         END DO
         WRITE (6,'(A)') ' ARIVIO: database initialized'
         RETURN
      END IF
C     
C     else calculate a figure of merit for the peak from the initial weight,
C     the frequency figure of merit, and the violation statistic.
      AWEIGH=ZERO
      AFIGME=ZERO
      NAVE=0
      NFIX=0
      DO N=1,NOENUM
         IF (NOECND(N).EQ.ICL) THEN
            IF (NOEWGH(N).LE.ONE) THEN
               NAVE=NAVE+1
               AWEIGH=AWEIGH+NOEWGH(N)
            ELSE
               NFIX=NFIX+1
            END IF
         END IF
      END DO
C
      IF (NAVE.EQ.0) THEN     
         AWEIGH = ONE
      ELSE
         AWEIGH = AWEIGH/NAVE
      END IF
C     
      WRITE(6,'(A)') 
     &     ' COUNtviolations: average restraint properties '
      WRITE(6,'(A,I5)') 
     &     '     number of fixed restraints: ', NFIX
      WRITE(6,'(A,I5)') 
     &     '     number of soft restraints: ', NAVE
         WRITE(6,'(A,F15.3)')
     &     '     average initial weight: ', AWEIGH
      NAVE=0
      DO N=1,NOENUM
         IF (NOECND(N).EQ.ICL) THEN
            IF (NOERAV(N).GT.ZERO) THEN
               NAVE=NAVE+1
               AFIGME=AFIGME+NOERAV(N)
            END IF
         END IF
      END DO
      IF (NAVE.EQ.0) THEN
         AFIGME = ONE
      ELSE
         AFIGME=AFIGME/NAVE
      END IF
      WRITE(6,'(A,F15.3)')
     &     '     average figure of merit: ', AFIGME
C     
      NEXC=0
      DO N=1,NOENUM
         IF (NOECND(N).EQ.ICL) THEN
            FIGMER=ONE-FLOAT(NOEVIO(N))/MAX(1,NUMNOE(N))
            IF (NOERAV(N).GT.ZERO) THEN
               FIGMER=FIGMER*NOERAV(N) /AFIGME
            END IF
            NOEXCL(N) = 1
            IF (NOEWGH(N).LE.ONE) THEN
               FIGMER=FIGMER*NOEWGH(N)/AWEIGH
            END IF
            IF (FIGMER.LE.(ONE-VIOEXC)) THEN
               IF (MODE.EQ.'EXCL') THEN
                  IF (NOEWGH(N).LE.ONE) THEN
                     NEXC=NEXC+1
                     NOEXCL(N) = 0
                     CEXCL = 'EXCL'
                  ELSE
                     CEXCL = 'KEPT'
                  END IF
                  WRITE(6,'(A,I5,3E15.5,X,I5,X,A)')
     $                 ' ARIEXC: peak, lower, upper, distance',
     $                 NOEPID(N),NOEDIS(N)-NOELOW(N),NOEDIS(N)
     $                 +NOEHIG(N),
     $                 NOECDI(N)**(-SIXTH),NOEVIO(N),CEXCL
               ELSEIF (MODE.EQ.'SET ') THEN
                  NEXC=NEXC+1
                  NOEXCL(N)=1
C     
C     if TOKEN was specified on input, VIOxxL are -1
                  IF (VIOUPL.GE.ZERO) THEN
                     NOEHIG(N) = MAX(ZERO,(VIOUPL-NOEDIS(N)))
                  END IF
                  IF (VIOLOL.GE.ZERO) THEN
                     NOELOW(N) = MAX(ZERO,(NOEDIS(N)-VIOLOL))
                  END IF
                  WRITE(6,'(A,I6, F15.3,F15.3)')
     &                 ' COUNtviolations: peak, new error estimates:',
     $                 NOEPID(N), NOELOW(N), NOEHIG(N)
               ELSEIF (MODE.EQ.'MULT') THEN
                  NEXC=NEXC+1
                  NOEXCL(N)=1
C     
C     if TOKEN was specified on input, VIOxxL are -1
                  IF (VIOUPL.GE.ZERO) THEN
                     NOEHIG(N) = NOEHIG(N)*VIOUPL
                  END IF
                  IF (VIOLOL.GE.ZERO) THEN
                     NOELOW(N) = NOELOW(N)*VIOLOL
                  END IF
                  WRITE(6,'(A,I6, F15.3,F15.3)')
     &                 ' COUNtviolations: peak, new error estimates:',
     $                 NOEPID(N), NOELOW(N), NOEHIG(N)
C     
               ELSEIF (MODE.EQ.'WEIG') THEN
                  NOEXCL(N)=1
                  NOEWGH(N)=EXP(-FIGMER**2)
               ELSE
                  WRITE(6,'(A)')
     &                 ' %COUNTV-ERR: unknown mode'
               END IF
            END IF
         END IF
      END DO
C     
      IF (MODE.EQ.'EXCL') THEN
         WRITE (6,'(A,I5,A)')
     &        ' COUNtviolations: ', NEXC, ' restraints excluded '
      ELSE
         WRITE (6,'(A,I5,A)')
     &        ' COUNtviolations: ', NEXC, ' limits reset '
      END IF
C     
      RETURN
      END
C     
C=====================================================================
C     
      SUBROUTINE ARIVIO
     1     (NOEORR,NOEIPR,NOEILS,NOEJPR,NOEJLS,NOECND,
     1     NOERAV,NOERRV,NOEDIS,NOELOW,NOEHIG,NOEVOL,
     1     NOEPP1,NOEPP2,NOEHP1,NOEHP2,NOEWGH,NOEVIO,NUMNOE,
     1     NOESTP,NOECV,NOEXCL,NOEPID)
C     
C     
C     subroutine counts noe violations and calculates average violation
C     
C     Author: Michael Nilges
C     
      IMPLICIT NONE
C     I/O
      INCLUDE 'cns.inc'
      INCLUDE 'consta.inc'
      INCLUDE 'coord.inc'
      INCLUDE 'pick.inc'
      INCLUDE 'noe.inc'
      INCLUDE 'aria.inc'
      INCLUDE 'numbers.inc'
      INCLUDE 'mtf.inc'
C     global NOE arrays on HEAP
C     restraint and atom pointers
      INTEGER NOEORR(*),NOEIPR(*),NOEILS(*),NOEJPR(*),NOEJLS(*)
C     classes
      INTEGER NOECND(*)
C     averages
      DOUBLE PRECISION NOERAV(*),NOERRV(*)
C     target distance and errors
      DOUBLE PRECISION NOEDIS(*),NOELOW(*),NOEHIG(*)
C     volume, chemical shifts
      DOUBLE PRECISION NOEVOL(*),NOEPP1(*),NOEPP2(*)
      DOUBLE PRECISION NOEHP1(*),NOEHP2(*)
C     weights
      DOUBLE PRECISION NOEWGH(*)
C     number of violations
      INTEGER NOEVIO(*),NUMNOE(*)
C     time average pointer, test set, restraint number
      INTEGER NOESTP(*), NOECV(*), NOEXCL(*), NOEPID(*)
C     
C     local
      DOUBLE PRECISION EN, SAVEXP, RN, RN2, LW, DDF, DEVI, WENS
      DOUBLE PRECISION XIJ, YIJ, ZIJ, RIJ, SIJ, XI, YI, ZI, XJ, YJ, ZJ
      INTEGER N, NVIO, NCV, L1, L2, INORR, NORR
      INTEGER I, J, II, JJ, LI, LJ
C     
C     begin
C     
      NVIO=0
      IF (NOENUM.EQ.0) THEN
         RETURN
      END IF
C     
      DO N=1,NOENUM
         IF (NOECV(N).NE.NOEICV) THEN
            NUMNOE(N)=NUMNOE(N)+1
            L1=0
            RN=ZERO
            INORR=0
            DO NORR=NOEORR(N)+1, NOEORR(N+1)
               INORR=INORR+1
C     
               IF (NOEAVE(NOECND(N)).EQ.NOEM6
     &              .OR.(NOEAVE(NOECND(N)).EQ.NOEM3)
     &              .OR.(NOEAVE(NOECND(N)).EQ.NOESUM)) THEN
                  IF (NOEAVE(NOECND(N)).EQ.NOEM3) THEN
                     SAVEXP=THREE
                  ELSEIF (NOEAVE(NOECND(N)).EQ.NOEM6) THEN
                     SAVEXP=SIX
                  ELSE
                     SAVEXP=NAVEXP(NOECND(N))
                  END IF
C     
                  L2=0
                  LW=ZERO
                  RN2=ZERO
C     
C     loop over all pairs of atoms belonging to restraint N
                  DO II=NOEIPR(NORR)+1,NOEIPR(NORR+1)
                     DO JJ=NOEJPR(NORR)+1,NOEJPR(NORR+1)
                        I=NOEILS(II)
                        J=NOEJLS(JJ)
                        XIJ=X(I)-X(J)
                        YIJ=Y(I)-Y(J)
                        ZIJ=Z(I)-Z(J)
                        SIJ=XIJ*XIJ+YIJ*YIJ+ZIJ*ZIJ
                        RIJ=ONE/(SIJ**(SAVEXP/TWO))
                        RN2=RN2+RIJ
                        LW=LW+ONE
                        L1=L1+1
                        L2=L2+1
                        RIJ=RIJ/SIJ
                     END DO
                  END DO
C     
                  IF (NOEAVE(NOECND(N)).EQ.NOESUM) THEN
                     IF (SAVEXP.EQ.OREXP(NOECND(N))) THEN
                        RN2=MAX(RN2/NMONO(NOECND(N)),RSMALL)
                     ELSE
                        RN2=MAX((NMONO(NOECND(N))/RN2)**(ONE/SAVEXP),
     $                       RSMALL)
                     END IF
                  ELSE
                     RN2=MAX((LW/RN2)**(ONE/SAVEXP),RSMALL)
                  END IF
C     
               ELSE IF (NOEAVE(NOECND(N)).EQ.NOECEN) THEN
                  LI=0
                  XI=ZERO
                  YI=ZERO
                  ZI=ZERO
                  DO II=NOEIPR(NORR)+1,NOEIPR(NORR+1)
                     I=NOEILS(II)
                     XI=XI+X(I)
                     YI=YI+Y(I)
                     ZI=ZI+Z(I)
                     LI=LI+1
                  END DO
                  XI=XI/LI
                  YI=YI/LI
                  ZI=ZI/LI
                  LJ=0
                  XJ=ZERO
                  YJ=ZERO
                  ZJ=ZERO
                  DO JJ=NOEJPR(NORR)+1,NOEJPR(NORR+1)
                     J=NOEJLS(JJ)
                     XJ=XJ+X(J)
                     YJ=YJ+Y(J)
                     ZJ=ZJ+Z(J)
                     LJ=LJ+1
                  END DO
                  XJ=XJ/LJ
                  YJ=YJ/LJ
                  ZJ=ZJ/LJ
                  XIJ=XI-XJ
                  YIJ=YI-YJ
                  ZIJ=ZI-ZJ
                  RN2=MAX(SQRT(XIJ**2+YIJ**2+ZIJ**2),RSMALL)
               END IF
C     
               IF (INORR.GT.1) THEN
                  IF (NOEAVE(NOECND(N)).EQ.NOESUM) THEN
                     IF (SAVEXP.EQ.OREXP(NOECND(N))) THEN
                        RN=RN+RN2
                     ELSE
                        RN=RN+RN2**(-OREXP(NOECND(N)))
                     END IF
                  ELSE
                     RN=RN+RN2**(-OREXP(NOECND(N)))
                  END IF
               ELSE
                  RN=RN2
               END IF
            END DO
C     
            RN2=MAX((ONE/RN)**(ONE/OREXP(NOECND(N))),RSMALL)
            RN=RN2
C     
            DEVI=MAX(ZERO,RN-NOEDIS(N)-
     &           MAX(ZERO,NOEHIG(N)-NOEOFF(NOECND(N))))+
     &           MIN(ZERO,RN-NOEDIS(N)+
     &           MAX(ZERO,NOELOW(N)-NOEMOF(NOECND(N))))
            NOERRV(N)=NOERRV(N)+DEVI**2
C     
            IF (ABS(DEVI).GT.VIOTHR) THEN
               WRITE(6,'(A,I5,3E15.5)')
     $              ' ARIEXC: peak, lower, upper, distance',
     $              NOEPID(N), NOEDIS(N)-NOELOW(N),
     $              NOEDIS(N)+NOEHIG(N),
     $              RN
               NOEVIO(N)=NOEVIO(N)+1
               NVIO=NVIO+1
            END IF
         END IF
      END DO
      WRITE(6,'(A,I5,A,f15.5)')
     &     ' COUNTV:',NVIO,' violations above ', VIOTHR
C     
      RETURN
      END
C     
C=====================================================================
C     
      SUBROUTINE NVIOLS
     1     (NOENUM,VIOEXC,NSTRUC,
     1     NOEORR,NOEIPR,NOEILS,NOEJPR,NOEJLS,NOECND, 
     1     NOERAV,NOERRV,NOEDIS,NOELOW,NOEHIG,NOEVOL, 
     1     NOEPP1,NOEPP2,NOEHP1,NOEHP2,NOEWGH,NOEVIO,NUMNOE,
     1     NOESTP,NOECV,NOEXCL,NOEPID)
C     
C     lists datapoints for which NOEVIO exceeds threshold
C     VIOEXC*NSTRUC
C     Author: Michael Nilges
C     
      IMPLICIT NONE
C     I/O
      INCLUDE 'cns.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'comand.inc'
      INCLUDE 'numbers.inc'
      INTEGER NOENUM,NSTRUC
      DOUBLE PRECISION VIOEXC
C     
C     global NOE arrays on HEAP
C     restraint and atom pointers
      INTEGER NOEORR(*),NOEIPR(*),NOEILS(*),NOEJPR(*),NOEJLS(*)
C     classes
      INTEGER NOECND(*)
C     averages
      DOUBLE PRECISION NOERAV(*),NOERRV(*)
C     target distance and errors
      DOUBLE PRECISION NOEDIS(*),NOELOW(*),NOEHIG(*)
C     volume, chemical shifts
      DOUBLE PRECISION NOEVOL(*),NOEPP1(*),NOEPP2(*)
      DOUBLE PRECISION NOEHP1(*),NOEHP2(*)
C     weights
      DOUBLE PRECISION NOEWGH(*)
C     number of violations
      INTEGER NOEVIO(*),NUMNOE(*)
C     time average pointer, test set, restraint number
      INTEGER NOESTP(*), NOECV(*), NOEXCL(*), NOEPID(*)
C     
C     local
      INTEGER I,J,K,N, NORR
C     
C     begin
C     
      IF (NOENUM.GT.0) THEN
         DO N=1,NOENUM
            IF (NOEXCL(N).EQ.0) THEN
               WRITE(PUNIT,'(A,I5,A)')
     &              ' ========== restraint ',NOEPID(N),' =========='
               DO NORR=NOEORR(N)+1, NOEORR(N+1)
                  WRITE(PUNIT,'(A)') ' set-i-atoms'
                  DO I=NOEIPR(NORR)+1,NOEIPR(NORR+1)
                     K=NOEILS(I)
                     WRITE(PUNIT,'(9X,4(1X,A))') SEGID(K),RESID(K),
     $                    RES(K),TYPE(K)
                  END DO
                  WRITE(PUNIT,'(A)') ' set-j-atoms'
                  DO J=NOEJPR(NORR)+1,NOEJPR(NORR+1)
                     K=NOEJLS(J)
                     WRITE(PUNIT,'(9X,4(1X,A))') SEGID(K),RESID(K),
     $                    RES(K),TYPE(K)
                  END DO
               END DO
C     
               WRITE(PUNIT,'(I5,A,F5.2,A,F5.2,A,F5.2,A,F5.2,A)')
     &             NOEVIO(N),
     $              ' Violations Above Threshold, Rms Violation=',
     &              Sqrt(NOERRV(N)/MAX(NOEVIO(N),1)),
     &              ' Target distance=',NOEDIS(N),
     &              ' (-',NOELOW(N),'/+',NOEHIG(N),')'
            END IF
         END DO
      END IF
C
      RETURN
      END
C
C=====================================================================
C

      SUBROUTINE NOESET
C
C Sets up NOE restraint force field for dynamics and minimization.
C Also performs elementary analysis to determine possible NOE's for
C a given structure.
C
C Author: Axel Brunger
C
      IMPLICIT NONE
      INCLUDE 'cns.inc'
      INCLUDE 'heap.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'funct.inc'
C local
      INTEGER ISLCT, JSLCT
C begin
      ISLCT=ALLHP(INTEG4(NATOM))
      JSLCT=ALLHP(INTEG4(NATOM))
      CALL NOESE2(HEAP(ISLCT),HEAP(JSLCT))
      CALL FREHP(JSLCT,INTEG4(NATOM))
      CALL FREHP(ISLCT,INTEG4(NATOM))
      RETURN
      END
C====================================================================
      SUBROUTINE NOESE2(ISLCT,JSLCT)
C
      IMPLICIT NONE
C I/O
      INCLUDE 'cns.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'noe.inc'
      INCLUDE 'comand.inc'
      INCLUDE 'coord.inc'
      INCLUDE 'consta.inc'
      INCLUDE 'heap.inc'
      INTEGER ISLCT(*), JSLCT(*)
C local
      INTEGER I, II, NISLCT, NJSLCT, ICL1, ICL2, NN, ITEMP, IEMODE
      CHARACTER*4 CLASS, CLASS2, STEMP, SRESET
      CHARACTER*8 ASTRING
      DOUBLE COMPLEX DBCOMP
      DOUBLE PRECISION DBPREC
      DOUBLE PRECISION SCALE, RTEMP, NOEDST, THRESH
      LOGICAL MATCH
C parameter
      DOUBLE PRECISION ZERO, ONE, TWO, SIX
      PARAMETER (ZERO=0.0D0, ONE=1.0D0, TWO=2.0D0, SIX=6.0D0)
C begin
C
C allocate space
      IF (NOEMAX.EQ.0) CALL NOEHP(200)
C all defaults are set in NOERES!
      CALL PUSEND('NOE>')
      DO WHILE (.NOT. DONE)
      CALL NEXTWD('NOE>')
      CALL MISCOM('NOE>',USED)
      IF (.NOT.USED) THEN
C
      IF (WD(1:4).EQ.'HELP') THEN
C
         CALL CNSHELP('cns-noe')
C
C====================================================================
      ELSE IF (WD(1:4).EQ.'NRES') THEN
      NN=NOEMAX
      CALL NEXTI('NREStraints=',NN)
      IF (NN.NE.NOEMAX) THEN
      WRITE(6,'(A,I7,A)')
     & ' NOE: allocating space for ',NN,' restraints.'
      CALL NOEHP(NN)
      END IF
C====================================================================
      ELSE IF (WD(1:4).EQ.'RESE') THEN
      CALL NOERES
C====================================================================
      ELSE IF (WD(1:4).EQ.'TEMP') THEN
      CALL NEXTF('TEMPerature=',NOETEM)
C====================================================================
      ELSE IF (WD(1:4).EQ.'CEIL') THEN
      CALL NEXTF('CEILing=',NOECEI)
C====================================================================
      ELSE IF (WD(1:4).EQ.'CLAS') THEN
      IF (NOECCN.EQ.1.AND.NOECNM(1).EQ.'NIL'.AND.NOENUM.EQ.0) THEN
      ELSE IF (NOECCN+1.GE.NOECMX) THEN
      CALL WRNDIE(-5,'NOESET',
     & 'exceeded NOECMX parameter --> recompile program')
      ELSE
      NOECCN=NOECCN+1
      END IF
      CALL NEXTA4('CLASsification=',NOECNM(NOECCN))
      DO I=1,NOECCN-1
      CALL EQSTWC(NOECNM(I),4,NOECNM(NOECCN),4,1,1,MATCH)
      IF (MATCH) THEN
      CALL WRNDIE(+5,'NOESET',
     & 'duplicate class name specified. ')
      END IF
      END DO
C
C set the default values for the class specifications
      NOESCA(NOECCN)=1.0D0
      NOEAVE(NOECCN)=NOEM6
      NOEPOT(NOECCN)=NOEBIH
      NOEEXP(NOECCN)=2
      NOECNS(NOECCN)=1.0D0
      NOEOFF(NOECCN)=0.0D0
      NOEMOF(NOECCN)=0.0D0
      NOESWI(NOECCN)=10.0D0
      NOEASY(NOECCN)=0.0D0
      NOESOE(NOECCN)=2
      NOEMSW(NOECCN)=10.0D0
      NOEMAS(NOECCN)=0.0D0
      NOEMSO(NOECCN)=2
      NMONO(NOECCN)=1
      NOERM2(NOECCN)=0.0D0
      NOENU2(NOECCN)=1
      NAVEXP(NOECCN)=SIX
      OREXP(NOECCN)=SIX
C
C reset time and running-average stuff
      DAVEXP(NOECCN)=3
      RAVEXP(NOECCN)=3
      MEMTAU(NOECCN)=1000.
      TMODE(NOECCN)='OFF'
      RMODE(NOECCN)='OFF'
      TFMODE(NOECCN)='CONS'
C
C initialize high-dim and 3-d stuff
C   noecor is number of noes in this class for highdim only
C   noebar sets hight of barrier in highdim pot.

      NOECOR(NOECCN)=2
      NOEBAR(NOECCN)=0.1
      IF (NOECCN.EQ.1.AND.NOENUM.GT.0) THEN
      WRITE(6,'(A)')
     &' %NOE-ERR: NIL-classified ASSIgn entries preceed this statement'
      END IF
C====================================================================
      ELSE IF (WD(1:4).EQ.'ASSI') THEN
      CALL NOEASS(NOENUM,NOEORN,NOEMAX,NOECCN,NOESMX,HEAP(HPNORR),
     &     HEAP(HPNIPR),
     &     HEAP(HPNILS),HEAP(HPNJPR),HEAP(HPNJLS),HEAP(HPNCND),
     &     HEAP(HPNRAV),HEAP(HPNRRV),HEAP(HPNNSP),HEAP(HPNDIS),
     &     HEAP(HPNLOW),HEAP(HPNHIG),HEAP(HPNWGH),HEAP(HPNCV),
     &     HEAP(HPNVIO),HEAP(HPNEXC),
     &     NPEAKI,HEAP(HPNPID),HEAP(HPNSPC),
     &     HEAP(HPNPP1),HEAP(HPNPP2),HEAP(HPNHP1),HEAP(HPNHP2),
     &     HEAP(HPNVOL),HEAP(HPCDIS),HEAP(HPCVOL),NORSMX,NATOM,
     &     ISLCT,NISLCT,
     &     JSLCT,NJSLCT,X,Y,Z)
C===================================================================
      ELSE IF (WD(1:4).EQ.'?   ') THEN
      WRITE(6,'(A,I6,A,I6,A,/,A,F8.3,A,I6)')
     & ' NOE: total number of restraints:',NOENUM,
     & ' partitioned into ',NOECCN,' classes',
     & ' NOE: ceiling=',NOECEI,' current allocation=',NOEMAX
      IF (NOEICV.GT.0) THEN
      WRITE(6,'(A,/,A,I6)')
     & ' NOE: data are partitioned into working set and test set.',
     & ' NOE: test set number=',NOEICV
      END IF
C===================================================================
      ELSE IF (WD(1:4).EQ.'SCAL') THEN
C
C get the class name:
      CALL NEXTA4('class-name=',CLASS)
      CALL NEXTF('SCALE=',SCALE)
      DO I=1,NOECCN
      CALL EQSTWC(NOECNM(I),4,CLASS,4,1,1,MATCH)
      IF (MATCH) NOESCA(I)=SCALE
      END DO
C====================================================================
      ELSE IF (WD(1:4).EQ.'AVEX') THEN
C
C get the class name:
      CALL NEXTA4('class-name=',CLASS)
      CALL NEXTF('AVERaging=',RTEMP)
      DO I=1,NOECCN
      CALL EQSTWC(NOECNM(I),4,CLASS,4,1,1,MATCH)
      IF (MATCH) THEN
      NAVEXP(I)=RTEMP
      END IF
      END DO
C====================================================================
      ELSE IF (WD(1:4).EQ.'OREX') THEN
C
C get the class name:
      CALL NEXTA4('class-name=',CLASS)
      CALL NEXTF('AVERaging=',RTEMP)
      DO I=1,NOECCN
      CALL EQSTWC(NOECNM(I),4,CLASS,4,1,1,MATCH)
      IF (MATCH) THEN
      OREXP(I)=RTEMP
      END IF
      END DO
C====================================================================
      ELSE IF (WD(1:4).EQ.'AVER') THEN
C
C get the class name:
      CALL NEXTA4('class-name=',CLASS)
      CALL NEXTA4('AVERaging=',STEMP)
      DO I=1,NOECCN
      CALL EQSTWC(NOECNM(I),4,CLASS,4,1,1,MATCH)
      IF (MATCH) THEN
      IF (STEMP.EQ.'R-6') THEN
      WRITE(6,'(A)')
     & 'R-6 distance-averaging.'
      NOEAVE(I)=NOEM6
      ELSE IF (STEMP.EQ.'R-3') THEN
      NOEAVE(I)=NOEM3
      ELSE IF (STEMP.EQ.'SUM') THEN
      NOEAVE(I)=NOESUM
      ELSE IF (STEMP.EQ.'CENT') THEN
      NOEAVE(I)=NOECEN
      ELSE
      CALL DSPERR('NOE','unknown averaging option')
      END IF
      END IF
      END DO
      IF (STEMP.EQ.'CENT'.AND.EMODE.EQ.'ON') THEN
      WRITE(6,'(A)')
     &'center averaging not compatible with ensemble-averaging',
     &'==> ensemble averaging turned OFF'
      EMODE='OFF'
      ENDIF
C====================================================================
      ELSE IF (WD(1:4).EQ.'MONO') THEN
C
C get the class name:
      CALL NEXTA4('class-name=',CLASS)
      CALL NEXTI('MONOmers=',NN)
      DO I=1,NOECCN
      CALL EQSTWC(NOECNM(I),4,CLASS,4,1,1,MATCH)
      IF (MATCH) NMONO(I)=NN
      END DO
C====================================================================
      ELSE IF (WD(1:4).EQ.'TAVE') THEN
C get the class name:
      CALL NEXTA4('class-name=',CLASS)
C defaults
C
C parsing
      CALL PUSEND('TAVErage>')
      DO WHILE (.NOT. DONE)
      CALL NEXTWD('TAVErage>')
C
      IF (WD(1:4).EQ.'HELP') THEN
C
         CALL CNSHELP('cns-noe-taverage')
C
      ELSE IF (WD(1:3).EQ.'TAU') THEN
      CALL NEXTI('TAU [steps]=',NN)
      DO I=1,NOECCN
      CALL EQSTWC(NOECNM(I),4,CLASS,4,1,1,MATCH)
      IF (MATCH) THEN
      MEMTAU(I)=NN
      END IF
      END DO
C
      ELSE IF (WD(1:3).EQ.'EXP') THEN
      CALL NEXTI('EXPOnent=',NN)
      DO I=1,NOECCN
      CALL EQSTWC(NOECNM(I),4,CLASS,4,1,1,MATCH)
      IF (MATCH) THEN
      DAVEXP(I)=NN
      END IF
      END DO
C
      ELSE IF (WD(1:4).EQ.'RESE') THEN
      CALL NEXTWD('RESEt=')


      IF (WD(1:4).EQ.'CURR') THEN
      SRESET='CURR'
      ELSEIF (WD(1:4).EQ.'CONS') THEN
      SRESET='CONS'
      ELSE
      CALL DSPERR('taverage','unknown reset option.')
      END IF
      DO I=1,NOECCN
      CALL EQSTWC(NOECNM(I),4,CLASS,4,1,1,MATCH)
      IF (MATCH) THEN
      CALL RESETN(I,HEAP(HPNCND),HEAP(HPNRAV),HEAP(HPNDIS),SRESET)
      END IF
      END DO
C
      ELSE IF (WD(1:2).EQ.'ON') THEN
      DO I=1,NOECCN
      CALL EQSTWC(NOECNM(I),4,CLASS,4,1,1,MATCH)
      IF (MATCH) THEN
      TMODE(I)='ON'
      END IF
      END DO
C
      ELSE IF (WD(1:3).EQ.'OFF') THEN
      DO I=1,NOECCN
      CALL EQSTWC(NOECNM(I),4,CLASS,4,1,1,MATCH)
      IF (MATCH) THEN
      TMODE(I)='OFF'
      END IF
      END DO
C
      ELSE IF (WD(1:4).EQ.'STAT') THEN
      DO I=1,NOECCN
      CALL EQSTWC(NOECNM(I),4,CLASS,4,1,1,MATCH)
      IF (MATCH) THEN
      TMODE(I)='STAT'
      END IF
      END DO
C
      ELSE IF (WD(1:4).EQ.'FORC') THEN
      CALL NEXTWD('FORCe=')
      IF (WD(1:4).EQ.'CONS') THEN
      DO I=1,NOECCN
      CALL EQSTWC(NOECNM(I),4,CLASS,4,1,1,MATCH)
      IF (MATCH) THEN
      TFMODE(I)='CONS'
      END IF
      END DO
      ELSEIF (WD(1:4).EQ.'NONC') THEN
      DO I=1,NOECCN
      CALL EQSTWC(NOECNM(I),4,CLASS,4,1,1,MATCH)
      IF (MATCH) THEN
      TFMODE(I)='NONC'
      END IF
      END DO
      ELSE
      CALL DSPERR('taverage','unknown force option.')
      END IF
C
      ELSE
      CALL CHKEND('TAVErage>',DONE)
      END IF
      END DO
      DONE=.FALSE.
C
C====================================================================
      ELSE IF (WD(1:4).EQ.'RAVE') THEN
C get the class name:
      CALL NEXTA4('class-name=',CLASS)
C defaults
C
C parsing
      CALL PUSEND('RAVErage>')
      DO WHILE (.NOT. DONE)
      CALL NEXTWD('RAVErage>')
C
      IF (WD(1:4).EQ.'HELP') THEN
C
         CALL CNSHELP('cns-noe-raverage')
C
      ELSE IF (WD(1:3).EQ.'EXP') THEN
      CALL NEXTI('EXPOnent=',NN)
      DO I=1,NOECCN
      CALL EQSTWC(NOECNM(I),4,CLASS,4,1,1,MATCH)
      IF (MATCH) THEN
      RAVEXP(I)=NN
      END IF
      END DO
C
      ELSE IF (WD(1:2).EQ.'ON') THEN
      DO I=1,NOECCN
      CALL EQSTWC(NOECNM(I),4,CLASS,4,1,1,MATCH)
      IF (MATCH) THEN
      RMODE(I)='ON'
      END IF
      END DO
C
      ELSE IF (WD(1:3).EQ.'OFF') THEN
      DO I=1,NOECCN
      CALL EQSTWC(NOECNM(I),4,CLASS,4,1,1,MATCH)
      IF (MATCH) THEN
      RMODE(I)='OFF'
      END IF
      END DO
C
      ELSE IF (WD(1:4).EQ.'RESE') THEN
      CALL NEXTWD('RESEt=')
      IF (WD(1:4).EQ.'CURR') THEN
      SRESET='CURR'
      ELSEIF (WD(1:4).EQ.'CONS') THEN
      SRESET='CONS'
      ELSE
      CALL DSPERR('raverage','unknown reset option.')
      END IF
      DO I=1,NOECCN
      CALL EQSTWC(NOECNM(I),4,CLASS,4,1,1,MATCH)
      IF (MATCH) THEN
      CALL RESETN(I,HEAP(HPNCND),HEAP(HPNRRV),HEAP(HPNDIS),SRESET)
      CALL RESETC(I,HEAP(HPNNSP),HEAP(HPNCND))
      END IF
      END DO
C
      ELSE
      CALL CHKEND('RAVErage>',DONE)
      END IF
      END DO
      DONE=.FALSE.
C
C====================================================================
      ELSE IF (WD(1:4).EQ.'POTE') THEN
C
C get the class name:
      CALL NEXTA4('class-name=',CLASS)
      CALL NEXTA4('POTEntial=',STEMP)
      DO I=1,NOECCN
      CALL EQSTWC(NOECNM(I),4,CLASS,4,1,1,MATCH)
      IF (MATCH) THEN
      IF (STEMP.EQ.'BIHA') THEN
      NOEPOT(I)=NOEBIH
      ELSE IF (STEMP.EQ.'SQUA') THEN
      NOEPOT(I)=NOESQW
      ELSE IF (STEMP.EQ.'SOFT') THEN
      NOEPOT(I)=NOESOF
      ELSE IF (STEMP.EQ.'SYMM') THEN
      NOEPOT(I)=NOESYM
      ELSE IF (STEMP.EQ.'HIGH') THEN
      NOEPOT(I)=NOEHDI
      ELSE IF (STEMP.EQ.'3DPO') THEN
      NOEPOT(I)=NOE3DP
      ELSE IF (STEMP.EQ.'LOGN') THEN
      NOEPOT(I)=NOELOG
      ELSE
      CALL DSPERR('NOE','unknown potential option')
      END IF
      END IF
      END DO
C====================================================================
      ELSE IF (WD(1:4).EQ.'SQEX') THEN
C
C get the class name:
      CALL NEXTA4('class-name=',CLASS)
      CALL NEXTI('NOE exponent=',ITEMP)
      DO I=1,NOECCN
      CALL EQSTWC(NOECNM(I),4,CLASS,4,1,1,MATCH)
      IF (MATCH) NOEEXP(I)=ITEMP
      END DO
C====================================================================
      ELSE IF (WD(1:4).EQ.'SQCO') THEN
C
C get the class name:
      CALL NEXTA4('class-name=',CLASS)
      CALL NEXTF('SQUAre-constant=',RTEMP)
      DO I=1,NOECCN
      CALL EQSTWC(NOECNM(I),4,CLASS,4,1,1,MATCH)
      IF (MATCH) NOECNS(I)=RTEMP
      END DO
C====================================================================
      ELSE IF (WD(1:4).EQ.'ASQC') THEN
C
C get the chi2 values in NOERM2:
      CALL NOEPRI(1000.0D0, 0,.FALSE.,0)
C
C get the class name:
      CALL NEXTA4('class-name=',CLASS)
      DO I=1,NOECCN
      CALL EQSTWC(NOECNM(I),4,CLASS,4,1,1,MATCH)
      IF (MATCH) THEN
      IF (NOENU2(I).GT.0) THEN
C assign the force constant automatically as Kboltz*T*N/chi2
C we use T=300 since this is the value used for the CSDX force field
      NOECNS(I)=KBOLTZ*NOETEM*FLOAT(NOENU2(I))/(TWO*NOERM2(I))
      WRITE(6,'(A,A,A,F15.5)')' NOE: weight for class ',NOECNM(I),':', 
     &  NOECNS(I)
      END IF
      END IF
      END DO
C====================================================================
      ELSE IF (WD(1:4).EQ.'SQOF') THEN
C
C get the class name:
      CALL NEXTA4('class-name=',CLASS)
      CALL NEXTF('SQOFfset=',RTEMP)
      DO I=1,NOECCN
      CALL EQSTWC(NOECNM(I),4,CLASS,4,1,1,MATCH)
      IF (MATCH) NOEOFF(I)=RTEMP
      END DO
C====================================================================
      ELSE IF (WD(1:4).EQ.'SQMO') THEN
C
C get the class name:
      CALL NEXTA4('class-name=',CLASS)
      CALL NEXTF('SQMOFfset=',RTEMP)
      DO I=1,NOECCN
      CALL EQSTWC(NOECNM(I),4,CLASS,4,1,1,MATCH)
      IF (MATCH) NOEMOF(I)=RTEMP
      END DO
C====================================================================
      ELSE IF (WD(1:4).EQ.'SOEX') THEN
C
C get the class name:
      CALL NEXTA4('class-name=',CLASS)
      CALL NEXTI('SOEXponent=',II)
      DO I=1,NOECCN
      CALL EQSTWC(NOECNM(I),4,CLASS,4,1,1,MATCH)
      IF (MATCH) NOESOE(I)=II
      END DO
C====================================================================
      ELSE IF (WD(1:4).EQ.'RSWI') THEN
C
C get the class name:
      CALL NEXTA4('class-name=',CLASS)
      CALL NEXTF('RSWItch=',RTEMP)
      DO I=1,NOECCN
      CALL EQSTWC(NOECNM(I),4,CLASS,4,1,1,MATCH)
      IF (MATCH) NOESWI(I)=RTEMP
      END DO
C====================================================================
      ELSE IF (WD(1:4).EQ.'ASYM') THEN
C
C get the class name:
      CALL NEXTA4('class-name=',CLASS)
      CALL NEXTF('ASYMptote=',RTEMP)
      DO I=1,NOECCN
      CALL EQSTWC(NOECNM(I),4,CLASS,4,1,1,MATCH)
      IF (MATCH) NOEASY(I)=RTEMP
      END DO
C====================================================================
      ELSE IF (WD(1:4).EQ.'MSOE') THEN
C
C get the class name:
      CALL NEXTA4('class-name=',CLASS)
      CALL NEXTI('SOEXponent=',II)
      DO I=1,NOECCN
      CALL EQSTWC(NOECNM(I),4,CLASS,4,1,1,MATCH)
      IF (MATCH) NOEMSO(I)=II
      END DO
C====================================================================
      ELSE IF (WD(1:4).EQ.'MRSW') THEN
C
C get the class name:
      CALL NEXTA4('class-name=',CLASS)
      CALL NEXTF('RSWItch=',RTEMP)
      DO I=1,NOECCN
      CALL EQSTWC(NOECNM(I),4,CLASS,4,1,1,MATCH)
      IF (MATCH) NOEMSW(I)=RTEMP
      END DO
C====================================================================
      ELSE IF (WD(1:4).EQ.'MASY') THEN
C
C get the class name:
      CALL NEXTA4('class-name=',CLASS)
      CALL NEXTF('ASYMptote=',RTEMP)
      DO I=1,NOECCN
      CALL EQSTWC(NOECNM(I),4,CLASS,4,1,1,MATCH)
      IF (MATCH) NOEMAS(I)=RTEMP
      END DO
C====================================================================
      ELSE IF (WD(1:4).EQ.'NCOU') THEN
C
C get the class name:
      CALL NEXTA4('class-name=',CLASS)
      CALL NEXTI('NCOUnt=',II)
      IF (II.GT.20) THEN
      CALL WRNDIE(-5,'NOE>','maximum value NCOUnt is 20. ')
      END IF
      DO I=1,NOECCN
      CALL EQSTWC(NOECNM(I),4,CLASS,4,1,1,MATCH)
      IF (MATCH) NOECOR(I)=II

      END DO
C====================================================================
      ELSE IF (WD(1:4).EQ.'BHIG') THEN
C
C get the class name:
      CALL NEXTA4('class-name=',CLASS)
      CALL NEXTF('BHIGht=',RTEMP)
      DO I=1,NOECCN
      CALL EQSTWC(NOECNM(I),4,CLASS,4,1,1,MATCH)
      IF (MATCH) NOEBAR(I)=RTEMP
      END DO

C====================================================================
      ELSE IF (WD(1:4).EQ.'DIST') THEN
C
C get the class name:
      CALL NEXTA4('class-name=',CLASS)
      CALL NEXTA4('class-name=',CLASS2)
      CALL NEXTF('switch-value=',NOEDST)
      ICL1=0
      ICL2=0
      DO I=1,NOECCN
      CALL EQSTWC(NOECNM(I),4,CLASS,4,1,1,MATCH)
      IF (MATCH) ICL1=I
      CALL EQSTWC(NOECNM(I),4,CLASS2,4,1,1,MATCH)
      IF (MATCH) ICL2=I
      END DO
      IF ((ICL1*ICL2).GT.0) THEN
      CALL DISNOE(ICL1,ICL2,NOEDST,HEAP(HPNCND))

      END IF
C====================================================================
      ELSE IF (WD(1:4).EQ.'COUN') THEN
C
C get the class name:
      CALL NEXTA4('class-name=',CLASS)
      ICL1=0
      DO I=1,NOECCN
      CALL EQSTWC(NOECNM(I),4,CLASS,4,1,1,MATCH)
      IF (MATCH) ICL1=I
      END DO
      IF (ICL1.GT.0) THEN
      CALL COUNTV(ICL1,HEAP(HPNCND))
      END IF
C====================================================================
      ELSE IF (WD(1:4).EQ.'PRIN') THEN
      CALL NEXTWD('PRINt>')
      IF (WD(1:4).NE.'THRE') THEN
      WRITE(6,'(A)') ' %NOE-ERR: print expects THREshold parameter'
      ELSE
      CALL NEXTF('THREshold=',THRESH)
      CALL NOEPRI(THRESH,0,.TRUE.,0)
      IF (NOEICV.GT.0) CALL NOEPRI(THRESH,1,.TRUE.,0)
      END IF
C====================================================================
      ELSE IF (WD(1:3).EQ.'RMS') THEN
      THRESH=100.0D0
      CALL NEXTA4('class-name=',CLASS)
      ICL1=-1
      DO I=1,NOECCN
      CALL EQSTWC(NOECNM(I),4,CLASS,4,1,1,MATCH)
      IF (MATCH) ICL1=I
      END DO
      CALL NOEPRI(THRESH,0,.FALSE.,ICL1)
      IF (NOEICV.GT.0) CALL NOEPRI(THRESH,1,.FALSE.,ICL1)
C====================================================================
      ELSE IF (WD(1:4).EQ.'ANAL') THEN
      CALL NEXTA4('ANALyse=',RANA)
C====================================================================
      ELSE IF (WD(1:2).EQ.'CV') THEN
      CALL NEXTI('CV excluded partition number:',NOEICV)
C====================================================================
      ELSE IF (WD(1:4).EQ.'PART') THEN
      CALL NEXTI('number of PARTitions:',ITEMP)
      ITEMP=MAX(0,ITEMP)
      CALL NOECVS(NOENUM,HEAP(HPNCV),ITEMP)
      IF (ITEMP.EQ.0) THEN
      NOEICV=0
      END IF
C====================================================================
      ELSE IF (WD(1:4).EQ.'PRED') THEN
      CALL NOEPRD(ISLCT,JSLCT)
C====================================================================
      ELSE IF (WD(1:4).EQ.'ENSE') THEN
C
C parsing
      CALL PUSEND('ENSEmble>')
      DO WHILE (.NOT. DONE)
      CALL NEXTWD('ENSEmble>')
C
      IF (WD(1:4).EQ.'HELP') THEN
C
         CALL CNSHELP('cns-noe-ensemble')
C
      ELSE IF (WD(1:2).EQ.'ON') THEN
      EMODE='ON'
      WRITE(6,'(A,A3)') 'ensemble-averaging turned ',EMODE
      IEMODE = 0
      DO I=1,NOECCN
      IF (NOEAVE(I).EQ.NOECEN) THEN
      IEMODE = 1
      END IF
      END DO
      IF (IEMODE.EQ.1) THEN
      WRITE(6,'(A)')
     & ' center averaging not compatible with ensemble-averaging',
     & ' ==> ensemble-averaging turned OFF'
      EMODE='OFF'
      END IF
C
      ELSE IF (WD(1:3).EQ.'OFF') THEN
      EMODE='OFF'
      DIENS=' '
      IDIMER=0
      WRITE(6,'(A,A3)') 'ensemble-averaging turned ',EMODE
C
      ELSE IF (WD(1:4).EQ.'DIME') THEN
      DIENS='DIME'
      IDIMER=IDIMER+1
      IF (IDIMER.GT.MAXMOD) THEN
      WRITE(6,'(A)')
     & ' maximum number of allowed interactions for ',
     & ' ensemble-averaged restraints exceeded'
      CALL WRNDIE(-1,'ENSE',
     & ' exceeded MAXMOD parameter --> recompile program')
      END IF
      CALL NEXTA4('segid #1=',ENSMOD(IDIMER,1))
      CALL NEXTA4('segid #2=',ENSMOD(IDIMER,2))
      WRITE(6,'(A,A4,A,A4)')
     & ' DIMEr NOE restraints allowed between segid''s ',
     & ENSMOD(IDIMER,1),' and ',ENSMOD(IDIMER,2)
C
      ELSE IF (WD(1:4).EQ.'OCCU') THEN
      CALL NEXTLO('OCCUpancy=', OCCU)
      IF (OCCU) THEN
      WRITE(6,'(A)') 'occupancy refinement turned ON'
      ELSE
      WRITE(6,'(A)') 'occupancy refinement turned OFF'
      END IF
      ELSE IF (WD(1:4).EQ.'RESE') THEN
      IDIMER = 0
      DIENS = ' '
C
      ELSE
      CALL CHKEND('ENSEmble>',DONE)
      END IF
      END DO
      DONE=.FALSE.
C
      ELSE
      CALL CHKEND('NOE>',DONE)
      END IF
      END IF
      END DO
      DONE=.FALSE.
      RETURN
      END
C====================================================================
      SUBROUTINE NOEASS(NOENUM,NOEORN,NOEMAX,NOECCN,NOESMX,NOEORR,
     &           NOEIPR,NOEILS,NOEJPR,NOEJLS,NOECND,NOERAV,NOERRV,
     &           NOESTP,NOEDIS,NOELOW,NOEHIG,NOEWGH,NOECV,NOEVIO,
     &           NOEXCL,NPEAKI,NOEPID,NOESPC,NOEPP1,NOEPP2,NOEHP1,
     $           NOEHP2,NOEVOL,NOECDI,
     &           NOECVO,NORSMX,NATOM,ISLCT,NISLCT,
     &           JSLCT,NJSLCT,X,Y,Z)
C
C Subroutine parses an NOE ASSIgn statement and
C puts the information into the NOE restraints list
C
C Author: Axel T. Brunger
C         extension to handle "or" restraints by Michael Nilges
C
      IMPLICIT NONE
      INCLUDE 'cns.inc'
      INCLUDE 'comand.inc'
      INCLUDE 'numbers.inc'
C I/O
      INTEGER NOENUM, NOEORN, NOEMAX, NOECCN, NOESMX, NOEORR(*)
      INTEGER NOEIPR(*),NOEILS(*),NOEJPR(*),NOEJLS(*),NOECND(*)
      DOUBLE PRECISION NOERAV(*), NOERRV(*), NOEDIS(*)
      DOUBLE PRECISION NOELOW(*), NOEHIG(*), NOEWGH(*)
      INTEGER NOECV(*), NOEVIO(*), NOESTP(*), NPEAKI, NOEPID(*)
      INTEGER NOEXCL(*)
      INTEGER NOESPC(*)
      DOUBLE PRECISION NOEPP1(*),NOEPP2(*),NOEHP1(*),NOEHP2(*)
      DOUBLE PRECISION NOEVOL(*), NOECDI(*),NOECVO(*)
      INTEGER NATOM, ISLCT(*), NISLCT, JSLCT(*), NJSLCT, NORSMX
      DOUBLE PRECISION X(*), Y(*), Z(*)
C local
      INTEGER I, II, JJ, J, TISLCT, TJSLCT, PEAKID, OLDORN
      LOGICAL SUCCES,OK
C begin
      NPEAKI=NPEAKI+1
      PEAKID=0
      SUCCES=.FALSE.
      TISLCT=0
      TJSLCT=0
      OLDORN=NOEORN
C
      WRITE (6,'(A,I5)') ' reading restraint ', NPEAKI
      IF (NOEORN.GE.NOEMAX-1) THEN
      WRITE(6,'(A)')
     & ' %NOE-ERR: allocation for NOE-restraints exceeded',
     & '              increase NRES parameter and run again'
      CALL WRNDIE(-1,'NOE>',
     & 'exceeded allocation for NOE-restraints')
      ELSE
      NOENUM=NOENUM+1
      END IF
C
      IF(NOENUM.EQ.1) NOEORR(NOENUM)=0
C
C parse fixed format portion of NOE restraint
      CALL SELCTA(ISLCT,NISLCT,X,Y,Z,.TRUE.)
      CALL SELCTA(JSLCT,NJSLCT,X,Y,Z,.TRUE.)
      CALL NEXTF('Distance=',NOEDIS(NOENUM))
      CALL NEXTF('lower-average-distance=',NOELOW(NOENUM))
      CALL NEXTF('higher-average-distance=',NOEHIG(NOENUM))
C
C initialize time-average and running average stuff
C
C set the time-averaged distance and
C running-average term to the NOE constraint distance
      NOERAV(NOENUM)=NOEDIS(NOENUM)
      NOERRV(NOENUM)=NOEDIS(NOENUM)
C
C Number of times the running-average term has been calculated
      NOESTP(NOENUM)=1
C
C assign the index into the class list
      NOECND(NOENUM)=NOECCN
C include the distance in the working set
      NOECV(NOENUM)=1
      NOEXCL(NOENUM)=1
C initialize number of violations
      NOEVIO(NOENUM)=0
C initialize peak id
      NOEPID(NOENUM)=NPEAKI
      NOESPC(NOENUM)=1
C initialize frequencies
      NOEPP1(NOENUM)=-999.0D0
      NOEPP2(NOENUM)=-999.0D0
      NOEHP1(NOENUM)=-999.0D0
      NOEHP2(NOENUM)=-999.0D0
C initialize volume
      NOEVOL(NOENUM)=ZERO
      NOECVO(NOENUM)=ZERO
      NOECDI(NOENUM)=ZERO
C initialize Iweight
      NOEWGH(NOENUM)=ONE
C
C set up the I and J lists
      DO I=1,NATOM
      IF (ISLCT(I).EQ.1.AND.JSLCT(I).EQ.1) THEN
      WRITE(6,'(A)') ' %NOESET-ERR: i and j set have to be disjoint'
      NISLCT=0
      NJSLCT=0
      END IF
      END DO
C
      IF (NISLCT.EQ.0.OR.NJSLCT.EQ.0) THEN
      WRITE(6,'(A)')' %NOESET-ERR: error in selection - no atoms spec.'
      ELSE
      SUCCES=.TRUE.
      NOEORN=NOEORN+1
C
C update maximum number of protons in each group
C      NOESMX=MAX(NOESMX,2*NISLCT)
C      NOESMX=MAX(NOESMX,2*NJSLCT)
      NOESMX=MAX(NOESMX, 2*2*NISLCT*NJSLCT)
C
      CALL MAKIND(ISLCT,NATOM,NISLCT)
      CALL MAKIND(JSLCT,NATOM,NJSLCT)
C
C now setup the I-list
      IF (NOENUM.EQ.1) NOEIPR(NOENUM)=0
      II=NOEIPR(NOEORN)
      DO I=1,NISLCT
      IF (II.GE.NOEMAX-1) THEN
      WRITE(6,'(A)')
     & ' %NOE-ERR: allocation for NOE-restraints exceeded',
     & '              increase NRES parameter and run again'
      CALL WRNDIE(-1,'NOE',
     & 'exceeded allocation for NOE-restraints')
      ELSE
      II=II+1
      END IF
      NOEILS(II)=ISLCT(I)
      END DO
      NOEIPR(NOEORN+1)=II
C
C now setup the J-list
      IF (NOENUM.EQ.1) NOEJPR(NOENUM)=0
      JJ=NOEJPR(NOEORN)
      DO J=1,NJSLCT
      IF (JJ.GE.NOEMAX-1) THEN
      WRITE(6,'(A)')
     & ' %NOE-ERR: allocation for NOE-restraints exceeded',
     & '              increase NRES parameter and run again'
      CALL WRNDIE(-1,'NOE',
     & 'exceeded allocation for NOE-restraints')
      ELSE
      JJ=JJ+1
      END IF
      NOEJLS(JJ)=JSLCT(J)
      END DO
      NOEJPR(NOEORN+1)=JJ
      END IF
C
C default parameters are parsed, check for additional keywords
      OK=.FALSE.
      DO WHILE (.NOT. OK)
      CALL NEXTWD('NOE>')
      IF (WD(1:4).EQ.'PEAK') THEN
      CALL NEXTI('PEAKid=',PEAKID)
      ELSE IF (WD(1:4).EQ.'SPEC') THEN
      CALL NEXTI('SPECtrum=',NOESPC(NOENUM))
      ELSE IF (WD(1:4).EQ.'PPM1') THEN
      CALL NEXTF('PPM(F1)=',NOEPP1(NOENUM))
      ELSE IF (WD(1:4).EQ.'PPM2') THEN
      CALL NEXTF('PPM(F2)=',NOEPP2(NOENUM))
      ELSE IF (WD(1:4).EQ.'HPM1') THEN
      CALL NEXTF('HPM(F1)=',NOEHP1(NOENUM))
      ELSE IF (WD(1:4).EQ.'HPM2') THEN
      CALL NEXTF('HPM(F2)=',NOEHP2(NOENUM))
      ELSE IF (WD(1:4).EQ.'VOLU') THEN
      CALL NEXTF('VOLUME=',NOEVOL(NOENUM))
      ELSE IF (WD(1:4).EQ.'WEIG') THEN
      CALL NEXTF('WEIGHT=',NOEWGH(NOENUM))
      ELSE IF (WD(1:4).EQ.'CV  ') THEN
      CALL NEXTI('CV=',NOECV(NOENUM))
      ELSE IF (WD(1:4).EQ.'OR  ') THEN
C
C add a restraint to the NOEORR array
      IF ((NOEORN.GE.NOEMAX-1)) THEN
      WRITE(6,'(A)')
     & ' %NOE-ERR: allocation for NOE-restraints exceeded',
     & '              increase NRES parameter and run again'
      CALL WRNDIE(-1,'NOE>',
     & 'exceeded allocation for NOE-restraints')
      ELSE
      NOEORN=NOEORN+1
      END IF
      TISLCT=TISLCT+1
C      TJSLCT=TJSLCT+NJSLCT
      CALL SELCTA(ISLCT,NISLCT,X,Y,Z,.TRUE.)
      CALL SELCTA(JSLCT,NJSLCT,X,Y,Z,.TRUE.)
C
C the rest is very similar to the normal parsing of selections above.
C set up the I and J lists
      DO I=1,NATOM
      IF (ISLCT(I).EQ.1.AND.JSLCT(I).EQ.1) THEN
      WRITE(6,'(A)') ' %NOESET-ERR: i and j set have to be disjoint'
      NISLCT=0
      NJSLCT=0
      END IF
      END DO
C
      IF (NISLCT.EQ.0.OR.NJSLCT.EQ.0) THEN
      WRITE(6,'(A)')' %NOESET-ERR: error in selection - no atoms spec.'
      NOEORN=NOEORN-1
      ELSE
      SUCCES=.TRUE.
C
C update maximum number of protons in each group
C      TISLCT=TISLCT+NISLCT
C      TJSLCT=TJSLCT+NJSLCT
C      NOESMX=MAX(NOESMX,2*TISLCT)
C      NOESMX=MAX(NOESMX,2*TJSLCT)
C
      CALL MAKIND(ISLCT,NATOM,NISLCT)
      CALL MAKIND(JSLCT,NATOM,NJSLCT)
C
C now setup the I-list
      II=NOEIPR(NOEORN)
      DO I=1,NISLCT
      IF (II.GE.NOEMAX-1) THEN
      WRITE(6,'(A)')
     & ' %NOE-ERR: allocation for NOE-restraints exceeded',
     & '              increase NRES parameter and run again'
      CALL WRNDIE(-1,'NOE',
     & 'exceeded allocation for NOE-restraints')
      ELSE
      II=II+1
      END IF
      NOEILS(II)=ISLCT(I)
      END DO
      NOEIPR(NOEORN+1)=II
C
C now setup the J-list
      JJ=NOEJPR(NOEORN)
      DO J=1,NJSLCT
      IF (JJ.GE.NOEMAX-1) THEN
      WRITE(6,'(A)')
     & ' %NOE-ERR: allocation for NOE-restraints exceeded',
     & '              increase NRES parameter and run again'
      CALL WRNDIE(-1,'NOE',
     & 'exceeded allocation for NOE-restraints')
      ELSE
      JJ=JJ+1
      END IF
      NOEJLS(JJ)=JSLCT(J)
      END DO
      NOEJPR(NOEORN+1)=JJ
      END IF

      ELSE
      CALL SAVEWD
      OK=.TRUE.
      END IF
      END DO
C
      IF (PEAKID.EQ.0) THEN
      PEAKID = NPEAKI
      END IF
C
      IF (.NOT.SUCCES) THEN
      WRITE (6,'(A,I5,4F10.3)') ' %NOE-ERR: problem at ',
     &    PEAKID, NOEPP1(NOENUM),NOEPP2(NOENUM),
     &    NOEHP1(NOENUM), NOEHP2(NOENUM)
      NOENUM=NOENUM-1
C we do not need to reduce NOEORN since it is only advanced if SUCCES
      ELSE
      WRITE(6,'(A,I5)') ' restraint successfully read: ', PEAKID
      NOEPID(NOENUM)=PEAKID
      NOEORR(NOENUM+1)=NOEORN
      END IF
C
      OLDORN=NOEORN-OLDORN+1
      NORSMX=MAX(NORSMX,OLDORN)
C
      RETURN
      END
C======================================================================
      SUBROUTINE NOEPRD(ISLCT,JSLCT)
C
C Parsing routine for NOE PREDict
C
C Author: Axel T. Brunger
C
      IMPLICIT NONE
C I/O
      INCLUDE 'cns.inc'
      INCLUDE 'comand.inc'
      INCLUDE 'heap.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'coord.inc'
      INCLUDE 'noe.inc'
      INCLUDE 'consta.inc'
      INTEGER ISLCT(*), JSLCT(*)
C local
      EXTERNAL EXCHR
      INTEGER MBOUNDS, I, UNIT
      PARAMETER (MBOUNDS=10)
      DOUBLE PRECISION CUTON, CUTOFF, BOUNDS(MBOUNDS), SCRAMBL
      DOUBLE PRECISION BSYMM, BUNSYM
      INTEGER NISLCT, NJSLCT, NBOUNDS
      LOGICAL UNIQUE, BYPASS
      CHARACTER*4 SMODE
C parameter
      DOUBLE PRECISION ZERO, TEN
      PARAMETER (ZERO=0.0D0, TEN=10.0D0)
C begin
C defaults
      SMODE='TOPO'
C topology mode
      CUTON=ZERO
      CUTOFF=TEN
      CALL FILL4(ISLCT,NATOM,1)
      CALL FILL4(JSLCT,NATOM,1)
C assignment mode
      NBOUNDS=1
      BOUNDS(1)=ZERO
      SCRAMBL=ZERO
      BSYMM=ZERO
      BUNSYM=ZERO
      UNIQUE=.FALSE.
      BYPASS=.FALSE.
      OFILE=' '
C
C parsing
      CALL PUSEND('PREDict>')
      DO WHILE (.NOT. DONE)
      CALL NEXTWD('PREDict>')
      CALL MISCOM('PREDict>',USED)
      IF (.NOT.USED) THEN
C
      IF (WD(1:4).EQ.'HELP') THEN
C
         CALL CNSHELP('cns-noe-predict')
C
      ELSE IF (WD(1:4).EQ.'TO  ') THEN
      CALL SELCTA(ISLCT,NISLCT,X,Y,Z,.TRUE.)
      ELSE IF (WD(1:4).EQ.'FROM') THEN
      CALL SELCTA(JSLCT,NJSLCT,X,Y,Z,.TRUE.)
      ELSE IF (WD(1:5).EQ.'CUTON') THEN
      CALL NEXTF('CUTON=',CUTON)
      ELSE IF (WD(1:5).EQ.'CUTOF') THEN
      CALL NEXTF('CUTOFf=',CUTOFF)
      ELSE IF (WD(1:4).EQ.'MODE') THEN
      CALL NEXTA4('MODE=',SMODE)
      ELSE IF (WD(1:5).EQ.'BSYMM') THEN
      CALL NEXTF('BSYMMetry=',BSYMM)
      ELSE IF (WD(1:6).EQ.'BUNSYM') THEN
      CALL NEXTF('BUNSYMetry=',BUNSYM)
      ELSE IF (WD(1:4).EQ.'BOUN') THEN
      IF (NBOUNDS.GE.MBOUNDS) THEN
      CALL WRNDIE(-5,'NOEPRD>',
     &    'maximum number of bounds (MBOUNDS) exceeded.')
      ELSE
      NBOUNDS=NBOUNDS+1
      END IF
      CALL NEXTF('BOUNdary=',BOUNDS(NBOUNDS))
C
C the 0 bound was already specified as default for NBOUNDS=1
      IF (ABS(BOUNDS(NBOUNDS)).LT.RSMALL) THEN
      NBOUNDS=NBOUNDS-1
      END IF
      ELSE IF (WD(1:4).EQ.'SCRA') THEN
      CALL NEXTF('SCRAmble=',SCRAMBL)
      ELSE IF (WD(1:4).EQ.'UNIQ') THEN
      CALL NEXTLO('UNIQue=',UNIQUE)
      ELSE IF (WD(1:4).EQ.'BYPA') THEN
      CALL NEXTLO('BYPAss=',BYPASS)
      ELSE IF (WD(1:4).EQ.'OUTP') THEN
      CALL NEXTFI('OUTPut=',OFILE)
      ELSE
      CALL CHKEND('PREDict>',DONE)
      END IF
      END IF
      END DO
      DONE=.FALSE.
C
      IF (SMODE.EQ.'TOPO') THEN
C
C topology mode
      IF (NOENUM.GT.0) THEN
      WRITE(6,'(A)')
     & ' NOEPRD-warning: NOE restraints database erased.'
      END IF
C
C allocate sufficient space
      CALL NOEHP(MAX(NISLCT,NJSLCT))
      CALL NOEPRE(ISLCT,JSLCT,CUTON,CUTOFF,HEAP(HPNORR),
     &     HEAP(HPNIPR),HEAP(HPNILS),HEAP(HPNJPR),HEAP(HPNJLS),
     &     HEAP(HPNCND),HEAP(HPNRAV),HEAP(HPNRRV),HEAP(HPNNSP),
     &     HEAP(HPNDIS),HEAP(HPNLOW),HEAP(HPNHIG),HEAP(HPNWGH),
     &     HEAP(HPNCV))
C
C reset the NOE database
      CALL NOERES
C
      ELSE
C use existing assignments for the predictions
C
      IF (OFILE.NE.' ') THEN
      CALL ASSFIL(OFILE,UNIT,'WRITE','FORMATTED',ERROR)
      ELSE
      UNIT=0
      END IF
C
C sort the bounds
      CALL SORT(NBOUNDS,EXCHR,ORDERR,BOUNDS,1,0,0,0,0,0,0)
      WRITE(6,'(A)') ' The following bounds will be used:'
      WRITE(6,'(A,10F8.3)') ' ',(BOUNDS(I),I=1,NBOUNDS)
      WRITE(6,'(A,F8.3,A,L1,A,L1,A,F8.3,A,F8.3)')
     & ' SCRAmbling=',SCRAMBL,'  UNIQue=',UNIQUE,'  BYPAss=',BYPASS,
     & ' BSYMMetry_error=',BSYMM,' BUNSYMetry_error=',BUNSYM
C
      CALL NOEPD2(HEAP(HPNORR),HEAP(HPNIPR),HEAP(HPNILS),
     &     HEAP(HPNJPR),HEAP(HPNJLS),HEAP(HPNCND),
     &     HEAP(HPNRAV),HEAP(HPNRRV),HEAP(HPNNSP),HEAP(HPNDIS),
     &     HEAP(HPNLOW),HEAP(HPNHIG),HEAP(HPNWGH),HEAP(HPNCV),
     &     NBOUNDS,BOUNDS,SCRAMBL,BSYMM,BUNSYM,UNIQUE,BYPASS,
     &     UNIT)
      END IF
C
      RETURN
      END
C====================================================================
      SUBROUTINE NOEPD2(NOEORR,NOEIPR,NOEILS,NOEJPR,NOEJLS,
     &           NOECND,NOERAV,NOERRV,NOESTP,NOEDIS,NOELOW,NOEHIG,
     &           NOEWGH,NOECV,NBOUNDS,BOUNDS,SCRAMBL,BSYMM,BUNSYM,
     &           UNIQUE,BYPASS,PUNIT)
C
C Routine "predicts" NOEs based on current cartesian coordinates.
C Distance ranges are declared according to the boundaries in
C array BOUNDS.  It is assumed that BOUNDS is sorted.  The
C boundaries define distances ranges by
C lower-bound=0
C upper-bound=BOUNDS (i)
C central-distance=BOUNDS(i)/2.
C
C Assigned distance restraints (NOEs) are pointed to the distance range
C that satisfies lower-bound < R < upper-bound where R is
C computed with the specified averaging option.
C
C If scramble is specified, distance restraints are randomly
C assigned to one range or the other if they are within SCRAMble
C around a boundary.
C
C If unique is specified (i.e., true) then only
C the distance restraints are "touched" with unique
C assignments.
C
C If BYPAss is specified then the NOEs are untouched.
C
C Only NOEs in the working set will be predicted.
C
C If the percentage NOE distance error (BSYMM,BUNSYM) is greater
C than zero then boundaries will be calculated for the
C "predicted NOEs.  There are two distances ranges, BUNSYM and
C BSYMM, for unsymmetrical boundaries and symmetrical boundaries.
C For BUNSYM
C lower boundary= (distance * BUNSYM) or
C                 [(distance - (distance * BUNSYM))>1.6]
C upper boundary= (distance * BUNSYM)
C For BSYMM
C lower boundary= (distance * BUNSYM)
C upper boundary= (distance * BUNSYM)
C
C Author: Axel T. Brunger, Gregory L. Warren
C
      IMPLICIT NONE
C I/O
      INCLUDE 'cns.inc'
      INCLUDE 'noe.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'pick.inc'
      INCLUDE 'consta.inc'
      INTEGER NOEORR(*), NOEIPR(*), NOEILS(*), NOEJPR(*)
      INTEGER NOEJLS(*), NOECND(*)
      DOUBLE PRECISION NOERAV(*), NOERRV(*), NOEDIS(*)
      DOUBLE PRECISION NOELOW(*), NOEHIG(*), NOEWGH(*)
      INTEGER NOESTP(*), NOECV(*), NBOUNDS
      DOUBLE PRECISION BOUNDS(*), SCRAMBL
      DOUBLE PRECISION BSYMM, BUNSYM
      LOGICAL UNIQUE, BYPASS
      INTEGER PUNIT
C local
      INTEGER N, I, K, J, CLASS, NB , KLAST
      DOUBLE PRECISION OLDDIS, OLDLOW, OLDHIG, DISTANC, RNUM, SMALLST
      DOUBLE PRECISION NEWLB, NEWUB, EN, DIFF, LOWLIM
      LOGICAL QFIRST, QUNCHG
C parameter
      DOUBLE PRECISION ZERO, TWO, HALF
      PARAMETER (ZERO=0.0D0, TWO=2.0D0, HALF=0.5D0, LOWLIM=1.6D0)
C begin
C
C loop over all classes
      DO CLASS=1,NOECCN
      IF (NOEPOT(CLASS).EQ.NOESYM.OR.
     &    NOEPOT(CLASS).EQ.NOEHDI.OR.
     &    NOEPOT(CLASS).EQ.NOE3DP) THEN
      CALL WRNDIE(-5,'NOEPD2',
     & 'PREDict not possible with POTEntial=SYMM, HIGH, or 3DPO')
      ELSE
C
C loop over all NOE's belonging to this class
      DO N=1,NOENUM
      IF (NOECV(N).NE.NOEICV.AND.NOECND(N).EQ.CLASS) THEN
C
C store old values
      OLDDIS=NOEDIS(N)
      OLDLOW=NOELOW(N)
      OLDHIG=NOEHIG(N)
C
C get distance (is returned in PCDATA(PCGEOM))
      CALL ENOE(EN,'ANAL',N)
      DISTANC=PCDATA(PCGEOM)
C
C check if UNIQUE or BYPASS is specified
      IF ((.NOT.BYPASS).AND.(.NOT.UNIQUE.OR.
     &    (NOEORR(N+1)-NOEORR(N).EQ.1.AND.
     &     NOEIPR(N+1)-(NOEIPR(N)+1).EQ.0 .AND.
     &     NOEJPR(N+1)-(NOEJPR(N)+1).EQ.0))) THEN
C
C generate the distance ranges using the percent NOE
C distance error value
      IF ((BSYMM.GT.ZERO).OR.(BUNSYM.GT.ZERO)) THEN
C test for low limit of distance
        IF (DISTANC.LT.LOWLIM) THEN
          DISTANC=LOWLIM
        END IF
C Function used generate symmetrical (BSYMM)
C  or unsymmetrical (BUNSYM) bounds
        IF (BSYMM.GT.ZERO) THEN
          NOEDIS(N)=DISTANC
          NOEHIG(N)=(DISTANC*BSYMM)
          NOELOW(N)=(DISTANC*BSYMM)
        ELSE
        NOEDIS(N)=DISTANC
        NOEHIG(N)=DISTANC*BUNSYM
        NOELOW(N)=DISTANC-(DISTANC*BUNSYM)
        IF (NOELOW(N).LT.LOWLIM) THEN
            NOELOW(N)=DISTANC-LOWLIM
        ELSE
            NOELOW(N)=DISTANC*BUNSYM
        END IF
        END IF
        QUNCHG=.FALSE.
      ELSE
C or find nearest boundary
      NB=1
      SMALLST=R4BIG
      DO I=1,NBOUNDS
      DIFF=DISTANC-BOUNDS(I)
      IF (ABS(DIFF).LT.ABS(SMALLST)) THEN
      SMALLST=DIFF
      NB=I
      END IF
      END DO
C
C scramble boundary assignment if required
      IF (ABS(SMALLST).LT.SCRAMBL) THEN
      CALL GGUBFS(RNUM)
      IF (RNUM.GE.HALF) THEN
      NB=MIN(NBOUNDS,NB+1)
      END IF
      ELSE
C
C no scrambling -- assign to appropriate range
C
C distance range is 0 < r < BOUNDS(NB+1) if DIFF is greater than
C BOUNDS(NB).
      IF (SMALLST.GE.ZERO) THEN
      NB=MIN(NBOUNDS,NB+1)
      END IF
      END IF
C
C generate the distance bounds for the restraint
      NEWLB=ZERO
      NEWUB=BOUNDS(NB)
      NOEDIS(N)=(NEWUB-NEWLB)/TWO
      NOELOW(N)=NOEDIS(N)-NEWLB
      NOEHIG(N)=NEWUB-NOEDIS(N)
C
      QUNCHG=.FALSE.
C
      END IF
C
C distance restraint is unchanged
      QUNCHG=.TRUE.
      END IF
C
      IF (PUNIT.GT.0) THEN
      WRITE(PUNIT,'(A)') ' '
      QFIRST=.TRUE.
      KLAST=NOEILS(NOEIPR(N+1))
      DO I=NOEIPR(N)+1,NOEIPR(N+1)
      K=NOEILS(I)
      IF (QFIRST) THEN
      QFIRST=.FALSE.
      IF (K.NE.KLAST) THEN
      WRITE(PUNIT,'(7A)') ' ASSIgn ((segid "',SEGID(K),
     & '" and resid ',RESID(K),' and name ',TYPE(K),')'
      ELSE
      WRITE(PUNIT,'(7A)') ' ASSIgn ((segid "',SEGID(K),
     & '" and resid ',RESID(K),' and name ',TYPE(K),'))'
      END IF
      ELSE
      IF (K.NE.KLAST) THEN
      WRITE(PUNIT,'(7A)') '      OR (segid "',SEGID(K),
     & '" and resid ',RESID(K),' and name ',TYPE(K),')'
      ELSE
      WRITE(PUNIT,'(7A)') '      OR (segid "',SEGID(K),
     & '" and resid ',RESID(K),' and name ',TYPE(K),'))'
      END IF
      END IF
      END DO
      QFIRST=.TRUE.
      KLAST=NOEJLS(NOEJPR(N+1))
      DO J=NOEJPR(N)+1,NOEJPR(N+1)
      K=NOEJLS(J)
      IF (QFIRST) THEN
      QFIRST=.FALSE.
      IF (K.NE.KLAST) THEN
      WRITE(PUNIT,'(7A)') '        ((segid "',SEGID(K),
     & '" and resid ',RESID(K),' and name ',TYPE(K),')'
      ELSE
      WRITE(PUNIT,'(7A)') '        ((segid "',SEGID(K),
     & '" and resid ',RESID(K),' and name ',TYPE(K),'))'
      END IF
      ELSE
      IF (K.NE.KLAST) THEN
      WRITE(PUNIT,'(7A)') '      OR (segid "',SEGID(K),
     & '" and resid ',RESID(K),' and name ',TYPE(K),')'
      ELSE
      WRITE(PUNIT,'(7A)') '      OR (segid "',SEGID(K),
     & '" and resid ',RESID(K),' and name ',TYPE(K),'))'
      END IF
      END IF
      END DO
      IF (QUNCHG) THEN
      WRITE(PUNIT,'(A,3F10.4,A,F10.4,A)')
     & '    ',NOEDIS(N),NOELOW(N),NOEHIG(N),
     & ' { unchanged } { R=',DISTANC,'}'
      ELSE
      WRITE(PUNIT,'(A,3F10.4,A,3F10.4,A)')
     & '    ',NOEDIS(N),NOELOW(N),NOEHIG(N),
     & ' { previous: ',OLDDIS,OLDLOW,OLDHIG,' }'
      END IF
      END IF
C
      END IF
      END DO
      END IF
      END DO
C
      RETURN
      END
C====================================================================
CMNTODO: implement noeorr array, for simplest case
      SUBROUTINE NOEPRE(ISLCT,JSLCT,CUTON,CUTOFF,
     &           NOEORR,NOEIPR,NOEILS,
     &           NOEJPR,NOEJLS,NOECND,NOERAV,NOERRV,NOESTP,NOEDIS,
     &           NOELOW,NOEHIG,NOEWGH,NOECDI,NOECV)
C
C predicts NOE distances
C Author: Axel T. Brunger
      IMPLICIT NONE
C I/O
      INCLUDE 'cns.inc'
      INCLUDE 'noe.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'pick.inc'
      INCLUDE 'comand.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'heap.inc'
      INTEGER ISLCT(*), JSLCT(*)
      DOUBLE PRECISION CUTON, CUTOFF
      INTEGER NOEORR(*),NOEIPR(*), NOEILS(*), NOEJPR(*)
      INTEGER NOEJLS(*), NOECND(*)
      DOUBLE PRECISION NOERAV(*), NOERRV(*), NOEDIS(*)
      DOUBLE PRECISION NOELOW(*), NOEHIG(*), NOEWGH(*), NOECDI(*)
      INTEGER NOESTP(*), NOECV(*)
C local
      INTEGER IG, JG, IAT, JAT, IGSLCT, JGSLCT, KGSLCT, LGSLCT, K
      DOUBLE PRECISION EN
      INTEGER DDX, DDY, DDZ
C parameter

      DOUBLE PRECISION ZERO
      PARAMETER (ZERO=0.0D0)
C begin
C
C loop over group-group pairs
      DO IG=1,NGRP
      IGSLCT=0
      KGSLCT=0
      DO IAT=IGPBS(IG)+1,IGPBS(IG+1)
      IGSLCT=IGSLCT+ISLCT(IAT)
      KGSLCT=KGSLCT+JSLCT(IAT)
      END DO
      IF (IGSLCT.GT.0) THEN
      DO JG=1,NGRP
      JGSLCT=0
      LGSLCT=0
      DO JAT=IGPBS(JG)+1,IGPBS(JG+1)
      JGSLCT=JGSLCT+JSLCT(JAT)
      LGSLCT=LGSLCT+ISLCT(JAT)
      END DO
      IF (JGSLCT.GT.0) THEN
C
C avoid duplications for group pairs
      IF (.NOT.(KGSLCT.GT.0.AND.LGSLCT.GT.0.AND.IG.GE.JG)) THEN
C
C now fill a dummy NOE table
      NOENUM=1
      NOEORR(1)=0
      NOEORR(2)=1
      NOEIPR(1)=0
      NOEIPR(2)=0
      DO IAT=IGPBS(IG)+1,IGPBS(IG+1)
      IF (ISLCT(IAT).GT.0) THEN
      NOEIPR(2)=NOEIPR(2)+1
      NOEILS(NOEIPR(2))=IAT
      END IF
      END DO
      NOEJPR(1)=0
      NOEJPR(2)=0
      DO JAT=IGPBS(JG)+1,IGPBS(JG+1)
      IF (JSLCT(JAT).GT.0) THEN
      NOEJPR(2)=NOEJPR(2)+1
      NOEJLS(NOEJPR(2))=JAT
      END IF
      END DO
      NOELOW(1)=1.0D0
      NOEHIG(1)=1.0D0
      NOECND(1)=1
      NOESCA(1)=1.0D0
      NOEAVE(1)=NOEM6
      NOEPOT(1)=NOEBIH
      NOEDIS(1)=1.0D0
      NOEWGH(1)=1.0D0
C
C symmetry stuff
      NMONO(1)=1
C
C reset time and running-average stuff
      NOESTP(1)=0
      DAVEXP(1)=3
      RAVEXP(1)=3
      MEMTAU(1)=1000.
      TMODE(1)='OFF'
      RMODE(1)='OFF'
      TFMODE(1)='CONS'
C
C update maximum number of protons in each group
C      NOESMX=MAX(NOEIPR(2),NOESMX)
C      NOESMX=MAX(NOEJPR(2),NOESMX)
      NOESMX=MAX(NOESMX,NOEIPR(2)*NOEJPR(2))
      DDX=ALLHP(IREAL8(NORSMX*NOESMX))
      DDY=ALLHP(IREAL8(NORSMX*NOESMX))
      DDZ=ALLHP(IREAL8(NORSMX*NOESMX))
      CALL ENOE2(EN,'ANAL',1,HEAP(DDX),HEAP(DDY),HEAP(DDZ),
     &     NOEORR,NOEIPR,NOEILS,
     &     NOEJPR,NOEJLS,NOECND,
     &     NOERAV,NOERRV,NOESTP,NOEDIS,
     &     NOELOW,NOEHIG,NOEWGH,NOECDI,NOECV)
      CALL FREHP(DDX,IREAL8(NORSMX*NOESMX))
      CALL FREHP(DDY,IREAL8(NORSMX*NOESMX))
      CALL FREHP(DDZ,IREAL8(NORSMX*NOESMX))
      IF (PCDATA(PCGEOM).GT.CUTON.AND.PCDATA(PCGEOM).LT.CUTOFF) THEN
      WRITE(PUNIT,'(A)') ' ========================================'
      WRITE(PUNIT,'(A)') ' set-i-atoms'
      DO IAT=NOEIPR(1)+1,NOEIPR(2)
      K=NOEILS(IAT)
      WRITE(PUNIT,'(9X,4(1X,A))') SEGID(K),RESID(K),RES(K),TYPE(K)
      END DO
      WRITE(PUNIT,'(A)') ' set-j-atoms'
      DO JAT=NOEJPR(1)+1,NOEJPR(2)
      K=NOEJLS(JAT)
      WRITE(PUNIT,'(9X,4(1X,A))') SEGID(K),RESID(K),RES(K),TYPE(K)
      END DO
      WRITE(PUNIT,'(A,F8.3)')
     &  ' ( ( <R^-6> )^-1/6 )        =        ',PCDATA(PCGEOM)
      END IF
C
      END IF
      END IF
      END DO
      END IF
      END DO
C
      RETURN
      END
C====================================================================
      SUBROUTINE NOEPRI(THRESH,ITEST,QPRINT,ICL)
C
C print a list of current NOE restraints
C Front-end for NOEPR2
      IMPLICIT NONE
C I/O
      INCLUDE 'cns.inc'
      INCLUDE 'heap.inc'
      INCLUDE 'noe.inc'
      DOUBLE PRECISION THRESH
      LOGICAL QPRINT
      INTEGER ITEST,ICL
C begin
      CALL NOEPR2(
     &           HEAP(HPNORR),HEAP(HPNIPR),HEAP(HPNILS),HEAP(HPNJPR),
     &           HEAP(HPNJLS),HEAP(HPNCND),HEAP(HPNRAV),HEAP(HPNRRV),
     &           HEAP(HPNDIS),HEAP(HPNLOW),HEAP(HPNHIG),HEAP(HPNVOL),
     &           HEAP(HPNPP1),HEAP(HPNPP2),HEAP(HPNHP1),HEAP(HPNHP2),
     &           HEAP(HPNWGH),HEAP(HPNVIO),
     &           HEAP(HPNNSP),HEAP(HPNCV), HEAP(HPNPID),
     $           HEAP(HPNSPC),THRESH,QPRINT,ITEST,ICL)

      RETURN
      END
C====================================================================
      SUBROUTINE NOEPR2(
     &     NOEORR,NOEIPR,NOEILS,NOEJPR,NOEJLS,NOECND,
     &     NOERAV,NOERRV,NOEDIS,NOELOW,NOEHIG,NOEVOL,
     &     NOEPP1,NOEPP2,NOEHP1,NOEHP2,NOEWGH,NOEVIO,
     &     NOESTP,NOECV,NOEPID,NOESPC,THRESH,QPRINT,ITEST,ICL)
      IMPLICIT NONE
C     I/O
      INCLUDE 'cns.inc'
      INCLUDE 'noe.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'pick.inc'
      INCLUDE 'comand.inc'
      INCLUDE 'numbers.inc'
      DOUBLE PRECISION THRESH
      LOGICAL QPRINT
      INTEGER ITEST,ICL
C     
C     global NOE arrays on HEAP
C     restraint and atom pointers
      INTEGER NOEORR(*),NOEIPR(*),NOEILS(*),NOEJPR(*),NOEJLS(*)
C     classes
      INTEGER NOECND(*)
C     averages
      DOUBLE PRECISION NOERAV(*),NOERRV(*)
C     target distance and errors
      DOUBLE PRECISION NOEDIS(*),NOELOW(*),NOEHIG(*)
C     volume, chemical shifts
      DOUBLE PRECISION NOEVOL(*),NOEPP1(*),NOEPP2(*),
     $     NOEHP1(*),NOEHP2(*)
C     weights
      DOUBLE PRECISION NOEWGH(*)
C     number of violations
      INTEGER NOEVIO(*)
C     time average pointer, test set, restraint number
      INTEGER NOESTP(*), NOECV(*), NOEPID(*)
C     spectrum name
      INTEGER NOESPC(*)
C     
C     local
      DOUBLE PRECISION EN, NOERMS
C     noerm2 and noenu2 now in noe.inc
C     DOUBLE PRECISION NOERM2(NOECMX)
      DOUBLE PRECISION NOEVSM, NOEVS2(NOECMX)
      DOUBLE COMPLEX DBCOMP
      DOUBLE PRECISION DBPREC
C     INTEGER NOENU2(NOECMX)
      INTEGER NOEVIT
      INTEGER N, K, I, J, CLASS, NOENUML, NORR, FIRSTCLASS, LASTCLASS
      CHARACTER*6 SSAVE
      CHARACTER*11 SSPOT
      LOGICAL QHEAD
C     begin
C
      DO CLASS=1,NOECMX
         NOENU2(CLASS)=0
         NOERM2(CLASS)=ZERO
         NOEVS2(CLASS)=ZERO
         NOEVIO(CLASS)=0
      END DO
      NOERMS=ZERO
      NOEVSM=ZERO
      NOEVIT=0
      NOENUML=0
C
C     if a class is specified (ICL>0) use it, else loop over all
C     classes. if class not known (icl<0) skip calculation
      IF (ICL.GT.0) THEN
         FIRSTCLASS=ICL
         LASTCLASS=ICL
      ELSE
         FIRSTCLASS=1
         LASTCLASS=NOECCN
      END IF
C
      IF (NOENUM.GT.0.AND.ICL.GE.0) THEN
C     
         IF (QPRINT) THEN
            IF (NOEICV.GT.0) THEN
               IF (ITEST.EQ.0) THEN
                  WRITE(PUNIT,'(A)')

     &                 ' $$$$$$$$$$$$$$$$$$ working set $$$$$$$$$
     $                 $$$$$$$$$$$$$$$$$$$$$'
               ELSE
                  WRITE(PUNIT,'(A,I5,A)')

     &                 ' $$$$$$$$$$$$$$$$$$$$ test set (TEST=',NOEICV,
     &                 ')  $$$$$$$$$$$$$$$$$$$$$$'
               END IF
            END IF
         END IF
C     
         DO CLASS=FIRSTCLASS,LASTCLASS
            IF (NOEPOT(CLASS).EQ.NOESYM.OR.
     &           NOEPOT(CLASS).EQ.NOEHDI.OR.
     &           NOEPOT(CLASS).EQ.NOE3DP) THEN
               CALL WRNDIE(-1,'NOEPRI',
     &              'PRINt not possible with POTEntial set to
     $              SYMM, HIGH, or 3DPO')
            ELSE
C     
C     loop over all NOE's belonging to this class
               QHEAD=.TRUE.
               DO N=1,NOENUM
                  IF ((ITEST.EQ.0.AND.NOECV(N).NE.NOEICV).OR.
     &                 (ITEST.EQ.1.AND.NOECV(N).EQ.NOEICV)) THEN
                     IF (NOECND(N).EQ.CLASS) THEN
                        NOENUML=NOENUML+1
C     
C     get energy and other results
                        CALL ENOE(EN,'ANAL',N)
                        NOERMS=NOERMS+PCDATA(PCDEVI)**2
                        NOEVSM=NOEVSM+ABS(PCDATA(PCDEVI))
                        NOERM2(CLASS)=NOERM2(CLASS)+PCDATA(PCDEVI)**2
                        NOEVS2(CLASS)=NOEVS2(CLASS)+ABS(PCDATA(PCDEVI))
                        NOENU2(CLASS)=NOENU2(CLASS)+1
                        IF (ABS(PCDATA(PCDEVI)).GT.THRESH) THEN
                           NOEVIO(CLASS)=NOEVIO(CLASS)+1
                           NOEVIT=NOEVIT+1
                        END IF
C     
C     if deviation greater than threshold then print the NOE
                        IF (QPRINT.AND.(ABS(PCDATA(PCDEVI)).
     $                       GT.THRESH)) THEN
C     
C     check whether we've to print the header for this class
                           IF (QHEAD) THEN
                              QHEAD=.FALSE.
                              WRITE(PUNIT,'(/2A/,3A)')
     &     ' +++++++++++++++++++++++++++++++++++++++',
     &     '+++++++++++++++++++++++++++++++++++++++',
     &     ' +++++++++++++++++++++++++++++++ CLASS ',NOECNM(CLASS),
     &     ' +++++++++++++++++++++++++++++++++++'
                              IF (NOEAVE(NOECND(N)).EQ.NOEM6) THEN
                                 SSAVE='R-6   '
                              ELSE IF (NOEAVE(NOECND(N)).EQ.NOEM3)
     $                                THEN
                                 SSAVE='R-3   '
                              ELSE IF (NOEAVE(NOECND(N)).EQ.NOESUM)
     $                                THEN
                                 SSAVE='sum'
                              ELSE IF (NOEAVE(NOECND(N)).EQ.NOECEN)
     $                                THEN
                                 SSAVE='center'
                              END IF
                              IF (NOEPOT(NOECND(N)).EQ.NOEBIH) THEN
                                 SSPOT='biharmonic '
                              ELSE IF (NOEPOT(NOECND(N)).EQ.NOESQW)
     $                                THEN
                                 SSPOT='square-well'
                              ELSE IF (NOEPOT(NOECND(N)).EQ.NOESOF)
     $                                THEN
                                 SSPOT='soft-square'
                              ELSE IF (NOEPOT(NOECND(N)).EQ.NOELOG)
     $                                THEN
                                 SSPOT='log-normal'
                              END IF
                              WRITE(PUNIT,'(A,F8.3,4A)')
     &                             ' for this class: SCALe=',
     $                             NOESCA(NOECND(N)),
     &                             ' AVERage=',SSAVE,' POTEntial=',
     $                             SSPOT
                              IF (NOEPOT(NOECND(N)).EQ.NOEBIH) THEN
                                 WRITE(PUNIT,'(A,F8.3)')
     &                                '                 TEMPerature=
     $                                ',NOETEM
                              ELSE IF (NOEPOT(NOECND(N)).EQ.NOESQW)
     $                                THEN
                                 WRITE(PUNIT,'(A,F8.3,A,I5,A,2F8.3)')
     &                                '                 SQCOnstant=',
     $                                NOECNS(NOECND(N)),
     &                                ' SQEXponent=',NOEEXP(NOECND(N)),
     &                                ' SQOFfsets(+/-)=',
     $                                NOEOFF(NOECND(N)),
     $                                NOEMOF(NOECND(N))
                              ELSE IF (NOEPOT(NOECND(N)).EQ.NOESOF)
     $                                THEN
                                 WRITE(PUNIT,'(A,F8.3,A,I5,A,2F8.3/A,
     $                                I5,A,F8.3,A,F8.3)')
     &                                '                 SQCOnstant=',
     $                                NOECNS(NOECND(N)),
     &                                ' SQEXponent=',NOEEXP(NOECND(N)),
     &                                ' SQOFfsets(+/-)=',
     $                                NOEOFF(NOECND(N)),
     $                                NOEMOF(NOECND(N)),
     &                                '                 SOEXponent=',
     $                                NOESOE(NOECND(N)),
     &                                ' RSWItch=',NOESWI(NOECND(N)),
     &                                ' ASYMptote=',NOEASY(NOECND(N))
                              ELSE IF (NOEPOT(NOECND(N)).EQ.NOELOG)
     $                                THEN
                                 WRITE(PUNIT,'(A,F8.3)')
     &                                '                 SQCOnstant=',
     $                                NOECNS(NOECND(N))
                              END IF
                              WRITE(PUNIT,'(A)') ' '
                           END IF ! QHEAD
C     
                           WRITE(PUNIT,'(A,I5,A,I5,A)')
     &                          ' ========== spectrum ', NOESPC(N),
     $                          ' restraint ',NOEPID(N),' =========='
                           DO NORR=NOEORR(N)+1, NOEORR(N+1)
                              WRITE(PUNIT,'(A)') ' set-i-atoms'
                              DO I=NOEIPR(NORR)+1,NOEIPR(NORR+1)
                                 K=NOEILS(I)
                                 WRITE(PUNIT,'(9X,4(1X,A))') SEGID(K),
     $                                RESID(K),RES(K),TYPE(K)
                              END DO
                              WRITE(PUNIT,'(A)') ' set-j-atoms'
                              DO J=NOEJPR(NORR)+1,NOEJPR(NORR+1)
                                 K=NOEJLS(J)
                                 WRITE(PUNIT,'(9X,4(1X,A))') SEGID(K),
     $                                RESID(K),RES(K),TYPE(K)
                              END DO
                           END DO
C     
                           WRITE(PUNIT,'(A,F8.3,A,F5.2,A,F5.2,A,F5.2,
     $                          2A,F8.3,A,F8.3)')
     &                          ' R<average>=',PCDATA(PCGEOM),
     &                          ' NOE=',NOEDIS(N),' (-',NOELOW(N),'/+',
     &                          NOEHIG(N),')',
     &                          ' Delta=',PCDATA(PCDEVI),
     &                          '  E(NOE)=',PCDATA(PCENER)
                           IF (RMODE(NOECND(N)).NE.'OFF') THEN
                              IF (RANA.EQ.'RAVE') THEN
                                 WRITE(PUNIT,'(A,F8.3,A)')
     &                              ' running-averaged <R>=',NOERRV(N),
     &                              ' (used in energy calculation)'
                              ELSE
                                 WRITE(PUNIT,'(A,F8.3)')
     &                              ' running-averaged <R>=',NOERRV(N)
                              END IF
                           END IF
                           IF (TMODE(NOECND(N)).NE.'OFF') THEN
                              IF (RANA.EQ.'TAVE') THEN
                                 WRITE(PUNIT,'(A,F8.3,A)')
     &                                ' time-averaged <R>=',NOERAV(N),
     &                                ' (used in energy calculation)'
                              ELSE
                                 WRITE(PUNIT,'(A,F8.3)')
     &                                ' time-averaged <R>=',NOERAV(N)
                              END IF
                           END IF  
                        END IF  ! qprint
                     END IF     ! class
                  END IF        ! test
               END DO           ! noes
            END IF              ! potential
         END DO                 ! classes
C     
         WRITE(PUNIT,'(/A,F8.3)')
     &        ' NOEPRI: RMS diff. =',SQRT(NOERMS/NOENUML)
C     
         IF (QPRINT) THEN
           DO I=1,NOECCN
              IF (NOENU2(I).GT.0) THEN
                WRITE(PUNIT,'(3A,F8.3,A,F4.1,A,I6,A,I6,A)')
     &              ' NOEPRI: RMS diff. class ',
     &              NOECNM(I),' =',SQRT(NOERM2(I)/NOENU2(I)),
     &              ',  #(viol.>',THRESH,
     &              ')=',NOEVIO(I),' of ',NOENU2(I),' NOEs'
              END IF
           END DO
         END IF
      END IF                    ! noenum > 0
      IF (ITEST.EQ.0) THEN
         DBPREC=NOEVIT
         CALL DECLAR( 'VIOLATIONS', 'DP', ' ', DBCOMP, DBPREC )
         DBPREC=SQRT(NOERMS/NOENUML)
         CALL DECLAR( 'RESULT', 'DP', ' ', DBCOMP, DBPREC )
         CALL DECLAR( 'RMS', 'DP', ' ', DBCOMP, DBPREC )
         DBPREC =NOEVSM/NOENUML
         CALL DECLAR( 'VAVE', 'DP', ' ', DBCOMP, DBPREC )
         DBPREC=NOENUML
         CALL DECLAR( 'NUMBER', 'DP', ' ', DBCOMP, DBPREC )
      ELSE
         DBPREC=NOEVIT
         CALL DECLAR( 'TEST_VIOLATIONS', 'DP', ' ', DBCOMP, DBPREC )
         DBPREC =SQRT(NOERMS/NOENUML)
         CALL DECLAR( 'TEST_RMS', 'DP', ' ', DBCOMP, DBPREC )
         DBPREC =NOEVSM/NOENUML
         CALL DECLAR( 'TEST_VAVE', 'DP', ' ', DBCOMP, DBPREC )
         DBPREC=NOENUML
         CALL DECLAR( 'TEST_NUMBER', 'DP', ' ', DBCOMP, DBPREC )
      END IF
C
      RETURN
      END
C====================================================================
      SUBROUTINE ENOE(EN,ANALYS,NA)
C
C Routine computes force field for NOE restraints
C
C Front-end routine for ENOE2
C
C Author: Axel Brunger
C
      IMPLICIT NONE
C I/O
      INCLUDE 'cns.inc'
      INCLUDE 'heap.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'noe.inc'
      INCLUDE 'mtf.inc'
      DOUBLE PRECISION EN
      CHARACTER*4 ANALYS
      INTEGER NA
      INTEGER NDISPR
C local
      INTEGER DDX, DDY, DDZ
C begin
      NDISPR= NORSMX*NOESMX
      DDX=ALLHP(IREAL8(NDISPR))
      DDY=ALLHP(IREAL8(NDISPR))
      DDZ=ALLHP(IREAL8(NDISPR))
      CALL ENOE2(EN,ANALYS,NA,HEAP(DDX),HEAP(DDY),HEAP(DDZ),
     &     HEAP(HPNORR),HEAP(HPNIPR),HEAP(HPNILS),
     &     HEAP(HPNJPR),HEAP(HPNJLS),HEAP(HPNCND),
     &     HEAP(HPNRAV),HEAP(HPNRRV),HEAP(HPNNSP),HEAP(HPNDIS),
     &     HEAP(HPNLOW),HEAP(HPNHIG),HEAP(HPNWGH),HEAP(HPCDIS),
     &     HEAP(HPNCV), HEAP(HPNPID))
      CALL FREHP(DDX,IREAL8(NDISPR))
      CALL FREHP(DDY,IREAL8(NDISPR))
      CALL FREHP(DDZ,IREAL8(NDISPR))
      RETURN
      END
C====================================================================
      SUBROUTINE ENOE2(EN,ANALYS,NA,DDX,DDY,DDZ,
     &           NOEORR,NOEIPR,
     &           NOEILS,NOEJPR,NOEJLS,NOECND,NOERAV,NOERRV,NOESTP,
     &           NOEDIS,NOELOW,NOEHIG,NOEWGH,NOECDI,NOECV,NOEPID)
C
C Modified: Alexandre Bonvin
C           inclusion of constraint interactions for multimodel
C           refinement
C Modified: Michael Nilges
C           to allow ambiguous restraints using "OR"
C
      IMPLICIT NONE
C I/O
      INCLUDE 'cns.inc'
      INCLUDE 'heap.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'noe.inc'
      INCLUDE 'pick.inc'
      INCLUDE 'deriv.inc'
      INCLUDE 'coord.inc'
      INCLUDE 'consta.inc'
      INCLUDE 'numbers.inc'
      INCLUDE 'comand.inc'
      INCLUDE 'mtf.inc'
      DOUBLE PRECISION EN
      CHARACTER*4 ANALYS
      INTEGER NA
      DOUBLE PRECISION DDX(*), DDY(*), DDZ(*)
      INTEGER NOEORR(*),NOEIPR(*), NOEILS(*), NOEJPR(*)
      INTEGER NOEJLS(*), NOECND(*)
      DOUBLE PRECISION NOERAV(*), NOERRV(*), NOEDIS(*)
      DOUBLE PRECISION NOELOW(*), NOEHIG(*), NOEWGH(*), NOECDI(*)
      INTEGER NOESTP(*), NOECV(*), NOEPID(*)
C local
      DOUBLE PRECISION XI, YI, ZI, XJ, YJ, ZJ, WENS
      DOUBLE PRECISION RN, RNN, RN2, XIJ, YIJ, ZIJ, SIJ, RIJ
      DOUBLE PRECISION DF, DDF, C
      DOUBLE PRECISION EL, DEVI, LW, LOGDEVI
      DOUBLE PRECISION AAA, BBB, NEXP, NSOE, SAVEXP
      INTEGER I, J, N, NSTART, NSTOP, II, JJ, LI, LJ
      INTEGER IPRI, NPRIME, ICLASS
      INTEGER L1,L2,INORR,NNORR,NORR
      DOUBLE PRECISION XIJP(2), YIJP(2), ZIJP(2), RIJP(2)
      LOGICAL QAVER, FIRST
      DOUBLE PRECISION  VRN(20)
      INTEGER HN
C begin
C
      EN=ZERO
C
      IF (ANALYS.EQ.'ANAL') THEN
      NSTART=NA
      NSTOP=NA
      ELSE
      NSTART=1
      NSTOP=NOENUM
      END IF
C
      FIRST=.TRUE.
      HN=0
C
      DO N=NSTART,NSTOP
C
      IF (((NOECV(N).NE.NOEICV).OR.(ANALYS.EQ.'ANAL'))
     &    .AND.((NOEPOT(NOECND(N)).EQ.NOEHDI).OR.
     &         (NOEPOT(NOECND(N)).EQ.NOE3DP))) THEN
      CALL MULTID(NSTART,NSTOP,N,HN,EN,RN,ANALYS,NA,DDX,DDY,DDZ,NOEORR,
     &           NOEIPR,NOEILS,NOEJPR,NOEJLS,NOECND,NOEDIS,
     &           NOELOW,NOEHIG,NOEWGH,NOECV,VRN)
C
      ELSEIF (((NOECV(N).NE.NOEICV).OR.(ANALYS.EQ.'ANAL').OR.
     &    (ANALYS.EQ.'ASSI')).AND.(NOEPOT(NOECND(N)).EQ.NOESYM)) THEN
C
C
C
C
C
C symmetry potential
C essentially, the whole code is duplicated to allow the computation
C of the NOE symmetry term. Two subsequent NOE restraints are constrained
C to have a specified difference equal.
C The input format of the NOE list is identical to that of
C the usual NOE terms, but the interpretation of the terms is different
C first restraint:   r => signed distance difference (a positive
C distance
C   difference means that the first distance is bigger than the second)
C   d- => -error; d+ => +error.
C second restraint:  r, d- and d+ are not used.
C (MN)
C
C check if this is the first or the second time round
      IF (FIRST) THEN
      FIRST=.FALSE.
C
C check if the following or previous is also NOESYM
      IF ((NOEPOT(NOECND(N+1)).NE.NOESYM)
     &     .AND.(ANALYS.NE.'ANAL')) THEN
      CALL WRNDIE(-5,'NOE',
     & 'error in SYMMETRY potential, check NOE table')
C
      ELSE
      ICLASS=NOECND(N)
C
C get the two distances
      DO IPRI=1,2
C
C calculate the indices properly with the new NOEORR stuff.
C nprime needs to be replaced by noeorr(nprime)+1
      NPRIME=N+IPRI-1
      II=NOEIPR(NOEORR(NPRIME)+1)+1-NOEIPR(NOEORR(NPRIME)+1+1)
      JJ=NOEJPR(NOEORR(NPRIME)+1)+1-NOEJPR(NOEORR(NPRIME)+1+1)
      QAVER=(II.NE.0.OR.JJ.NE.0)
C if more than one pair of atoms in constraint
      IF (QAVER) THEN
      LI=0
      XI=ZERO
      YI=ZERO
      ZI=ZERO
C ...loop over all pairs of atoms belonging to restraint N
      DO II=NOEIPR(NOEORR(NPRIME)+1)+1,NOEIPR(NOEORR(NPRIME)+1+1)
      I=NOEILS(II)
      XI=XI+X(I)
      YI=YI+Y(I)
      ZI=ZI+Z(I)
      LI=LI+1
      END DO
      XI=XI/LI
      YI=YI/LI
      ZI=ZI/LI
      LJ=0
      XJ=ZERO
      YJ=ZERO
      ZJ=ZERO
      DO JJ=NOEJPR(NOEORR(NPRIME)+1)+1,NOEJPR(NOEORR(NPRIME)+1+1)
      J=NOEJLS(JJ)
      XJ=XJ+X(J)
      YJ=YJ+Y(J)
      ZJ=ZJ+Z(J)
      LJ=LJ+1
      END DO
      XJ=XJ/LJ
      YJ=YJ/LJ
      ZJ=ZJ/LJ
      XIJP(IPRI)=XI-XJ
      YIJP(IPRI)=YI-YJ
      ZIJP(IPRI)=ZI-ZJ
      RIJP(IPRI)=MAX(RSMALL,
     &           SQRT(XIJP(IPRI)**2+YIJP(IPRI)**2+ZIJP(IPRI)**2))
C  if only one pair of atoms in constraint
      ELSE
      I=NOEILS(NOEIPR(NOEORR(NPRIME)+1)+1)
      J=NOEJLS(NOEJPR(NOEORR(NPRIME)+1)+1)
      XIJP(IPRI)=X(I)-X(J)
      YIJP(IPRI)=Y(I)-Y(J)
      ZIJP(IPRI)=Z(I)-Z(J)
      RIJP(IPRI)=XIJP(IPRI)**2+YIJP(IPRI)**2+ZIJP(IPRI)**2
      RIJP(IPRI)=MAX(RSMALL, SQRT(RIJP(IPRI)))
      ENDIF
C
      END DO
C
      RN=RIJP(1)-RIJP(2)
C
C do square well potential with soft asymptote
C
      C=MIN(NOEWGH(N)*NOESCA(ICLASS)*NOECNS(ICLASS),NOECEI)
C
      DEVI=MAX(ZERO,RN-NOEDIS(N)-
     &            MAX(ZERO,NOEHIG(N)-NOEOFF(ICLASS)))+
     &           MIN(ZERO,RN-NOEDIS(N)+
     &            MAX(ZERO,NOELOW(N)-NOEMOF(ICLASS)))
      IF ((DEVI.LE.NOESWI(ICLASS))
     &          .AND.(DEVI.GE.-NOESWI(ICLASS))) THEN
      EL=C*DEVI**NOEEXP(ICLASS)
      DF=NOEEXP(ICLASS)*C*DEVI**(NOEEXP(ICLASS)-1)
      ELSE
      AAA=(FLOAT(NOEEXP(ICLASS))
     &           /FLOAT(NOESOE(ICLASS))+1.0D0)
     &           *NOESWI(ICLASS)**(NOEEXP(ICLASS))
     &           -NOEASY(ICLASS)
     &           *(1.0D0+1.0D0/FLOAT(NOESOE(ICLASS)))
     &           *NOESWI(ICLASS)
      BBB=-FLOAT(NOEEXP(ICLASS))
     &           /FLOAT(NOESOE(ICLASS))
     &           *NOESWI(ICLASS)
     &           **(NOEEXP(ICLASS)+NOESOE(ICLASS))
     &           +NOEASY(ICLASS)/FLOAT(NOESOE(ICLASS))
     &            *NOESWI(ICLASS)**(NOESOE(ICLASS)+1)
      EL=C*(AAA+BBB/ABS(DEVI)**(NOESOE(ICLASS))
     &          +NOEASY(ICLASS)*ABS(DEVI))
      DF=C*(-NOESOE(ICLASS)*BBB/ABS(DEVI)**(NOESOE(ICLASS)+1)
     &          +NOEASY(ICLASS))*SIGN(1.0D0, DEVI)
      END IF
C
C accumulate energy
      EN=EN+EL
C
C accumulate derivatives
      DO IPRI=1,2
C
      NPRIME=N+IPRI-1
      LI=NOEIPR(NOEORR(NPRIME)+1+1)-NOEIPR(NOEORR(NPRIME)+1)
      LJ=NOEJPR(NOEORR(NPRIME)+1+1)-NOEJPR(NOEORR(NPRIME)+1)
      QAVER=(LI.GT.1.OR.LJ.GT.1)
C if more than one pair of atoms in constraint
      IF (QAVER) THEN
C
      DO II=NOEIPR(NOEORR(NPRIME)+1)+1,NOEIPR(NOEORR(NPRIME)+1+1)
      I=NOEILS(II)
      DX(I)=DX(I)+DF*XIJP(IPRI)/(RIJP(IPRI)*LI)
      DY(I)=DY(I)+DF*YIJP(IPRI)/(RIJP(IPRI)*LI)
      DZ(I)=DZ(I)+DF*ZIJP(IPRI)/(RIJP(IPRI)*LI)
      END DO
      DO JJ=NOEJPR(NOEORR(NPRIME)+1)+1,NOEJPR(NOEORR(NPRIME)+1+1)
      J=NOEJLS(JJ)
      DX(J)=DX(J)-DF*XIJP(IPRI)/(RIJP(IPRI)*LJ)
      DY(J)=DY(J)-DF*YIJP(IPRI)/(RIJP(IPRI)*LJ)
      DZ(J)=DZ(J)-DF*ZIJP(IPRI)/(RIJP(IPRI)*LJ)
      END DO
C if only one pair of atoms in constraint
      ELSE
      I=NOEILS(NOEIPR(NOEORR(NPRIME)+1)+1)
      J=NOEJLS(NOEJPR(NOEORR(NPRIME)+1)+1)
      DX(I)=DX(I)+DF*XIJP(IPRI)/RIJP(IPRI)
      DY(I)=DY(I)+DF*YIJP(IPRI)/RIJP(IPRI)
      DZ(I)=DZ(I)+DF*ZIJP(IPRI)/RIJP(IPRI)
      DX(J)=DX(J)-DF*XIJP(IPRI)/RIJP(IPRI)
      DY(J)=DY(J)-DF*YIJP(IPRI)/RIJP(IPRI)
      DZ(J)=DZ(J)-DF*ZIJP(IPRI)/RIJP(IPRI)
      ENDIF
C the following takes care of a -1 in the chain rule
      DF=-DF
      END DO
C
      END IF
      ELSE
      FIRST=.TRUE.
      END IF
C
C
C
C
      ELSEIF (((NOECV(N).NE.NOEICV).OR.(ANALYS.EQ.'ANAL').OR.
     &    (ANALYS.EQ.'ASSI')).AND.(NOEPOT(NOECND(N)).NE.NOESYM)) THEN
C
C
C
C mn_new we add an outer loop that allows calculation of multiple
C restraints connected by "or" statements
C
C is more than one pair of atoms in constraint ?
C noeipr(noeorr(N)+1) replaces noeipr(N)
      QAVER=.TRUE.
      NNORR=NOEORR(N+1)-NOEORR(N)
      IF (NNORR.EQ.1) THEN
       NORR=NOEORR(N)+1
       II=NOEIPR(NORR)+1-NOEIPR(NORR+1)
       JJ=NOEJPR(NORR)+1-NOEJPR(NORR+1)
       QAVER=(II.NE.0.OR.JJ.NE.0)
      END IF
C
      IF (.NOT.QAVER) THEN
       I=NOEILS(NOEIPR(NOEORR(N)+1)+1)
       J=NOEJLS(NOEJPR(NOEORR(N)+1)+1)
      RN=SQRT(MAX(((X(I)-X(J))*(X(I)-X(J)) + 
     &              (Y(I)-Y(J))*(Y(I)-Y(J)) +
     &              (Z(I)-Z(J))*(Z(I)-Z(J))), RSMALL))
       DF=ONE
C
C we have more than one atom and/or more than one possib
      ELSE 
       L1=0
       RN=ZERO
       INORR=0
       DO NORR=NOEORR(N)+1, NOEORR(N+1)
        INORR=INORR+1
C
        IF (NOEAVE(NOECND(N)).EQ.NOEM6
     &    .OR.(NOEAVE(NOECND(N)).EQ.NOEM3)
     &    .OR.(NOEAVE(NOECND(N)).EQ.NOESUM)) THEN
C do r-6/r-3 or sum averaging
C ++++++++++++++++
C R = ( <R-6> ) -1/6
         IF (NOEAVE(NOECND(N)).EQ.NOEM3) THEN
          SAVEXP=THREE
         ELSEIF (NOEAVE(NOECND(N)).EQ.NOEM6) THEN
          SAVEXP=SIX
         ELSE
          SAVEXP=NAVEXP(NOECND(N))
         END IF
C
         L2=0
         LW=ZERO
         RN2=ZERO
C
C loop over all pairs of atoms belonging to restraint N
         DO II=NOEIPR(NORR)+1,NOEIPR(NORR+1)
          DO JJ=NOEJPR(NORR)+1,NOEJPR(NORR+1)
           I=NOEILS(II)
           J=NOEJLS(JJ)
C
C ensemble averaging:
C setup weight for each selections ij
C with value 0 if i and j does not belong to identical
C segids otherwise 1 or occupancy if OCCU = .true.
           IF (EMODE .EQ.'ON') THEN
            CALL ENSBLE(WENS,I,J)
           ELSE
            WENS = ONE
           END IF
C
           IF (WENS.GE.ZERO) THEN
            XIJ=X(I)-X(J)
            YIJ=Y(I)-Y(J)
            ZIJ=Z(I)-Z(J)
            SIJ=XIJ*XIJ+YIJ*YIJ+ZIJ*ZIJ
            RIJ=ONE/(SIJ**(SAVEXP/TWO))
            RN2=RN2+RIJ*WENS
C local derivative accumulation
            LW=LW+WENS
            L1=L1+1
            L2=L2+1
            RIJ=RIJ/SIJ
            DDX(L1)=RIJ*XIJ
            DDY(L1)=RIJ*YIJ
            DDZ(L1)=RIJ*ZIJ
           END IF
C
          END DO
         END DO
C
C for NOESUM we do not average (divide by L)
C if we have a multimeric protein, we have to divide by the
C number of molecules to get the scaling right.
C the exponent is (-OREXP(NOECND(N))-1+SAVEXP+1)
C if savexp=orexp, the derivative here is one as it should
C if NNORR=1, the use of orexp is avoided, and the distance is calculated
C the standard way.
         IF (NNORR.EQ.1) THEN
          IF (NOEAVE(NOECND(N)).EQ.NOESUM) THEN
           RN2=MAX((NMONO(NOECND(N))/RN2)**(ONE/SAVEXP),RSMALL)
           DDF=ONE/NMONO(NOECND(N))
          ELSE
           RN2=MAX((LW/RN2)**(ONE/SAVEXP),RSMALL)
           DDF=ONE/LW
          END IF
         ELSE
          IF (NOEAVE(NOECND(N)).EQ.NOESUM) THEN
           IF (SAVEXP.EQ.OREXP(NOECND(N))) THEN
            RN2=MAX(RN2/NMONO(NOECND(N)),RSMALL)
            DDF=ONE/NMONO(NOECND(N))
           ELSE
            RN2=MAX((NMONO(NOECND(N))/RN2)**(ONE/SAVEXP),RSMALL)
            DDF=RN2**(SAVEXP-OREXP(NOECND(N)))/NMONO(NOECND(N))
           END IF
          ELSE
           RN2=MAX((LW/RN2)**(ONE/SAVEXP),RSMALL)
           DDF=RN2**(SAVEXP-OREXP(NOECND(N)))/LW
          END IF
         END IF
C
C derivatives
         L1=L1-L2
         DO II=NOEIPR(NORR)+1,NOEIPR(NORR+1)
          DO JJ=NOEJPR(NORR)+1,NOEJPR(NORR+1)
           I=NOEILS(II)
           J=NOEJLS(JJ)
C
C ensemble averaging:
C setup weight for each selections ij
C with value 0 if i and j does not belong to identical
C segids otherwise 1 or occupancy if OCCU = .true.
           IF (EMODE .EQ.'ON') THEN
              CALL ENSBLE(WENS,I,J)
           ELSE
            WENS = ONE
           END IF
C
           IF (WENS.GE.ZERO) THEN
             L1=L1+1
             DDX(L1)=DDX(L1)*DDF
             DDY(L1)=DDY(L1)*DDF
             DDZ(L1)=DDZ(L1)*DDF
           END IF
C
          END DO
         END DO
C
        ELSE IF (NOEAVE(NOECND(N)).EQ.NOECEN) THEN
C do center averaging
C +++++++++++++++++++
C R= (r1   -    r2      )
C       center    center
C
         LI=0
         XI=ZERO
         YI=ZERO
         ZI=ZERO
C ...loop over all pairs of atoms belonging to restraint N
         DO II=NOEIPR(NORR)+1,NOEIPR(NORR+1)
          I=NOEILS(II)
          XI=XI+X(I)
          YI=YI+Y(I)
          ZI=ZI+Z(I)
          LI=LI+1
         END DO
         XI=XI/LI
         YI=YI/LI
         ZI=ZI/LI
         LJ=0
         XJ=ZERO
         YJ=ZERO
         ZJ=ZERO
         DO JJ=NOEJPR(NORR)+1,NOEJPR(NORR+1)
          J=NOEJLS(JJ)
          XJ=XJ+X(J)
          YJ=YJ+Y(J)
          ZJ=ZJ+Z(J)
          LJ=LJ+1
         END DO
         XJ=XJ/LJ
         YJ=YJ/LJ
         ZJ=ZJ/LJ
         XIJ=XI-XJ
         YIJ=YI-YJ
         ZIJ=ZI-ZJ
         RN2=MAX(SQRT(XIJ**2+YIJ**2+ZIJ**2),RSMALL)
C chain rule
         IF (NNORR.GT.1) THEN
          DDF=RN2**(-OREXP(NOECND(N))-1)
         ELSE
          DDF=ONE
         END IF
         DDX(INORR)=XIJ/(RN2*LI)*DDF
         DDY(INORR)=YIJ/(RN2*LI)*DDF
         DDZ(INORR)=ZIJ/(RN2*LI)*DDF
         DDX(NNORR+INORR)=XIJ/(RN2*LJ)*DDF
         DDY(NNORR+INORR)=YIJ/(RN2*LJ)*DDF
         DDZ(NNORR+INORR)=ZIJ/(RN2*LJ)*DDF
C
        ELSE
         WRITE(6,'(A)') ' %ENOE-ERR: averaging - check code'
        END IF
C
        IF (NNORR.GT.1) THEN
         IF (NOEAVE(NOECND(N)).EQ.NOESUM) THEN
          IF (SAVEXP.EQ.OREXP(NOECND(N))) THEN
           RN=RN+RN2
          ELSE
           RN=RN+RN2**(-OREXP(NOECND(N)))
          END IF
         ELSE
          RN=RN+RN2**(-OREXP(NOECND(N)))
         END IF
        ELSE
         RN=RN2
         IF (NOEAVE(NOECND(N)).EQ.NOECEN) THEN
          DF=ONE
         ELSE
          DF=RN**(SAVEXP+1)
         END IF
        END IF

C this is the end of the "OR" loop
       END DO
C
       IF ((NNORR.GT.1)) THEN
        RN2=MAX((ONE/RN)**(ONE/OREXP(NOECND(N))),RSMALL)
        DF=RN2/RN
       END IF
C
       RN=RN2
      END IF !quaver
C
C running-average distance
C ++++++++++++++++++++++
      IF (RMODE(NOECND(N)).NE.'OFF'.AND.ANALYS.NE.'ANAL') THEN
       NOESTP(N)=NOESTP(N)+1
       NOERRV(N)=(((NOESTP(N)-1)*(NOERRV(N)**(-RAVEXP(NOECND(N))))+
     &          RN**(-RAVEXP(NOECND(N)))) /
     &          NOESTP(N))**(-ONE/RAVEXP(NOECND(N)))
      END IF
C
C time-averaged distance
C ++++++++++++++++++++++
C Modified by SIOD, 17/11/92
      RNN=RN
      IF (TMODE(NOECND(N)).NE.'OFF'.AND.ANALYS.NE.'ANAL') THEN
        RN=(RN**(-DAVEXP(NOECND(N)))/MEMTAU(NOECND(N))
     &   +(EXP(-ONE/MEMTAU(NOECND(N))))*NOERAV(N)**(-DAVEXP(NOECND(N)))
     &   )**(-ONE/DAVEXP(NOECND(N)))
       IF (TFMODE(NOECND(N)).EQ.'CONS') THEN
        DF=DF*(RN/RNN)**FOUR/MEMTAU(NOECND(N))
       END IF
C
       IF (TMODE(NOECND(N)).NE.'STAT') THEN
        NOERAV(N)=RN
       END IF
      END IF
C
C time-averaging analyse mode only
C ++++++++++++++++++++++++++++++++
C A. Bonvin 17/05/95
      IF (ANALYS.EQ.'ANAL') THEN
       IF (RMODE(NOECND(N)).NE.'OFF'.AND.RANA.EQ.'RAVE') THEN
        RN=NOERRV(N)
        RNN=RN
       END IF
      IF (TMODE(NOECND(N)).NE.'OFF'.AND.RANA.EQ.'TAVE') THEN
       RN=NOERAV(N)
       RNN=RN
       END IF
      END IF
C
C
      IF ((NOECV(N).NE.NOEICV).OR.(ANALYS.EQ.'ANAL')) THEN
C potential function and derivative calculation only for working set
C Mod: if ANALYS mode test set is also included for cross-validation
C A.Bonvin 17/05/95
C
       IF (NOEPOT(NOECND(N)).EQ.NOEBIH) THEN
C do biharmonic potential
C +++++++++++++++++++++++
C
C                      -1         2            c(low)   R < d
C    E= S K T (2 c **2 ) ( R - d )     c   =
C          b      ij                    ij     c(high)  R > d
C
        IF (RN.GT.NOEDIS(N)) THEN
         C=NOEHIG(N)
        ELSE
         C=NOELOW(N)
        END IF
C
C ...convert the constant
        C=ABS(NOEWGH(N)*(NOESCA(NOECND(N))
     &      *KBOLTZ*NOETEM*0.5D0)/(C*C))
        C=MIN(C,NOECEI)
C
        DEVI=RN-NOEDIS(N)
        EL=C*DEVI*DEVI
        DF=DF*TWO*C*DEVI
C
       ELSEIF (NOEPOT(NOECND(N)).EQ.NOELOG) THEN
C do lognormal potential
C +++++++++++++++++++++++
C                    2
C E= const log((d/R))  
C
C we calculate the deviation and the deviation of logarithms but keep only
C the deviation of logarithms
C need to limit RN to avoid singularity
        ICLASS=NOECND(N)
        C=MIN(NOEWGH(N)*NOESCA(ICLASS)*NOECNS(ICLASS),NOECEI)
        DEVI=RN-NOEDIS(N)
        LOGDEVI=LOG(MAX(RN,RSMALL)/NOEDIS(N))
        DF=DF*C*TWO*LOGDEVI/RN
        EL  =C*LOGDEVI*LOGDEVI
        DEVI=LOGDEVI
C
       ELSE IF (NOEPOT(NOECND(N)).EQ.NOESQW) THEN
C do square well potential
C ++++++++++++++++++++++++
C
C                   exp           R-(d+dplus)  d+dplus <  R
C E= const ( delta )    , delta = 0            d-dminus < R <  d+dplus
C                                 (d-dminus)-R   R < d-dminus
C
        DEVI=MAX(ZERO,
     &     RN-(NOEDIS(N)+MAX(ZERO,NOEHIG(N)-NOEOFF(NOECND(N)))))+
     &     MIN(ZERO,RN
     &     -(NOEDIS(N)-MAX(ZERO,NOELOW(N)-NOEMOF(NOECND(N)))))
        C=MIN(NOEWGH(N)*NOESCA(NOECND(N))*NOECNS(NOECND(N)),NOECEI)
        EL=C*DEVI**NOEEXP(NOECND(N))
        DF=DF*NOEEXP(NOECND(N))*C*DEVI**(NOEEXP(NOECND(N))-1)
C
       ELSE IF (NOEPOT(NOECND(N)).EQ.NOESOF) THEN
C do square well potential with soft asymptote
C ++++++++++++++++++++++++++++++++++++++++++++
C Modifications: Michael Nilges
C                  softexp
C E= a + b / delta         + c delta,
C                     delta = R-(d+dplus)+rswitch, R>d+dplus+ rswitch
C                   exp          ( R-(d+dplus) , d+dplus < R < d+dplus+rswitch
C E= const ( delta )    , delta= ( 0           , d-dminus < R < d+dplus
C                                ( (d-dminus)-R, R < d-dminus
C
C
        ICLASS=NOECND(N)
        C=MIN(NOEWGH(N)*NOESCA(ICLASS)*NOECNS(ICLASS),NOECEI)
        DEVI=MAX(ZERO,RN
     &       -(NOEDIS(N)+MAX(ZERO,NOEHIG(N)-NOEOFF(ICLASS))))+
     &       MIN(ZERO,RN
     &       -(NOEDIS(N)-MAX(ZERO,NOELOW(N)-NOEMOF(ICLASS))))
C
        IF (DEVI.LT.-NOEMSW(ICLASS)) THEN
         NEXP=FLOAT(NOEEXP(ICLASS))
         NSOE=FLOAT(NOEMSO(ICLASS))
         AAA=(NEXP/NSOE+ONE)*NOEMSW(ICLASS)**NEXP
     &      +NOEMAS(ICLASS)*(ONE+ONE/NSOE)*NOEMSW(ICLASS)
c         BBB=-NEXP/NSOE*NOEMSW(ICLASS)**(NEXP+NSOE)
c     &      -NOEMAS(ICLASS)/NSOE*NOEMSW(ICLASS)**(NSOE+ONE)
c         EL=C*(AAA+BBB/ABS(DEVI)**NSOE-NOEMAS(ICLASS)*ABS(DEVI))
c         DF=DF*C*(-NSOE*BBB/ABS(DEVI)**(NSOE+1)-NOEMAS(ICLASS))
c     &     *SIGN(1.0D0, DEVI)
C MN sign corrected for nsoe <> 1 (12-02-99)
         BBB=+NEXP/NSOE*NOEMSW(ICLASS)**(NEXP+NSOE)
     &      +NOEMAS(ICLASS)/NSOE*NOEMSW(ICLASS)**(NSOE+ONE)
         EL=C*(AAA-BBB/ABS(DEVI)**NSOE-NOEMAS(ICLASS)*ABS(DEVI))
         DF=DF*C*(NSOE*BBB/ABS(DEVI)**(NSOE+1)-NOEMAS(ICLASS))
     &     *SIGN(1.0D0, DEVI)
C
        ELSE IF (DEVI.LE.NOESWI(ICLASS)) THEN
         EL=C*DEVI**NOEEXP(ICLASS)
         DF=DF*NOEEXP(ICLASS)*C*DEVI**(NOEEXP(ICLASS)-1)
C
        ELSE
         NEXP=NOEEXP(ICLASS)
         NSOE=NOESOE(ICLASS)
         AAA=(NEXP/NSOE+ONE)*NOESWI(ICLASS)**NEXP
     &      -NOEASY(ICLASS)*(ONE+ONE/NSOE)*NOESWI(ICLASS)
         BBB=-NEXP/NSOE*NOESWI(ICLASS)**(NEXP+NSOE)
     &      +NOEASY(ICLASS)/NSOE*NOESWI(ICLASS)**(NSOE+1)
         EL=C*(AAA+BBB/DEVI**NSOE+NOEASY(ICLASS)*DEVI)
         DF=DF*C*(-NSOE*BBB/DEVI**(NSOE+1)+NOEASY(ICLASS))
        END IF
C
       ELSE
        WRITE(6,'(A)') ' %ENOE-ERR: potential - check code'
       END IF

C
C accumulate energy
       EN=EN+EL
C
C accumulate derivatives
C
C mn_new we add an outer loop that allows calculation of multiple
C restraints connected by "or" statements
C here: calculation of derivatives
       IF (.NOT.QAVER) THEN
        I=NOEILS(NOEIPR(NOEORR(N)+1)+1)
        J=NOEJLS(NOEJPR(NOEORR(N)+1)+1)
        DF=DF/RN
        DX(I)= DX(I)+DF*(X(I)-X(J))
        DX(J)= DX(J)-DF*(X(I)-X(J))
        DY(I)= DY(I)+DF*(Y(I)-Y(J))
        DY(J)= DY(J)-DF*(Y(I)-Y(J))
        DZ(I)= DZ(I)+DF*(Z(I)-Z(J))
        DZ(J)= DZ(J)-DF*(Z(I)-Z(J))
C
       ELSE
C
        L1=0
        INORR=0
        NNORR=NOEORR(N+1)-NOEORR(N)
        DO NORR=NOEORR(N)+1, NOEORR(N+1)
         INORR=INORR+1
C
         IF (NOEAVE(NOECND(N)).EQ.NOEM6
     &    .OR.(NOEAVE(NOECND(N)).EQ.NOEM3)
     &    .OR.(NOEAVE(NOECND(N)).EQ.NOESUM)) THEN
C do r-6/r-3 averaging
C ++++++++++++++++
C
          DO II=NOEIPR(NORR)+1,NOEIPR(NORR+1)
           DO JJ=NOEJPR(NORR)+1,NOEJPR(NORR+1)
            I=NOEILS(II)
            J=NOEJLS(JJ)
C
C ensemble averaging:
C setup weight for each selections ij
C with value 0 if i and j does not belong to have identical
C segids otherwise 1
            IF (EMODE.EQ.'ON') THEN
             CALL ENSBLE(WENS,I,J)
            ELSE
             WENS = ONE
            END IF
C
            IF (WENS.GE.ZERO) THEN
             L1=L1+1
             DX(I)=DX(I)+DF*DDX(L1)
             DX(J)=DX(J)-DF*DDX(L1)
             DY(I)=DY(I)+DF*DDY(L1)
             DY(J)=DY(J)-DF*DDY(L1)
             DZ(I)=DZ(I)+DF*DDZ(L1)
             DZ(J)=DZ(J)-DF*DDZ(L1)
            END IF
           END DO
          END DO
C
         ELSE IF (NOEAVE(NOECND(N)).EQ.NOECEN) THEN
C do center averaging
C +++++++++++++++++++
C
          DO II=NOEIPR(NORR)+1,NOEIPR(NORR+1)
           I=NOEILS(II)
           DX(I)=DX(I)+DF*DDX(INORR)
           DY(I)=DY(I)+DF*DDY(INORR)
           DZ(I)=DZ(I)+DF*DDZ(INORR)
          END DO
          DO JJ=NOEJPR(NORR)+1,NOEJPR(NORR+1)
           J=NOEJLS(JJ)
           DX(J)=DX(J)-DF*DDX(NNORR+INORR)
           DY(J)=DY(J)-DF*DDY(NNORR+INORR)
           DZ(J)=DZ(J)-DF*DDZ(NNORR+INORR)
          END DO
C
         ELSE
          WRITE(6,'(A)') ' %ENOE-ERR: averaging - check code'
         END IF
C
C end of OR loop for force calculation
        END DO
       END IF !qaver
C
      END IF ! noeicv
      END IF ! potentials
      NOECDI(N)=RN
      END DO
C
      IF (ANALYS.EQ.'ANAL') THEN
      PCDATA(PCGEOM)=RNN
      PCDATA(PCENER)=EN
      PCDATA(PCEQUI)=NOEDIS(NA)
      PCDATA(PCCONS)=C
      PCDATA(PCDEVI)=-DEVI
      END IF
C
      RETURN
      END
C======================================================================
      SUBROUTINE MULTID(NSTART,NSTOP,N,HN,EN,RN,ANALYS,NA,DDX,DDY,DDZ,
     &           NOEORR,NOEIPR,NOEILS,NOEJPR,NOEJLS,NOECND,
     &           NOEDIS,NOELOW,NOEHIG,
     &           NOEWGH,NOECV,VRN)
C
      IMPLICIT NONE
C I/O
      INCLUDE 'cns.inc'
      INCLUDE 'noe.inc'
      INCLUDE 'pick.inc'
      INCLUDE 'deriv.inc'
      INCLUDE 'coord.inc'
      INCLUDE 'consta.inc'
      DOUBLE PRECISION EN
      CHARACTER*4 ANALYS
      INTEGER NA
      DOUBLE PRECISION DDX(*), DDY(*), DDZ(*)
      INTEGER NOEORR(*), NOEIPR(*), NOEILS(*), NOEJPR(*)
      INTEGER NOEJLS(*), NOECND(*)
      DOUBLE PRECISION NOEDIS(*), NOELOW(*), NOEHIG(*),NOEWGH(*)
      INTEGER NOECV(*)
C local
      DOUBLE PRECISION RN
      DOUBLE PRECISION EL
      DOUBLE PRECISION DEVI
      DOUBLE PRECISION ELOW, EHIG, HE
      DOUBLE PRECISION ZZ(20),ZZZ(20),ZZZZ(20),DZZ(20),DZZZ(20)
      DOUBLE PRECISION D1ZZZ(20), D2ZZZ(20)
      DOUBLE PRECISION LIM1,LIM2,E1,E2,FAKT1,FAKT2,HV1,HV2,ELIM1
      DOUBLE PRECISION HA,HB,HC,HDZ,HDZZ,HDZZZ,HZ,HZZ,HZZZ,HZD,HZZD
      DOUBLE PRECISION VXI(20),VYI(20),VZI(20),VLJ(20),VXJ(20),VYJ(20)
      DOUBLE PRECISION VZJ(20),VXIJ(20),VYIJ(20),VZIJ(20)
      DOUBLE PRECISION VRN(20),VDF(20)
      DOUBLE PRECISION VSIJ(20),VRIJ(20),VDDX(20,20)
      DOUBLE PRECISION VDDY(20,20),VDDZ(20,20)
      INTEGER VLI(20)
      INTEGER I, J, N, L, NSTART, NSTOP, II, JJ
      INTEGER HN, K, BV
C parameter
      DOUBLE PRECISION SIX, SEVEN, ZERO, ONE, TWO, THREE, TWELVE
      DOUBLE PRECISION FOUR, TEN, P15
      PARAMETER (SIX=6.0D0, SEVEN=7.0D0, ONE=1.0D0, TWO=2.0D0)
      PARAMETER (THREE=3.0D0, ZERO=0.0D0, TWELVE=12.0D0, FOUR=4.0D0)
      PARAMETER (TEN=10.D0, P15=1.5D0)
C begin
      IF ((NOEORR(N+1)-NOEORR(N)).GT.1) THEN
      WRITE(6,'(A)') '%ENOE-ERR: OR not allowed in MULTID'
C
      ELSEIF (NOEPOT(NOECND(N)).EQ.NOEHDI) THEN
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C do the highdimensional potential for stereospecific assignment
C
      HN = HN + 1
C HN counts number of read in noes in higdim pot.; if HN=1 new
C potential is started to
C be constructed with the  next noecor noes. if done then HN set to 0.
      E1=ZERO
      E2=ZERO
      IF (HN.EQ.1) THEN
C only at the beginning of a new class of noes
C
      DO L=1, NOECOR(NOECND(N)),2
C loop over the whole noe class, pairwise
C
      DO K=L,L+1
C loop for each noe pair
C
      IF (NOEAVE(NOECND(N)).NE.NOECEN) THEN
      WRITE(6,'(A)') '%ENOE-ERR: averaging - check code'
      END IF
C do center averaging
C +++++++++++++++++++
C R= (r1   -    r2      )
C       center    center
C
      VLI(K)=0
      VXI(K)=ZERO
      VYI(K)=ZERO
      VZI(K)=ZERO
C ...loop over all pairs of atoms belonging to restraint N
CSGI-specific optimization
C*$*SCALAR OPTIMIZE(0)
      DO II=NOEIPR(N+K-1)+1,NOEIPR(N+K)
      I=NOEILS(II)
      VXI(K)=VXI(K)+X(I)
      VYI(K)=VYI(K)+Y(I)
      VZI(K)=VZI(K)+Z(I)
      VLI(K)=VLI(K)+1
      END DO
CSGI-specific optimization
C*$*SCALAR OPTIMIZE(3)
      VXI(K)=VXI(K)/VLI(K)
      VYI(K)=VYI(K)/VLI(K)
      VZI(K)=VZI(K)/VLI(K)
      VLJ(K)=0
      VXJ(K)=ZERO
      VYJ(K)=ZERO
      VZJ(K)=ZERO
      DO JJ=NOEJPR(N+K-1)+1,NOEJPR(N+K)
      J=NOEJLS(JJ)
      VXJ(K)=VXJ(K)+X(J)
      VYJ(K)=VYJ(K)+Y(J)
      VZJ(K)=VZJ(K)+Z(J)
      VLJ(K)=VLJ(K)+1
      END DO
      VXJ(K)=VXJ(K)/VLJ(K)
      VYJ(K)=VYJ(K)/VLJ(K)
      VZJ(K)=VZJ(K)/VLJ(K)
      VXIJ(K)=VXI(K)-VXJ(K)
      VYIJ(K)=VYI(K)-VYJ(K)
      VZIJ(K)=VZI(K)-VZJ(K)
      VRN(K)=SQRT(VXIJ(K)**2+VYIJ(K)**2+VZIJ(K)**2)
      END DO
C***************************************
      LIM1=0.1D0
      LIM2=0.2D0
      FAKT1=ONE
      FAKT2=ONE
C LIM1 is distance from where on the square function is set linear
C LIM2 distance between the two potential minima from where on hight
C is set.
C FAKT1 variable for barrier calculation
C FAKT2 variable for setting the gradient
C****************************************
      ZZ(L)=ZERO
      ZZZ(L)=ZERO
      ZZZZ(L)=ZERO
      ZZ(L+1)=ZERO
      ZZZ(L+1)=ZERO
      ZZZZ(L+1)=ZERO
      DZZ(L)=ZERO
      DZZ(L+1)=ZERO
      DZZZ(L)=ZERO
      DZZZ(L+1)=ZERO
      D1ZZZ(L)=ZERO
      D1ZZZ(L+1)=ZERO
      D2ZZZ(L)=ZERO
      D2ZZZ(L+1)=ZERO
      DEVI =ZERO
C calculating FAKT1
      IF (NOELOW(N+L-1).LT.NOELOW(N+L)) THEN
      ELIM1= NOELOW(N+L) - NOELOW(N+L-1) + LIM1
      ELSE
      ELIM1= NOELOW(N+L-1)-NOELOW(N+L) + LIM1
      END IF
C
C ATB
      BV=0
C
      IF ((NOEHIG(N+L-1).GT.ZERO).AND.(NOEHIG(N+L).GT.ZERO)) THEN
      IF(NOEHIG(N+L-1)*SQRT(TWO).LT.LIM2) THEN
      BV=0
      ELSE
      BV=1
      HV1=NOEDIS(L+N)-NOELOW(L+N-1)
      IF (HV1.GT.ZERO) THEN
      HV1=HV1/TWO
      ELSE
      HV1=ZERO
      END IF
      HV2=SQRT(TWO)*NOEHIG(N+L-1)/TWO
      END IF
      ELSE IF ((NOEHIG(N+L-1).LT.ZERO).AND.(NOEHIG(N+L).LT.ZERO)) THEN
      IF (ABS(NOEHIG(N+L))*SQRT(TWO).LT.LIM2) THEN
      BV=0
      ELSE
      BV=1
      HV1=NOEDIS(L+N-1)-NOELOW(L+N)
      IF (HV1.GT.ZERO) THEN
      HV1=HV1/TWO
      ELSE
      HV1=ZERO
      END IF
      HV2=SQRT(TWO)*ABS(NOEHIG(N+L))/TWO
      END IF
      END IF
C
      IF (BV.EQ.1) THEN
      IF (HV1.GT.LIM1) THEN
      HZ=LIM1**2+2*LIM1*(HV1-LIM1)
      ELSE
      HZ=HV1**2
      END IF
      IF (HV2.GT.LIM1) THEN
      HZZ=LIM1**2 + 2*LIM1*(HV2-LIM1)
      ELSE
      HZZ=HV2**2
      END IF
      FAKT1=2*SQRT(NOEBAR(NOECND(N)))/NOECOR(NOECND(N))/(2*HZ+HZZ)
      ELSE
      FAKT1=ONE
      END IF
C calculate FAKT2
      IF (NOELOW(L+N).GT.NOELOW(L+N-1)) THEN
      HDZ=NOELOW(N+L) + LIM1 - NOELOW(N+L-1)
      HDZZ = LIM1
      IF (NOEHIG(N+L-1).GT.ZERO) THEN
      HDZZZ=NOEHIG(N+L-1)/SQRT(TWO)
      ELSE
      HDZZZ=ZERO
      END IF
C
      ELSE IF (NOELOW(L+N-1).GE.NOELOW(N+N)) THEN
      HDZ=NOELOW(N+L-1)+LIM1-NOELOW(N+L)
      HDZZ=LIM1
      IF (NOEHIG(N+L).LT.ZERO) THEN
      HDZZZ=ABS(NOEHIG(N+L))/SQRT(TWO)
      ELSE
      HDZZZ=ZERO
      END IF
      END IF
C
      HZZ=LIM1**2 *FAKT1
      HZZD=FAKT1*TWO*LIM1
      IF (HDZ.GT.LIM1) THEN
      HZ=(LIM1**2 + TWO*LIM1*(HDZ-LIM1))*FAKT1
      HZD=FAKT1*TWO*LIM1
      ELSE
      HZ=HDZ**2 *FAKT1
      HZD=TWO*FAKT1*HDZ
      END IF
      IF (HDZZZ.GT.LIM1) THEN
      HZZZ=(LIM1**2 + TWO*LIM1*(HDZZZ-LIM1))*FAKT1
      ELSE
      HZZZ=FAKT1*HDZZZ**2
      END IF
      HA=HZZ*HZZD
      HB= HZZ*HZD + HZ*HZZD + HZZZ*HZZD
      HC= HZ*HZD + HZD*HZZZ - ELIM1
      FAKT2=(-HB + SQRT(HB**2 - FOUR*HA*HC))/(TWO*HA)
      IF (BV.EQ.0) THEN
      FAKT1=SQRT(ELIM1/(2*LIM1*(LIM1**2+2*LIM1*(HDZ-LIM1)+HDZZZ**2+
     &     LIM1**2+LIM1**2+2*LIM1*(HDZ-LIM1)+HDZZZ**2 + LIM1**2)))
      FAKT2=ONE
      ELSE IF (FAKT2.LE.ZERO) THEN
      FAKT2=0.0001D0
      END IF

C calculate noe(i1)x
      IF (VRN(L).GT.NOELOW(N+L-1)) THEN
      DEVI=VRN(L)-NOELOW(N+L-1)
      IF (DEVI.LT.LIM1) THEN
      ZZ(L)=(DEVI)**2
      DZZ(L)=TWO*DEVI
      ELSE
      ZZ(L)=LIM1**2  + (DEVI-LIM1)*2*LIM1
      DZZ(L)=TWO*LIM1
      END IF
      ELSE
      IF (VRN(L).LT.NOEDIS(N+L-1)) THEN
      DEVI=NOEDIS(N+L-1)-VRN(L)
      IF (DEVI.LT.LIM1) THEN
      ZZ(L)=(DEVI)**2
      DZZ(L)=-TWO*DEVI
      ELSE
      ZZ(L)= LIM1**2 + (DEVI-LIM1)*2*LIM1
      DZZ(L)=-TWO*LIM1
      END IF
      END IF
      END IF
C calculate noe(i1)y
      IF (VRN(L+1).GT.NOELOW(N+L)) THEN
      DEVI=VRN(L+1)-NOELOW(N+L)
      IF (DEVI.LT.LIM1) THEN
      ZZZ(L)=(DEVI)**2
      DZZZ(L)=TWO*DEVI
      ELSE
      ZZZ(L)=LIM1**2  + (DEVI-LIM1)*2*LIM1
      DZZZ(L)=TWO*LIM1
      END IF
      ELSE
      IF (VRN(L+1).LT.NOEDIS(N+L)) THEN
      DEVI=NOEDIS(N+L)-VRN(L+1)
      IF (DEVI.LT.LIM1) THEN
      ZZZ(L)=(DEVI)**2
      DZZZ(L)=-TWO*DEVI
      ELSE
      ZZZ(L)= LIM1**2 + (DEVI-LIM1)*2*LIM1
      DZZZ(L)=-TWO*LIM1
      END IF
      END IF
      END IF
C delta noe(i1)
      IF (VRN(L+1).LT.VRN(L)+NOEHIG(N+L-1)) THEN
      DEVI=(-VRN(L+1)+VRN(L)+NOEHIG(N+L-1))/SQRT(TWO)
      IF (DEVI.LT.LIM1) THEN
      ZZZZ(L)=DEVI**2
      D1ZZZ(L)=TWO*DEVI/SQRT(TWO)
      D2ZZZ(L)=-TWO*DEVI/SQRT(TWO)
      ELSE
      ZZZZ(L)=LIM1**2 + (DEVI-LIM1)*2*LIM1
      D1ZZZ(L)=TWO*LIM1/SQRT(TWO)
      D2ZZZ(L)=-TWO*LIM1/SQRT(TWO)
      END IF
      ELSE IF (VRN(L+1).GT.VRN(L)+NOEHIG(N+L)) THEN
      DEVI=(VRN(L+1)-VRN(L)-NOEHIG(N+L))/SQRT(TWO)
      IF (DEVI.LT.LIM1) THEN
      ZZZZ(L)=DEVI**2
      D1ZZZ(L)=-TWO*DEVI/SQRT(TWO)
      D2ZZZ(L)=TWO*DEVI/SQRT(TWO)
      ELSE
      ZZZZ(L)=LIM1**2+(DEVI-LIM1)*2*LIM1
      D1ZZZ(L)=-TWO*LIM1/SQRT(TWO)
      D2ZZZ(L)=TWO*LIM1/SQRT(TWO)
      END IF
      END IF
C
      IF (VRN(L).GT.NOELOW(N+L)) THEN
      DEVI=VRN(L)-NOELOW(N+L)
      IF (DEVI.LT.LIM1) THEN
      ZZ(L+1)=DEVI**2
      DZZ(L+1)=TWO*DEVI
      ELSE
      ZZ(L+1)=LIM1**2  + (DEVI-LIM1)*2*LIM1
      DZZ(L+1)=TWO*LIM1
      END IF
      ELSE
      IF (VRN(L).LT.NOEDIS(N+L)) THEN
      DEVI=NOEDIS(N+L)-VRN(L)
      IF (DEVI.LT.LIM1) THEN
      ZZ(L+1)=DEVI**2
      DZZ(L+1)=-TWO*DEVI
      ELSE
      ZZ(L+1)= LIM1**2 + (DEVI-LIM1)*2*LIM1
      DZZ(L+1)=-TWO*LIM1
      END IF
      END IF
      END IF
C
      IF (VRN(L+1).GT.NOELOW(N+L-1)) THEN
      DEVI=VRN(L+1)-NOELOW(N+L-1)
      IF (DEVI.LT.LIM1) THEN
      ZZZ(L+1)=DEVI**2
      DZZZ(L+1)=TWO*DEVI
      ELSE
      ZZZ(L+1)=LIM1**2  + (DEVI-LIM1)*2*LIM1
      DZZZ(L+1)=TWO*LIM1
      END IF
      ELSE
      IF (VRN(L+1).LT.NOEDIS(N+L-1)) THEN
      DEVI=NOEDIS(N+L-1)-VRN(L+1)
      IF (DEVI.LT.LIM1) THEN
      ZZZ(L+1)=DEVI**2
      DZZZ(L+1)=-TWO*DEVI
      ELSE
      ZZZ(L+1)= LIM1**2 + (DEVI-LIM1)*2*LIM1
      DZZZ(L+1)=-TWO*LIM1
      END IF
      END IF
      END IF
C
      IF (VRN(L+1).LT.VRN(L)-NOEHIG(N+L)) THEN
      DEVI=(-VRN(L+1)+VRN(L)-NOEHIG(N+L))/SQRT(TWO)
      IF (DEVI.LT.LIM1) THEN
      ZZZZ(L+1)=DEVI**2
      D1ZZZ(L+1)=2*DEVI/SQRT(TWO)
      D2ZZZ(L+1)=-2*DEVI/SQRT(TWO)
      ELSE
      ZZZZ(L+1)=LIM1**2 + (DEVI-LIM1)*2*LIM1
      D1ZZZ(L+1)=2*LIM1/SQRT(TWO)
      D2ZZZ(L+1)=-2*LIM1/SQRT(TWO)
      END IF
      ELSE IF (VRN(L+1).GT.VRN(L)-NOEHIG(N+L-1)) THEN
      DEVI=(VRN(L+1)-VRN(L)+NOEHIG(N+L-1))/SQRT(TWO)
      IF (DEVI.LT.LIM1) THEN
      ZZZZ(L+1)=DEVI**2
      D1ZZZ(L+1)=-2*DEVI/SQRT(TWO)
      D2ZZZ(L+1)=2*DEVI/SQRT(TWO)
      ELSE
      ZZZZ(L+1)=LIM1**2+(DEVI-LIM1)*2*LIM1
      D1ZZZ(L+1)=-2*LIM1/SQRT(TWO)
      D2ZZZ(L+1)=2*LIM1/SQRT(TWO)
      END IF
      END IF
C
      DZZ(L)=DZZ(L)*FAKT1
      DZZ(L+1)=DZZ(L+1)*FAKT1
      DZZZ(L)=DZZZ(L)*FAKT1
      DZZZ(L+1)=DZZZ(L+1)*FAKT1
      D1ZZZ(L)=D1ZZZ(L)*FAKT1
      D2ZZZ(L)=D2ZZZ(L)*FAKT1
      D1ZZZ(L+1)=D1ZZZ(L+1)*FAKT1
      D2ZZZ(L+1)=D2ZZZ(L+1)*FAKT1
C multiply FAKT2
      IF ((VRN(L).LT.NOEDIS(L+N-1)).AND.(VRN(L).LT.NOEDIS(L+N))) THEN
      IF (NOEDIS(L+N).LE.NOEDIS(L+N-1)) THEN
      ZZ(L+1)=FAKT2*ZZ(L+1)
      DZZ(L+1)=FAKT2*DZZ(L+1)
      ELSE IF (NOEDIS(L+N-1).LE.NOEDIS(L+N)) THEN
      ZZ(L) = FAKT2*ZZ(L)
      DZZ(L)=FAKT2*DZZ(L)
      END IF
      ELSE IF ((VRN(L).GT.NOELOW(L+N))
     &  .AND.(VRN(L).GT.NOELOW(L+N-1))) THEN
      IF (NOELOW(L+N).GE.NOELOW(L+N-1)) THEN
      ZZ(L+1)=FAKT2*ZZ(L+1)
      DZZ(L+1)=FAKT2*DZZ(L+1)
      ELSE IF (NOELOW(L+N-1).GE.NOELOW(L+N)) THEN
      ZZ(L)=FAKT2*ZZ(L)
      DZZ(L)=FAKT2*DZZ(L)
      END IF
      END IF
C
      IF ((VRN(L+1).LT.NOEDIS(L+N-1))
     &        .AND.(VRN(L+1).LT.NOEDIS(L+N))) THEN
      IF (NOEDIS(L+N).LE.NOEDIS(L+N-1)) THEN
      ZZZ(L)=FAKT2*ZZZ(L)
      DZZZ(L)=DZZZ(L)*FAKT2
      ELSE IF (NOEDIS(L+N-1).LE.NOEDIS(L+N)) THEN
      ZZZ(L+1) = FAKT2*ZZZ(L+1)
      DZZZ(L+1)= DZZZ(L+1)*FAKT2
      END IF
      ELSE IF ((VRN(L+1).GT.NOELOW(L+N))
     &        .AND.(VRN(L+1).GT.NOELOW(L+N-1))) THEN
      IF (NOELOW(L+N).GE.NOELOW(L+N-1)) THEN
      ZZZ(L)=FAKT2*ZZZ(L)
      DZZZ(L)=FAKT2*DZZZ(L)
      ELSE IF (NOELOW(L+N-1).GE.NOELOW(L+N)) THEN
      ZZZ(L+1)=FAKT2*ZZZ(L+1)
      DZZZ(L+1)=FAKT2*DZZZ(L+1)
      END IF
      END IF
C
      IF (((VRN(L+1).GT.ABS(NOEHIG(L+N))+VRN(L)).AND.
     &     (VRN(L+1).GT.VRN(L)+ABS(NOEHIG(L+N-1)))).OR.
     &     ((VRN(L).GT.ABS(NOEHIG(L+N))+VRN(L+1)).AND.
     &     (VRN(L).GT.ABS(NOEHIG(L+N-1))+VRN(L+1)))) THEN
      IF (ZZZZ(L+1).LE.ZZZZ(L)) THEN
      ZZZZ(L+1)=ZZZZ(L+1)*FAKT2
      D1ZZZ(L+1)=D1ZZZ(L+1)*FAKT2
      D2ZZZ(L+1)=D2ZZZ(L+1)*FAKT2
      ELSE
      ZZZZ(L)=ZZZZ(L)*FAKT2
      D1ZZZ(L)=D1ZZZ(L)*FAKT2
      D2ZZZ(L)=D2ZZZ(L)*FAKT2
      END IF
      END IF
      ZZZZ(L)=ZZZZ(L)*P15
      ZZZZ(L+1)=ZZZZ(L+1)*P15
      D1ZZZ(L)=D1ZZZ(L)*P15
      D2ZZZ(L)=D2ZZZ(L)*P15
      D1ZZZ(L+1)=D1ZZZ(L+1)*P15
      D2ZZZ(L+1)=D2ZZZ(L+1)*P15
      E1=E1 + FAKT1*(ZZ(L)+ZZZ(L) + ZZZZ(L))
      E2=E2 + FAKT1*(ZZ(L+1)+ZZZ(L+1) + ZZZZ(L+1))
      END DO
      DO L=1,NOECOR(NOECND(N)),2
      VDF(L)=NOEWGH(N)*NOESCA(NOECND(N))*(E2*(DZZ(L)+D1ZZZ(L))+
     &                              E1*(DZZ(L+1)+D1ZZZ(L+1)))
      VDF(L+1)=NOEWGH(N)*NOESCA(NOECND(N))*(E2*(DZZZ(L) + D2ZZZ(L))
     &                            + E1*(DZZZ(L+1) + D2ZZZ(L+1)))
      END DO
C*************************************
      EL = E1*E2* NOEWGH(N)*NOESCA(NOECND(N))
C accumulate energy
      EN=EN+EL
      DO K=1,NOECOR(NOECND(N))
C
C accumulate derivatives
C
C do center averaging
C +++++++++++++++++++
      L=0
      DO II=NOEIPR(N+K-1)+1,NOEIPR(N+K)
      I=NOEILS(II)
      DX(I)=DX(I)+VDF(K)*VXIJ(K)/(VRN(K)*VLI(K))
      DY(I)=DY(I)+VDF(K)*VYIJ(K)/(VRN(K)*VLI(K))
      DZ(I)=DZ(I)+VDF(K)*VZIJ(K)/(VRN(K)*VLI(K))
      END DO
      DO JJ=NOEJPR(N+K-1)+1,NOEJPR(N+K)
      J=NOEJLS(JJ)
      DX(J)=DX(J)-VDF(K)*VXIJ(K)/(VRN(K)*VLJ(K))
      DY(J)=DY(J)-VDF(K)*VYIJ(K)/(VRN(K)*VLJ(K))
      DZ(J)=DZ(J)-VDF(K)*VZIJ(K)/(VRN(K)*VLJ(K))
      END DO
      END DO
C
      ELSE IF (HN.EQ.NOECOR(NOECND(N))) THEN
      HN=0
      END IF
C +++++++++++++++++++++++++++++++++++++++++++++++++++++
C end highdimensional potential
C
      ELSE IF (NOEPOT(NOECND(N)).EQ.NOE3DP) THEN
C +++++++++++++++++++++++++++++++++++++++++++++++++++++++
C  do 3dpotential
C
      HN = HN + 1
      E1=ZERO
      E2=ZERO
      IF (HN.EQ.1) THEN
C only at the beginning of a new class of noes
C
      DO K=1,2
C loop for each noe pair
C
      IF (NOEAVE(NOECND(N)).EQ.NOEM6) THEN
C do r-6 averaging
C ++++++++++++++++
C      WRITE(PUNIT,'(A)') 'DO R-6 AVERAGING '
C R = ( <R-6> ) -1/6
      VLI(K)=0
      VRN(K)=ZERO
C loop over all pairs of atoms belonging to restraint N
      DO II=NOEIPR(N+K-1)+1,NOEIPR(N+K)
      DO JJ=NOEJPR(N+K-1)+1,NOEJPR(N+K)
      I=NOEILS(II)
      J=NOEJLS(JJ)
      VXIJ(K)=X(I)-X(J)
      VYIJ(K)=Y(I)-Y(J)
      VZIJ(K)=Z(I)-Z(J)
      VSIJ(K)=VXIJ(K)**2+VYIJ(K)**2+VZIJ(K)**2
      VRIJ(K)=ONE/(VSIJ(K)**(THREE))
      VRN(K)=VRIJ(K)+VRN(K)
C local derivative accumulation
      VLI(K)=VLI(K)+1
      VRIJ(K)=VRIJ(K)/VSIJ(K)
      VDDX(VLI(K),K)=VRIJ(K)*VXIJ(K)
      VDDY(VLI(K),K)=VRIJ(K)*VYIJ(K)
      VDDZ(VLI(K),K)=VRIJ(K)*VZIJ(K)
      END DO
      END DO
C
      VRN(K)=(VLI(K)/VRN(K))**(ONE/SIX)
C
      ELSE IF (NOEAVE(NOECND(N)).EQ.NOECEN) THEN

C do center averaging
C +++++++++++++++++++
C R= (r1   -    r2      )
C       center    center
C
      VLI(K)=0
      VXI(K)=ZERO
      VYI(K)=ZERO
      VZI(K)=ZERO
C ...loop over all pairs of atoms belonging to restraint N
CSGI-specific optimization
C*$*SCALAR OPTIMIZE(0)
      DO II=NOEIPR(N+K-1)+1,NOEIPR(N+K)
      I=NOEILS(II)
      VXI(K)=VXI(K)+X(I)
      VYI(K)=VYI(K)+Y(I)
      VZI(K)=VZI(K)+Z(I)
      VLI(K)=VLI(K)+1
      END DO
CSGI-specific optimization
C*$*SCALAR OPTIMIZE(3)
      VXI(K)=VXI(K)/VLI(K)
      VYI(K)=VYI(K)/VLI(K)
      VZI(K)=VZI(K)/VLI(K)
      VLJ(K)=0
      VXJ(K)=ZERO
      VYJ(K)=ZERO
      VZJ(K)=ZERO
      DO JJ=NOEJPR(N+K-1)+1,NOEJPR(N+K)
      J=NOEJLS(JJ)
      VXJ(K)=VXJ(K)+X(J)
      VYJ(K)=VYJ(K)+Y(J)
      VZJ(K)=VZJ(K)+Z(J)
      VLJ(K)=VLJ(K)+1
      END DO
      VXJ(K)=VXJ(K)/VLJ(K)
      VYJ(K)=VYJ(K)/VLJ(K)
      VZJ(K)=VZJ(K)/VLJ(K)
      VXIJ(K)=VXI(K)-VXJ(K)
      VYIJ(K)=VYI(K)-VYJ(K)
      VZIJ(K)=VZI(K)-VZJ(K)
      VRN(K)=SQRT(VXIJ(K)**2+VYIJ(K)**2+VZIJ(K)**2)
      END IF
      END DO
C
      IF (NOEDIS(N).LE.NOELOW(N)) NOELOW(N)=NOEDIS(N)/TEN
      ELOW=(NOESWI(NOECND(N))*(NOEDIS(N)-NOELOW(N)))**(-ONE/TWELVE)
      EHIG=(NOESWI(NOECND(N))*(NOEDIS(N)+NOEHIG(N)))**(-ONE/TWELVE)
      E2=(VRN(1)**(-SIX)*VRN(2)**(-SIX))**(-ONE/TWELVE)
      IF (E2.GT.ELOW) THEN
      HE=E2-ELOW
      ELSE IF (E2.LT.EHIG) THEN
      HE=E2-EHIG
      ELSE
      HE=0
      END IF
C
C +++++++++++++++++++++++++++++++++++++++++++++++++++
      VDF(1)=NOEWGH(N)*NOESCA(NOECND(N))*(HE)*E2**13*VRN(2)**(-SIX)*
     &             VRN(1)**(-SEVEN)
      VDF(2)=NOEWGH(N)*NOESCA(NOECND(N))*(HE)*E2**13*VRN(2)**(-SEVEN)*
     &             VRN(1)**(-SIX)
      EL = NOEWGH(N)*NOESCA(NOECND(N))*(HE)**2
C
C accumulate energy
      EN=EN+EL
      DO K=1,2
C
C accumulate derivatives
C
      IF (NOEAVE(NOECND(N)).EQ.NOEM6) THEN
C do r-6 averaging
C ++++++++++++++++
      VDF(K)=(VDF(K)*VRN(K)**(SEVEN))/VLI(K)
      VLI(K)=0
      DO II=NOEIPR(N+K-1)+1,NOEIPR(N+K)
      DO JJ=NOEJPR(N+K-1)+1,NOEJPR(N+K)
      I=NOEILS(II)
      J=NOEJLS(JJ)
      VLI(K)=VLI(K)+1
      DX(I)=DX(I)+VDF(K)*VDDX(VLI(K),K)
      DX(J)=DX(J)-VDF(K)*VDDX(VLI(K),K)
      DY(I)=DY(I)+VDF(K)*VDDY(VLI(K),K)
      DY(J)=DY(J)-VDF(K)*VDDY(VLI(K),K)
      DZ(I)=DZ(I)+VDF(K)*VDDZ(VLI(K),K)
      DZ(J)=DZ(J)-VDF(K)*VDDZ(VLI(K),K)
      END DO
      END DO
C
      ELSE IF (NOEAVE(NOECND(N)).EQ.NOECEN) THEN
C do center averaging
C +++++++++++++++++++
      L=0
      DO II=NOEIPR(N+K-1)+1,NOEIPR(N+K)
      I=NOEILS(II)
      DX(I)=DX(I)+VDF(K)*VXIJ(K)/(VRN(K)*VLI(K))
      DY(I)=DY(I)+VDF(K)*VYIJ(K)/(VRN(K)*VLI(K))
      DZ(I)=DZ(I)+VDF(K)*VZIJ(K)/(VRN(K)*VLI(K))
      END DO
      DO JJ=NOEJPR(N+K-1)+1,NOEJPR(N+K)
      J=NOEJLS(JJ)
      DX(J)=DX(J)-VDF(K)*VXIJ(K)/(VRN(K)*VLJ(K))
      DY(J)=DY(J)-VDF(K)*VYIJ(K)/(VRN(K)*VLJ(K))
      DZ(J)=DZ(J)-VDF(K)*VZIJ(K)/(VRN(K)*VLJ(K))
      END DO
      END IF
      END DO
C
      RN=VRN(1)
      ELSE IF (HN.EQ.2.0) THEN
      RN=VRN(2)
      HN=0
      END IF
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++
C end 3dpot
C
      END IF
C
      RETURN
      END
C====================================================================
      SUBROUTINE DISNOE(ICL1,ICL2,NOEDST,NOECND)
C
C
C subroutine reclassifies noe restraints between two classes:
C If the actual deviation is larger than NOEDST, it goes into class 2,
C otherwise it goes into class 1.
C
C Author: Michael Nilges
C
      IMPLICIT NONE
C I/O
      INCLUDE 'cns.inc'
      INCLUDE 'noe.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'pick.inc'
      INCLUDE 'comand.inc'
      INTEGER ICL1, ICL2
      DOUBLE PRECISION NOEDST
      INTEGER NOECND(*)
C local
      DOUBLE PRECISION EN
      INTEGER N, NEXCL, N1, N2
C begin
      NEXCL=0
      N1=0
      N2=0
      IF (NOENUM.GT.0) THEN
      DO N=1,NOENUM
      CALL ENOE(EN,'ANAL',N)
      IF (NOECND(N).EQ.ICL1) THEN
      IF (ABS(PCDATA(PCDEVI)).GE.NOEDST) THEN
      NOECND(N)=ICL2
      NEXCL=NEXCL+1
      N2=N2+1
      ELSE
      N1=N1+1
      END IF
      ELSE
      IF (NOECND(N).EQ.ICL2) THEN
      IF (ABS(PCDATA(PCDEVI)).LT.NOEDST) THEN
      NOECND(N)=ICL1
      NEXCL=NEXCL+1
      N1=N1+1
      ELSE
      N2=N2+1
      END IF
      END IF
      END IF
      END DO
      WRITE(6,'(A,I5,A)') ' DISNOE:',NEXCL,' restraints reclassified'
      WRITE(6,'(A,I5,A,A4)')
     &     '         ',N1,' restraints in class ',NOECNM(ICL1)
      WRITE(6,'(A,I5,A,A4)')
     &     '         ',N2,' restraints in class ',NOECNM(ICL2)
      END IF
      RETURN
      END
C====================================================================
      SUBROUTINE RESETN(ICL1,NOECND,NOERAV,NOEDIS,SRESET)
C
C
C This subroutine resets current values of either the NOERAV or NOERRV
C arrays; these contain the current (exponentially weighted)
C time averaged-distances, and the running-total distances respectively.
C
      IMPLICIT NONE
C I/O
      INCLUDE 'cns.inc'
      INCLUDE 'noe.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'pick.inc'
      INCLUDE 'comand.inc'
      INTEGER ICL1
      INTEGER NOECND(*)
      DOUBLE PRECISION NOERAV(*), NOEDIS(*)
      CHARACTER*4 SRESET
C local
      INTEGER N
      DOUBLE PRECISION EN
C parameter
      DOUBLE PRECISION ZERO
      PARAMETER (ZERO=0.0D0)
C begin
      IF (NOENUM.GT.0) THEN
      IF (SRESET.EQ.'CURR') THEN
      DO N=1,NOENUM
      IF (NOECND(N).EQ.ICL1) THEN
      CALL ENOE(EN,'ANAL',N)
      NOERAV(N)=PCDATA(PCGEOM)
      END IF
      END DO
      ELSEIF (SRESET.EQ.'CONS') THEN
      DO N=1,NOENUM
      IF (NOECND(N).EQ.ICL1) THEN
      NOERAV(N)=NOEDIS(N)
      END IF
      END DO
      END IF
      END IF
      RETURN
      END
C====================================================================
      SUBROUTINE RESETC(ICL1,NOESTP,NOECND)
C
C
C This subroutine resets current values of the NOESTP array.
C This array contains the current number of time/energy steps used
C to calculate the running-average.
C
      IMPLICIT NONE
C I/O
      INCLUDE 'cns.inc'
      INCLUDE 'noe.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'pick.inc'
      INCLUDE 'comand.inc'
      INTEGER ICL1, NOESTP(*), NOECND(*)
C local
      INTEGER N
C begin
      DO N=1,NOENUM
      IF (NOECND(N).EQ.ICL1) THEN
      NOESTP(N)=0
      END IF
      END DO
      RETURN
      END
C====================================================================
      SUBROUTINE COUNTV(ICL1,NOECND)
C
C
C subroutine counts noe violations in a class
C and stores the smallest positive violation in $result.
C if there are no violations, $result is set to 0, if there
C are no restraints, $result is set to -1.
C
C Author: Michael Nilges
C
      IMPLICIT NONE
C I/O

      INCLUDE 'cns.inc'
      INCLUDE 'noe.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'pick.inc'
      INCLUDE 'comand.inc'
      INCLUDE 'symbol.inc'
      INTEGER ICL1
      INTEGER NOECND(*)
C local
      DOUBLE PRECISION EN, ZERO, MINVIO
      INTEGER N, NVIOL, MONE, NCLASS
      PARAMETER (ZERO=0.0D0,MONE=-1.0D0)
      DOUBLE COMPLEX DBCOMP
C begin
      NVIOL=0
      NCLASS=0
      MINVIO=9999.0D0
      IF (NOENUM.GT.0) THEN
      DO N=1,NOENUM
      IF (NOECND(N).EQ.ICL1) THEN
      CALL ENOE(EN,'ANAL',N)
      NCLASS=NCLASS+1
      IF (ABS(PCDATA(PCDEVI)).GT.ZERO) THEN
      NVIOL=NVIOL+1
      MINVIO=MIN(MINVIO,ABS(PCDATA(PCDEVI)))
      END IF
      END IF
      END DO
      END IF
      IF(NVIOL.EQ.0)MINVIO=ZERO
      IF(NCLASS.EQ.0)MINVIO=MONE
      WRITE(6,'(A,I5,A,A4)')
     &     ' COUNTV:',NVIOL,' violations in class ',NOECNM(ICL1)
C
      CALL DECLAR( 'RESULT', 'DP', ' ', DBCOMP, MINVIO )
      CALL DECLAR( 'MIN_VIOLATIONS', 'DP', ' ', DBCOMP, MINVIO )
      IF (NVIOL.GT.0) THEN
      WRITE(6,'(A,F8.3)') '        smallest violation=',MINVIO
      END IF
C
      RETURN
      END
C====================================================================
      SUBROUTINE NOEINI
C
C subroutine initializes the NOE list
C

C Author: Axel Brunger
C
      IMPLICIT NONE
C I/O
      INCLUDE 'cns.inc'
      INCLUDE 'noe.inc'
C begin
      NOETEM=300.0D0
      NOECEI=30.0D0
C
C set heap pointers of dynamic data structure
C to zero
      HPNORR=0
      HPNIPR=0
      HPNILS=0
      HPNJPR=0
      HPNJLS=0
      HPNCND=0
      HPNRAV=0
      HPNRRV=0
      HPNNSP=0
      HPNDIS=0
      HPNLOW=0
      HPNHIG=0
      HPNWGH=0
      HPNCV=0
      HPNEXC=0
      HPNNUM=0
      HPNVIO=0
      HPNPID=0
      HPNSPC=0
      HPNPP1=0
      HPNPP2=0
      HPNHP1=0
      HPNHP2=0
      HPNVOL=0
      HPCVOL=0
      HPCDIS=0
      HPNPRD=0
C
C
C reset other variables
      CALL NOERES
      RETURN
      END
C====================================================================
      SUBROUTINE NOERES
C
C subroutine resets the NOE list
C Author: Axel T. Brunger
C
      IMPLICIT NONE
C I/O
      INCLUDE 'cns.inc'
      INCLUDE 'noe.inc'
      INCLUDE 'consta.inc'
C begin
      CALL NOEHP(0)
C
      NOESMX=0
      NORSMX=0
      NOECCN=1
      NOECNM(1)='NIL'
      NOESCA(1)=1.0D0
      NOEAVE(1)=NOEM6
      NOEPOT(1)=NOEBIH
      NOEEXP(1)=2
      NOECNS(1)=20.0D0
      NOEOFF(1)=0.0D0
      NOEMOF(1)=0.0D0
      NOESOE(1)=2
      NOEASY(1)=0.0D0
      NOESWI(1)=10.0D0
      NOEMSO(1)=2
      NOEMAS(1)=0.0D0
      NOEMSW(1)=10.0D0
      NOEICV=0
      NMONO(1)=1
      NOERM2(1)=0.0D0
      NOENU2(1)=1
      NAVEXP(1)=6.0D0
      OREXP(1)=6.0D0
C
C reset time and running-average stuff
      DAVEXP(1)=3
      RAVEXP(1)=3
      MEMTAU(1)=1000.

      TMODE(1)='OFF'
      RMODE(1)='OFF'
      TFMODE(1)='CONS'
      RANA='CURR'
C
C reset ensemble-average stuff
      IDIMER=0
      DIENS=' '
      EMODE='OFF'
      OCCU=.FALSE.
C
      RETURN
      END
C====================================================================
      SUBROUTINE NOEHP(NOENEW)
C
C routine allocates space for NOE restraints list on the HEAP
C
C Author: Axel T. Brunger
C =======================
      IMPLICIT NONE
C I/O
      INCLUDE 'cns.inc'
      INCLUDE 'heap.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'noe.inc'
C mtf.inc necessary for ARIA
      INCLUDE 'mtf.inc'
      INTEGER NOENEW
      LOGICAL HEAPDEBUG
C begin
C
C check whether space was already allocated
      IF (HPNORR.NE.0) CALL FREHP(HPNORR,INTEG4(NOEMAX))
      IF (HPNIPR.NE.0) CALL FREHP(HPNIPR,INTEG4(NOEMAX))
      IF (HPNILS.NE.0) CALL FREHP(HPNILS,INTEG4(NOEMAX))
      IF (HPNJPR.NE.0) CALL FREHP(HPNJPR,INTEG4(NOEMAX))
      IF (HPNJLS.NE.0) CALL FREHP(HPNJLS,INTEG4(NOEMAX))
      IF (HPNCND.NE.0) CALL FREHP(HPNCND,INTEG4(NOEMAX))
      IF (HPNRAV.NE.0) CALL FREHP(HPNRAV,IREAL8(NOEMAX))
      IF (HPNRRV.NE.0) CALL FREHP(HPNRRV,IREAL8(NOEMAX))
      IF (HPNNSP.NE.0) CALL FREHP(HPNNSP,INTEG4(NOEMAX))
      IF (HPNDIS.NE.0) CALL FREHP(HPNDIS,IREAL8(NOEMAX))
      IF (HPNLOW.NE.0) CALL FREHP(HPNLOW,IREAL8(NOEMAX))
      IF (HPNHIG.NE.0) CALL FREHP(HPNHIG,IREAL8(NOEMAX))
      IF (HPNWGH.NE.0) CALL FREHP(HPNWGH,IREAL8(NOEMAX))
      IF (HPNCV.NE.0)  CALL FREHP(HPNCV, INTEG4(NOEMAX))
      IF (HPNEXC.NE.0) CALL FREHP(HPNEXC, INTEG4(NOEMAX))
      IF (HPNNUM.NE.0) CALL FREHP(HPNNUM, INTEG4(NOEMAX))
      IF (HPNVIO.NE.0) CALL FREHP(HPNVIO,INTEG4(NOEMAX))
      IF (HPNPID.NE.0) CALL FREHP(HPNPID,INTEG4(NOEMAX))
      IF (HPNSPC.NE.0) CALL FREHP(HPNSPC,IREAL8(NOEMAX))
      IF (HPNPP1.NE.0) CALL FREHP(HPNPP1,IREAL8(NOEMAX))
      IF (HPNPP2.NE.0) CALL FREHP(HPNPP2,IREAL8(NOEMAX))
      IF (HPNHP1.NE.0) CALL FREHP(HPNHP1,IREAL8(NOEMAX))
      IF (HPNHP2.NE.0) CALL FREHP(HPNHP2,IREAL8(NOEMAX))
      IF (HPNVOL.NE.0) CALL FREHP(HPNVOL,IREAL8(NOEMAX))
      IF (HPCVOL.NE.0) CALL FREHP(HPCVOL,IREAL8(NOEMAX))
      IF (HPCDIS.NE.0) CALL FREHP(HPCDIS,IREAL8(NOEMAX))
C
      NOENUM=0
      NOEORN=0
      NOEMAX=0
      NPEAKI=0
C
      HPNORR=0
      HPNIPR=0
      HPNILS=0
      HPNJPR=0
      HPNJLS=0
      HPNCND=0
      HPNRAV=0
      HPNRRV=0
      HPNNSP=0
      HPNDIS=0
      HPNLOW=0
      HPNHIG=0
      HPNWGH=0
      HPNCV=0
      HPNEXC=0
      HPNNUM=0
      HPNVIO=0
      HPNPID=0
      HPNSPC=0
      HPNPP1=0
      HPNPP2=0
      HPNHP1=0
      HPNHP2=0
      HPNVOL=0
      HPCVOL=0
      HPCDIS=0
      HPNPRD=0
C
C now allocate new space
      IF (NOENEW.GT.0) THEN
      NOEMAX=NOENEW
      HPCDIS=ALLHP(IREAL8(NOENEW))
      HPCVOL=ALLHP(IREAL8(NOENEW))
      HPNVOL=ALLHP(IREAL8(NOENEW))
      HPNHP2=ALLHP(IREAL8(NOENEW))
      HPNHP1=ALLHP(IREAL8(NOENEW))
      HPNPP2=ALLHP(IREAL8(NOENEW))
      HPNPP1=ALLHP(IREAL8(NOENEW))
      HPNSPC=ALLHP(IREAL8(NOENEW))
      HPNPID=ALLHP(INTEG4(NOENEW))
      HPNVIO=ALLHP(INTEG4(NOENEW))
      HPNCV=ALLHP(INTEG4(NOENEW))
      HPNEXC=ALLHP(INTEG4(NOENEW))
      HPNNUM=ALLHP(INTEG4(NOENEW))
      HPNWGH=ALLHP(IREAL8(NOENEW))
      HPNHIG=ALLHP(IREAL8(NOENEW))
      HPNLOW=ALLHP(IREAL8(NOENEW))
      HPNRAV=ALLHP(IREAL8(NOENEW))
      HPNRRV=ALLHP(IREAL8(NOENEW))
      HPNNSP=ALLHP(INTEG4(NOENEW))
      HPNDIS=ALLHP(IREAL8(NOENEW))
      HPNCND=ALLHP(INTEG4(NOENEW))
      HPNJLS=ALLHP(INTEG4(NOENEW))
      HPNJPR=ALLHP(INTEG4(NOENEW))
      HPNILS=ALLHP(INTEG4(NOENEW))
      HPNIPR=ALLHP(INTEG4(NOENEW))
      HPNORR=ALLHP(INTEG4(NOENEW))
      END IF
      RETURN
      END
C====================================================================
      SUBROUTINE NOECVS(NOENUM,NOECV,PART)
C
C Routine partitions NOE data into PART sets.
C NOECV will contain integer numbers between 1 and PART.
C
C Author: Axel T. Brunger
C
C
C     IMPLICIT NONE
C I/O
      INTEGER NOENUM, NOECV(*)
      INTEGER PART
C local
      INTEGER I, P, NP, NRETRY, NTRYTOT
      DOUBLE PRECISION RNUM
      NTRYTOT = 0
C begin
  100 CONTINUE
      NRETRY = 0
      IF (PART.GT.0) THEN
      DO I=1,NOENUM
      CALL GGUBFS(RNUM)
      NOECV(I)=MAX(1,MIN(PART,INT(RNUM*PART)+1))
      END DO
C
      IF (PART .EQ. NOENUM) THEN
      DO I=1,NOENUM
      NOECV(I)=I
      END DO
      END IF
C
      DO P=1,PART
      NP=0
      DO I=1,NOENUM
      IF (NOECV(I).EQ.P) THEN
      NP=NP+1
      END IF
      END DO
      IF (NP .EQ. 0) THEN
        NRETRY = 1
      ENDIF
      WRITE(6,'(A,I3,A,I5,A)') ' For set ',P,
     & ' there are ',NP,' distance restraints.'
      END DO
      ELSE
      WRITE(6,'(A)')
     & ' Data are not partitioned or partitioning removed.'
      DO I=1,NOENUM
      NOECV(I)=-1
      END DO
      END IF
      NTRYTOT = NTRYTOT + NRETRY
      IF (NRETRY .GT. 0 .AND. NTRYTOT .LE. 10) THEN
      WRITE(6,'(A)')
     & ' Test set with 0 constraints! New trial...'
      GOTO 100
      ELSE IF (NTRYTOT .GT. 10) THEN
      CALL WRNDIE(-1,'NOECVS',
     & 'Unable to correctly partition the NOE data within ten trials')
      ENDIF
C
      RETURN
      END
C====================================================================
      SUBROUTINE ENSBLE(WENS,I,J)
C
C  set weighting factors for ensemble-averaged restraints
C  to keep only intra model distances
C
      IMPLICIT NONE
C I/O
      INCLUDE 'cns.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'noe.inc'
      INCLUDE 'coord.inc'
      DOUBLE PRECISION WENS
      INTEGER I, J, L
C
      IF (SEGID(I).NE.SEGID(J)) THEN
      WENS = -1.0
      IF (DIENS.EQ.'DIME') THEN
      DO L = 1, IDIMER
      IF ((SEGID(I).EQ.ENSMOD(L,1).AND.
     &     SEGID(J).EQ.ENSMOD(L,2)).OR.
     &    (SEGID(I).EQ.ENSMOD(L,2).AND.
     &     SEGID(J).EQ.ENSMOD(L,1))) THEN
      WENS = MIN(QMAIN(I),QMAIN(J))
      END IF
      END DO
      END IF
      ELSE
      WENS = MIN(QMAIN(I),QMAIN(J))
      END IF
      IF (.NOT. OCCU .AND. WENS .GE. 0.0) WENS = 1.0
C      WRITE(6,'(A,A5,A,A5,F5.2)')
C     & 'SEGID I=',SEGID(I),' SEGID J=',SEGID(J),WENS
      RETURN
      END
C

C===============
      SUBROUTINE EVEAN (EV, WHICH)
C     
C     Calls EVEAN2, which does the actual energy calculation
C     
C     by Jens Meiler / Michael Nilges Jan 1999
C===============
      IMPLICIT NONE
C     include files
      INCLUDE 'cns.inc'
      INCLUDE 'vectangl.inc'
      INCLUDE 'heap.inc'
C     i/o
      DOUBLE PRECISION EV
      CHARACTER*7 WHICH
C     begin
C     
C     
      CALL EVEAN2(EV, HEAP(VEANIPTR), HEAP(VEANJPTR), HEAP(VEANKPTR),
     &     HEAP(VEANLPTR),
     &     HEAP(VEANVOBSPTR), HEAP(VEANVERRPTR), HEAP(CALCVEANPTR),
     &     WHICH, HEAP(VEANCV))
      RETURN
      END
C===============
      SUBROUTINE EVEAN2 (EV, ATOMI, ATOMJ, ATOMK, ATOML,
     &     VOBS, VERR, VCALC, WHICH, VCV)
C     
C     Calculates vectorangle constant energies
C     
C     energies are of the form
C     E = kbord*deltaV**2 or E*kcent*(1+cos(deltaV / delta))
C     where
C     kbord = energy constant for angles at border,
C     kcent = energy constant for angles in center,
C     
C     by Jens Meiler / Michael Nilges Jan 1999
C     
C===============
      IMPLICIT NONE
C     include files
      INCLUDE 'cns.inc'
      INCLUDE 'coord.inc'
      INCLUDE 'numbers.inc'
      INCLUDE 'deriv.inc'
      INCLUDE 'vectangl.inc'
      INCLUDE 'consta.inc'
      INCLUDE 'comand.inc'
C     
      INCLUDE 'mtf.inc'
C     i/o
      INTEGER ATOMI(*), ATOMJ(*), ATOMK(*), ATOML(*), VCV(*)
      DOUBLE PRECISION VOBS(2,*), VERR(2,*), VCALC(2,*)
      DOUBLE PRECISION EV
      CHARACTER*7 WHICH
C     local variables
      INTEGER COUNT, CLASS
      DOUBLE PRECISION Kveancent, Kveanbord, Ealpha, Dalpha
      DOUBLE PRECISION XI, XJ, XK, XL, YI, YJ, YK, YL, ZI, ZJ, ZK, ZL
      DOUBLE PRECISION XIJ, XKL, YIJ, YKL, ZIJ, ZKL, LIJ, LKL
      DOUBLE PRECISION COSALPHA, SINALPHA, RECSIN, ALPHA, VOBSA
      DOUBLE PRECISION VOBSB, VOBSC, VOBSD, DV
      DOUBLE PRECISION DPRIJX, DPRIJY, DPRIJZ, DPRKLX, DPRKLY, DPRKLZ
C     begin
C     
C     following Axel's code in ETOR,
C     
C     zero out partial energy
C     
      EV = ZERO
C     
      CLASS = 1
      Kveancent = VEANFORCES(2,CLASS)
      Kveanbord = VEANFORCES(1,CLASS)
      DO COUNT = 1, NVEANS
         IF (VEANASSNDX(CLASS).LT.COUNT) THEN
            CLASS = CLASS + 1
            Kveancent = VEANFORCES(1,CLASS)
            Kveanbord = VEANFORCES(2,CLASS)
         END IF
C     
         XI = X(ATOMI(COUNT))
         XJ = X(ATOMJ(COUNT))
         XK = X(ATOMK(COUNT))
         XL = X(ATOML(COUNT))
C     
         YI = Y(ATOMI(COUNT))
         YJ = Y(ATOMJ(COUNT))
         YK = Y(ATOMK(COUNT))
         YL = Y(ATOML(COUNT))
C     
         ZI = Z(ATOMI(COUNT))
         ZJ = Z(ATOMJ(COUNT))
         ZK = Z(ATOMK(COUNT))
         ZL = Z(ATOML(COUNT))
C     
         VOBSA = (VOBS(1,COUNT) - VERR(1,COUNT)) * PI / 180
         VOBSB = (VOBS(1,COUNT) + VERR(1,COUNT)) * PI / 180
         VOBSC = (VOBS(2,COUNT) - VERR(2,COUNT)) * PI / 180
         VOBSD = (VOBS(2,COUNT) + VERR(2,COUNT)) * PI / 180
         if(VOBSC.lt.VOBSB) then
            VOBSC = PI/2
            VOBSB = PI/2
         end if
C     
C     now calculate diffs RIJ=RI-RJ, RJK=RJ-RK, RKL=RK-RL
C     
         XIJ = XI - XJ
         XKL = XK - XL
C     
         YIJ = YI - YJ
         YKL = YK - YL
C     
         ZIJ = ZI - ZJ
         ZKL = ZK - ZL
C     
C     calculate the norm of A, B, & C & set to MCONST if it's too small
C     
         LIJ = ONE/SQRT(MAX(MCONST, XIJ**2+YIJ**2+ZIJ**2))
         LKL = ONE/SQRT(MAX(MCONST, XKL**2+YKL**2+ZKL**2))
C     
C     normalize A, B, & C
C     
         XIJ = XIJ * LIJ
         YIJ = YIJ * LIJ
         ZIJ = ZIJ * LIJ
         XKL = XKL * LKL
         YKL = YKL * LKL
         ZKL = ZKL * LKL
C     
C     calculate cos(alpha)
C     
         COSALPHA = XIJ*XKL+YIJ*YKL+ZIJ*ZKL
         SINALPHA = SQRT(MAX(ZERO,ONE-COSALPHA**2))
C     
C     calculate alpha (make sure cos is within bounds and get sign from
C     sin) and keep it it radians
C     
         ALPHA = ACOS(MIN(ONE,MAX(-ONE,COSALPHA)))
C     
C     calculate energy and forces for normal entries
C     
         if (ALPHA.lt.VOBSA) then
            Ealpha = Kveanbord*((ALPHA-VOBSA)**2)
            Dalpha = Kveanbord* (ALPHA-VOBSA) *2
         elseif (ALPHA.lt.VOBSB) then
            Ealpha = 0
            Dalpha = 0
         elseif (ALPHA.lt.VOBSC.AND.VOBSB.lt.VOBSC) then
            Ealpha = 0.5*Kveancent*(1+COS(2*PI*(ALPHA-VOBSB)/
     $           (VOBSC-VOBSB)-PI))
            Dalpha = Kveancent*PI/(VOBSB-VOBSC)*
     $           SIN(2*PI*(ALPHA-VOBSB)/(VOBSC-VOBSB)-PI)
         elseif (ALPHA.lt.VOBSD) then
            Ealpha = 0
            Dalpha = 0
         else
            Ealpha = Kveanbord*((ALPHA-VOBSD)**2)
            Dalpha = Kveanbord* (ALPHA-VOBSD) *2
         end if
C     
C     If we're printing out the couplings, then we need to
C     try both possible assignments of observed with the
C     the angle and pick the one with the lower total violation.
C     
         IF (WHICH.EQ.'ANALYZE') VCALC(1,COUNT) = ALPHA
C     
C     accumulate energy (only for working set)
C     
         EV = Ealpha + EV
         DV = Dalpha
C     
C     compute reciprocal of SP multiplied by the derivative of the
C     function DF
         RECSIN = DV/MAX(MCONST,SINALPHA)
C     
C     compute:
C     d (alpha)
C     DF ---------,  etc.
C     d rij
         DPRIJX = RECSIN*LIJ*(COSALPHA*XIJ-XKL)
         DPRIJY = RECSIN*LIJ*(COSALPHA*YIJ-YKL)
         DPRIJZ = RECSIN*LIJ*(COSALPHA*ZIJ-ZKL)
         DPRKLX = RECSIN*LKL*(COSALPHA*XKL-XIJ)
         DPRKLY = RECSIN*LKL*(COSALPHA*YKL-YIJ)
         DPRKLZ = RECSIN*LKL*(COSALPHA*ZKL-ZIJ)
C     
C     now update forces if in energy & force mode
C     
         IF (WHICH.NE.'ANALYZE') THEN
            IF (VCV(COUNT).NE.VICV) THEN
               DX(ATOMI(COUNT))=DX(ATOMI(COUNT))+DPRIJX
               DY(ATOMI(COUNT))=DY(ATOMI(COUNT))+DPRIJY
               DZ(ATOMI(COUNT))=DZ(ATOMI(COUNT))+DPRIJZ
               DX(ATOMJ(COUNT))=DX(ATOMJ(COUNT))-DPRIJX
               DY(ATOMJ(COUNT))=DY(ATOMJ(COUNT))-DPRIJY
               DZ(ATOMJ(COUNT))=DZ(ATOMJ(COUNT))-DPRIJZ
               DX(ATOMK(COUNT))=DX(ATOMK(COUNT))+DPRKLX
               DY(ATOMK(COUNT))=DY(ATOMK(COUNT))+DPRKLY
               DZ(ATOMK(COUNT))=DZ(ATOMK(COUNT))+DPRKLZ
               DX(ATOML(COUNT))=DX(ATOML(COUNT))-DPRKLX
               DY(ATOML(COUNT))=DY(ATOML(COUNT))-DPRKLY
               DZ(ATOML(COUNT))=DZ(ATOML(COUNT))-DPRKLZ
            END IF
         END IF
      END DO
      RETURN
      END
C================
      SUBROUTINE READVEAN
C     
C     reads in vectorangle constant information
C     
C     by Jens Meiler / Michael Nilges Jan 1999
C================
      IMPLICIT NONE
C     include files
      INCLUDE 'cns.inc'
      INCLUDE 'comand.inc'
      INCLUDE 'vectangl.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'heap.inc'
      INCLUDE 'numbers.inc'
      INCLUDE 'ctitla.inc'
C     i/o
C     local variables
      INTEGER COUNT, SPTR, OLDCLASS, OLDMAXVEANS, TEMP
      DOUBLE PRECISION K1, K2, CUTOFF
      CHARACTER*4 THENAME
C     begin
C     
C     this is used by READVEAN2 to hold the selection
C     
      SPTR=ALLHP(INTEG4(NATOM))
C     
C     reset database only if no vectorangles have been entered
C     ie., this is the first time in the xplor script that
C     vectorangles has appeared
C     
      IF (VEANIPTR.EQ.0) THEN
         CALL VEANDEFAULTS
         CALL ALLOCVEANS(0, MAXVEANS)
      END IF
C     
C     now read input
C     
      CALL PUSEND('VEANORANGLES>')
      DO WHILE (.NOT.DONE)
         CALL NEXTWD('VEANORANGLES>')
         CALL MISCOM('VEANORANGLES>',USED)
         IF (.NOT.USED) THEN
C     
            IF (WD(1:4).EQ.'HELP') THEN
               CALL CNSHELP('cns-vectangle')
C     
C     Get class name.  Determine if it's an already-defined class.
C     Insert a new class if it's not.
C     
            ELSE IF (WD(1:4).EQ.'CLAS') THEN
               OLDCLASS = CURCLASS
               CALL NEXTA4('class name =', THENAME)
               MODE = NEW
               DO COUNT = 1, NCLASSES
                  IF (VEANCLASSNAMES(COUNT).EQ.THENAME) THEN
                     MODE = UPDATE
                     CURCLASS = COUNT
                  END IF
               END DO
               IF (MODE.EQ.NEW) THEN
C     
C     make sure you can't add more than the maximum
C     number of classes
C     
                  IF (OLDCLASS.EQ.MAXVEANCLASSES) THEN
                     CALL DSPERR('VEAN','Too many classes.')
                     CALL DSPERR('VEAN',
     &                    'Increase MAXVEANCLASSES and recompile.')
                     CALL WRNDIE(-5, 'READVEAN',
     &                    'Too many vectorangle classes.')
                  END IF
                  NCLASSES = NCLASSES + 1
                  CURCLASS = NCLASSES
                  VEANCLASSNAMES(CURCLASS) = THENAME
C     
C     If this isn't the first class, close off the old class
C     
                  IF (NCLASSES.GT.1) THEN
                     VEANASSNDX(OLDCLASS) = NVEANS
                  END IF
               END IF
C     
C     set force constant for current class
C     
            ELSE IF (WD(1:4).EQ.'FORC') THEN
               CALL NEXTF('border force constant =', K1)
               CALL NEXTF('center force constant =', K2)
C     
C     start a default class if there isn't one defined
C     
               IF (CURCLASS.EQ.0) THEN
                  NCLASSES = 1
                  CURCLASS = 1
               END IF
               WRITE(DUNIT, '(A, A, A, F8.3, F8.3)')
     &              'Setting force consts for class ',
     &              VEANCLASSNAMES(CURCLASS), ' to ', K1, K2
               VEANFORCES(1,CURCLASS) = K1
               VEANFORCES(2,CURCLASS) = K2
C     
C     reset vectorangle database
C     
            ELSE IF (WD(1:4).EQ.'RESE') THEN
               CALL VEANDEFAULTS
               CALL ALLOCVEANS(MAXVEANS, MAXVEANS)
C     
C     change number of assignment slots
C     
            ELSE IF (WD(1:4).EQ.'NRES') THEN
               OLDMAXVEANS = MAXVEANS
               CALL NEXTI('number of slots =', MAXVEANS)
               CALL ALLOCVEANS(OLDMAXVEANS, MAXVEANS)
C     
C     read in an assignment
C     
            ELSE IF (WD(1:4).EQ.'ASSI') THEN
C     
C     make sure you can't add more vectorangle assignments
C     than you have slots for
C     
               IF (NVEANS.EQ.MAXVEANS) THEN
                  CALL DSPERR('VEAN','Too many assignments.')
                  CALL DSPERR('VEAN',
     &                 'Increase NREStraints and run again.')
                  CALL WRNDIE(-1,'VEAN>',
     &                 'exceeded allocation for vectorangle restr.')
               END IF
C     
C     if there isn't a class specified,
C     start a default class
C     
               IF (CURCLASS.EQ.0) THEN
                  NCLASSES = 1
                  CURCLASS = 1
               END IF
               CALL READVEAN2(HEAP(VEANIPTR), HEAP(VEANJPTR),
     &              HEAP(VEANKPTR), HEAP(VEANLPTR),
     &              HEAP(VEANVOBSPTR), HEAP(VEANVERRPTR),
     &              HEAP(SPTR), HEAP(VEANCV))
C     
C     print violations
C     
            ELSE IF (WD(1:4).EQ.'PRIN') THEN
               CALL NEXTWD('PRINt>')
               IF (WD(1:4).NE.'THRE') THEN
                  CALL DSPERR('VEANORANGLES',
     &                 'print expects THREshold parameter.')
               ELSE
                  CALL NEXTF('THREshold =', CUTOFF)
                  IF (CUTOFF.LT.ZERO) THEN
                     CALL DSPERR('VEANORANGLES',
     &                    'cutoff must be positive.')
                     CUTOFF = ABS(CUTOFF)
                  END IF
                  CALL NEXTA4('ALL or CLASs>', THENAME)
                  IF (THENAME(1:3).EQ.'ALL') THEN
                     DO COUNT = 1,NCLASSES
                        PRINTCLASS(COUNT) = .TRUE.
                     END DO
                  ELSE IF (THENAME(1:4).EQ.'CLAS') THEN
                     CALL NEXTA4('class name =', THENAME)
                     DO COUNT = 1,NCLASSES
                        IF (VEANCLASSNAMES(COUNT).EQ.
     &                       THENAME) THEN
                           PRINTCLASS(COUNT) = .TRUE.
                        ELSE
                           PRINTCLASS(COUNT) = .FALSE.
                        END IF
                     END DO
                  ELSE
                     CALL DSPERR('VEANORANGLES',
     &                    'not understood.  Printing all classes')
                     DO COUNT = 1,NCLASSES
                        PRINTCLASS(COUNT) = .TRUE.
                     END DO
                  END IF
C     
                  CALL PRINTVEANS(CUTOFF, HEAP(CALCVEANPTR),
     &                 HEAP(VEANVOBSPTR), HEAP(VEANVERRPTR),
     &                 HEAP(VEANIPTR), HEAP(VEANJPTR),
     &                 HEAP(VEANKPTR), HEAP(VEANLPTR),
     &                 HEAP(VEANCV), 0)
                  IF (VICV.GT.0) THEN
                     CALL PRINTVEANS(CUTOFF, HEAP(CALCVEANPTR),
     &                    HEAP(VEANVOBSPTR), HEAP(VEANVERRPTR),
     &                    HEAP(VEANIPTR), HEAP(VEANJPTR),
     &                    HEAP(VEANKPTR), HEAP(VEANLPTR),
     &                    HEAP(VEANCV), 1)
                  END IF
               END IF
C====================================================================
            ELSE IF (WD(1:2).EQ.'CV') THEN
               CALL NEXTI('CV excluded partition number:',VICV)
C====================================================================
            ELSE IF (WD(1:4).EQ.'PART') THEN
               CALL NEXTI('number of PARTitions:',TEMP)
               TEMP=MAX(0,TEMP)
               CALL VCVS(NVEANS,HEAP(VEANCV),TEMP)
               IF (TEMP.EQ.0) THEN
                  VICV=0
               END IF
C     
C     check for END statement
C     
            ELSE
               CALL CHKEND('VEANANGL>', DONE)
            END IF
         END IF
      END DO
      DONE = .FALSE.
      CALL FREHP(SPTR,INTEG4(NATOM))
      RETURN
      END
C===============
      SUBROUTINE ALLOCVEANS (OLDSIZE, NEWSIZE)
C     
C     resets vectorangle constant arrays to hold SIZE entries
C     
C     by Jens Meiler / Michael Nilges Jan 1999
C===============
      IMPLICIT NONE
C     include files
      INCLUDE 'cns.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'vectangl.inc'
C     i/o
      INTEGER OLDSIZE, NEWSIZE
C     begin
      IF (OLDSIZE.NE.0) THEN
         CALL FREHP(VEANIPTR, INTEG4(OLDSIZE))
         CALL FREHP(VEANJPTR, INTEG4(OLDSIZE))
         CALL FREHP(VEANKPTR, INTEG4(OLDSIZE))
         CALL FREHP(VEANLPTR, INTEG4(OLDSIZE))
         CALL FREHP(VEANCV  , INTEG4(OLDSIZE))
         CALL FREHP(VEANVOBSPTR, IREAL8(2*OLDSIZE))
         CALL FREHP(VEANVERRPTR, IREAL8(2*OLDSIZE))
         CALL FREHP(CALCVEANPTR, IREAL8(2*OLDSIZE))
      END IF
C     
      VEANIPTR = ALLHP(INTEG4(NEWSIZE))
      VEANJPTR = ALLHP(INTEG4(NEWSIZE))
      VEANKPTR = ALLHP(INTEG4(NEWSIZE))
      VEANLPTR = ALLHP(INTEG4(NEWSIZE))
      VEANCV   = ALLHP(INTEG4(NEWSIZE))
      VEANVOBSPTR = ALLHP(IREAL8(2*NEWSIZE))
      VEANVERRPTR = ALLHP(IREAL8(2*NEWSIZE))
      CALCVEANPTR = ALLHP(IREAL8(2*NEWSIZE))
      RETURN
      END
C==============
      SUBROUTINE VEANDEFAULTS
C
C sets up defaults
C
C by Jens Meiler / Michael Nilges Jan 1999
C==============
      IMPLICIT NONE
C include files
      INCLUDE 'vectangl.inc'
C local variables
      INTEGER COUNT
      DOUBLE PRECISION P
C begin
      MODE = NEW
      MAXVEANS = 1000
      NVEANS = 0
      NCLASSES = 0
      CURCLASS = 0
      VICV = 0
      DO COUNT = 1, MAXVEANCLASSES
           VEANCLASSNAMES(COUNT) = 'DEFAULT'
           VEANASSNDX(COUNT) = 0
           VEANFORCES (1,COUNT) = 200
           VEANFORCES (2,COUNT) =  50
      END DO
      RETURN
      END
C==============
      SUBROUTINE READVEAN2 (ATOMI, ATOMJ, ATOMK, ATOML,
     &     VOBS, VERR, SEL, VCV)
C     
C     reads actual vectorangle assignments into arrays
C     
C     by Jens Meiler / Michael Nilges Jan 1999
C==============
      IMPLICIT NONE
C     include files
      INCLUDE 'cns.inc'
      INCLUDE 'coord.inc'
      INCLUDE 'vectangl.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'comand.inc'
C     i/o
      INTEGER ATOMI(*), ATOMJ(*), ATOMK(*), ATOML(*),
     &     SEL(*), VCV(*)
      DOUBLE PRECISION VOBS(2,*), VERR(2,*)
C     local variables
      INTEGER NSEL, INSERTPOS, COUNT, CURSTOP, OTHERSTOP
      DOUBLE PRECISION JO, JE
C     begin
C     
C     if we're in update mode, make a space for the new line
C     
      IF (MODE.EQ.UPDATE) THEN
         DO COUNT = NVEANS+1, VEANASSNDX(CURCLASS)+1, -1
            ATOMI(COUNT) = ATOMI(COUNT-1)
            ATOMJ(COUNT) = ATOMJ(COUNT-1)
            ATOMK(COUNT) = ATOMK(COUNT-1)
            ATOML(COUNT) = ATOML(COUNT-1)
            VOBS(1,COUNT) = VOBS(1,COUNT-1)
            VOBS(2,COUNT) = VOBS(2,COUNT-1)
            VERR(1,COUNT) = VERR(1,COUNT-1)
            VERR(2,COUNT) = VERR(2,COUNT-1)
            VCV(COUNT) = VCV(COUNT-1)
         END DO
         CURSTOP = VEANASSNDX(CURCLASS)
         DO COUNT = 1, NCLASSES
            OTHERSTOP = VEANASSNDX(COUNT)
            IF (OTHERSTOP.GT.CURSTOP) THEN
               VEANASSNDX(COUNT) = OTHERSTOP + 1
            END IF
         END DO
         VEANASSNDX(CURCLASS) = CURSTOP + 1
         INSERTPOS = CURSTOP
         NVEANS = NVEANS + 1
      ELSE
         NVEANS = NVEANS + 1
         INSERTPOS = NVEANS
         VEANASSNDX(CURCLASS) = INSERTPOS
      END IF
C     
      CALL SELCTA(SEL, NSEL, X, Y, Z,.TRUE.)
      IF (NSEL.GT.1) THEN
         CALL DSPERR('VEAN',
     &        'more than 1 atom in selection for atom i. Using first')
      END IF
      CALL MAKIND(SEL, NATOM, NSEL)
      ATOMI(INSERTPOS) = SEL(1)
C     
      CALL SELCTA(SEL, NSEL, X, Y, Z,.TRUE.)
      IF (NSEL.GT.1) THEN
         CALL DSPERR('VEAN',
     &        'more than 1 atom in selection for atom j. Using first')
      END IF
      CALL MAKIND(SEL, NATOM, NSEL)
      ATOMJ(INSERTPOS) = SEL(1)
C     
      CALL SELCTA(SEL, NSEL, X, Y, Z,.TRUE.)
      IF (NSEL.GT.1) THEN
         CALL DSPERR('VEAN',
     &        'more than 1 atom in selection for atom k. Using first')
      END IF
      CALL MAKIND(SEL, NATOM, NSEL)
      ATOMK(INSERTPOS) = SEL(1)
C     
      CALL SELCTA(SEL, NSEL, X, Y, Z,.TRUE.)
      IF (NSEL.GT.1) THEN
         CALL DSPERR('VEAN',
     &        'more than 1 atom in selection for atom l. Using first')
      END IF
      CALL MAKIND(SEL, NATOM, NSEL)
      ATOML(INSERTPOS) = SEL(1)
C     
      CALL NEXTF('observed vectorangle =', JO)
      CALL NEXTF('error in vectorangle =', JE)
      VOBS(1,INSERTPOS) = JO
      VERR(1,INSERTPOS) = JE
      CALL NEXTF('observed vectorangle =', JO)
      CALL NEXTF('error in vectorangle =', JE)
      VOBS(2,INSERTPOS) = JO
      VERR(2,INSERTPOS) = JE
      VCV(INSERTPOS)  = -1
      RETURN
      END
C===============
      SUBROUTINE VEANINIT
C     
C     initializes vectorangles
C     
C     by Jens Meiler / Michael Nilges Jan 1999
C==============
      IMPLICIT NONE
C     include files
      INCLUDE 'vectangl.inc'
C     begin
      CALL VEANDEFAULTS
      CALL ALLOCVEANS(0, MAXVEANS)
      RETURN
      END
C===============
      SUBROUTINE VEANHP
C
C deallocates vectorangles
C
C by Jens Meiler / Michael Nilges Jan 1999
C================
      IMPLICIT NONE
C include files
      INCLUDE 'vectangl.inc'
C begin
      CALL ALLOCVEANS(MAXVEANS,0)
      RETURN
      END
C=================
      SUBROUTINE PRINTVEANS (CUTOFF, VCALC, VOBS, VERR,
     &     ATOMI, ATOMJ, ATOMK, ATOML,
     &     VCV, ITEST)
C     
C     prints vectorangles with delta alpha greater than cutoff
C     calculates RMS deviation and puts it into $RESULT
C     
C     by Jens Meiler / Michael Nilges Jan 1999
C=================
      IMPLICIT NONE
C     include files
      INCLUDE 'cns.inc'
      INCLUDE 'vectangl.inc'
      INCLUDE 'comand.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'numbers.inc'
      INCLUDE 'consta.inc'
C     i/o
      DOUBLE PRECISION CUTOFF, VCALC(2,*), VOBS(2,*), VERR(2,*)
      INTEGER ATOMI(*), ATOMJ(*), ATOMK(*), ATOML(*)
      INTEGER VCV(*), ITEST
C     local variables
      DOUBLE PRECISION RMS, VIOLS, VENERGY, DELTA, CALCV, VOBSA
      DOUBLE PRECISION VOBSB, VOBSC, VOBSD
      INTEGER NASSIGNSINCLUDED, COUNT, CLASS, I, J, K, L
      LOGICAL PRINTTHISCLASS
      DOUBLE COMPLEX DUMMY2
C     begin
      RMS = ZERO
      VIOLS = ZERO
      NASSIGNSINCLUDED = ZERO
C     
C     make sure that the calcJ array is up to date
C     
      CALL EVEAN(VENERGY, 'ANALYZE')
      IF (VICV.GT.0) THEN
         IF (ITEST.EQ.0) THEN
            WRITE(PUNIT,'(A)')
     &           ' $$$$$$$$$$$$$$$$$$ working set $$$$$$$$$$$$$$$$$$$$$'
         ELSE
            WRITE(PUNIT,'(A,I5,A)')
     &           ' $$$$$$$$$$$$$$$$$$$$ test set (TEST=',VICV,
     &           ')  $$$$$$$$$$$$$$$$$$$$$$'
         END IF
      END IF
      WRITE (PUNIT, '(A)') 'The following vectorangles have delta'
      WRITE (PUNIT, '(A)') 'greater than the cutoff:'
      WRITE (PUNIT, '(A,A)')
     $     '(calculated)(observed borderA borderB borderC borderD)',
     $     '(delta)'
C     
C     write out first class heading
C     
      CLASS = 1
      PRINTTHISCLASS = PRINTCLASS(CLASS)
      IF (PRINTTHISCLASS) THEN
         WRITE (PUNIT, '(A, A)') 'class ', VEANCLASSNAMES(1)
      END IF
C     
C     for every vectorangle entry,
C     
      DO COUNT = 1, NVEANS
C     
C     is this the start of a new class?
C     
         IF (VEANASSNDX(CLASS).LT.COUNT) THEN
            CLASS = CLASS + 1
            PRINTTHISCLASS = PRINTCLASS(CLASS)
            IF (PRINTTHISCLASS) THEN
               WRITE (PUNIT, '(A, A)') 'class ', VEANCLASSNAMES(CLASS)
            END IF
         END IF
C     
C     check if in test set or not (cross-validation)
C     
         IF ((ITEST.EQ.0.AND.VCV(COUNT).NE.VICV).OR.
     &        (ITEST.EQ.1.AND.VCV(COUNT).EQ.VICV)) THEN
C     IF (1.EQ.1) THEN
C     
C     if this ASSIgnment is in a class that will be printed,
C     
            IF (PRINTTHISCLASS) THEN
C     
C     update RMS delta J
C     
               CALCV = VCALC(1,COUNT) * 180 / PI
               VOBSA = (VOBS(1,COUNT) - VERR(1,COUNT))
               VOBSB = (VOBS(1,COUNT) + VERR(1,COUNT))
               VOBSC = (VOBS(2,COUNT) - VERR(2,COUNT))
               VOBSD = (VOBS(2,COUNT) + VERR(2,COUNT))
               if (CALCV.lt.VOBSA) then
                  DELTA = VOBSA - CALCV
               else if (CALCV.lt.VOBSB) then
                  DELTA = 0
               else if (CALCV.lt.VOBSC.AND.VOBSB.lt.VOBSC) then
                  DELTA = MIN(CALCV - VOBSB, VOBSC - CALCV)
               else if (CALCV.lt.VOBSD) then
                  DELTA = 0
               else
                  DELTA = CALCV - VOBSD
               end if
               RMS = RMS + DELTA**2
               NASSIGNSINCLUDED = NASSIGNSINCLUDED + 1
C     
C     print out delta Js greater than cutoff
C     and update number of violations
C     
               IF (ABS(DELTA).GT.CUTOFF) THEN
                  I = ATOMI(COUNT)
                  J = ATOMJ(COUNT)
                  K = ATOMK(COUNT)
                  L = ATOML(COUNT)
                  WRITE(PUNIT,'(9X,16(1X,A), 6(F8.3))')
     &                 SEGID(I),RESID(I),RES(I),TYPE(I),
     &                 SEGID(J),RESID(J),RES(J),TYPE(J),
     &                 SEGID(K),RESID(K),RES(K),TYPE(K),
     &                 SEGID(L),RESID(L),RES(L),TYPE(L),
     &                 CALCV, VOBSA, VOBSB, VOBSC, VOBSD, DELTA
                  VIOLS = VIOLS + ONE
               END IF
            END IF
         END IF
      END DO
C     
      IF (NASSIGNSINCLUDED.GT.ZERO) THEN
         RMS = SQRT(RMS / NASSIGNSINCLUDED)
      ELSE
         RMS = ZERO
      END IF
      WRITE(PUNIT,'(A,F8.3,A,F5.2,A,F6.0,A,I6,A)')
     &     '  RMS diff. =',RMS,
     &     ', #(violat.>',CUTOFF,')=',VIOLS,
     &     ' of ',NASSIGNSINCLUDED,' vectorangles'
      IF (ITEST.EQ.1) THEN
         CALL DECLAR('RESULT', 'DP', ' ', DUMMY2, RMS)
         CALL DECLAR('TEST_RMS', 'DP', ' ', DUMMY2, RMS)
         CALL DECLAR('TEST_VIOLATIONS', 'DP', ' ', DUMMY2, VIOLS)
      ELSE
         CALL DECLAR('RESULT', 'DP', ' ', DUMMY2, RMS)
         CALL DECLAR('RMS', 'DP', ' ', DUMMY2, RMS)
         CALL DECLAR('VIOLATIONS', 'DP', ' ', DUMMY2, VIOLS)
      END IF
      RETURN
      END
C     
C====================================================================
      SUBROUTINE VCVS(VNUM,VCV,PART)
C     
C     Routine partitions vectorangle data into PART sets.
C     VCV will contain integer numbers between 1 and PART.
C     
C     Author: Axel T. Brunger
C     Modifed for vectorangles: Jens Meiler / Michael Nilges Jan 1999
C     
C     
C     IMPLICIT NONE
C     I/O
      INTEGER VNUM, VCV(*)
      INTEGER PART
C     local
      INTEGER I, P, NP, NRETRY, NTRYTOT
      DOUBLE PRECISION RNUM
      NRETRY = 0
      NTRYTOT = 0
C     begin
 100  CONTINUE
      IF (PART.GT.0) THEN
         DO I=1,VNUM
            CALL GGUBFS(RNUM)
            VCV(I)=MAX(1,MIN(PART,INT(RNUM*PART)+1))
         END DO
C     
         IF (PART.EQ.VNUM) THEN
            DO I=1,VNUM
               VCV(I)=I
            END DO
         END IF
C     
         DO P=1,PART
            NP=0
            DO I=1,VNUM
               IF (VCV(I).EQ.P) THEN
                  NP=NP+1
               END IF
            END DO
            IF (NP .EQ. 0) THEN
               NRETRY = 1
            ENDIF
            WRITE(6,'(A,I3,A,I5,A)') ' For set ',P,
     &           ' there are ',NP,' vectorangle restraints.'
         END DO
      ELSE
         WRITE(6,'(A)')
     &        ' Data are not partitioned or partitioning removed.'
         DO I=1,VNUM
            VCV(I)=-1
         END DO
      END IF
      NTRYTOT = NTRYTOT + NRETRY
      IF (NTRYTOT .GT. 0 .AND. NTRYTOT .LE. 10) THEN
         WRITE(6,'(A)')
     &        ' Test set with 0 constraints! New trial...'
         GOTO 100
      ELSE IF (NTRYTOT .GT. 10) THEN
         CALL WRNDIE(-1,'VCVS',
     &        'Unable to partition the vectorangle data in ten trials')
      ENDIF
C     
      RETURN
      END
C

      SUBROUTINE ENERGY
C
C Main target function routine
C
C Authors: Thomas Simonson and Axel T. Brunger
C
C Uses multiple Pairs of Interacting Groups (PIGs) and atom-based parameters
C
C
      IMPLICIT NONE
C input/output
      INCLUDE 'cns.inc'
      INCLUDE 'deriv.inc'
      INCLUDE 'heap.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'consta.inc'
      INCLUDE 'ener.inc'
      INCLUDE 'param.inc'
      INCLUDE 'timer.inc'
      INCLUDE 'funct.inc'
C local
      INTEGER I, NDIM, N
      DOUBLE PRECISION TOTAL
      DOUBLE COMPLEX DCVAL
      DOUBLE COMPLEX EDUMMY
C parameters
      DOUBLE PRECISION ZERO, ONE
      PARAMETER (ZERO=0.0D0, ONE=1.0D0)
C begin
      IF (TIMER.GT.0) CALL DSPCPU(' ENERGY: at entry ')
C
C initialization
      DO I=1,NENERT
      RENR(I)=ZERO
      END DO
      DO I=1,NATOM
      DX(I)=ZERO
      DY(I)=ZERO
      DZ(I)=ZERO
      END DO
C
C
C loop over all active PIGs and call routines that are
C sensitive to PIGs.
      DO N=1,NPIG
      CALL ENERG2(HEAP(IINTER(N)),N)
      DO I=1,NENERT
      RENR(I)=RENR(I)+REN2(I)
      ENDDO
      ENDDO
C
C call energy routines that are insensitive to double-selections
      IF (QENER(SSHARM)) THEN
      CALL ECNSTR(RENR(SSHARM),REFX,REFY,REFZ,KCNSTR,NATOM,KCEXPN,
     &            QPLANAR,PNORMAL)
      IF (TIMER.GT.1) CALL DSPCPU(' ENERGY: after harm. CONStr. term ')
      END IF
C
      IF (QENER(SSNOE)) THEN
      CALL ENOE(RENR(SSNOE),'NOAN',0)
      IF (TIMER.GT.1) CALL DSPCPU(' ENERGY: after NOE constr. term')
      END IF
C
      IF (QENER(SSDG)) THEN
      CALL EMMDG(RENR(SSDG))
      IF (TIMER.GT.1) CALL DSPCPU(' ENERGY: after DG term')
      END IF
C
      IF (QENER(SSCDIH)) THEN
C
C cross-validation on dihedral angles: use only working set
C
      IF (DIHICV.GT.0) THEN
      CALL ETOR(RENR(SSCDIH),EDUMMY,HEAP(IWCIP),HEAP(IWCJP),HEAP(IWCKP),
     &          HEAP(IWCLP),HEAP(ICICP),CWNPHI,HEAP(IWCCPC),
     &          HEAP(IWCCPD),HEAP(IWCCPB),'GENERAL',
     &          HEAP(IWCCPO),HEAP(IWCCPE),'NOAN',CNSCA,ONE)
      ELSE
      CALL ETOR(RENR(SSCDIH),EDUMMY,HEAP(ICIP),HEAP(ICJP),HEAP(ICKP),
     &          HEAP(ICLP),HEAP(ICICP),CNPHI,HEAP(ICCPC),
     &          HEAP(ICCPD),HEAP(ICCPB),'GENERAL',
     &          HEAP(ICCPO),HEAP(ICCPE),'NOAN',CNSCA,ONE)
      ENDIF
      IF (TIMER.GT.1) CALL DSPCPU(' ENERGY: after Cons-DIHEdral term ')
      END IF
C
      IF (QENER(SSXREF)) THEN
      CALL XRENER(RENR(SSXREF))
      IF (TIMER.GT.1) CALL DSPCPU(' ENERGY: after XREFIne term')
      END IF
C
      IF (QENER(SSNCS)) THEN
      CALL ENENCS(RENR(SSNCS))
      IF (TIMER.GT.1) THEN
      CALL DSPCPU(' ENERGY: after non-crystallog. restraint term')
      END IF
      END IF
C
      IF (QENER(SSPLN)) THEN
      CALL ENEPLN(RENR(SSPLN))
      IF (TIMER.GT.1) THEN
      CALL DSPCPU(' ENERGY: after planarity restraint term')
      END IF
      END IF
C=====================================================================
C #if defined(CNS_SOLVE_COMPILE)
C=====================================================================
C
C three-bond J coupling energy
C
      IF (QENER(SSJCOUP)) THEN
      CALL ECOUP(RENR(SSJCOUP), 'ENERGY ')
      IF (TIMER.GT.1) CALL DSPCPU(' ENERGY: after J coupling term')
      END IF
C
C carbon chemical shift energy
C
      IF (QENER(SSCARB)) THEN
      CALL ECSHIFT(RENR(SSCARB), 'ENERGY ')
      IF (TIMER.GT.1) CALL DSPCPU(' ENERGY: after carbon shift term')
      END IF
C
C proton chemical shift energy
C
      IF (QENER(SSPROT)) THEN
      CALL EPROTONSHIFT(RENR(SSPROT), 'ENERGY ')
      IF (TIMER.GT.1) CALL DSPCPU(' ENERGY: after proton shift term')
      END IF
C
C one bond couplings energy
C
      IF (QENER(SSONEJ)) THEN
      CALL EONEBOND(RENR(SSONEJ), 'ENERGY ')
      IF (TIMER.GT.1) CALL DSPCPU(' ENERGY: after one bond coup term')
      END IF
C
C Susceptibility anisotropy energy
      IF(QENER(SSVEAN)) THEN
      CALL EVEAN(RENR(SSVEAN),'ENERGY ')
      IF (TIMER.GT.1)
     $     CALL DSPCPU(' ENERGY: after VEAN-Anisotropy term')
      ENDIF
C
C Susceptibility anisotropy energy
      IF(QENER(SSSANI)) THEN
      CALL ESANI(RENR(SSSANI),'ENERGY ')
      IF (TIMER.GT.1)
     $     CALL DSPCPU(' ENERGY: after Susc-Anisotropy term')
      ENDIF
C
C Diffusion anisotropy energy
      IF(QENER(SSDANI)) THEN
      CALL EDANI(RENR(SSDANI),'ENERGY ')
      IF (TIMER.GT.1)
     $     CALL DSPCPU(' ENERGY: after Diff-Anisotropy term')
      ENDIF
C
C database energy
C
      IF (QENER(SSRAMA)) THEN
      CALL ERAMA(RENR(SSRAMA), 'ENERGY ')
      IF (TIMER.GT.1) CALL DSPCPU(' ENERGY: after torsion DB term')
      END IF
C
C bond angle database energy
C
      IF (QENER(SSANGDB)) THEN
      CALL EANGLEDB(RENR(SSANGDB), 'ENERGY ')
      IF (TIMER.GT.1) CALL DSPCPU(' ENERGY: after angle DB term')
      END IF
C=====================================================================
C #endif
C=====================================================================
C
      IF (TIMER.EQ.1) CALL DSPCPU(' ENERGY: after ALL terms ')
C
C declare active energy terms
      DO I = 1,NENERT
      IF ( QENER(I) ) THEN
      CALL DECLAR( ANER(I), 'DP', ' ', DCVAL, RENR(I) )
      END IF
      END DO
C
C compute total energy, and put in the accumulation slot SSENER
      TOTAL=ZERO
      DO I=1,NENERT
      IF (QENER(I)) TOTAL=TOTAL+RENR(I)
      END DO
      RENR(SSENER)=TOTAL
      CALL DECLAR( ANER(SSENER), 'DP', ' ', DCVAL, RENR(SSENER) )
C
C compute gradient and put in the accumulation slot SSSD
      TOTAL=ZERO
      NDIM=0
      DO I=1,NATOM
      TOTAL=TOTAL+DX(I)*DX(I)+DY(I)*DY(I)+DZ(I)*DZ(I)
      NDIM=NDIM+3
      END DO
      IF (NDIM.GT.0) TOTAL=SQRT(TOTAL/NDIM)
      RENR(SSSD)=TOTAL
      CALL DECLAR( ANER(SSSD), 'DP', ' ', DCVAL, RENR(SSSD) )
C
      RETURN
      END
C
      SUBROUTINE EFLAGSYMBOLS
C
C Routine exports energy flags to symbols
C
C Author: RWGK
C ============
C
      IMPLICIT NONE
C I/O
      INCLUDE 'cns.inc'
      INCLUDE 'ener.inc'
C
C local
      INTEGER           I, L
      CHARACTER         VARN*10
      DOUBLE PRECISION  DPVAL
      DOUBLE COMPLEX    DCVAL
C
C begin
      DPVAL = DFLOAT(0)
      DCVAL = DCMPLX(DPVAL, DPVAL)
C
      DO I = 1, NENERT
        IF (ANER(I) .NE. ' ') THEN
          VARN = 'EFLAG.' // ANER(I)
          L = LEN(VARN)
          CALL TRIMM(VARN, L)
          IF (QENER(I)) THEN
            CALL DECLAR(VARN(1:L), 'LO', 'TRUE',  DCVAL, DPVAL)
          ELSE
            CALL DECLAR(VARN(1:L), 'LO', 'FALSE', DCVAL, DPVAL)
          END IF
        END IF
      END DO
C
      RETURN
      END
C
      SUBROUTINE ENEINI
C
C Routine initializes energy terms
C
C Author: Axel T. Brunger
C =======================
C
      IMPLICIT NONE
C I/O
      INCLUDE 'cns.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'ener.inc'
      INCLUDE 'symbol.inc'
C local
      INTEGER I
C begin
C energy term flags and descriptors
      DO I=1,NENERT
      RENR(I)=0.0D0
      ANER(I)='    '
      QENER(I)=.FALSE.
      END DO
C
C accumulation slots, only to inquire, not to manipulate
      ANER(SSTOTE)='TOTE'
      ANER(SSTOTK)='TOTK'
      ANER(SSENER)='ENER'
      ANER(SSTEMP)='TEMP'
      ANER(SSSD)='GRAD'
C
C regular slots
      ANER(SSBOND)='BOND'
      QENER(SSBOND)=.TRUE.
      ANER(SSANGL)='ANGL'
      QENER(SSANGL)=.TRUE.
      ANER(SSDIHE)='DIHE'
      QENER(SSDIHE)=.TRUE.
      ANER(SSIMPR)='IMPR'
      QENER(SSIMPR)=.TRUE.
      ANER(SSVDW)='VDW '
      QENER(SSVDW)=.TRUE.
      ANER(SSELEC)='ELEC'
      QENER(SSELEC)=.TRUE.
      ANER(SSHARM)='HARM'
      ANER(SSCDIH)='CDIH'
      ANER(SSNOE)='NOE '
      ANER(SSDG)='DG  '
      ANER(SSXREF)='XREF'
      ANER(SSPVDW)='PVDW'
      ANER(SSPELE)='PELE'
      ANER(SSNCS)='NCS '
      ANER(SSPLN)='PLAN'
C=====================================================================
C #if defined(CNS_SOLVE_COMPILE)
C=====================================================================
      ANER(SSJCOUP)='COUP'
      ANER(SSCARB)='CARB'
      ANER(SSPROT)='PROT'
      ANER(SSONEJ)='ONEB'
      ANER(SSRAMA)='RAMA'
      ANER(SSANGDB)='ANDB'
      ANER(SSVEAN)='VEAN'
      ANER(SSSANI)='SANI'
      ANER(SSDANI)='DANI'
C=====================================================================
C #endif
C=====================================================================
C harmonic restraints
      PNORMAL(1)=0.0D0
      PNORMAL(2)=0.0D0
      PNORMAL(3)=0.0D0
      QPLANAR=.FALSE.
C
      EOLD=0.0D0
C
      CALL EFLAGSYMBOLS
C
      RETURN
      END
C
      SUBROUTINE EFLAGS(MODE)
C
C Routine sets flags which energy routines are to be used.
C
C For syntax see main parsing loop "HELP"
C
C Author: Axel T. Brunger
C =======================
C
      IMPLICIT NONE
C input/output
      INCLUDE 'cns.inc'
      INCLUDE 'ener.inc'
      INCLUDE 'comand.inc'
      INCLUDE 'funct.inc'
      CHARACTER*(*) MODE
C local
      INTEGER J, NINCL
      LOGICAL TERM, FOUND, MATCH
      CHARACTER*4 BNER(NENERT)
C begin
      TERM=.FALSE.
      CALL PUSEND('FLAGS>')
      DO WHILE (.NOT.DONE)
      CALL NEXTWD('FLAGS>')
      CALL MISCOM('FLAGS>',USED)
      IF (.NOT.USED) THEN
C
      IF (WD(1:4).EQ.'HELP') THEN
C
         CALL CNSHELP('cns-flags')
C
      ELSE IF (WD(1:4).EQ.'?   ') THEN
      WRITE(6,'(A)') ' EFLAGS: the following energy flags are set'
      NINCL=0
      DO J=1,NENERT
      IF (ANER(J).NE.'    '.AND.QENER(J)) THEN
      NINCL=NINCL+1
      BNER(NINCL)=ANER(J)
      END IF
      END DO
      WRITE(6,'(1X,A,14(A,A))') 'EFLAGS:',(' ',BNER(J),J=1,NINCL)
      ELSE IF (WD(1:4).EQ.'INCL') THEN
      TERM=.TRUE.
      ELSE IF (WD(1:4).EQ.'EXCL') THEN
      TERM=.FALSE.
      ELSE
      FOUND=.FALSE.
      DO J=1,NENERT
      CALL EQSTWC(ANER(J),4,WD(1:4),4,1,1,MATCH)
      IF (MATCH) THEN
      QENER(J)=TERM
      FOUND=.TRUE.
      END IF
      END DO
      IF (.NOT.FOUND) CALL CHKEND('FLAGS>',DONE)
      END IF
C
C don't include the accumulation variables
C TOTE, TOTK, TEMP, ENER
      QENER(SSTOTE)=.FALSE.
      QENER(SSTOTK)=.FALSE.
      QENER(SSTEMP)=.FALSE.
      QENER(SSENER)=.FALSE.
      QENER(SSSD)=.FALSE.
C
      END IF
      END DO
      DONE=.FALSE.
C
      CALL EFLAGSYMBOLS
C
      RETURN
      END
C
      SUBROUTINE PGETE(ICYCLE)
C
C Command interpreter for stand-alone and accumulation
C requests for energy
C
C Author: Axel T. Brunger
C =======================
      IMPLICIT NONE
C I/O
      INCLUDE 'cns.inc'
      INCLUDE 'coord.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'comand.inc'
      INCLUDE 'ener.inc'
      INCLUDE 'consta.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'heap.inc'
      INTEGER ICYCLE
C local
      INTEGER I
      LOGICAL QPRINT
      CHARACTER*4 SACCU
C
C defaults
      QPRINT=.TRUE.
      SACCU='ENER'
C
C parsing
      CALL PUSEND('ENERGY>')
      DO WHILE (.NOT.DONE)
      CALL NEXTWD('ENERGY>')
      CALL MISCOM('ENERGY>',USED)
      IF (.NOT.USED) THEN
C
      IF (WD(1:4).EQ.'HELP') THEN
C
         CALL CNSHELP('cns-energy')
C
C turn off automatic call to ENERGY in this case
      SACCU='    '
C
      ELSE IF (WD(1:4).EQ.'ACCU') THEN
      CALL NEXTA4('ACCUmulate=',SACCU)
      ELSE
      CALL CHKEND('ENERGY>',DONE)
      END IF
      END IF
      END DO
      DONE=.FALSE.
C
      IF (SACCU.EQ.'ENER') THEN
      CALL ENERGY
      ICYCLE=ICYCLE+1
      IF (QPRINT) THEN
      WRITE(6,'(A,I6,A)')
     & ' --------------- cycle=',ICYCLE,
     & ' --------------------------------------------------'
      CALL PRINTE(RENR)
      WRITE(6,'(2A)') ' --------------------------------------------',
     & '-----------------------------------'
      END IF
C
C accumulation stuff
      IF (ICYCLE.EQ.1) THEN
      DO I=1,NENERT
      RENRA(I)=0.0D0
      RENR2A(I)=0.0D0
      END DO
      END IF
      DO I=1,NENERT
      RENRA(I)=RENRA(I)+RENR(I)
      RENR2A(I)=RENR2A(I)+RENR(I)*RENR(I)
      END DO
C
      ELSE IF (SACCU.EQ.'RESE') THEN
      ICYCLE=0
      DO I=1,NENERT
      RENRA(I)=0.0D0
      RENR2A(I)=0.0D0
      END DO
C
      ELSE IF (SACCU.EQ.'PRIN') THEN
      DO I=1,NENERT
      RENRP(I)=RENR(I)
      RENR(I)=RENRA(I)/ICYCLE
      END DO
      WRITE(6,'(A,I8,A)') ' --------------- averages for last ',
     & ICYCLE,'  steps -----------------------------'
      CALL PRINTE(RENR)
      WRITE(6,'(2A)') ' --------------------------------------------',
     &                 '-----------------------------------'
      DO I=1,NENERT
      RENR(I)=RENR2A(I)/ICYCLE-RENR(I)*RENR(I)
      IF (RENR(I).LE.RSMALL) THEN
      RENR(I)=0.0D0
      ELSE
      RENR(I)=SQRT(RENR(I))
      END IF
      END DO
      WRITE(6,'(A,I8,A)') ' --------------- rms fluctations for last ',
     & ICYCLE,' steps -----------------------'
      CALL PRINTE(RENR)
      WRITE(6,'(2A)') ' --------------------------------------------',
     &                 '-----------------------------------'
      DO I=1,NENERT
      RENR(I)=RENRP(I)
      END DO
      END IF
C
      RETURN
      END
C
      SUBROUTINE PRINTE(RENRL)
C
C See routine PRINT2 below
C
C Author: Axel T. Brunger
C =======================
C
C I/O
      DOUBLE PRECISION RENRL(*)
C begin
      CALL PRINT2(.TRUE.,RENRL)
      RETURN
      END
C
      SUBROUTINE PRINT2(QSPCL,RENRL)
C
C Routine prints energies, if QSPCL is true, then this includes the
C Etotal, the grad(E), and the perturbation term.
C
C Author: Axel T. Brunger
C =======================
C
      IMPLICIT NONE
C I/O
      LOGICAL QSPCL
      DOUBLE PRECISION RENRL(*)
      INCLUDE 'cns.inc'
      INCLUDE 'ener.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'deriv.inc'
C local
      CHARACTER*80 LINE
      CHARACTER*20 ST
      INTEGER NTERMS, J, START, STOP, STLEN
C parameters
      DOUBLE PRECISION MAXNUM
      DOUBLE PRECISION MINNUM
      PARAMETER (MAXNUM=999999.D0)
      PARAMETER (MINNUM=-99999.D0)
C begin
C
C write total energy
      LINE=' '
      LINE(2:2)='|'
      LINE(80:80)='|'
      IF (QSPCL) THEN
      IF (RENRL(SSENER).GT.MAXNUM.OR.RENRL(SSENER).LT.MINNUM) THEN
      WRITE(ST,'(E10.2)') RENRL(SSENER)
      ELSE
      WRITE(ST,'(F10.3)') RENRL(SSENER)
      END IF
      STLEN=10
      CALL TRIML(ST,STLEN)
      WRITE(LINE(3:21),'(4A)') ' Etotal =',ST(1:STLEN)
C
C write the RMS gradient
      IF (RENRL(SSSD).GT.MAXNUM.OR.RENRL(SSSD).LT.MINNUM) THEN
      WRITE(ST,'(E10.2)') RENRL(SSSD)
      ELSE
      WRITE(ST,'(F10.3)') RENRL(SSSD)
      END IF
      STLEN=10
      CALL TRIML(ST,STLEN)
      WRITE(LINE(22:40),'(4A)') ' grad(E)=',ST(1:STLEN)
C
      NTERMS=2
      ELSE
      NTERMS=0
      END IF
C
C now write the partial energy terms
      DO J=1,NENERT
      IF (QENER(J).AND.ANER(J).NE.'    ') THEN
      IF (NTERMS.GE.4) THEN
      WRITE(6,'(A80)') LINE
      LINE=' '
      LINE(2:2)='|'
      LINE(80:80)='|'
      NTERMS=0
      END IF
      NTERMS=NTERMS+1
      IF (RENRL(J).GT.MAXNUM.OR.RENRL(J).LT.MINNUM) THEN
      WRITE(ST,'(E10.2)') RENRL(J)
      ELSE
      WRITE(ST,'(F10.3)') RENRL(J)
      END IF
      STLEN=10
      CALL TRIML(ST,STLEN)
      START=(NTERMS-1)*19 +3
      STOP=NTERMS*19+2
      WRITE(LINE(START:STOP),'(4A)') ' E(',ANER(J),')=',ST(1:STLEN)
      END IF
      END DO
      IF (NTERMS.GE.1) WRITE(6,'(A80)') LINE
C
      RETURN
      END
C=====================================================================
      SUBROUTINE ENERG2(INTERE,N)
C
C Front-end routine for various partial energy routines
C
C Author: Axel T. Brunger
C =======================
C
      IMPLICIT NONE
C input/output
      INCLUDE 'cns.inc'
      INCLUDE 'deriv.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'consta.inc'
      INCLUDE 'ener.inc'
      INCLUDE 'param.inc'
      INCLUDE 'timer.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'heap.inc'
      INTEGER N, INTERE(*)
C local
      INTEGER I, NNPIG
      LOGICAL ERR
C parameters
      DOUBLE PRECISION ZERO
      PARAMETER (ZERO=0.0D0)
C begin
C
C initialization
      DO I=1,NENERT
      REN2(I)=ZERO
      RENV(I)=ZERO
      ENDDO
C
C check that all atomic coordinates are known
      CALL ATMCHK(HEAP(IINTER(N)),ERR)
      IF (.NOT.ERR) THEN
C
      IF (NBOND.GT.0.AND.QENER(SSBOND).AND.
     &    (ABS(PIGWGHT(N,SSBOND)).GE.RSMALL.OR.
     &     ABS(PIGAVWT(N,SSBOND)).GE.RSMALL)) THEN
      CALL EBOND(REN2(SSBOND),RENV(SSBOND),IB,JB,INTERE,NBOND,
     &  ACBC,ACBB,QACBC,QACBB,'NOAN',
     &  PIGWGHT(N,SSBOND),PIGAVWT(N,SSBOND),IAC,SEGID,RESID,TYPE)
      IF (TIMER.GT.1) CALL DSPCPU(' ENERGY: after BOND term ')
      END IF
C
      IF (NTHETA.GT.0.AND.QENER(SSANGL).AND.
     &    (ABS(PIGWGHT(N,SSANGL)).GE.RSMALL.OR.
     &     ABS(PIGAVWT(N,SSANGL)).GE.RSMALL)) THEN
      CALL EANGLE(REN2(SSANGL),RENV(SSANGL),IT,JT,KT,INTERE,
     &    NTHETA,ACTC,ACTB,ACTUC,ACTUB,QACTC,QACTB,QACTUC,QACTUB,
     &    'NOAN',PIGWGHT(N,SSANGL),PIGAVWT(N,SSANGL),
     &    IAC,SEGID,RESID,TYPE)
      IF (TIMER.GT.1) CALL DSPCPU(' ENERGY: after ANGLE term ')
      END IF
C
      IF (NPHI.GT.0.AND.QENER(SSDIHE).AND.
     &    (ABS(PIGWGHT(N,SSDIHE)).GE.RSMALL.OR.
     &     ABS(PIGAVWT(N,SSDIHE)).GE.RSMALL)) THEN
      CALL EDIHE(REN2(SSDIHE),RENV(SSDIHE),IP,JP,KP,LP,INTERE,
     &      NPHI,ACPC,ACPD,ACPB,
     &      QACPC,QACPD,QACPB,'NORMAL',0.0D0,0,'NOAN',
     &      PIGWGHT(N,SSDIHE),PIGAVWT(N,SSDIHE),IAC,SEGID,RESID,TYPE)
      IF (TIMER.GT.1) CALL DSPCPU(' ENERGY: after DIHEdral term ')
      END IF
C
      IF (NIMPHI.GT.0.AND.QENER(SSIMPR).AND.
     &    (ABS(PIGWGHT(N,SSIMPR)).GE.RSMALL.OR.
     &     ABS(PIGAVWT(N,SSIMPR)).GE.RSMALL)) THEN
      CALL EIMPR(REN2(SSIMPR),RENV(SSIMPR),IM,JM,KM,LM,INTERE,
     &    NIMPHI,ACIC,ACID,ACIB,
     &    QACIC,QACID,QACIB,'NORMAL',0.0D0,0,'NOAN',
     &    PIGWGHT(N,SSIMPR),PIGAVWT(N,SSIMPR),IAC,SEGID,RESID,TYPE)
      IF (TIMER.GT.1) CALL DSPCPU(' ENERGY: after IMPRoper term ')
      END IF
C
      IF (QENER(SSELEC).OR.QENER(SSVDW)  .OR.
     &    QENER(SSPELE).OR.QENER(SSPVDW)) THEN
C
C determine the last PIG that is turned on.
      NNPIG=0
      DO I=1,NPIG
      IF (ABS(PIGWGHT(I,SSVDW)) .GE.RSMALL.OR.
     &    ABS(PIGWGHT(I,SSELEC)).GE.RSMALL.OR.
     &    ABS(PIGAVWT(I,SSVDW)) .GE.RSMALL.OR.
     &    ABS(PIGAVWT(I,SSELEC)).GE.RSMALL) THEN
      NNPIG=I
      END IF
      END DO
C
      IF (ABS(PIGWGHT(N,SSVDW)) .GE.RSMALL.OR.
     &    ABS(PIGWGHT(N,SSELEC)).GE.RSMALL.OR.
     &    ABS(PIGAVWT(N,SSVDW)) .GE.RSMALL.OR.
     &    ABS(PIGAVWT(N,SSELEC)).GE.RSMALL) THEN
      CALL ENBOND(REN2(SSVDW),REN2(SSELEC),REN2(SSPVDW),REN2(SSPELE),
     &            RENV(SSVDW),RENV(SSELEC),RENV(SSPVDW),RENV(SSPELE),N,
     &            NNPIG,'NOAN')
      IF (TIMER.GT.1) CALL DSPCPU(' ENERGY: after NONBonded term ')
      END IF
      END IF
C
      END IF
      RETURN
      END
C=====================================================================
      SUBROUTINE ATMCHK(INTERE,ERR)
C
C subroutine checks whether all atoms are known that are
C referenced in the interaction energy array.
C
C Author: Axel T. Brunger
C
      IMPLICIT NONE
C I/O
      INCLUDE 'cns.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'coord.inc'
      INTEGER INTERE(*)
      LOGICAL ERR
C local
      INTEGER I
C begin
      ERR=.FALSE.
      DO I=1,NATOM
      IF (.NOT.INITIA(I,X,Y,Z).AND.INTERE(I).LT.9999) THEN
      ERR=.TRUE.
      WRITE(6,'(9A)')
     &  ' %ATMCHK-ERR: unknown coordinates for atom "',
     &    SEGID(I),'-',RESID(I),'-',RES(I),'-',TYPE(I),'"'
      END IF
      END DO
      IF (ERR) THEN
      CALL WRNDIE(-5,'ATMCHK','Unknown coordinates')
      END IF
      RETURN
      END

      SUBROUTINE ARISET
C     
C     Sets up parameters for ARIA assignment, calibration and
C     violation analysis.
C     Nilges, M., Macias, M., O'Donoghue, S., & Oschkinat, M. (1997).
C     Automated NOESY Interpretation with Ambiguous Distance Restraints
C     The Refined Solution Structure of the Pleckstrin Homology Domain
C     from beta-Spectrin.
C     J. Mol. Biol. 269, 408-422.
C     
C     **********************************************
C     * Author and copyright: Michael Nilges, EMBL *
C     * No warranty implied or expressed           *
C     * All rights reserved                        *
C     **********************************************
C     
      IMPLICIT NONE
C     
      INCLUDE 'cns.inc'
      INCLUDE 'aria.inc'
      INCLUDE 'heap.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'noe.inc'
      INCLUDE 'numbers.inc'
C     local
      INTEGER ISLCT, JSLCT, NISLCT
C     begin
C     
      IF (ARINIT) THEN
         CALL ARIHP(0,0,NATOM)
         NMRATM=NATOM
         CALL FILL4(HEAP(HPNHGL),NMRATM,1)
         CALL FILL4(HEAP(HPNPSE),NMRATM,1)
         CALL MAKIND(HEAP(HPNPSE),NMRATM,NISLCT)
         WRITE (6,'(A)') ' ARIA arrays initialized'
         ARINIT = .FALSE.
C         CALL MAKIND(NOEHGL,NMRATM,ISLCT)
      END IF
C     
      ISLCT=ALLHP(INTEG4(NATOM))
      JSLCT=ALLHP(INTEG4(NATOM))
      CALL ARISE2(HEAP(ISLCT),HEAP(JSLCT),HEAP(HPNHGL),HEAP(HPNPSE))
      CALL FREHP(JSLCT,INTEG4(NATOM))
      CALL FREHP(ISLCT,INTEG4(NATOM))
C     
      RETURN
      END
C====================================================================
      SUBROUTINE ARISE2(ISLCT,JSLCT,NOEHGL,NOEPSE)
C     
C     **********************************************
C     * Author and copyright: Michael Nilges, EMBL *
C     * No warranty implied or expressed           *
C     * All rights reserved                        *
C     **********************************************
C     
      IMPLICIT NONE
C     
C     I/O
      INCLUDE 'cns.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'noe.inc'
      INCLUDE 'aria.inc'
      INCLUDE 'comand.inc'
      INCLUDE 'coord.inc'
      INCLUDE 'consta.inc'
      INCLUDE 'deriv.inc'
      INCLUDE 'heap.inc'
      INCLUDE 'funct.inc'
      INTEGER ISLCT(*), JSLCT(*), NOEHGL(*), NOEPSE(*)
C     local
      INTEGER I, J, NISLCT, NJSLCT, NMISS, IPEAK, MATDIM2, NHG2
      INTEGER IAT, JAT, II, JJ, NIAT, NJAT
      CHARACTER*4 CLASS, ACTION
      DOUBLE PRECISION VIOUPL, VIOLOL, TEMPX, TEMPY, TEMPZ
      DOUBLE PRECISION OLDNOE, NEWNOE, FSWAP, RNUM
      LOGICAL MATCH, QNEXT
C     parameter
      DOUBLE PRECISION ZERO, ONE, SIX
      PARAMETER (ZERO=0.0D0, ONE=1.0D0, SIX=6.0D0)
C     function
      INTEGER BONDED
      LOGICAL FRSTEL
      EXTERNAL FRSTEL, BONDED
C     
C     begin
C     
C     all defaults are set in NOERES!
      CALL PUSEND('ARIA>')
      DO WHILE (.NOT.DONE)
         CALL NEXTWD('ARIA>')
         CALL MISCOM('ARIA>',USED)
         IF (.NOT.USED) THEN
C     
            IF (WD(1:4).EQ.'HELP') THEN
               CALL CNSHELP('cns-aria')
C     
C====================================================================
            ELSE IF (WD(1:2).EQ.'DO') THEN
               CALL ARIMAN(HEAP(HPNDIS),HEAP(HPNLOW),HEAP(HPNHIG),
     &              HEAP(HPNWGH),HEAP(HPNVOL),HEAP(HPNCV))
C====================================================================
            ELSE IF (WD(1:4).EQ.'FLOA') THEN
               CALL PUSEND('FLOAting-assignment>')
               DO WHILE (.NOT.DONE)
                  CALL NEXTWD('FLOAting-assignment>')
C     
                  IF (WD(1:4).EQ.'HELP') THEN
                     CALL CNSHELP('cns-aria-floatingassignment')
C     
                  ELSE IF (WD(1:4).EQ.'DEFI') THEN
                     CALL SELCTA(ISLCT,NISLCT,X,Y,Z,.TRUE.)
                     IF (NISLCT.GT.0) THEN
                        NMISS=0
                        DO I=1,NATOM
                           IF ((ISLCT(I).GT.0).AND.
     $                          (.NOT.FRSTEL(I,NOEHGL)))
     $                          THEN
                              ISLCT(I)=0
                              NISLCT=NISLCT-1
                           END IF
                        END DO
                     END IF
                     IF (NISLCT.EQ.2) THEN
                        CALL MAKIND(ISLCT,NATOM,NISLCT)    
                        IAT=ISLCT(1)
                        JAT=ISLCT(2)
                        NOEPSE(IAT)=JAT
                     ELSE
                        WRITE(6,'(A,A)') ' ARIA-FLOAT-ERR: exactly',
     $                       ' two atom groups have to be selected '
                     END IF
C     
                  ELSE IF (WD(1:4).EQ.'SWAP') THEN
                     CALL NEXTF('SWAP_limit',FSWAP)
                     DO I=1,NATOM
                        CALL GGUBFS(RNUM)
                        IF ((NOEPSE(I).NE.I).AND.(RNUM.LT.FSWAP)) THEN
                           JJ=ABS(NOEPSE(I))
                           CALL ENOE(OLDNOE,'NOAN',0)
                           CALL ARIFLI(IAT,JAT,ISLCT,JSLCT,
     $                          HEAP(HPNILS), HEAP(HPNJLS), NOEHGL)
                           CALL ENOE(NEWNOE,'NOAN',0)
                           WRITE(6,'(A,2F15.5)')
     $                          ' ARIFLI energies: ', OLDNOE, NEWNOE
C     we store the information on the flipping in NOEPSE
                           IF (NEWNOE.GT.OLDNOE) THEN
                              CALL ARIFLI(IAT,JAT,ISLCT,JSLCT,
     $                             HEAP(HPNILS), HEAP(HPNJLS),NOEHGL)
                           ELSE
                              IF (NOEPSE(IAT).EQ.IAT) THEN
                                 NOEPSE(IAT)=-JAT
                              ELSE
                                 NOEPSE(IAT)=-NOEPSE(IAT)
                              END IF
                           END IF
                        END IF
                     END DO
C     
                  ELSE IF (WD(1:4).EQ.'STOR') THEN
C     
C     this writes the state of the assignments to a print file.
                     DO I=1,NATOM
                        IF (NOEPSE(I).LT.0) THEN      
                           II=I
                           NOEPSE(I)=-NOEPSE(I)
                           JJ=NOEPSE(I)
                           NOEPSE(JJ)=I
C     
                           WRITE(PUNIT,'(14A)')
     $                          ' REVE ((segid "',SEGID(II),
     &                          '" and resid ',RESID(II),
     &                          ' and name ',TYPE(II),')',
     $                          ' OR   ( segid "',SEGID(JJ),
     &                          '" and resid ',RESID(JJ),
     &                          ' and name ',TYPE(JJ),'))'
                        END IF
                     END DO
                  ELSE
                     CALL CHKEND('FLOAting-assignment>',DONE)
                  END IF
               END DO
               DONE=.FALSE.
C====================================================================
            ELSE IF (WD(1:4).EQ.'CFLI') THEN
               CALL SELCTA(ISLCT,NISLCT,X,Y,Z,.TRUE.)
               IF (NISLCT.GT.0) THEN
                  NMISS=0
                  DO I=1,NATOM
                     IF ((ISLCT(I).GT.0).AND.
     $                    (.NOT.FRSTEL(I,NOEHGL))
     $                    .OR..NOT.INITIA(I,X,Y,Z)) THEN
                        ISLCT(I)=0
                        NMISS=NMISS+1
                        NISLCT=NISLCT-1
                     END IF
                  END DO
               END IF
               IF (NISLCT.EQ.2) THEN
                  CALL MAKIND(ISLCT,NATOM,NISLCT)
                  II=ISLCT(1)
                  JJ=ISLCT(2)      
                  NIAT=0
                  QNEXT=.TRUE.
                  DO WHILE (QNEXT)
                     NIAT=NIAT+1
                     ISLCT(NIAT)=II
                     CALL NEXTHY(II, NOEHGL,QNEXT)
                  END DO
                  NJAT=0
                  QNEXT=.TRUE.
                  DO WHILE (QNEXT)
                     NJAT=NJAT+1
                     JSLCT(NJAT)=JJ
                     CALL NEXTHY(JJ, NOEHGL,QNEXT)
                  END DO
C     
                  IF (NIAT.EQ.NJAT) THEN
                     DO II=1,NIAT
                        IAT=ISLCT(II)
                        JAT=JSLCT(II)
                        TEMPX=X(IAT)
                        TEMPY=Y(IAT)
                        TEMPZ=Z(IAT)
                        X(IAT)=X(JAT)
                        Y(IAT)=Y(JAT)
                        Z(IAT)=Z(JAT)
                        X(JAT)=TEMPX
                        Y(JAT)=TEMPY
                        Z(JAT)=TEMPZ
                     END DO
C     this is maybe a little risky
C     the heavy atom attached to the first 
C     of the hydrogens is swapped, too
                     IF (NIAT.GT.1) THEN
                        IAT=BONDED(ISLCT(1))
                        JAT=BONDED(JSLCT(1))
                        TEMPX=X(IAT)
                        TEMPY=Y(IAT)
                        TEMPZ=Z(IAT)
                        X(IAT)=X(JAT)
                        Y(IAT)=Y(JAT)
                        Z(IAT)=Z(JAT)
                        X(JAT)=TEMPX
                        Y(JAT)=TEMPY
                        Z(JAT)=TEMPZ
                     END IF
                  END IF
               END IF
C     
            ELSE IF (WD(1:4).EQ.'VFLI') THEN
C     
               IF (NISLCT.GT.0) THEN
                  NMISS=0
                  DO I=1,NATOM
                     IF (ISLCT(I).NE.1) THEN
                     ELSE IF (.NOT.INITIA(I,X,Y,Z)) THEN
                        ISLCT(I)=0
                        NMISS=NMISS+1
                        NISLCT=NISLCT-1
                     END IF
                  END DO
               END IF
               IF (NISLCT.EQ.2) THEN
                  CALL MAKIND(ISLCT,NATOM,NISLCT)
                  TEMPX=XV(ISLCT(1))
                  TEMPY=YV(ISLCT(1))
                  TEMPZ=ZV(ISLCT(1))
                  XV(ISLCT(1))=XV(ISLCT(2))
                  YV(ISLCT(1))=YV(ISLCT(2))
                  ZV(ISLCT(1))=ZV(ISLCT(2))
                  XV(ISLCT(2))=TEMPX
                  YV(ISLCT(2))=TEMPY
                  ZV(ISLCT(2))=TEMPZ
               END IF
C     
C====================================================================
            ELSE IF (WD(1:4).EQ.'FLIP') THEN
C     
               CALL SELCTA(ISLCT,NISLCT,X,Y,Z,.TRUE.)
               IF (NISLCT.GT.0) THEN
                  NMISS=0
                  DO I=1,NATOM
                     IF ((ISLCT(I).GT.0).AND.
     $                    (.NOT.FRSTEL(I,NOEHGL)))
     $                    THEN
                        ISLCT(I)=0
                        NISLCT=NISLCT-1
                     END IF
                  END DO
               END IF
C     
               WRITE (6, '(A,I6,A)') ' ARIFLI: ', NISLCT,
     $              ' groups selected'
               IF (NISLCT.EQ.2) THEN
                  CALL MAKIND(ISLCT,NATOM,NISLCT)    
                  IAT=ISLCT(1)
                  JAT=ISLCT(2)
                  CALL ENOE(OLDNOE,'NOAN',0)
                  CALL ARIFLI(IAT,JAT,ISLCT,JSLCT,HEAP(HPNILS),
     $                 HEAP(HPNJLS), NOEHGL)
                  CALL ENOE(NEWNOE,'NOAN',0)
                  WRITE(6,'(A,2F15.5)')
     $                 ' ARIFLI energies: ', OLDNOE, NEWNOE
C     we store the information on the flipping in NOEPSE
                  IF (NEWNOE.GT.OLDNOE) THEN
                     CALL ARIFLI(IAT,JAT,ISLCT,JSLCT,
     $                    HEAP(HPNILS), HEAP(HPNJLS),NOEHGL)
                  ELSE
                     IF (NOEPSE(IAT).EQ.IAT) THEN
                        NOEPSE(IAT)=-JAT
                     ELSE
                        NOEPSE(IAT)=-NOEPSE(IAT)
                     END IF
                  END IF
               END IF
C     
C     
C====================================================================
            ELSE IF (WD(1:4).EQ.'KEEP') THEN
C     do nothing - leave group as it is - just parse
               CALL SELCTA(ISLCT,NISLCT,X,Y,Z,.TRUE.)
C     
C====================================================================
            ELSE IF (WD(1:4).EQ.'REVE') THEN
C     
               CALL SELCTA(ISLCT,NISLCT,X,Y,Z,.TRUE.)
               IF (NISLCT.GT.0) THEN
                  NMISS=0
                  DO I=1,NATOM
                     IF ((ISLCT(I).GT.0).
     $                    AND.(.NOT.FRSTEL(I,NOEHGL))) THEN
                        ISLCT(I)=0
                        NISLCT=NISLCT-1
                     END IF
                  END DO
               END IF
C     
ccc   WRITE (6, '(A,I6,A)') ' ARIFLI: ', NISLCT, ' groups selected'
               IF (NISLCT.EQ.2) THEN
                  CALL MAKIND(ISLCT,NATOM,NISLCT)    
                  IAT=ISLCT(1)
                  JAT=ISLCT(2)
                  CALL ARIFLI(IAT,JAT,ISLCT,JSLCT,HEAP(HPNILS),
     $                 HEAP(HPNJLS),NOEHGL)
                  IF (NOEPSE(IAT).EQ.IAT) THEN
                     NOEPSE(IAT)=-JAT
                  ELSE
                     NOEPSE(IAT)=-NOEPSE(IAT)
                  END IF
               END IF
C     
C====================================================================
            ELSE IF (WD(1:4).EQ.'MODI') THEN
C     get peakid, then use truncated form of noeass
C     e.g. modify 333 test=0 end
               CALL ARIMOD(HEAP(HPNORR),
     &              HEAP(HPNIPR),
     &              HEAP(HPNILS),HEAP(HPNJPR),HEAP(HPNJLS),
     $              HEAP(HPNCND),
     &              HEAP(HPNRAV),HEAP(HPNRRV),HEAP(HPNNSP),
     $              HEAP(HPNDIS),
     &              HEAP(HPNLOW),HEAP(HPNHIG),HEAP(HPNWGH),
     $              HEAP(HPNCV),
     &              HEAP(HPNVIO),
     &              HEAP(HPNPID),
     &              HEAP(HPNPP1),HEAP(HPNPP2),HEAP(HPNHP1),
     $              HEAP(HPNHP2),
     &              HEAP(HPNVOL),NATOM,ISLCT,NISLCT,
     &              JSLCT,NJSLCT,X,Y,Z)
C===================================================================
            ELSE IF (WD(1:4).EQ.'?   ') THEN
               WRITE(6,'(A,I6,A,I6,A,/,A,F8.3,A,I6)')
     &              ' NOE: total number of restraints:',NOENUM,
     &              ' partitioned into ',NOECCN,' classes',
     &              ' NOE: ceiling=',NOECEI
     $              ,' current allocation=',NOEMAX
               IF (NOEICV.GT.0) THEN
                  WRITE(6,'(2A,/,A,I6)')
     &                 ' NOE: data are partitioned into working set',
     $                 ' and test set.',
     &                 ' NOE: test set number=',NOEICV
               END IF
C===================================================================
            ELSE IF (WD(1:4).EQ.'COUN') THEN
C     
C     get the class name:
               CALL PUSEND('COUNtviolations>')
               DO WHILE (.NOT.DONE)
                  CALL NEXTWD('COUNtviolations>')
C     
                  IF (WD(1:4).EQ.'HELP') THEN
                     CALL CNSHELP('cns-aria-countviolations')
C     
                  ELSE IF (WD(1:4).EQ.'RESE') THEN
                     VIOSTR = 0
                     VIOEXC = ZERO
                     VIOTHR = ZERO
                     CALL NOEEXC(0,NOENUM,VIOEXC,VIOSTR,'INIT',
     $                    ZERO,ZERO,
     1                    HEAP(HPNORR),HEAP(HPNIPR),HEAP(HPNILS
     $                    ),HEAP(HPNJPR),HEAP(HPNJLS)
     $                    ,HEAP(HPNCND),HEAP(HPNRAV)
     $                    ,HEAP(HPNRRV),HEAP(HPNDIS)
     $                    ,HEAP(HPNLOW),HEAP(HPNHIG)
     $                    ,HEAP(HPNVOL),HEAP(HPNPP1)
     $                    ,HEAP(HPNPP2),HEAP(HPNHP1)
     $                    ,HEAP(HPNHP2),HEAP(HPNWGH)
     $                    ,HEAP(HPNVIO),HEAP(HPNNUM)
     $                    ,HEAP(HPNNSP),HEAP(HPNCV),HEAP(HPNEXC
     $                    ),HEAP(HPNPID),HEAP(HPCDIS))
C     
                  ELSE IF (WD(1:4).EQ.'THRE') THEN
                     CALL NEXTF('THREshold=',VIOTHR)
                     VIOSTR=VIOSTR+1
                     CALL ARIVIO(HEAP(HPNORR),HEAP(HPNIPR),
     $                    HEAP(HPNILS),HEAP(HPNJPR),
     $                    HEAP(HPNJLS),HEAP(HPNCND),HEAP(HPNRAV
     $                    ), HEAP(HPNRRV),HEAP(HPNDIS)
     $                    ,HEAP(HPNLOW),HEAP(HPNHIG)
     $                    ,HEAP(HPNVOL), HEAP(HPNPP1)
     $                    ,HEAP(HPNPP2),HEAP(HPNHP1),
     $                    HEAP(HPNHP2), HEAP(HPNWGH)
     $                    ,HEAP(HPNVIO), HEAP(HPNNUM),
     $                    HEAP(HPNNSP),HEAP(HPNCV),HEAP(HPNEXC)
     $                    , HEAP(HPNPID))
C     
                  ELSE IF (WD(1:4).EQ.'EXCL') THEN
                     CALL NEXTA4('class-name=',CLASS)
                     CALL NEXTF('EXCLude=',VIOEXC)
                     DO I=1,NOECCN
                        CALL EQSTWC(NOECNM(I),4,CLASS,4,1,1
     $                       ,MATCH)
                        IF (MATCH) THEN
                           CALL NOEEXC(I,NOENUM,VIOEXC,VIOSTR
     $                          ,'EXCL',ZERO,ZERO,HEAP(HPNORR)
     $                          ,HEAP(HPNIPR),HEAP(HPNILS)
     $                          ,HEAP(HPNJPR),HEAP(HPNJLS)
     $                          ,HEAP(HPNCND),HEAP(HPNRAV)
     $                          ,HEAP(HPNRRV),HEAP(HPNDIS)
     $                          ,HEAP(HPNLOW),HEAP(HPNHIG)
     $                          ,HEAP(HPNVOL),HEAP(HPNPP1)
     $                          ,HEAP(HPNPP2),HEAP(HPNHP1)
     $                          ,HEAP(HPNHP2),HEAP(HPNWGH)
     $                          ,HEAP(HPNVIO),HEAP(HPNNUM)
     $                          ,HEAP(HPNNSP),HEAP(HPNCV)
     $                          ,HEAP(HPNEXC),HEAP(HPNPID)
     $                          ,HEAP(HPCDIS))
                        END IF
                     END DO
C     
                  ELSE IF (WD(1:3).EQ.'SET') THEN
                     CALL NEXTA4('class-name=',CLASS)
                     CALL NEXTF('ratio=',VIOEXC)
C     get lower limit. check for TOKEN.
                     CALL NEXTA4('lower_limit=',ACTION)
                     IF (ACTION.EQ.'TOKE') THEN
                        VIOLOL = -ONE
                     ELSE
                        CALL SAVEWD
                        CALL NEXTF('lower_limit=',VIOLOL)
                     END IF
C     get upper limit. check for TOKEN.
                     CALL NEXTA4('upper_limit=',ACTION)
                     IF (ACTION.EQ.'TOKE') THEN
                        VIOUPL = -ONE
                     ELSE
                        CALL SAVEWD
                        CALL NEXTF('upper_limit=',VIOUPL)
                     END IF
C     
                     DO I=1,NOECCN
                        CALL EQSTWC(NOECNM(I),4,CLASS,4,1,1
     $                       ,MATCH)
                        IF (MATCH) THEN
                           CALL NOEEXC(I,NOENUM,VIOEXC,VIOSTR
     $                          ,'SET ',VIOLOL,VIOUPL
     $                          ,HEAP(HPNORR),HEAP(HPNIPR)
     $                          ,HEAP(HPNILS),HEAP(HPNJPR)
     $                          ,HEAP(HPNJLS),HEAP(HPNCND)
     $                          ,HEAP(HPNRAV),HEAP(HPNRRV)
     $                          ,HEAP(HPNDIS),HEAP(HPNLOW)
     $                          ,HEAP(HPNHIG),HEAP(HPNVOL)
     $                          ,HEAP(HPNPP1),HEAP(HPNPP2)
     $                          ,HEAP(HPNHP1),HEAP(HPNHP2)
     $                          ,HEAP(HPNWGH),HEAP(HPNVIO)
     $                          ,HEAP(HPNNUM),HEAP(HPNNSP)
     $                          ,HEAP(HPNCV),HEAP(HPNEXC)
     $                          ,HEAP(HPNPID),HEAP(HPCDIS))
                        END IF
                     END DO
C     
                  ELSE IF (WD(1:4).EQ.'MULT') THEN
                     CALL NEXTA4('class-name=',CLASS)
                     CALL NEXTF('ratio=',VIOEXC)
C     get lower limit. check for TOKEN.
                     CALL NEXTA4('lower_limit=',ACTION)
                     IF (ACTION.EQ.'TOKE') THEN
                        VIOLOL = -ONE
                     ELSE
                        CALL SAVEWD
                        CALL NEXTF('lower_limit=',VIOLOL)
                     END IF
C     get upper limit. check for TOKEN.
                     CALL NEXTA4('upper_limit=',ACTION)
                     IF (ACTION.EQ.'TOKE') THEN
                        VIOUPL = -ONE
                     ELSE
                        CALL SAVEWD
                        CALL NEXTF('upper_limit=',VIOUPL)
                     END IF
C     
                     DO I=1,NOECCN
                        CALL EQSTWC(NOECNM(I),4,CLASS,4,1,1
     $                       ,MATCH)
                        IF (MATCH) THEN
                           CALL NOEEXC(I,NOENUM,VIOEXC,VIOSTR
     $                          ,'MULT',VIOLOL,VIOUPL
     $                          ,HEAP(HPNORR),HEAP(HPNIPR)
     $                          ,HEAP(HPNILS),HEAP(HPNJPR)
     $                          ,HEAP(HPNJLS),HEAP(HPNCND)
     $                          ,HEAP(HPNRAV),HEAP(HPNRRV)
     $                          ,HEAP(HPNDIS),HEAP(HPNLOW)
     $                          ,HEAP(HPNHIG),HEAP(HPNVOL)
     $                          ,HEAP(HPNPP1),HEAP(HPNPP2)
     $                          ,HEAP(HPNHP1),HEAP(HPNHP2)
     $                          ,HEAP(HPNWGH),HEAP(HPNVIO)
     $                          ,HEAP(HPNNUM),HEAP(HPNNSP)
     $                          ,HEAP(HPNCV),HEAP(HPNEXC)
     $                          ,HEAP(HPNPID),HEAP(HPCDIS))
                        END IF
                     END DO
C     
                  ELSE IF (WD(1:4).EQ.'WEIG') THEN
                     CALL NEXTA4('class-name=',CLASS)
                     DO I=1,NOECCN
                        CALL EQSTWC(NOECNM(I),4,CLASS,4,1,1
     $                       ,MATCH)
                        IF (MATCH) THEN
                           CALL NOEEXC(I,NOENUM,VIOEXC,VIOSTR
     $                          ,'WEIG',VIOLOL,VIOUPL
     $                          ,HEAP(HPNORR),HEAP(HPNIPR)
     $                          ,HEAP(HPNILS),HEAP(HPNJPR)
     $                          ,HEAP(HPNJLS),HEAP(HPNCND)
     $                          ,HEAP(HPNRAV),HEAP(HPNRRV)
     $                          ,HEAP(HPNDIS),HEAP(HPNLOW)
     $                          ,HEAP(HPNHIG),HEAP(HPNVOL)
     $                          ,HEAP(HPNPP1),HEAP(HPNPP2)
     $                          ,HEAP(HPNHP1),HEAP(HPNHP2)
     $                          ,HEAP(HPNWGH),HEAP(HPNVIO)
     $                          ,HEAP(HPNNUM),HEAP(HPNNSP)
     $                          ,HEAP(HPNCV),HEAP(HPNEXC)
     $                          ,HEAP(HPNPID))
                        END IF
                     END DO
C     
                  ELSE IF (WD(1:4).EQ.'LIST') THEN
                     CALL NEXTA4('class-name=',CLASS)
                     CALL NEXTF('EXCLude=',VIOEXC)
                     DO I=1,NOECCN
                        CALL EQSTWC(NOECNM(I),4,CLASS,4,1,1
     $                       ,MATCH)
                        IF (MATCH) THEN
                           CALL NVIOLS(NOENUM,VIOEXC,VIOSTR,
     1                          HEAP(HPNORR),HEAP(HPNIPR),
     $                          HEAP(HPNILS),HEAP(HPNJPR),
     1                          HEAP(HPNJLS),HEAP(HPNCND),
     $                          HEAP(HPNRAV),HEAP(HPNRRV),
     1                          HEAP(HPNDIS),HEAP(HPNLOW),
     $                          HEAP(HPNHIG),HEAP(HPNVOL),
     1                          HEAP(HPNPP1),HEAP(HPNPP2),
     $                          HEAP(HPNHP1),HEAP(HPNHP2),
     1                          HEAP(HPNWGH),HEAP(HPNVIO),
     $                          HEAP(HPNNUM),
     1                          HEAP(HPNNSP),HEAP(HPNCV)
     $                          ,HEAP(HPNEXC),HEAP(HPNPID))
                        END IF
                     END DO
C     
                  ELSE
                     CALL CHKEND('COUNtviolations>',DONE)
                  END IF
               END DO
               DONE=.FALSE.
C====================================================================
            ELSE IF (WD(1:4).EQ.'CALI') THEN
               HPNDIA=ALLHP(IREAL8(NATOM))
               CALL FILLR8(HEAP(HPNDIA),NATOM,1.0D0)
               HPNCAL=ALLHP(INTEG4(NATOM))
               CALL FILL4(HEAP(HPNCAL),NATOM,0)
               CALL CALIBR(ISLCT,HEAP(HPNCAL),HEAP(HPNDIA))
               CALL FREHP(HPNCAL,INTEG4(NATOM))
               CALL FREHP(HPNDIA,IREAL8(NATOM))
C====================================================================
            ELSE IF (WD(1:4).EQ.'ANAL') THEN
               CALL ANALRS(NOEHGL,ISLCT,JSLCT)
C====================================================================
c            ELSE IF (WD(1:4).EQ.'RESE') THEN
c               ARINIT=.TRUE.
c               CALL ARIINI
C====================================================================
            ELSE
               CALL CHKEND('ARIA>',DONE)
            END IF
         END IF
      END DO
      DONE=.FALSE.
      RETURN
      END
C     
C====================================================================
C     
      SUBROUTINE ARIFLI(I,J,ISLCT,JSLCT,NOEILS,NOEJLS,NOEHGL)
C     
C     flips the assignments of two atoms in the restraint list
C     
C     **********************************************
C     * Author and copyright: Michael Nilges, EMBL *
C     * No warranty implied or expressed           *
C     * All rights reserved                        *
C     **********************************************
C     
      IMPLICIT NONE
C     
C     -I/O
      INCLUDE 'cns.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'comand.inc'
      INCLUDE 'consta.inc'
      INCLUDE 'coord.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'noe.inc'
      INTEGER NOEILS(*),NOEJLS(*)
      INTEGER NOEHGL(*),ISLCT(*),JSLCT(*),I,J
C     -local
      INTEGER II,JJ,NIAT,NJAT,IINOE
      LOGICAL QNEXT
C     
C     -begin
C     
      NIAT=0
      II=I
      QNEXT=.TRUE.
      DO WHILE (QNEXT)
         NIAT=NIAT+1
         ISLCT(NIAT)=II
         CALL NEXTHY(II, NOEHGL,QNEXT)
      END DO
      NJAT=0
      JJ=J
      QNEXT=.TRUE.
      DO WHILE (QNEXT)
         NJAT=NJAT+1
         JSLCT(NJAT)=JJ
         CALL NEXTHY(JJ, NOEHGL,QNEXT)
      END DO
C      WRITE(6,'(A,2I5)') ' ARIFLI: atoms in group: ', NIAT, NJAT
      IF (NIAT.EQ.NJAT) THEN
         DO IINOE=1,NOEMAX
            DO II=1,NIAT
               IF (NOEILS(IINOE).EQ.ISLCT(II)) THEN
                  NOEILS(IINOE)=JSLCT(II)
               ELSEIF (NOEILS(IINOE).EQ.JSLCT(II)) THEN
                  NOEILS(IINOE)=ISLCT(II)
               END IF
               IF (NOEJLS(IINOE).EQ.ISLCT(II)) THEN
                  NOEJLS(IINOE)=JSLCT(II)
               ELSEIF (NOEJLS(IINOE).EQ.JSLCT(II)) THEN
                  NOEJLS(IINOE)=ISLCT(II)
               END IF
            END DO
         END DO
      END IF      
C     
      RETURN
      END
C     
C====================================================================
C     
      SUBROUTINE ARIMOD(NOEORR,
     &     NOEIPR,NOEILS,NOEJPR,NOEJLS,NOECND,NOERAV,NOERRV,
     &     NOESTP,NOEDIS,NOELOW,NOEHIG,NOEWGH,NOECV,NOEVIO,
     &     NOEPID,NOEPP1,NOEPP2,NOEHP1,NOEHP2,NOEVOL,
     &     NATOM,ISLCT,NISLCT,
     &     JSLCT,NJSLCT,X,Y,Z)
C     
C     Subroutine modifies any of the values of the specified restraint. 
C     e.g., MODIFY H200 1111 TEST=0 END
C     
C     **********************************************
C     * Author and copyright: Michael Nilges, EMBL *
C     * No warranty implied or expressed           *
C     * All rights reserved                        *
C     **********************************************
C     
      IMPLICIT NONE
C     
      INCLUDE 'cns.inc'
      INCLUDE 'noe.inc'
      INCLUDE 'comand.inc'
      INCLUDE 'numbers.inc'
C     I/O
      INTEGER NOEORR(*)
      INTEGER NOEIPR(*), NOEILS(*), NOEJPR(*), NOEJLS(*), NOECND(*)
      DOUBLE PRECISION NOERAV(*), NOERRV(*), NOEDIS(*)
      DOUBLE PRECISION NOELOW(*), NOEHIG(*), NOEWGH(*)
      INTEGER NOECV(*), NOEVIO(*), NOESTP(*), NOEPID(*)
      DOUBLE PRECISION NOEPP1(*),NOEPP2(*),NOEHP1(*),NOEHP2(*)
     $     ,NOEVOL(*)
      INTEGER NATOM, ISLCT(*), NISLCT, JSLCT(*), NJSLCT
      DOUBLE PRECISION X(*), Y(*), Z(*)
C     local
      INTEGER I, II, JJ, J, TISLCT, TJSLCT, IINOE, PEAKID
      LOGICAL SUCCES,OK,FOUND
      CHARACTER*4 CLASS
C     
C     begin
C     
      CALL NEXTA4('class-name=',CLASS)
      CALL NEXTI('PEAKid=',PEAKID)
      IINOE=0
      FOUND=.FALSE.
      DO WHILE (.NOT.FOUND.AND.IINOE.LT.NOENUM)
         IINOE=IINOE+1
         FOUND = (NOEPID(IINOE).EQ.PEAKID)
     $        .AND.(CLASS.EQ.NOECNM(NOECND(IINOE)))
      END DO
      IF (.NOT.FOUND) THEN
         WRITE(6,'(A)')
     &        ' %ARIMOD-ERR: peak not found'
         IINOE=NOEMAX
      END IF

C     
         CALL PUSEND('ARIMOD>')
         DO WHILE (.NOT. DONE)
            CALL NEXTWD('ARIMOD>')
            CALL MISCOM('ARIMOD>',USED)
            IF (.NOT.USED) THEN
C     
               IF (WD(1:4).EQ.'HELP') THEN
                  CALL CNSHELP('cns-noe')
               ELSEIF (WD(1:4).EQ.'DIST') THEN
                  CALL NEXTF('Distance=',NOEDIS(IINOE))
               ELSEIF (WD(1:4).EQ.'LOW ') THEN
                  CALL NEXTF('lower-error=',NOELOW(IINOE))
               ELSEIF (WD(1:4).EQ.'HIGH') THEN
                  CALL NEXTF('higher-error=',NOEHIG(IINOE))
               ELSE IF (WD(1:4).EQ.'PPM1') THEN
                  CALL NEXTF('PPM(F1)=',NOEPP1(IINOE))
               ELSE IF (WD(1:4).EQ.'PPM2') THEN
                  CALL NEXTF('PPM(F2)=',NOEPP2(IINOE))
               ELSE IF (WD(1:4).EQ.'HPM1') THEN
                  CALL NEXTF('PPM(F1)=',NOEHP1(IINOE))
               ELSE IF (WD(1:4).EQ.'HPM2') THEN
                  CALL NEXTF('PPM(F2)=',NOEHP2(IINOE))
               ELSE IF (WD(1:4).EQ.'VOLU') THEN
                  CALL NEXTF('VOLUME=',NOEVOL(IINOE))
               ELSE IF (WD(1:4).EQ.'WEIG') THEN
                  CALL NEXTF('WEIGHT=',NOEWGH(IINOE))
               ELSE IF (WD(1:4).EQ.'CV  ') THEN
                  CALL NEXTI('CV=',NOECV(IINOE))
               ELSE
                  CALL CHKEND('ARIMOD>',DONE)
               END IF
            END IF
         END DO
         DONE=.FALSE.
      RETURN
      END
C     
C=======================================================================
      SUBROUTINE ATGR(NATOM,HGLNK,IATGR)
C     
C     sets up pointer array  iat --> igra
C     (<=> HGLNK(IAT) >= I; then enter all atoms in group)
C     
C     **********************************************
C     * Author and copyright: Michael Nilges, EMBL *
C     * No warranty implied or expressed           *
C     * All rights reserved                        *
C     **********************************************
C     
      IMPLICIT NONE
C     
C     input/ output
      INTEGER NATOM, HGLNK(*), IATGR(*)
      LOGICAL FRSTEL
      EXTERNAL FRSTEL
C     
C     local
      INTEGER I,I1,NGRP
      LOGICAL QNEXT
C     
C     begin
C     
      DO I=1,NATOM
         IATGR(I)=0
      END DO
C     
      NGRP=0
      DO I=1,NATOM
         IF (FRSTEL(I,HGLNK)) THEN
            NGRP=NGRP+1
            I1=I
            QNEXT=.TRUE.
            DO WHILE (QNEXT)
               CALL NEXTHY(I1,HGLNK,QNEXT)
               IATGR(I1)=NGRP
            END DO
         END IF
      END DO
C     
      RETURN
      END
C====================================================================
C     
      SUBROUTINE NEXTHY(IAT, HGLNK, QNEXT)
C     
C     -returns next element in a group in IAT (cyclically).
C     -QNEXT true if there are elements left in group  
C     
      IMPLICIT NONE
C     
C     -global
C     
C     -input/ output
      INTEGER IAT, HGLNK(*)
      LOGICAL QNEXT
C     
C     -local
      INTEGER JAT
C     
C     -begin
C     
      JAT=HGLNK(IAT)
      QNEXT=(HGLNK(JAT).LT.JAT)
      IAT=JAT
C     
      END
C     
C======================================================================
C     
      SUBROUTINE EQVGRP(NATOM,HGLNK)
C     
C     group hydrogen atoms into groups of unresolved hydrogens.
C     
C     Author and copyright: Michael Nilges, EMBL
C     No warranty implied or expressed
C     All rights reserved
C     
      IMPLICIT NONE
C     global
      INCLUDE 'cns.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'comand.inc'
      INCLUDE 'heap.inc'
      INCLUDE 'coord.inc'
C     input/output
      INTEGER NATOM,HGLNK(*)
C     local
      INTEGER IISLCT,INHYBO,IPATBO,NSLCT,NHYBMX,IHGR
C     
C     begin
C     
      NHYBMX=4
C     
C     initialise group link array
C     
C     allocate space for the bond lists
      IISLCT=ALLHP(INTEG4(NATOM))
      INHYBO=ALLHP(INTEG4(NATOM))
      IPATBO=ALLHP(INTEG4(NHYBMX*NATOM))
      IHGR=ALLHP(INTEG4(NATOM))
C     
C     -parsing
      CALL PUSEND('EQUIvalent>')
      DO WHILE (.NOT. DONE)
         CALL NEXTWD('EQUIvalent>')
         CALL MISCOM('EQUIvalent>',USED)
         IF (.NOT.USED) THEN
C     
            IF (WD(1:4).EQ.'HELP') THEN
               CALL CNSHELP('cns-aria-equivalent')
C=====================================================================
            ELSE IF (WD(1:4).EQ.'METH') THEN
               CALL ALLGRP(3,.FALSE.,HGLNK,HEAP(INHYBO),4,
     @              HEAP(IPATBO),HEAP(IISLCT),HEAP(IHGR))
C=====================================================================
            ELSE IF (WD(1:4).EQ.'1-2 ') THEN
               CALL ALLGRP(2,.FALSE.,HGLNK,HEAP(INHYBO),4,
     @              HEAP(IPATBO),HEAP(IISLCT),HEAP(IHGR))
C=====================================================================
            ELSE IF ((WD(1:4).EQ.'NONE').OR.(WD(1:4).EQ.'INIT')) THEN
               CALL HGRINI(NATOM,HGLNK)
C=====================================================================
            ELSE IF (WD(1:4).EQ.'SELE') THEN
               CALL SELCTA(HEAP(IISLCT),NSLCT,X,Y,Z,.TRUE.)
               CALL NEWGRP(HEAP(IISLCT),NSLCT,.TRUE.,HGLNK,HEAP(IHGR))
C=====================================================================
            ELSE
               CALL CHKEND('EQUIvalent>',DONE)
C     
            END IF
         END IF
      END DO
      DONE=.FALSE.
C     
      CALL FREHP(IHGR,INTEG4(NATOM))
      CALL FREHP(IPATBO,INTEG4(NHYBMX*NATOM))
      CALL FREHP(INHYBO,INTEG4(NATOM))
      CALL FREHP(IISLCT,INTEG4(NATOM))
C     
      RETURN
      END
C     
C=======================================================================
C     
      SUBROUTINE HGRINI(NATOM,HGLNK)
C     
C     -initialises the hydrogen group array.
C     -Checks if atoms are known and interact.
C     -All subsequent hydrogen tests are based on the hydrogen group array.
C     
C     -Author: Michael Nilges, HHMI and Yale University
C     
      IMPLICIT NONE
C     -global
      INCLUDE 'cns.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'coord.inc'
      INCLUDE 'funct.inc'
C     -input/output
      INTEGER NATOM,HGLNK(*)
C     -local
      INTEGER I,NH
C     
C     -begin
C     
      NH=0
      DO I=1,NATOM
         HGLNK(I)=0
      END DO
      DO I=1,NATOM
         IF (HYDROG(I)) THEN
            HGLNK(I)=I
            NH=NH+1
         END IF
      END DO
C     
      RETURN
      END
C     
C=======================================================================
C     
      SUBROUTINE ALLGRP(HMIN,OVRWRT,HGLNK,NHYBON,NHYBMX,
     &     PATBON,ISLCT,LHGR)
C     
C     defines hydrogen groups by connectivity and number.
C     if OVRWRT any existing overlapping groups are overwritten.
C     
C     Author: Michael Nilges, HHMI and Yale University
C     
      IMPLICIT NONE
C     global
      INCLUDE 'cns.inc'
      INCLUDE 'mtf.inc'
C     input/output
      INTEGER HMIN,HGLNK(*),NHYBON(*)
      INTEGER NHYBMX,PATBON(NHYBMX,*),ISLCT(*),LHGR(*)
      LOGICAL OVRWRT
C     local
      INTEGER NHYDRO,I,J,IBT,JBT,I1,J1
C     function
      LOGICAL FRSTEL
      EXTERNAL FRSTEL
C     
C     begin
C     
C     set up list of bonds to hydrogens
      DO I=1,NATOM
         NHYBON(I)=0
      END DO
C     
      DO I=1,NBOND
         IBT=IB(I)
         JBT=JB(I)
         IF (IBT.GT.0 .AND. JBT.GT.0) THEN
            IF (HGLNK(JBT).GT.0) THEN
               NHYBON(IBT)=NHYBON(IBT)+1
               PATBON(NHYBON(IBT),IBT)=JBT
            END IF
            IF (HGLNK(IBT).GT.0) THEN
               NHYBON(JBT)=NHYBON(JBT)+1
               PATBON(NHYBON(JBT),JBT)=IBT
            END IF
         END IF
      END DO
C     
C     insert groups
      DO I=1,NATOM
C     
         IF (HGLNK(I).EQ.0) THEN
            NHYDRO=NHYBON(I)
            DO I1=1,NATOM
               ISLCT(I1)=0
            END DO
C     
            IF (NHYDRO.GE.HMIN) THEN
C     found a group
               DO J=1,NHYDRO
                  J1=PATBON(J,I)
                  ISLCT(J1)=1
               END DO
               CALL NEWGRP(ISLCT,NHYDRO,OVRWRT,HGLNK,LHGR)
C     
            ELSEIF (NHYDRO.GT.0) THEN
C     one group for each h-atom
               DO J=1,NHYDRO
                  J1=PATBON(J,I)
                  ISLCT(J1)=1
                  CALL NEWGRP(ISLCT,1,OVRWRT,HGLNK,LHGR)
                  ISLCT(J1)=0
               END DO
C     
            END IF
         END IF
      END DO
C     
      RETURN
      END
C     
C=======================================================================
C     
      SUBROUTINE NEWGRP(ISLCT,NSLCT,OVRWRT,HGLNK,LGRP)
C     
C     groups are defined by array ISELCT.
C     non-hydrogen atoms are removed.
C     the groups are connected by cyclic pointers:
C     HGLNK(I1ST) = ILAST; => HGLNK(I1ST) > I1ST
C     HGLNK(I2ND) = I1ST;  => HGLNK(I2ND) < I2ND
C     HGLNK(I3RD) = I2ND;  ...
C     ...
C     HGLNK(I) = I  <=>  I is the only atom in group
C     HGLNK(I) = 0  <=>  I is not a hydrogen
C     if OVRWRT any existing overlapping groups are overwritten.
C     
C     Author and copyright: Michael Nilges, EMBL
C     No warranty implied or expressed
C     All rights reserved
C     
C     
      IMPLICIT NONE
C     

C     global variables
      INCLUDE 'cns.inc'
      INCLUDE 'mtf.inc'
C     input/output
      INTEGER ISLCT(*),NSLCT,HGLNK(*),LGRP(*)
      LOGICAL OVRWRT
C     local variables
      INTEGER NHYDRO,I,J,J1,JTEMP
      LOGICAL CLEAR
C     function
      LOGICAL FRSTEL
      EXTERNAL FRSTEL
C     
C     begin
C     
C     remove non-hydrogen and unknown or non-interacting atoms in selection
      DO I=1,NATOM
         IF (HGLNK(I).GT.0) THEN
            ISLCT(I)=ISLCT(I)
         ELSE
            ISLCT(I)=0
         END IF
      END DO
C     gather selected group indices
      NHYDRO=0
      DO I=1,NATOM
         IF ((ISLCT(I)).GT.0) THEN
            NHYDRO=NHYDRO+1
            LGRP(NHYDRO)=I
         END IF
      END DO
C     
      CLEAR=.TRUE.
C     
C     check if any groups exist and delete if OVRWRT
      DO J=1,NHYDRO
         J1=HGLNK(LGRP(J))
         IF (HGLNK(J1).NE.J1) THEN
            IF (OVRWRT) THEN
C     remove group
               DO WHILE ((HGLNK(J1).NE.J1))
                  JTEMP=J1
                  HGLNK(J1)=J1
                  J1=HGLNK(JTEMP)
               END DO
            ELSE
               CLEAR=.FALSE.
            END IF
         END IF
      END DO
C     
      IF (CLEAR) THEN
C     
C     add a new group
         IF (NHYDRO.GT.0) THEN
            DO J=1,NHYDRO
               IF (J.GT.1) THEN
                  J1=J-1
               ELSE
                  J1=NHYDRO
               END IF
               HGLNK(LGRP(J))=LGRP(J1)
            END DO
         END IF
      END IF
C     
      RETURN
      END
C     
C====================================================================
C     
      LOGICAL FUNCTION FRSTEL(IAT, HGLNK)
C     
C     true if IAT is first element on input. 
C     
      IMPLICIT NONE
C     
C     input/ output
      INTEGER IAT, HGLNK(*)
C     
C     begin
C     
      FRSTEL=((HGLNK(IAT).GE.IAT).AND.(HGLNK(IAT).GT.0))
C     
      END
C     
C====================================================================
      SUBROUTINE ARIINI
C     
C     subroutine initializes the ARIA list
C     
C     Author and copyright: Michael Nilges, EMBL
C     No warranty implied or expressed
C     All rights reserved
C     
      IMPLICIT NONE
C     
C     I/O
      INCLUDE 'cns.inc'
      INCLUDE 'aria.inc'
C     begin
C     
C     set heap pointers of dynamic data structure to zero
      HPNHGL=0
      HPNMAT=0
      HPNMA2=0
      HPDMAT=0
      HPIMAT=0
      HPNCAL=0
      HPNPSE=0
      HPNDIA=0
      HPHHPR=0
      HPNPR =0
      HPRATE=0
C     
C     initialize array sizes
      MATDIM=0
      DIMMAT=0
      NHG=0
      DIMNHG=0
      NMRATM=0
      DIMATM=0
C     
C     reset other variables
      CALL ARIRES
      RETURN
      END

C====================================================================
      SUBROUTINE ARIRES
C     
C     subroutine resets all ARIA variables
C     
C     Author and copyright: Michael Nilges, EMBL
C     No warranty implied or expressed
C     All rights reserved
C     
C     
      IMPLICIT NONE
C     
C     I/O
      INCLUDE 'cns.inc'
      INCLUDE 'aria.inc'
      INCLUDE 'consta.inc'
C begin
      CALL ARIHP(0,0,0)
C
      ARINIT = .TRUE.
      VIOSTR = 0
      VIOEXC = 0.0D0
      VIOTHR = 0.0D0
      AMBLEV = 1.0D0
      AMBMAX = 1
      AMBMIN = 1
      AMBSTR = 0
      AMBCUT = R4BIG
      AVEMOD = 'AVER'
      AMBMOD = 'ALL '
      AMBFRM = 'OR-R'
      CALCNT=0
      CALDIS=6.0D0
C
      RETURN
      END
C     
C====================================================================
      SUBROUTINE ARIHP(NMATDIM,NNHG,NNATOM)
C     
C     **********************************************
C     * Author and copyright: Michael Nilges, EMBL *
C     * No warranty implied or expressed           *
C     * All rights reserved                        *
C     **********************************************
C     
      IMPLICIT NONE
C     
      INCLUDE 'cns.inc'
      INCLUDE 'heap.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'aria.inc'
      INTEGER NMATDIM,NNHG,NNATOM
C     
C     free old space if things have changed
C     assign new space or initialize variables
      IF (NMATDIM.NE.DIMMAT) THEN
         IF (HPNMA2.NE.0)   CALL FREHP(HPNMA2,INTEG4(DIMMAT))
         IF (HPNMAT.NE.0)   CALL FREHP(HPNMAT,IREAL8(DIMMAT))
         IF (NMATDIM .GT. 0) THEN
            HPNMAT=ALLHP(IREAL8(NMATDIM))
            HPNMA2=ALLHP(INTEG4(NMATDIM))
         ELSE
            HPNMA2=0
            HPNMAT=0
         END IF
      END IF
      IF (NNHG.NE.DIMNHG) THEN
         IF (HPIMAT.NE.0)   CALL FREHP(HPIMAT,IREAL8(DIMNHG*DIMNHG))
         IF (HPDMAT.NE.0)   CALL FREHP(HPDMAT,IREAL8(DIMNHG*DIMNHG))
         IF (HPHHPR.NE.0)   CALL FREHP(HPHHPR,INTEG4(DIMNHG*DIMNHG))
         IF (HPRATE.NE.0)   CALL FREHP(HPRATE,IREAL8(DIMNHG*DIMNHG))
         IF (NNHG .GT. 0) THEN
            HPRATE = ALLHP(IREAL8(NNHG*NNHG))
            HPHHPR = ALLHP(INTEG4(NNHG*NNHG))
            HPDMAT = ALLHP(IREAL8(NNHG*NNHG))
            HPIMAT = ALLHP(IREAL8(NNHG*NNHG))
         ELSE
            HPDMAT=0
            HPHHPR=0
            HPIMAT=0
            HPRATE=0
         END IF
      END IF
      IF (NNATOM.NE.DIMATM) THEN
         IF (HPPOPU.NE.0)   CALL FREHP(HPPOPU,IREAL8(DIMATM))
         IF (HPNPR.NE.0)    CALL FREHP(HPNPR,INTEG4(DIMATM))
         IF (HPIGR.NE.0)    CALL FREHP(HPIGR,INTEG4(DIMATM))
         IF (HPNCAL.NE.0)   CALL FREHP(HPNCAL,INTEG4(DIMATM))
         IF (HPNDIA.NE.0)   CALL FREHP(HPNDIA,IREAL8(DIMATM))
         IF (HPNPSE.NE.0)   CALL FREHP(HPNPSE,INTEG4(DIMATM))
         IF (HPNHGL.NE.0)   CALL FREHP(HPNHGL,INTEG4(DIMATM))
         IF (NNATOM .GT. 0) THEN
            HPNHGL = ALLHP(INTEG4(NNATOM))
            HPNPSE = ALLHP(INTEG4(NNATOM))
            HPNDIA = ALLHP(IREAL8(NNATOM))
            HPNCAL = ALLHP(INTEG4(NNATOM))
            HPIGR = ALLHP(INTEG4(NNATOM))
            HPNPR = ALLHP(INTEG4(NNATOM))
            HPPOPU = ALLHP(IREAL8(NNATOM))
         ELSE
            HPNHGL=0
            HPNPSE=0
            HPNDIA=0
            HPNCAL=0
            HPPOPU=0
            HPNPR=0
            HPIGR=0
         END IF
      END IF
C        
C     store the dimensions values in common block
      DIMATM=NNATOM
      DIMNHG=NNHG
      DIMMAT=NMATDIM
C     
      RETURN 
      END

C====================================================
      SUBROUTINE ESANI (ESA, WHICH)
C
C Calls ESANI2, which does the actual energy calculation
C
C by Nico Tjandra and Marius Clore June 1997
C====================================================
      IMPLICIT NONE
C include files
      INCLUDE 'cns.inc'
      INCLUDE 'susc_anis.inc'
      INCLUDE 'heap.inc'
C i/o
      DOUBLE PRECISION ESA
      CHARACTER*7 WHICH
C
      IF (SANIIPTR.NE.0) THEN
      CALL ESANI2(ESA, HEAP(SANIIPTR), HEAP(SANIJPTR), HEAP(SANIKPTR),
     &        HEAP(SANILPTR), HEAP(SANIMPTR), HEAP(SANINPTR),
     &        HEAP(SANIOBSPTR), HEAP(SANIERRPTR),
     &        HEAP(CALCSANIPTR), WHICH)
      END IF
      RETURN
      END
C
C=====================================================
      SUBROUTINE ESANI2 (ESA, ATOMI, ATOMJ, ATOMK, ATOML,
     & ATOMM, ATOMN, SANIOBS, SANIERR, SANICALC, WHICH)
C
C Calculates anisotropy energies
C
C Anis energies are of the form
C      E = k1*deltaAnis**2
C where
C      k1 = force constant,
C      deltaAnis = calculated Anis - observed Anis
C Alos note: that one defines the Anisotropy functions as:
C dip=coef0+coef1*(3*cos(theta)^2-1)+(3/2)*coef2*(sin(theta)^2*cos(2*phi))
C
C which is a flag that switches between energy & force and
C calculated Anis (for violations) calcs
C
C by Nico Tjandra and Marius Clore June 1997
C
C=========================================================
      IMPLICIT NONE
C include files
      INCLUDE 'cns.inc'
      INCLUDE 'coord.inc'
      INCLUDE 'numbers.inc'
      INCLUDE 'deriv.inc'
      INCLUDE 'susc_anis.inc'
      INCLUDE 'consta.inc'
      INCLUDE 'mtf.inc'
C i/o
      INTEGER ATOMI(*), ATOMJ(*), ATOMK(*), ATOML(*)
      INTEGER ATOMM(*), ATOMN(*)
      DOUBLE PRECISION SANIOBS(*), SANIERR(*), SANICALC(*)
      DOUBLE PRECISION ESA
      CHARACTER*7 WHICH
C local variables
      INTEGER COUNT, CLASS
      DOUBLE PRECISION XI, XJ, XK, XL, XM, XN, YI, YJ, YK, YL, YM, YN,
     &                 ZI, ZJ, ZK, ZL, ZM, ZN,
     &                 CALCSANI, DELTASANI, E, DF1, DF2,
     &                 PHI, DPXI, DPYI, DPZI, DPXJ, DPYJ, DPZJ,
     &                 DPXK, DPYK, DPZK, DPXL, DPYL, DPZL,
     &                 DPXM, DPYM, DPZM, DPXN, DPYN, DPZN,
     &                 THETA, DTXI, DTYI, DTZI, DTXJ, DTYJ, DTZJ,
     &                 DTXK, DTYK, DTZK, DTXL, DTYL, DTZL,
     &                 DTXM, DTYM, DTZM, DTXN, DTYN, DTZN,
     &                 o1, o2, o3, o4 ,o5 ,o6 ,o7 ,o8, o9, o10,
     &                 o11, o12, o13, o14, o15, o16, o17, o18, o19,
     &                 o20, o21, o22, o23, o24, o25, o26, o27, o28,
     &                 o29, o30, o31, o32, o33, o34, o35, o36, o37,
     &                 o38, o39, o40, o41, o42, o43, o44, o45, o46,
     &                 o47, o48, o49, o50, o51, o52, o53, o54, o55,
     &                 o56, o57, o58, o59, o60, o61, o62, o63, o64,
     &                 o65, o66, o67, o68, o69, o70, o71, o72, o73,
     &                 o74, o75, o76, o77, o78, o79, o80, o81, o82
      DOUBLE PRECISION OBSSANI, ERRSANI, K1, COEF0,
     &                 COEF1, COEF2, A, B
C
C begin
C
C following Axel's code in ETOR,
C
C zero out partial energy
C
      ESA = ZERO
C
      CLASS = 1
      K1 = SANIFORCES(1)
      COEF0 = SANICOEF0(1)
      COEF1 = SANICOEF1(1)
      COEF2 = SANICOEF2(1)
C
          COUNT=0
C
      DO WHILE(COUNT.LT.NSANI)
          COUNT = COUNT+1
C
          IF (SANIASSNDX(CLASS).LT.COUNT) THEN
               CLASS = CLASS + 1
             IF (SANIASSNDX(CLASS).EQ.SANIASSNDX(CLASS-1)) THEN
               COUNT = COUNT - 1
             ELSE
               K1 = SANIFORCES(CLASS)
               COEF0 = SANICOEF0(CLASS)
               COEF1 = SANICOEF1(CLASS)
               COEF2 = SANICOEF2(CLASS)
            END IF
          END IF     
C
          XI = X(ATOMI(COUNT))
          XJ = X(ATOMJ(COUNT))
          XK = X(ATOMK(COUNT))
          XL = X(ATOML(COUNT))
          XM = X(ATOMM(COUNT))
          XN = X(ATOMN(COUNT))
          YI = Y(ATOMI(COUNT))
          YJ = Y(ATOMJ(COUNT))
          YK = Y(ATOMK(COUNT))
          YL = Y(ATOML(COUNT))
          YM = Y(ATOMM(COUNT))
          YN = Y(ATOMN(COUNT))
          ZI = Z(ATOMI(COUNT))
          ZJ = Z(ATOMJ(COUNT))
          ZK = Z(ATOMK(COUNT))
          ZL = Z(ATOML(COUNT))
          ZM = Z(ATOMM(COUNT))
          ZN = Z(ATOMN(COUNT))
C
          OBSSANI = SANIOBS(COUNT)
          ERRSANI = SANIERR(COUNT)
C
C Calculate phi and its derivatives with respect to x,y,z of atoms:
C i, j, k, l, m, and n. This was done with Mathematica !!!
C
C
        o1=-XI+XJ
        o2=o1**2
        o3=-YI+YJ
        o4=o3**2
        o5=-ZI+ZJ
        o6=o5**2
        o7=o2+o4+o6
        o8=sqrt(o7)
        o9=1/o8
        o10=-XM+XN
        o11=o1*o10
        o12=-YM+YN
        o13=o12*o3
        o14=-ZM+ZN
        o15=o14*o5
        o16=o11+o13+o15
        o17=o10**2
        o18=o12**2
        o19=o14**2
        o20=o17+o18+o19
        o21=sqrt(o20)
        o22=1/o21
        o23=1/o7
        o24=o16**2
        o25=1/o20
        o26=o23*o24*o25
        o27=sqrt(1.d0-o26)
        o28=1/o27
        o29=XM-XN
        o30=o7**(3.d0/2.d0)
        o31=1/o30
        o32=o1*o16*o22*o31
        o33=YM-YN
        o34=o16*o22*o3*o31
        o35=ZM-ZN
        o36=o16*o22*o31*o5
        o37=o20**(3.d0/2.d0)
        o38=1/o37
        o39=o10*o16*o38*o9
        o40=o12*o16*o38*o9
        o41=o14*o16*o38*o9
        o42=-XI+XK
        o43=o42**2
        o44=-YI+YK
        o45=o44**2
        o46=-ZI+ZK
        o47=o46**2
        o48=o43+o45+o47
        o49=sqrt(o48)
        o50=-XI+XL
        o51=o50**2
        o52=-YI+YL
        o53=o52**2
        o54=-ZI+ZL
        o55=o54**2
        o56=o51+o53+o55
        o57=sqrt(o56)
        o58=1/o57
        o59=o10*o42
        o60=o12*o44
        o61=o14*o46
        o62=o59+o60+o61
        o63=1/o62
        o64=o10*o50
        o65=o12*o52
        o66=o14*o54
        o67=o64+o65+o66
        o68=o62**2
        o69=1/o68
        o70=o56**(3.d0/2.d0)
        o71=1/o70
        o72=o49*o50*o63*o67*o71
        o73=1/o49
        o74=o42*o58*o63*o67*o73
        o75=1/o56
        o76=o67**2
        o77=o48*o69*o75*o76
        o78=1/(1.d0+o77)
        o79=o49*o52*o63*o67*o71
        o80=o44*o58*o63*o67*o73
        o81=o49*o54*o63*o67*o71
        o82=o46*o58*o63*o67*o73
C
        THETA = acos(o16*o22*o9)
C
        DTXI = -(o28*(o32+o22*o29*o9))
        DTYI = -(o28*(o34+o22*o33*o9))
        DTZI = -(o28*(o36+o22*o35*o9))
        DTXJ = -(o28*(-o32+o10*o22*o9))
        DTYJ = -(o28*(-o34+o12*o22*o9))
        DTZJ = -(o28*(-o36+o14*o22*o9))
        DTXK = 0
        DTYK = 0
        DTZK = 0
        DTXL = 0
        DTYL = 0
        DTZL = 0
        DTXM = -(o28*(o39+o22*o9*(XI-XJ)))
        DTYM = -(o28*(o40+o22*o9*(YI-YJ)))
        DTZM = -(o28*(o41+o22*o9*(ZI-ZJ)))
        DTXN = -(o28*(-o39+o1*o22*o9))
        DTYN =  -(o28*(-o40+o22*o3*o9))
        DTZN = -(o28*(-o41+o22*o5*o9))
C
        PHI = atan(o49*o58*o63*o67)
C
        DPXI = (o29*o49*o58*o63-o29*o49*o58*o67*o69+o72-o74)*o78
        DPYI = o78*(o33*o49*o58*o63-o33*o49*o58*o67*o69+o79-o80)
        DPZI = o78*(o35*o49*o58*o63-o35*o49*o58*o67*o69+o81-o82)
        DPXJ = 0
        DPYJ = 0
        DPZJ = 0
        DPXK = (-(o10*o49*o58*o67*o69)+o74)*o78
        DPYK = o78*(-(o12*o49*o58*o67*o69)+o80)
        DPZK = o78*(-(o14*o49*o58*o67*o69)+o82)
        DPXL = (o10*o49*o58*o63-o72)*o78
        DPYL = o78*(o12*o49*o58*o63-o79)
        DPZL = o78*(o14*o49*o58*o63-o81)
        DPXM = o78*(-(o49*o58*o67*o69*(XI-XK))+o49*o58*o63*(XI-XL))
        DPYM = o78*(-(o49*o58*o67*o69*(YI-YK))+o49*o58*o63*(YI-YL))
        DPZM = o78*(-(o49*o58*o67*o69*(ZI-ZK))+o49*o58*o63*(ZI-ZL))
        DPXN = (o49*o50*o58*o63-o42*o49*o58*o67*o69)*o78
        DPYN = (o49*o52*o58*o63-o44*o49*o58*o67*o69)*o78
        DPZN = (o49*o54*o58*o63-o46*o49*o58*o67*o69)*o78
C
C
C
C
C calculate energy as a function of delta anis
C
C
C
C Casting the coefficients to relate to the correct definition
C COEF0 = DFS
C COEF2 = B/A   i.e. rhombicity
C
C************************
C IF COEF1 is defined as the minimum observed value
C
C COEF1 = -A - 1.5*A*COEF2 + DFS
C and
C       A = (COEF0 - COEF1)/(1. + (1.5*COEF2))
C************************
C
C************************
C IF COEF1 is defined as the magnitude of the axial component
C
C COEF1 = A
C
C
        A = COEF1
        B = A * COEF2
C
        CALCSANI = COEF0+A*(3.*COS(THETA)*COS(THETA)-1.)+
     &            B*(3./2.)*(SIN(THETA)*SIN(THETA)*COS(2.*PHI))
          IF (WHICH.EQ.'ANALYZE') SANICALC(COUNT) = CALCSANI
          DELTASANI = CALCSANI-OBSSANI
          IF (     (ABS(DELTASANI).LT.ERRSANI)
     &        .AND.(POTENTIAL.EQ.SQUARE)) THEN
              E = 0
              DF1 = 0
              DF2 = 0
          ELSE
           E = K1*(DELTASANI**2)
           DF1 = 2*K1*DELTASANI*(A*(-6.)*SIN(THETA)*COS(THETA)
     &                +B*3.*SIN(THETA)*COS(THETA)*COS(2.*PHI))
           DF2 = 2*K1*DELTASANI*(B*(-3.)*SIN(THETA)*SIN(THETA)*
     &           SIN(2.*PHI))
C
          END IF
C
C
C accumulate energy
C
          ESA = ESA + E
C
C now update forces if in energy & force mode
C
ccc      write (6,'(5i5)') count,atomi(count),atomj(count)
          IF (WHICH.NE.'ANALYZE') THEN
           DX(ATOMI(COUNT))=DX(ATOMI(COUNT))+DF1*DTXI+DF2*DPXI
           DY(ATOMI(COUNT))=DY(ATOMI(COUNT))+DF1*DTYI+DF2*DPYI
           DZ(ATOMI(COUNT))=DZ(ATOMI(COUNT))+DF1*DTZI+DF2*DPZI
           DX(ATOMJ(COUNT))=DX(ATOMJ(COUNT))+DF1*DTXJ+DF2*DPXJ
           DY(ATOMJ(COUNT))=DY(ATOMJ(COUNT))+DF1*DTYJ+DF2*DPYJ
           DZ(ATOMJ(COUNT))=DZ(ATOMJ(COUNT))+DF1*DTZJ+DF2*DPZJ
           DX(ATOMK(COUNT))=DX(ATOMK(COUNT))+DF1*DTXK+DF2*DPXK
           DY(ATOMK(COUNT))=DY(ATOMK(COUNT))+DF1*DTYK+DF2*DPYK
           DZ(ATOMK(COUNT))=DZ(ATOMK(COUNT))+DF1*DTZK+DF2*DPZK
           DX(ATOML(COUNT))=DX(ATOML(COUNT))+DF1*DTXL+DF2*DPXL
           DY(ATOML(COUNT))=DY(ATOML(COUNT))+DF1*DTYL+DF2*DPYL
           DZ(ATOML(COUNT))=DZ(ATOML(COUNT))+DF1*DTZL+DF2*DPZL
           DX(ATOMM(COUNT))=DX(ATOMM(COUNT))+DF1*DTXM+DF2*DPXM
           DY(ATOMM(COUNT))=DY(ATOMM(COUNT))+DF1*DTYM+DF2*DPYM
           DZ(ATOMM(COUNT))=DZ(ATOMM(COUNT))+DF1*DTZM+DF2*DPZM
           DX(ATOMN(COUNT))=DX(ATOMN(COUNT))+DF1*DTXN+DF2*DPXN
           DY(ATOMN(COUNT))=DY(ATOMN(COUNT))+DF1*DTYN+DF2*DPYN
           DZ(ATOMN(COUNT))=DZ(ATOMN(COUNT))+DF1*DTZN+DF2*DPZN
          END IF
      END DO
      RETURN
      END
C
C================
      SUBROUTINE READSANI
C
C reads in coupling constant information
C
C by Nico Tjandra and Marius Clore June 1997
C================
      IMPLICIT NONE
C include files
      INCLUDE 'cns.inc'
      INCLUDE 'comand.inc'
      INCLUDE 'susc_anis.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'heap.inc'
      INCLUDE 'numbers.inc'
C i/o
C local variables
      INTEGER COUNT, SPTR, OLDCLASS, OLDMAXSANI
      DOUBLE PRECISION K1, CUTOFF, COEF0, COEF1, COEF2
      CHARACTER*4 THENAME
C begin
C
C this is used by READSANI2 to hold the selection
C
      SPTR=ALLHP(INTEG4(NATOM))
C
C reset database only if no couplings have been entered
C ie., this is the first time that SANIsotropy has been called
C
      IF (SANIIPTR.EQ.0) THEN
           CALL SANIDEFAULTS
           CALL ALLOCSANI(0, MAXSANI)
      END IF
C
C now read input
C
      CALL PUSEND('SANI>')
      DO WHILE (.NOT.DONE)
           CALL NEXTWD('SANI>')
           CALL MISCOM('SANI>',USED)
           IF (.NOT.USED) THEN
C
           IF (WD(1:4).EQ.'HELP') THEN
C
              CALL CNSHELP('cns-sanisotropy')
C
C Get class name.  Determine if it's an already-defined class.
C Insert a new class if it's not.
C
           ELSE IF (WD(1:4).EQ.'CLAS') THEN
                OLDCLASS = CURCLASS
                CALL NEXTA4('class name =', THENAME)
                MODE = NEW
                DO COUNT = 1, NCLASSES
                     IF (SANICLASSNAMES(COUNT).EQ.THENAME) THEN
                          MODE = UPDATE
                          CURCLASS = COUNT
                     END IF
                END DO
                IF (MODE.EQ.NEW) THEN
C
C make sure you can't add more than the maximum
C number of classes
C
                     IF (OLDCLASS.EQ.MAXSANICLASSES) THEN
                          CALL DSPERR('SANI','Too many classes.')
                          CALL DSPERR('SANI',
     &                      'Increase MAXSANICLASSES and recompile.')
                          CALL WRNDIE(-5, 'READSANI',
     &                      'Too many Anisotropy classes.')
                     END IF
                     NCLASSES = NCLASSES + 1
                     CURCLASS = NCLASSES
                     SANICLASSNAMES(CURCLASS) = THENAME
C
C If this isn't the first class, close off the old class
C
                     IF (NCLASSES.GT.1) THEN
                            SANIASSNDX(OLDCLASS) = NSANI
                     END IF
               END IF
C
C
C set force constant for current class
C
           ELSE IF (WD(1:4).EQ.'FORC') THEN
                CALL NEXTF('force constant =', K1)
C
C start a default class if there isn't one defined
C
                IF (CURCLASS.EQ.0) THEN
                     NCLASSES = 1
                     CURCLASS = 1
                END IF
        WRITE(PUNIT, '(A, A, A, F8.3)')
     &            'Setting force const for class ',
     &            SANICLASSNAMES(CURCLASS), ' to ', K1
                SANIFORCES(CURCLASS) = K1
C
C set coefficient constant for current class
C
           ELSE IF (WD(1:4).EQ.'COEF') THEN
                CALL NEXTF('coefficient 0 =', COEF0)
                CALL NEXTF('coefficient 1 =', COEF1)
                CALL NEXTF('coefficient 2 =', COEF2)
C
C start a default class if there isn't one already defined
C
                IF (CURCLASS.EQ.0) THEN
                     NCLASSES = 1
                     CURCLASS = 1
                END IF
                WRITE(PUNIT, '(A,A,A, F8.3, F8.3, F8.3, F8.3)')
     &            'Setting coefficients for class ',
     &            SANICLASSNAMES(CURCLASS), 'to', COEF0, COEF1, COEF2
C
                SANICOEF0(CURCLASS) = COEF0
                SANICOEF1(CURCLASS) = COEF1
                SANICOEF2(CURCLASS) = COEF2
C
C
C reset couplings database
C
           ELSE IF (WD(1:4).EQ.'RESE') THEN
                CALL SANIHP
                CALL SANIINIT
                CALL ALLOCSANI(0, MAXSANI)
C
C set potential type
C
           ELSE IF (WD(1:4).EQ.'POTE') THEN
                CALL NEXTA4('potential type =', THENAME)
                IF (THENAME.EQ.'SQUA') THEN
                     WRITE(PUNIT, '(A)') 'using square well potential.'
                     POTENTIAL = SQUARE
                ELSE IF (THENAME.EQ.'HARM') THEN
                     WRITE(PUNIT, '(A)') 'using harmonic potential.'
                     POTENTIAL = HARMONIC
                ELSE
                  CALL DSPERR('SANI','unknown potential. Using square.')
                  POTENTIAL = SQUARE
                END IF
C
C
C change number of assignment slots
C
           ELSE IF (WD(1:4).EQ.'NRES') THEN
                OLDMAXSANI = MAXSANI
                CALL NEXTI('number of slots =', MAXSANI)
                CALL ALLOCSANI(OLDMAXSANI, MAXSANI)
                WRITE(PUNIT, '(A, I8)')
     &            'SANI: Allocating space for', MAXSANI,
     &            'number of constraints '
C
C
C read in an assignment
C
           ELSE IF (WD(1:4).EQ.'ASSI') THEN
C
C make sure you can't add more coupling assignments
C than you have slots for
C
                IF (NSANI.EQ.MAXSANI) THEN
                     CALL DSPERR('SANI','Too many assignments.')
                     CALL DSPERR('SANI',
     &                    'Increase NREStraints and run again.')
                     CALL WRNDIE(-1,'SANI>',
     &                    'exceeded allocation for SANI restraints')
                END IF
C
C if there isn't a class specified,
C start a default class
C
                IF (CURCLASS.EQ.0) THEN
                     NCLASSES = 1
                     CURCLASS = 1
                END IF
                CALL READSANI2(HEAP(SANIIPTR), HEAP(SANIJPTR),
     &                  HEAP(SANIKPTR), HEAP(SANILPTR),
     &                  HEAP(SANIMPTR),
     &                  HEAP(SANINPTR), HEAP(SANIOBSPTR),
     &                  HEAP(SANIERRPTR), HEAP(SPTR))
C
C print violations
C
           ELSE IF (WD(1:4).EQ.'PRIN') THEN
                CALL NEXTWD('PRINt>')
                IF (WD(1:4).NE.'THRE') THEN
                  CALL DSPERR('SANI',
     &                        'print expects THREshold parameter.')
                ELSE
                     CALL NEXTF('THREshold =', CUTOFF)
                     IF (CUTOFF.LT.ZERO) THEN
                       CALL DSPERR('SANI', 'cutoff must be positive.')
                       CUTOFF = ABS(CUTOFF)
                     END IF
                     CALL NEXTA4('ALL or CLASs>', THENAME)
                     IF (THENAME(1:3).EQ.'ALL') THEN
                          DO COUNT = 1,NCLASSES
                               PRINTCLASS(COUNT) = .TRUE.
                          END DO
                     ELSE IF (THENAME(1:4).EQ.'CLAS') THEN
                          CALL NEXTA4('class name =', THENAME)
                          DO COUNT = 1,NCLASSES
                               IF (SANICLASSNAMES(COUNT).EQ.
     &                              THENAME) THEN
                                    PRINTCLASS(COUNT) = .TRUE.
                               ELSE
                                    PRINTCLASS(COUNT) = .FALSE.
                               END IF
                          END DO
                     ELSE
                          DO COUNT = 1,NCLASSES
                               PRINTCLASS(COUNT) = .TRUE.
                          END DO
                     END IF
C
           CALL PRINTSANI(CUTOFF, HEAP(CALCSANIPTR), HEAP(SANIOBSPTR),
     &                 HEAP(SANIIPTR), HEAP(SANIJPTR), HEAP(SANIKPTR),
     &                 HEAP(SANILPTR), HEAP(SANIMPTR), HEAP(SANINPTR))
                END IF
C
C check for END statement
C
           ELSE
                CALL CHKEND('SANI>', DONE)
           END IF
           END IF
      END DO
      DONE = .FALSE.
      CALL FREHP(SPTR,INTEG4(NATOM))
      RETURN
      END
C===============
      SUBROUTINE ALLOCSANI (OLDSIZE, NEWSIZE)
C
C resets coupling constant arrays to hold SIZE entries
C
C by Nico Tjandra and Marius Clore June 1997
C===============
      IMPLICIT NONE
C include files
      INCLUDE 'funct.inc'
      INCLUDE 'susc_anis.inc'
C i/o
      INTEGER OLDSIZE, NEWSIZE
C begin
      IF (OLDSIZE.NE.0) THEN
           CALL FREHP(SANIIPTR, INTEG4(OLDSIZE))
           CALL FREHP(SANIJPTR, INTEG4(OLDSIZE))
           CALL FREHP(SANIKPTR, INTEG4(OLDSIZE))
           CALL FREHP(SANILPTR, INTEG4(OLDSIZE))
           CALL FREHP(SANIMPTR, INTEG4(OLDSIZE))
           CALL FREHP(SANINPTR, INTEG4(OLDSIZE))
           CALL FREHP(SANIOBSPTR, IREAL8(OLDSIZE))
           CALL FREHP(SANIERRPTR, IREAL8(OLDSIZE))
           CALL FREHP(CALCSANIPTR, IREAL8(OLDSIZE))
      END IF
C
      SANIIPTR = 0
      SANIJPTR = 0
      SANIKPTR = 0
      SANILPTR = 0
      SANIMPTR = 0
      SANINPTR = 0
      SANIOBSPTR = 0
      SANIERRPTR = 0
      CALCSANIPTR = 0
C
      IF (NEWSIZE.NE.0) THEN
        SANIIPTR = ALLHP(INTEG4(NEWSIZE))
        SANIJPTR = ALLHP(INTEG4(NEWSIZE))
        SANIKPTR = ALLHP(INTEG4(NEWSIZE))
        SANILPTR = ALLHP(INTEG4(NEWSIZE))
        SANIMPTR = ALLHP(INTEG4(NEWSIZE))
        SANINPTR = ALLHP(INTEG4(NEWSIZE))
        SANIOBSPTR = ALLHP(IREAL8(NEWSIZE))
        SANIERRPTR = ALLHP(IREAL8(NEWSIZE))
        CALCSANIPTR = ALLHP(IREAL8(NEWSIZE))
      END IF
C
      RETURN
      END
C==============
      SUBROUTINE SANIDEFAULTS
C
C sets up defaults
C
C by Nico Tjandra and Marius Clore June 1997
C==============
      IMPLICIT NONE
C include files
      INCLUDE 'susc_anis.inc'
C local variables
      INTEGER COUNT
C begin
      SANIIPTR = 0
      MODE = NEW
      MAXSANI = 200
      NSANI = 0
      NCLASSES = 0
      CURCLASS = 0
      POTENTIAL = SQUARE
      DO COUNT = 1, MAXSANICLASSES
           SANICLASSNAMES(COUNT) = 'DEFAULT'
           SANIASSNDX(COUNT) = 0
           SANIFORCES (COUNT) = 50
           SANICOEF0(COUNT) = 1.0
           SANICOEF1(COUNT) = 1.0
           SANICOEF2(COUNT) = 1.0
      END DO
      RETURN
      END
C==============
      SUBROUTINE READSANI2 (ATOMI, ATOMJ, ATOMK, ATOML,
     &         ATOMM, ATOMN, SANIOBS, SANIERR, SEL)
C
C reads actual J coupling assignments into arrays
C
C by Nico Tjandra and Marius Clore June 1997
C==============
      IMPLICIT NONE
C include files
      INCLUDE 'cns.inc'
      INCLUDE 'coord.inc'
      INCLUDE 'susc_anis.inc'
      INCLUDE 'mtf.inc'
C i/o
      INTEGER ATOMI(*), ATOMJ(*), ATOMK(*), ATOML(*)
      INTEGER ATOMM(*), ATOMN(*),  SEL(*)
      DOUBLE PRECISION SANIOBS(*), SANIERR(*)
C local variables
      INTEGER NSEL, INSERTPOS, COUNT, CURSTOP, OTHERSTOP, NFLAG
      DOUBLE PRECISION SANIO, SANIE
C begin
C
C if we're in update mode, make a space for the new line
C
      NFLAG = 0
C
      IF (MODE.EQ.UPDATE) THEN
           DO COUNT = NSANI+1, SANIASSNDX(CURCLASS)+1, -1
                ATOMI(COUNT) = ATOMI(COUNT-1)
                ATOMJ(COUNT) = ATOMJ(COUNT-1)
                ATOMK(COUNT) = ATOMK(COUNT-1)
                ATOML(COUNT) = ATOML(COUNT-1)
                ATOMM(COUNT) = ATOMM(COUNT-1)
                ATOMN(COUNT) = ATOMN(COUNT-1)
                SANIOBS(COUNT) = SANIOBS(COUNT-1)
                SANIERR(COUNT) = SANIERR(COUNT-1)
           END DO
           CURSTOP = SANIASSNDX(CURCLASS)
           DO COUNT = 1, NCLASSES
                OTHERSTOP = SANIASSNDX(COUNT)
                IF (OTHERSTOP.GT.CURSTOP) THEN
                     SANIASSNDX(COUNT) = OTHERSTOP + 1
                END IF
           END DO
           SANIASSNDX(CURCLASS) = CURSTOP + 1
           INSERTPOS = CURSTOP
           NSANI = NSANI + 1
      ELSE
           NSANI = NSANI + 1
           INSERTPOS = NSANI
           SANIASSNDX(CURCLASS) = INSERTPOS
      END IF
C
      CALL SELCTA(SEL, NSEL, X, Y, Z,.TRUE.)
      IF (NSEL.GT.1) THEN
       CALL DSPERR('SANI',
     &             'more than 1 atom in sel for atom i. Using first')
      END IF
      IF (NSEL.EQ.0) THEN
       CALL DSPERR('SANI','Error with atom selection')
       NFLAG = 1
      ENDIF
      CALL MAKIND(SEL, NATOM, NSEL)
      ATOMI(INSERTPOS) = SEL(1)
C
      CALL SELCTA(SEL, NSEL, X, Y, Z,.TRUE.)
      IF (NSEL.GT.1) THEN
       CALL DSPERR('SANI',
     &             'more than 1 atom in sel for atom j. Using first')
      END IF
      IF (NSEL.EQ.0) THEN
       CALL DSPERR('SANI','Error with atom selection')
       NFLAG = 1
      ENDIF
      CALL MAKIND(SEL, NATOM, NSEL)
      ATOMJ(INSERTPOS) = SEL(1)
C
      CALL SELCTA(SEL, NSEL, X, Y, Z,.TRUE.)
      IF (NSEL.GT.1) THEN
       CALL DSPERR('SANI',
     &             'more than 1 atom in sel for atom k. Using first')
      END IF
      IF (NSEL.EQ.0) THEN
       CALL DSPERR('SANI','Error with atom selection')
       NFLAG = 1
      ENDIF
      CALL MAKIND(SEL, NATOM, NSEL)
      ATOMK(INSERTPOS) = SEL(1)
C
      CALL SELCTA(SEL, NSEL, X, Y, Z,.TRUE.)
      IF (NSEL.GT.1) THEN
       CALL DSPERR('SANI',
     &             'more than 1 atom in sel for atom l. Using first')
      END IF
      IF (NSEL.EQ.0) THEN
       CALL DSPERR('SANI','Error with atom selection')
       NFLAG = 1
      ENDIF
      CALL MAKIND(SEL, NATOM, NSEL)
      ATOML(INSERTPOS) = SEL(1)
C
      CALL SELCTA(SEL, NSEL, X, Y, Z,.TRUE.)
      IF (NSEL.GT.1) THEN
       CALL DSPERR('SANI',
     &             'more than 1 atom in sel for atom l. Using first')
      END IF
      IF (NSEL.EQ.0) THEN
       CALL DSPERR('SANI','Error with atom selection')
       NFLAG = 1
      ENDIF
      CALL MAKIND(SEL, NATOM, NSEL)
      ATOMM(INSERTPOS) = SEL(1)
C
      CALL SELCTA(SEL, NSEL, X, Y, Z,.TRUE.)
      IF (NSEL.GT.1) THEN
       CALL DSPERR('SANI',
     &             'more than 1 atom in sel for atom l. Using first')
      END IF
      IF (NSEL.EQ.0) THEN
       CALL DSPERR('SANI','Error with atom selection')
       NFLAG = 1
      ENDIF
      CALL MAKIND(SEL, NATOM, NSEL)
      ATOMN(INSERTPOS) = SEL(1)
C
      CALL NEXTF('observed Anis =', SANIO)
      CALL NEXTF('error in Anis =', SANIE)
      SANIOBS(INSERTPOS) =SANIO
      SANIERR(INSERTPOS) = SANIE
C
C Check for error atom selection. If there is one than reset the
C counter for restraint
C
      IF (NFLAG.EQ.1) THEN
       NSANI = NSANI-1
      ENDIF
C
      RETURN
      END
C===============
      SUBROUTINE SANIINIT
C
C initializes J-coupling stuff
C
C by nico Tjandra and Marius Clore June 1997
C================
      IMPLICIT NONE
C include files
      INCLUDE 'susc_anis.inc'
C begin
      CALL SANIDEFAULTS
C
      RETURN
      END
C===============
      SUBROUTINE SANIHP
C
C deallocates susceptibility anisotropy stuff
C
C by Gregory Warren 1/9/98
C================
      IMPLICIT NONE
C include files
      INCLUDE 'susc_anis.inc'
C begin
      IF (SANIIPTR.NE.0) THEN
      CALL ALLOCSANI(MAXSANI,0)
      END IF
      RETURN
      END
C=================
      SUBROUTINE PRINTSANI (CUTOFF, SANICALC, SANIOBS,
     &       ATOMI, ATOMJ, ATOMK, ATOML, ATOMM, ATOMN)
C
C prints anisotropy with deltaJ greater than cutoff
C calculates RMS deviation and puts it into $RESULT
C
C by Nico Tjandra and Marius Clore June 1997
C=================
      IMPLICIT NONE
C include files
      INCLUDE 'cns.inc'
      INCLUDE 'susc_anis.inc'
      INCLUDE 'comand.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'numbers.inc'
C i/o
      DOUBLE PRECISION CUTOFF, SANICALC(*), SANIOBS(*)
      INTEGER ATOMI(*), ATOMJ(*), ATOMK(*), ATOML(*)
      INTEGER ATOMM(*), ATOMN(*)
C local variables
      DOUBLE PRECISION CALCSANI, OBSSANI, DELTASANI, SANIENERGY
      INTEGER COUNT, CLASS, I, J, K, L, M, N, NUM
      DOUBLE PRECISION RMS, VIOLS, DBPREC
      DOUBLE COMPLEX DUMMY2
      LOGICAL PRINTTHISCLASS
C begin
      RMS = ZERO
      VIOLS = ZERO
      NUM = 0
C
C make sure that the calcJ array is up to date
C
      CALL ESANI(SANIENERGY, 'ANALYZE')
      WRITE (PUNIT, '(A)') 'The following anisotropies have'
      WRITE (PUNIT, '(A)') 'delta SANI greater than the cutoff:'
      WRITE (PUNIT, '(A)') '(calc Anis) (obs Anis) (delta Anis)'
C
C write out first class heading
C
      CLASS = 1
      PRINTTHISCLASS = PRINTCLASS(CLASS)
      IF (PRINTTHISCLASS) THEN
           WRITE (PUNIT, '(A, A)') 'class ', SANICLASSNAMES(1)
      END IF
C
C for every anisotropy entry,
C
      COUNT = 0
      DO WHILE(COUNT.LT.NSANI)
          COUNT=COUNT+1
C
C is this the start of a new class?
C
          IF (SANIASSNDX(CLASS).LT.COUNT) THEN
               CLASS = CLASS + 1
               PRINTTHISCLASS = PRINTCLASS(CLASS)
               IF (SANIASSNDX(CLASS).EQ.SANIASSNDX(CLASS-1)) THEN
                 COUNT = COUNT - 1
               ENDIF
               IF (PRINTTHISCLASS) THEN
                 WRITE (PUNIT, '(A, A)') 'class ', SANICLASSNAMES(CLASS)
               END IF
          END IF
C
C If this assignment is in a class to be printed
C and make sure there is an entry for that class
C
         IF((PRINTTHISCLASS).AND.(SANIASSNDX(CLASS).NE.
     &    SANIASSNDX(CLASS-1))) THEN
C
C always update RMS delta J
C
          CALCSANI = SANICALC(COUNT)
          OBSSANI = SANIOBS(COUNT)
          DELTASANI = (CALCSANI-OBSSANI)
          RMS = RMS + DELTASANI**2
          NUM = NUM + 1
C
C print out delta Js greater than cutoff
C and update number of violations
C
          IF (ABS(DELTASANI).GT.CUTOFF) THEN
               I = ATOMI(COUNT)
               J = ATOMJ(COUNT)
               K = ATOMK(COUNT)
               L = ATOML(COUNT)
               M = ATOMM(COUNT)
               N = ATOMN(COUNT)
               WRITE(PUNIT,'(5X,8(1X,A), 3(F8.3))')
     &               SEGID(M),RESID(M),RES(M),TYPE(M),
     &               SEGID(N),RESID(N),RES(N),TYPE(N),
     &               CALCSANI, OBSSANI, DELTASANI
               VIOLS = VIOLS + ONE
          END IF
       END IF
      END DO

      IF (NUM.GT.0) THEN
          RMS = SQRT(RMS / NUM)
      ELSE
          RMS=0.0
      ENDIF
      DBPREC = NUM
      CALL DECLAR('NUMBER', 'DP', ' ', DUMMY2, DBPREC)
      CALL DECLAR('RESULT', 'DP', ' ', DUMMY2, RMS)
      CALL DECLAR('VIOLATIONS', 'DP', ' ', DUMMY2, VIOLS)
      RETURN
      END
C
      SUBROUTINE SCRASANI
C
C Author: Gregory Warren
      IMPLICIT NONE
C I/O
      INCLUDE 'susc_anis.inc'
C reset diffusion anisotropy database
      IF (SANIIPTR.NE.0) THEN
      WRITE(6,'(A)')
     & ' SCRATC-warning: susceptibility anistropy database erased.'
      CALL SANIHP
      CALL SANIINIT
      END IF
      RETURN
      END
C

C==== 6====1=========2=========3=========4=========5=========6=========72
      SUBROUTINE RXPAIR3
     $     (DIM, NLAYERS, HGLNK, DUMMY, NPAIRS, HHPAIR, CUTOFF,
     $     DMAT, RXAVEX, NJMAX)
C     
C     calculate list of J spins that interact with I spins.
C     we do this by calculating several layers around each atom:
C     first, get all JG that interact with IG.
C     then, get all KG that interact with all JG etc
C     in contrast to RXPAIRS, this routine uses an average DMAT distance 
C     matrix accumulated from an ensemble of structures by AMBACC
C     
C     **********************************************
C     * Author and copyright: Michael Nilges, EMBL *
C     * No warranty implied or expressed           *
C     * All rights reserved                        *
C     **********************************************
C     
      IMPLICIT NONE
C     
      INCLUDE 'consta.inc'
      INCLUDE 'numbers.inc'
C     
      INTEGER DIM, NLAYERS, DUMMY(*), HGLNK(*), 
     $     NPAIRS(*), HHPAIR(DIM,*), NJMAX
      DOUBLE PRECISION DMAT(DIM,*), RXAVEX, CUTOFF
C     
      INTEGER IG, JG, KG, ILAYER, ILIST, JLIST, NIJPR, IAT, JAT,
     $     NIJPR2, NIJPR1
      DOUBLE PRECISION DISIJ, MAXDIS
      LOGICAL WARN, FOUND
C     
C     begin
C     
C     
C     the routine first sets up a square mask of 1 and 0
C     and then condenses the rows
C     
C     initialize the pair array
C     
      DO IG=1,DIM
         DO JG=1,DIM
            HHPAIR(IG,JG)=0
         END DO
         HHPAIR(IG,IG)=1
      END DO
C     
C     first, calculate the first layer of neighbours
C     
      NJMAX=0
      WARN=.FALSE.
      DO IG=1,DIM-1
         DO JG=IG+1,DIM
            DISIJ=DMAT(IG,JG)
            IF (DISIJ.LT.CUTOFF) THEN
               HHPAIR(IG,JG)=1
               HHPAIR(JG,IG)=1
            END IF
         END DO
      END DO
C     
C     loop over layers
C     
      IF (NLAYERS.GT.1) THEN
         DO ILAYER=2,NLAYERS
            DO IG=1,DIM
               DO KG=1,DIM
                  DUMMY(KG)=0
               END DO
               DO JG=IG,DIM
                  IF (HHPAIR(IG,JG).GT.0) THEN
                     DO KG=1,DIM
                        DUMMY(KG)=DUMMY(KG)+HHPAIR(JG,KG)
                     END DO
                  END IF
               END DO
               DO KG=1,DIM
                  HHPAIR(IG,KG)=HHPAIR(IG,KG)+DUMMY(KG)
               END DO
            END DO
         END DO
      END IF
C     
C     now condense HHPAIR
C     
      MAXDIS = ZERO
      DO IG=1,DIM
         NIJPR=0
         DO KG=1,DIM
            DUMMY(KG)=HHPAIR(IG,KG)
            HHPAIR(IG,KG)=0
         END DO
         DO JG=1,DIM
            IF (DUMMY(JG).GT.0) THEN
               NIJPR=NIJPR+1
               HHPAIR(IG,NIJPR)=JG
               IF (DMAT(IG,JG).GT.MAXDIS) THEN
                  MAXDIS = DMAT(IG,JG)
                  WRITE(6,'(2I5,E15.5)') IG,JG,MAXDIS
               END IF                  
            END IF
         END DO
         NPAIRS(IG)=NIJPR
         IF (NIJPR.LE.1) WARN=.TRUE.
         NJMAX=MAX(NIJPR,NJMAX)
      END DO
C     
      WRITE(6,'(A,I5,E15.5)') ' RXPAIR2: maximum Npair, distance ',
     $     NJMAX,MAXDIS
      IF (WARN) THEN
         WRITE(6,'(A)') ' RXPAIR-WRN: no interactions for some spins'
      END IF
C     
      RETURN
      END
C==== 6====1=========2=========3=========4=========5=========6=========72
      SUBROUTINE RXPAIRS
     $     (DIM, NATOM, NLAYERS, HGLNK, IGRAT, NPAIRS, HHPAIR, CUTOFF,
     $     X, Y, Z, DMAT, RXAVEX, NJMAX)
C     
C     calculate list of J spins that interact with I spins.
C     we do this by calculating several layers around each atom:
C     first, get all JG that interact with IG.
C     then, get all KG that interact with all JG etc
C     
C     **********************************************
C     * Author and copyright: Michael Nilges, EMBL *
C     * No warranty implied or expressed           *
C     * All rights reserved                        *
C     **********************************************
C
      IMPLICIT NONE
C
      INCLUDE 'consta.inc'
      INCLUDE 'numbers.inc'
C     
      INTEGER DIM, NATOM, NLAYERS, IGRAT(*), HGLNK(*), 
     $     NPAIRS(*), HHPAIR(DIM,*), NJMAX
      DOUBLE PRECISION DMAT(DIM,*), RXAVEX, X(*), Y(*), Z(*), CUTOFF
C     
      INTEGER IG, JG, ILAYER, ILIST, JLIST, NIJPR, IAT, JAT, NIJPR2,
     $     NIJPR1
      DOUBLE PRECISION DISIJ, MAXDIS
      LOGICAL WARN, FOUND
C     
C     begin
C     
C     
      NJMAX=0
      WARN=.FALSE.
      DO IG=1,DIM
         NIJPR2=1
         NIJPR1=1
         NIJPR =1
C     enter atom itself on list
         HHPAIR(IG,NIJPR)=IG
         MAXDIS = ZERO
C     loop over layers
         DO ILAYER=1,NLAYERS
            NIJPR1=NIJPR2
            NIJPR2=NIJPR
            DO ILIST=NIJPR1,NIJPR2
               IAT=IGRAT(HHPAIR(IG,ILIST))
               DO JG=1,DIM
                  JAT=IGRAT(JG)
                  IAT=IGRAT(IG)
C     first calculate the distance between IG and JG
                  CALL RM6DIS(IAT,JAT,HGLNK,X,Y,Z,RXAVEX,DISIJ)
                  DMAT(IG,JG)=DISIJ
C     then the distances to JG from the neighbours of IG
                  IAT=IGRAT(HHPAIR(IG,ILIST))
                  CALL RM6DIS(IAT,JAT,HGLNK,X,Y,Z,RXAVEX,DISIJ)
                  IF (DISIJ.LT.CUTOFF) THEN
C     check if the atom is already on the list
                     FOUND=.FALSE.
                     DO JLIST=1,NIJPR
                        IF (HHPAIR(IG,JLIST).EQ.JG) FOUND = .TRUE.
                     END DO
C     if not yet present, enter on the list
                     IF (.NOT. FOUND) THEN
                        NIJPR=NIJPR+1
                        HHPAIR(IG,NIJPR)=JG
                        MAXDIS = MAX(MAXDIS, DMAT(IG,JG))       
                     END IF
                  END IF
               END DO
            END DO
         END DO
         NPAIRS(IG)=NIJPR
         IF (NIJPR.LE.1) WARN=.TRUE.
         NJMAX=MAX(NIJPR,NJMAX)
C         WRITE (6, '(A, 2I5, E15.5)') ' RXPAIR: IG, NIJPR, DISIJ ',
C     $        IG, NIJPR, MAXDIS
      END DO
      WRITE(6,'(A,I5,E15.5)') ' RXPAIR: maximum Npair, distance ',
     $     NJMAX,MAXDIS
      IF (WARN) THEN
         WRITE(6,'(A)') ' RXPAIR-WRN: no interactions for some spins'
      END IF
C     
      RETURN
      END
C=======================================================================
C==== 6====1=========2=========3=========4=========5=========6=========72
      SUBROUTINE RXPAIR2
     $     (DIM, NLAYERS, HGLNK, IGRAT, NPAIRS, HHPAIR, CUTOFF,
     $     DMAT, RXAVEX, NJMAX)
C     
C     calculate list of J spins that interact with I spins.
C     we do this by calculating several layers around each atom:
C     first, get all JG that interact with IG.
C     then, get all KG that interact with all JG etc
C     in contrast to RXPAIRS, this routine uses an average DMAT distance 
C     matrix accumulated from an ensemble of structures by AMBACC
C     
C     **********************************************
C     * Author and copyright: Michael Nilges, EMBL *
C     * No warranty implied or expressed           *
C     * All rights reserved                        *
C     **********************************************
C
      IMPLICIT NONE
C
      INCLUDE 'consta.inc'
      INCLUDE 'numbers.inc'
C     
      INTEGER DIM, NLAYERS, IGRAT(*), HGLNK(*), 
     $     NPAIRS(*), HHPAIR(DIM,*), NJMAX
      DOUBLE PRECISION DMAT(DIM,*), RXAVEX, CUTOFF
C     
      INTEGER IG, JG, ILAYER, ILIST, JLIST, NIJPR, IAT, JAT, NIJPR2,
     $     NIJPR1
      DOUBLE PRECISION DISIJ, MAXDIS
      LOGICAL WARN, FOUND
C     
C     begin
C     
C     
      NJMAX=0
      WARN=.FALSE.
      DO IG=1,DIM
         NIJPR2=1
         NIJPR1=1
         NIJPR =1
C     enter atom itself on list
         HHPAIR(IG,NIJPR)=IG
         MAXDIS = ZERO
C     loop over layers
         DO ILAYER=1,NLAYERS
            NIJPR1=NIJPR2
            NIJPR2=NIJPR
            DO ILIST=NIJPR1,NIJPR2
               IAT=IGRAT(HHPAIR(IG,ILIST))
               DO JG=1,DIM
                  DISIJ=DMAT(HHPAIR(IG,ILIST),JG)
                  IF (DISIJ.LT.CUTOFF) THEN
C     found one - check if the atom is already on the list
                     FOUND=.FALSE.
                     DO JLIST=1,NIJPR
                        IF (HHPAIR(IG,JLIST).EQ.JG) FOUND = .TRUE.
                     END DO
C     ok, enter on the list
                     IF (.NOT. FOUND) THEN
                        NIJPR=NIJPR+1
                        HHPAIR(IG,NIJPR)=JG
                        MAXDIS = MAX(MAXDIS, DMAT(IG,JG))                  
                     END IF
                  END IF
               END DO
            END DO
         END DO
         NPAIRS(IG)=NIJPR
         IF (NIJPR.LE.1) WARN=.TRUE.
         NJMAX=MAX(NIJPR,NJMAX)
      END DO
      WRITE(6,'(A,I5,E15.5)') ' RXPAIR2: maximum Npair, distance ',
     $     NJMAX,MAXDIS
      IF (WARN) THEN
         WRITE(6,'(A)') ' RXPAIR-WRN: no interactions for some spins'
      END IF
C     
      RETURN
      END
C=======================================================================
C==== 6====1=========2=========3=========4=========5=========6=========72

      SUBROUTINE CNTGRP(NATOM,HGLNK,NHG2,NHY2)
C
C     subroutine counts the number of groups and hydrogens in the system
C     
C     **********************************************
C     * Author and copyright: Michael Nilges, EMBL *
C     * No warranty implied or expressed           *
C     * All rights reserved                        *
C     **********************************************
C
      IMPLICIT NONE
C
C     global
C      INCLUDE 'aria.inc'
C     
C     input/output
      INTEGER NATOM,HGLNK(*),NHG2,NHY2
C     
C     local
      INTEGER I,I1,POPI
      LOGICAL QNEXT
C     
C     begin
C     
C     count number of groups present and maximum population
      NHG2=0
      NHY2=0
      DO I=1,NATOM
         IF (HGLNK(I).GE.I) THEN
            NHG2=NHG2+1
            I1=I
            POPI=0
            QNEXT=.TRUE.
            DO WHILE (QNEXT)
               POPI=POPI+1
               CALL NEXTHY(I1, HGLNK, QNEXT)
            END DO
C$$$  EQVMAX=MAX(EQVMAX,POPI)
         END IF
         IF (HGLNK(I).GT.0) NHY2=NHY2+1
      END DO
      WRITE(6,'(A,2I5)') ' CNTGRP: NHG2, NHY2 ', NHG2, NHY2
C     
      RETURN
      END
C=======================================================================
C==== 6====1=========2=========3=========4=========5=========6=========72
      SUBROUTINE GRFPOP(NATOM,HGLNK,GRPOP)
C     
C     returns sqrt(number of hydros) in each group
C     
C     **********************************************
C     * Author and copyright: Michael Nilges, EMBL *
C     * No warranty implied or expressed           *
C     * All rights reserved                        *
C     **********************************************
C
      IMPLICIT NONE
C     
C     global
      INCLUDE 'numbers.inc'
C     
C     input/ output
      INTEGER NATOM, HGLNK(*)
      DOUBLE PRECISION GRPOP(*)
C     
C     local
      INTEGER I,I1,NGRP
      DOUBLE PRECISION POPI
C     
C     begin
C     
      NGRP=0
      DO I=1,NATOM
         IF (HGLNK(I).GE.I) THEN
            NGRP=NGRP+1
            I1=I
C first atom in group
            POPI=ONE
C other atoms
            DO WHILE (HGLNK(I1).GT.I1)
               POPI=POPI+ONE
               I1=HGLNK(I1)     
            END DO
            GRPOP(NGRP)=POPI
         END IF
      END DO
C     
      RETURN
      END
C=======================================================================
C==== 6====1=========2=========3=========4=========5=========6=========72
      SUBROUTINE GRAT(NATOM,HGLNK,IGRAT)
C     
C     sets up pointer array  igrf --> ihy
C     (<=> HGLNK(IAT) >= I)
C     
C     **********************************************
C     * Author and copyright: Michael Nilges, EMBL *
C     * No warranty implied or expressed           *
C     * All rights reserved                        *
C     **********************************************
C     
      IMPLICIT NONE
C     
C     input/ output
      INTEGER NATOM, HGLNK(*), IGRAT(*)
C     
C     local
      INTEGER I,NGRP
C     
C     begin
C     
      NGRP=0
      DO I=1,NATOM
         IF (HGLNK(I).GE.I) THEN
            NGRP=NGRP+1
            IGRAT(NGRP)=I
         END IF
      END DO
C     
      RETURN
      END
C
C
      SUBROUTINE RM6DIS(I,J,HGLNK,X,Y,Z,EXPO,DSIX)
C     
C     calculates the weighted distance between two groups of atoms
C     if the exponent is 0, the distance between the geometric
C     averages of the groups is calculated
C     
C     **********************************************
C     * Author and copyright: Michael Nilges, EMBL *
C     * No warranty implied or expressed           *
C     * All rights reserved                        *
C     **********************************************
C
      IMPLICIT NONE
C
C     global
      INCLUDE 'numbers.inc'
      INCLUDE 'consta.inc'
      INCLUDE 'funct.inc'
C     
C     input/ output
      INTEGER I,J,HGLNK(*)
      DOUBLE PRECISION X(*),Y(*),Z(*),EXPO,DSIX
      LOGICAL FRSTEL
      EXTERNAL FRSTEL
C     
C     local
      INTEGER II,JJ,L,LZ,LI,LJ
      DOUBLE PRECISION XIJ,YIJ,ZIJ,RIJ,SIJ
      DOUBLE PRECISION XIAVE,YIAVE,ZIAVE,XJAVE,YJAVE,ZJAVE
      DOUBLE PRECISION MINDIS
      LOGICAL QNEXTI, QNEXTJ
C     
C     begin
C     
C set the minimum distance to 1.0 (to the inverse sixth power)
      MINDIS=1.0

      IF ((I.EQ.0).OR.(J.EQ.0)
     $     .OR.(.NOT.FRSTEL(I,HGLNK))
     $     .OR.(.NOT.FRSTEL(J,HGLNK))) THEN
         WRITE(6, '(A,2I8)') ' %RM6DIS: error in atom number',
     $        I, J
         DSIX=9999.0D0
C     
      ELSE
         IF (EXPO.EQ.ZERO) THEN
C     generate average coordinates for the pseudo atoms
            II=I
            JJ=J
            XIAVE=ZERO
            YIAVE=ZERO
            ZIAVE=ZERO
            LI=0
            QNEXTI=.TRUE.
            DO WHILE (QNEXTI)
               XIAVE=XIAVE+X(II)
               YIAVE=YIAVE+Y(II)
               ZIAVE=ZIAVE+Z(II)
               LI=LI+1
            END DO
            XIAVE=XIAVE/FLOAT(LI)
            YIAVE=YIAVE/FLOAT(LI)
            ZIAVE=ZIAVE/FLOAT(LI)
C     
            XJAVE=ZERO
            YJAVE=ZERO
            ZJAVE=ZERO
            LJ=0
            QNEXTJ=.TRUE.
            DO WHILE (QNEXTJ)
               XJAVE=XJAVE+X(JJ)
               YJAVE=YJAVE+Y(JJ)
               ZJAVE=ZJAVE+Z(JJ)
               LJ=LJ+1
            END DO
            XJAVE=XJAVE/FLOAT(LJ)
            YJAVE=YJAVE/FLOAT(LJ)
            ZJAVE=ZJAVE/FLOAT(LJ)
C     
            DSIX=SQRT((XIAVE-XJAVE)**2
     $           +(YIAVE-YJAVE)**2+(ZIAVE-ZJAVE)**2)
C     
         ELSE
C     
            DSIX=ZERO
            II=I
            JJ=J
            L=0
            LZ=0
C     loop over all pairs of atoms
            QNEXTI=.TRUE.
            DO WHILE (QNEXTI)
               QNEXTJ=.TRUE.
               DO WHILE (QNEXTJ)
                  XIJ = X(II)-X(JJ)
                  YIJ = Y(II)-Y(JJ)
                  ZIJ = Z(II)-Z(JJ)
                  SIJ = XIJ**2+YIJ**2+ZIJ**2
                  IF (SIJ.GT.RSMALL) THEN
                     RIJ = SIJ**(-EXPO/TWO)
                     DSIX=DSIX+RIJ
                     L=L+1
                  ELSE
                     RIJ=-ONE
                     LZ=LZ+1
                     DSIX = MINDIS
                  END IF     
                  CALL NEXTHY(JJ, HGLNK, QNEXTJ)
               END DO
               CALL NEXTHY(II, HGLNK, QNEXTI)
            END DO
C     
            IF (L.GT.0) THEN
               DSIX=DSIX/FLOAT(L) ! inverse distances
               DSIX=DSIX**(ONE/EXPO)
            END IF
C     
            IF (DSIX.GT.RSMALL) THEN
               DSIX=ONE/DSIX
            ELSEIF (L.EQ.0) THEN
               DSIX=ZERO
            ELSE
               DSIX=9999.0D0
               WRITE(6,'(A)')
     $              ' %RM6DIS-ERR: infinite distance, set to 9999'
            END IF
         END IF
      END IF
C     
      RETURN
      END
C=======================================================================
C==== 6====1=========2=========3=========4=========5=========6=========72
      SUBROUTINE RMATRIX
     $     (DIM,NATOM, HGLNK,GRPOP,
     $     SUMTRP, RATE,DMAT,HHPAIR,
     $     NPAIR, OMEGA,ZLEAK,MTAU)
C     
C     Calculates the complete rate matrix
C     Ref.: Keepers, J.W., and James, T.L. (1984), J. Magn. Reson. 57, 404.
C     
C     
C     **********************************************
C     * Author and copyright: Michael Nilges, EMBL *
C     * No warranty implied or expressed           *
C     * All rights reserved                        *
C     **********************************************
C
      IMPLICIT NONE
C
C     global variables
      INCLUDE 'cns.inc'
      INCLUDE 'numbers.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'consta.inc'
      INCLUDE 'heap.inc'
      INCLUDE 'aria.inc'
C     
C     input/ output
      INTEGER NATOM, DIM
      INTEGER HGLNK(*)
      DOUBLE PRECISION GRPOP(*)
      DOUBLE PRECISION RATE(DIM,*), DMAT(DIM,*)
      INTEGER HHPAIR(DIM,*),NPAIR(*)
      DOUBLE PRECISION OMEGA,ZLEAK,MTAU
C     
C     workspace
      DOUBLE PRECISION SUMTRP(*)
C     
C     local variables
      INTEGER I,IG,IH,JH,JG,IJ,L
      INTEGER II,JJ,LI,LJ,LR
      DOUBLE PRECISION TAU, TSWS, TS2WS
      DOUBLE PRECISION POPISQ, POPJSQ, POPIJ
      DOUBLE PRECISION XIJ,YIJ,ZIJ,SIJ,RIJ,DIJ,Q,DSIX,DDSIX
      DOUBLE PRECISION OMSQ, SORD
      DOUBLE PRECISION S0,S1,S2
      DOUBLE PRECISION CON0,CON1,CON2,TRPI,TRPJ,DRT,DTRI,DTRJ
      DOUBLE PRECISION CRAT
      INTEGER ETAU,EOM,EDIST,EMU
      LOGICAL DISJUNCT
      CHARACTER*6 PROCNAME
      INTEGER NI,JJG
C     
C     begin
C     
      SORD=ONE
C

      CON0=MGYR**4*MHBAR**2
      CON1=3.0D0*CON0
      CON2=6.0D0*CON0
      OMSQ=2.0D0*PI*OMEGA*1.0D-9
      OMSQ=OMSQ*OMSQ
      WRITE(6,'(A,2E15.5)') ' RMATRIX: tau, omega: ', MTAU,OMEGA
C     
C     correction factors
      EOM=9                     !GHz-->Hz
      ETAU=-9                   !ns-->s
      EDIST=-10                 !A -->m
      EMU=-14                   !Mu0**2/16pi**2
      CRAT=1.0D0                !10**(4*EGYR+2*EHBAR+ETAU-6*EDIST+EMU-1)
C     
C     initialise relaxation matrix etc.
      DO IG=1,DIM
         DO JG=1,DIM
            RATE(JG,IG) = ZERO
         END DO
      END DO
C     
      DO IG=1,DIM
         SUMTRP(IG) = ZERO
      END DO
C     
      IJ=0
      DO IG=1,DIM
         DO JG=1,DIM
C
C get spectral densities
c$$$            CALL TAUGET(IG,JG,HGLNK,MTAU,SORD)
            TAU=MTAU*1.0D9
            TSWS=TAU*TAU*OMSQ
            TS2WS=FOUR*TSWS
            S0 = SORD*CON0*TAU
            S1 = SORD*CON1*TAU/(ONE+TSWS)
            S2 = SORD*CON2*TAU/(ONE+TS2WS)
C     
C     relaxation rate and transition probabilities
C     diagonal elements
            IF (IG.EQ.JG) THEN
               IF (GRPOP(IG).GT.ONE) THEN 
                  Q=DMAT(IG,IG)**(-SIX)
                  DRT=TWO*(GRPOP(IG)-ONE)*(HALF*S1+S2)*CRAT
                  RATE(IG,IG)=Q*DRT
                  TRPI=ZERO
                  TRPJ=ZERO
               ELSE
                  RATE(IG,IG)=ZERO
                  TRPI=ZERO
                  TRPJ=ZERO
               END IF 
C     
C     off-diagonal elements and accumulate transition probabilities
            ELSE
               Q=DMAT(IG,JG)**(-SIX)
               DRT=(S2-S0)*GRPOP(IG)*CRAT
               RATE(IG,JG)=Q*DRT
               DTRI=(S1+S2+S0)*GRPOP(JG)*CRAT
               TRPI=Q*DTRI
               SUMTRP(IG)=SUMTRP(IG)+TRPI
            ENDIF
         END DO
      END DO
C     
C     add z leakage and transition probabilities to diagonal terms
      DO I=1,DIM
         RATE(I,I)=RATE(I,I)+SUMTRP(I)+ZLEAK
      END DO
C
      WRITE(6, '(A)') ' RMATRIX: constructed relaxation matrix '
C     
      RETURN                         
      END
C=======================================================================
C==== 6====1=========2=========3=========4=========5=========6=========72
      SUBROUTINE RXIBLQ
     $     (NHG,NJMAX,NTAUP1,ABSZIS,GRPOP,DMAT,RTMAT,CALVOL,
     $     INTMAT,HHPAIR,NPAIR,TAUMIX)
C     
C     calculate a sparse spectrum using numerical integration
C     of a sparse relaxation matrix.
C     the time intervals are squared
C     
C     **********************************************
C     * Author and copyright: Michael Nilges, EMBL *
C     * No warranty implied or expressed           *
C     * All rights reserved                        *
C     **********************************************
C     
      IMPLICIT NONE
C     
C     global variables
      INCLUDE 'numbers.inc'
      INCLUDE 'consta.inc'
C     
C     input/ output  
C     
      INTEGER NHG,NJMAX,NTAUP1
      DOUBLE PRECISION RTMAT(NHG,*), DMAT(NHG,*), INTMAT(NHG,*), 
     $     CALVOL(NHG,NHG,NTAUP1)
      INTEGER  HHPAIR(NHG,*), NPAIR(*)
      DOUBLE PRECISION ABSZIS(*),GRPOP(*)
      DOUBLE PRECISION TAUMIX
C     
C     local variables               
      INTEGER           I,J,NI,NJ,JJ,LL,L,T,NTAUP12
      DOUBLE PRECISION  DELTAU, INTBEG, SUMDIS, SUMVOL,
     $     MAXVOL, MINDIS
      CHARACTER*6       PROCNAME
C     
C     begin
C     
      DO T=1,NTAUP1
         DO J=1,NHG
            DO I=1,NHG
               CALVOL(I,J,T)=ZERO
            END DO
         END DO
      END DO
C     
      ABSZIS(1)=ZERO
      ABSZIS(2)=ONE
      DO T=3,NTAUP1
         ABSZIS(T)=ABSZIS(T-1)*2
      END DO
      DO T=1,NTAUP1
         ABSZIS(T)=ABSZIS(T)/ABSZIS(NTAUP1)*TAUMIX
      END DO
C     
      DELTAU=ABSZIS(2)-ABSZIS(1)
      WRITE(6,'(A,E15.5)') ' RXIBLQ: integration interval, '
     $     , DELTAU
C     
C     rewrite RTMAT to be (I - dtR)
      DO J=1,NHG
         DO I=1,NHG
            RTMAT(I,J)=-DELTAU*RTMAT(I,J)
         END DO
      END DO
      DO I=1,NHG
         RTMAT(I,I)=RTMAT(I,I)+ONE
      END DO
C     
C     first integration step
      T=2
      SUMVOL=ZERO
      DO I=1,NHG
         DO JJ=1,NPAIR(I)
            J=HHPAIR(I,JJ)
            CALVOL(I,J,T)=RTMAT(I,J)
            IF (I.NE.J) THEN
               SUMVOL=SUMVOL+CALVOL(I,J,T)
            END IF
         END DO
      END DO
      WRITE(6, '(A,I5,2E15.5)')
     $     ' RXIBLQ: step, mixing time, sum of volumes: ',
     $     T, ABSZIS(T), SUMVOL
C     
      DO T=3,NTAUP1
         SUMVOL=ZERO
         SUMDIS=ZERO
         DO I=1,NHG
            DO JJ=1,NPAIR(I)
               J=HHPAIR(I,JJ)
               DO LL=1,NPAIR(I)
                  L=HHPAIR(I,LL)
                  CALVOL(I,J,T)= CALVOL(I,J,T)
     $                 +CALVOL(I,L,T-1)*CALVOL(L,J,T-1)
               END DO
               IF (I.NE.J) THEN
                  SUMDIS=SUMDIS+DMAT(I,J)**(-SIX)
                  SUMVOL=SUMVOL+CALVOL(I,J,T)
               END IF
            END DO
         END DO
         WRITE(6, '(A,I5,2E15.5)')
     $        ' RXIBLQ: step, mixing time, sum of volumes: ',
     $        T, ABSZIS(T), SUMVOL
      END DO
C     
C     multiply with the populations (i.e. the magnetization at zero)
      DO T=1,NTAUP1
         SUMVOL=ZERO
         SUMDIS=ZERO
         MINDIS=ZERO
         MAXVOL=-R4BIG
         DO I=1,NHG
            DO JJ=1,NPAIR(I)
               J=HHPAIR(I,JJ)
               CALVOL(I,J,T)=
     $              CALVOL(I,J,T)*GRPOP(J)
               IF (I.NE.J) THEN
                  SUMDIS=SUMDIS+GRPOP(I)*GRPOP(J)*DMAT(I,J)**(-SIX)
                  SUMVOL=SUMVOL+CALVOL(I,J,T)
                  MINDIS=MAX(MINDIS,
     $                 GRPOP(I)*GRPOP(J)*DMAT(I,J)**(-SIX))
                  MAXVOL=MAX(MAXVOL,CALVOL(I,J,T))
               END IF
            END DO
         END DO
      END DO
C     
      DO I=1,NHG
         DO J=1,NHG
            INTMAT(J,I)=ZERO
         END DO
      END DO
C     scale intensities such that they come out ~ d^-6
      DO I=1, NHG
         DO JJ=1,NPAIR(I)
            J=HHPAIR(I,JJ)
            IF (J.GT.NHG) THEN
               WRITE(6,'(A)') ' RXIBLQ: programming error, nhg'
            ELSE
               INTMAT(I,J)=MINDIS/MAXVOL*CALVOL(I,J,NTAUP1)
            END IF
         END DO
      END DO
C     
      WRITE(6, '(A,2E15.5)')
     $     ' RXIBLQ: sum, max of calculated volumes: ',
     $     SUMVOL, MAXVOL
      WRITE(6, '(A,2E15.5)')
     $     ' RXIBLQ: sum, max of calculated r^-6: ',
     $     SUMDIS, MINDIS
C     
      RETURN
      END



C=======================================================================
C==== 6====1=========2=========3=========4=========5=========6=========72
      SUBROUTINE RXIBL2
     $     (NHG,NJMAX,NTAUP1,ABSZIS,GRPOP,DMAT,RTMAT,CALVOL,
     $     INTMAT,HHPAIR,NPAIR,TAUMIX)
C     
C     calculate a sparse spectrum using numerical integration
C     of a sparse relaxation matrix.
C     the time intervals are squared
C     
C     **********************************************
C     * Author and copyright: Michael Nilges, EMBL *
C     * No warranty implied or expressed           *
C     * All rights reserved                        *
C     **********************************************
C     
      IMPLICIT NONE
C     
C     global variables
      INCLUDE 'numbers.inc'
      INCLUDE 'consta.inc'
C     
C     input/ output  
C     
      INTEGER NHG,NJMAX,NTAUP1
      DOUBLE PRECISION RTMAT(NHG,*), DMAT(NHG,*), INTMAT(NHG,*), 
     $     CALVOL(NHG,NJMAX,NTAUP1)
      INTEGER  HHPAIR(NHG,*), NPAIR(*)
      DOUBLE PRECISION ABSZIS(*),GRPOP(*)
      DOUBLE PRECISION TAUMIX
C     
C     local variables               
      INTEGER           I,J,NI,NJ,JJ,LL,L,T,NTAUP12
      DOUBLE PRECISION  DELTAU, INTBEG, SUMDIS, SUMVOL,
     $     MAXVOL, MINDIS
      CHARACTER*6       PROCNAME
C     
C     begin
C     
      DO T=1,NTAUP1
         DO J=1,NJMAX
            DO I=1,NHG
               CALVOL(I,J,T)=ZERO
            END DO
         END DO
      END DO
C     
      ABSZIS(1)=ZERO
      ABSZIS(2)=ONE
      DO T=3,NTAUP1
         ABSZIS(T)=ABSZIS(T-1)*2
      END DO
      DO T=1,NTAUP1
         ABSZIS(T)=ABSZIS(T)/ABSZIS(NTAUP1)*TAUMIX
      END DO
C     
      DELTAU=ABSZIS(2)-ABSZIS(1)
      WRITE(6,'(A,E15.5)') ' RXIBLQ: integration interval, '
     $     , DELTAU
C     
C     rewrite RTMAT to be (I - dtR)
      DO J=1,NHG
         DO I=1,NHG
            RTMAT(I,J)=-DELTAU*RTMAT(I,J)
         END DO
      END DO
      DO I=1,NHG
         RTMAT(I,I)=RTMAT(I,I)+ONE
      END DO
C     
C     first integration step
      T=2
      SUMVOL=ZERO
      DO I=1,NHG
         DO J=1,NHG
            CALVOL(I,J,T)=RTMAT(I,J)
            IF (I.NE.J) THEN
               SUMVOL=SUMVOL+CALVOL(I,J,T)
            END IF
         END DO
      END DO
      WRITE(6, '(A,I5,2E15.5)')
     $     ' RXIBLQ: step, mixing time, sum of volumes: ',
     $     T, ABSZIS(T), SUMVOL
C     
      DO T=3,NTAUP1
         SUMVOL=ZERO
         SUMDIS=ZERO
         DO I=1,NHG
            DO J=1,NHG
               DO L=1,NHG
                  CALVOL(I,J,T)= CALVOL(I,J,T)
     $                 +CALVOL(I,L,T-1)*CALVOL(L,J,T-1)
               END DO
               IF (I.NE.J) THEN
                  SUMDIS=SUMDIS+DMAT(I,J)**(-SIX)
                  SUMVOL=SUMVOL+CALVOL(I,J,T)
               END IF
            END DO
         END DO
         WRITE(6, '(A,I5,2E15.5)')
     $        ' RXIBLQ: step, mixing time, sum of volumes: ',
     $        T, ABSZIS(T), SUMVOL
      END DO
C     
C     multiply with the populations (i.e. the magnetization at zero)
      DO T=1,NTAUP1
         SUMVOL=ZERO
         SUMDIS=ZERO
         MINDIS=R4BIG
         MAXVOL=-R4BIG
         DO I=1,NHG
            DO J=1,NHG
               CALVOL(I,J,T)=
     $              CALVOL(I,J,T)*GRPOP(J)
               IF (I.NE.J) THEN
                  SUMDIS=SUMDIS+DMAT(I,J)**(-SIX)
                  SUMVOL=SUMVOL+CALVOL(I,J,T)
                  MINDIS=MIN(MINDIS,DMAT(I,J))
                  MAXVOL=MAX(MAXVOL,CALVOL(I,J,T))
               END IF
            END DO
         END DO
      END DO
      MINDIS=MINDIS**(-SIX)
C     
      DO I=1,NHG
         DO J=1,NHG
            INTMAT(J,I)=ZERO
         END DO
      END DO
C     scale intensities such that they come out ~ d^-6
      DO I=1, NHG
         DO J=1,NHG
            INTMAT(I,J)=MINDIS/MAXVOL*CALVOL(I,J,NTAUP1)
         END DO
      END DO
C     
      WRITE(6, '(A,2E15.5)')
     $     ' RXIBLQ: sum, max of calculated volumes: ',
     $     SUMVOL, MAXVOL
      WRITE(6, '(A,2E15.5)')
     $     ' RXIBLQ: sum, max of calculated r^-6: ',
     $     SUMDIS, MINDIS
C     
      RETURN
      END

C=====================================================================
C     
      SUBROUTINE CALIBR(ISLCT,CALPTR,DIAGON)
C     
C     Set up distance calibration.
C     
C     Author: Michael Nilges, EMBL, 1994.
C     
      IMPLICIT NONE
C     
C     global
      INCLUDE 'cns.inc'
      INCLUDE 'comand.inc'
      INCLUDE 'consta.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'coord.inc'
      INCLUDE 'numbers.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'heap.inc'
      INCLUDE 'noe.inc'
      INCLUDE 'aria.inc'
C     
C     input/ output
C     ISLCT,           flags for selected atoms
      INTEGER ISLCT(*),CALPTR(*)
      DOUBLE PRECISION DIAGON(*)
C     
C     local
      DOUBLE PRECISION RTEMP
      INTEGER NISLCT, ICAL, JCAL, I, J
      LOGICAL QMATCH,QCALIB
      CHARACTER*4 CALMOD,ACTION,ERRMOD
C     functions
      LOGICAL FRSTEL
      EXTERNAL FRSTEL
C     
C     begin
C     
      QCALIB=.TRUE.
      CALMOD='ANIS'
      ERRMOD='DIST'
      ACTION='DEFA'
      CALL PUSEND('CALIBR>')
      DO WHILE (.NOT.DONE)
         CALL NEXTWD('CALIBR>')
C     
C     
         IF (WD(1:4).EQ.'HELP') THEN
C     
            CALL CNSHELP('cns-aria-calibrate')
C     
         ELSE IF (WD(1:4).EQ.'RESE') THEN
            CALCNT=0
            CALL FILL4(CALPTR,NATOM,0)
            CALL FILLR8(DIAGON, NATOM, ONE)
            CALEXP=SIX
            CALDIS=SIX     
C     
         ELSE IF (WD(1:4).EQ.'MODE') THEN
            CALL NEXTA4('Calibration-mode=',CALMOD)
C     
         ELSE IF (WD(1:4).EQ.'ERRM') THEN
            CALL NEXTA4('ERRor-mode=',ERRMOD)
C     
         ELSE IF (WD(1:4).EQ.'EXPO') THEN
            CALL NEXTF('Calibration-exponent=',CALEXP)
C     
         ELSE IF (WD(1:4).EQ.'CUTO') THEN
            CALL NEXTF('Calibration-cutoff=',CALDIS)
C     
         ELSE IF (WD(1:4).EQ.'VECT') THEN
C     select two groups of atoms
            CALL SELCTA(ISLCT,NISLCT,X,Y,Z,.TRUE.)
            CALL CHKSEL
     &           (ISLCT,NISLCT,NATOM,CALPTR,CALCNT,ICAL,MAXCAL,QMATCH)
C     if a new group has been created initialize the arrays
C     
            IF (ICAL.GT.0) THEN
C     
               IF (.NOT.QMATCH) THEN
                  DO I=1,CALCNT
                     DREFER(ICAL,I)=ZERO
                     DREFER(I,ICAL)=ZERO
                     VREFER(ICAL,I)=ZERO
                     VREFER(I,ICAL)=ZERO
                  END DO
               END IF
C     
            ELSE
               WRITE (6,'(A)') ' CALIBR: ill-formed group pointer'
            END IF
C     
            CALL SELCTA(ISLCT,NISLCT,X,Y,Z,.TRUE.)
            CALL CHKSEL
     &           (ISLCT,NISLCT,NATOM,CALPTR,CALCNT,JCAL,MAXCAL,QMATCH)
C     if a new group has been created initialize the arrays
C     
            IF (JCAL.GT.0) THEN
C     
               IF (.NOT.QMATCH) THEN
                  DO J=1,CALCNT
                     DREFER(JCAL,J)=ZERO
                     DREFER(J,JCAL)=ZERO
                     VREFER(JCAL,J)=ZERO
                     VREFER(J,JCAL)=ZERO
                  END DO
               END IF
C     
            ELSE
               WRITE (6,'(A)') ' CALIBR: ill-formed group pointer'
            END IF
C     
C     
         ELSE IF (WD(1:4).EQ.'DREF') THEN
            CALL NEXTF('Reference-distance=',RTEMP)
C     
            IF ((ICAL.GT.0).AND.(JCAL.GT.0)) THEN
C     
               IF (RTEMP.GT.RSMALL) THEN
                  RTEMP=RTEMP**(-CALEXP)
               END IF
C     
               DREFER(ICAL,JCAL)=RTEMP
               DREFER(JCAL,ICAL)=RTEMP
            ELSE
               WRITE (6,'(A)') ' CALIBR: ill-formed group pointer'
            END IF
C     
         ELSE IF (WD(1:4).EQ.'VREF') THEN
            CALL NEXTF('Reference-intensity=',RTEMP)
            IF ((ICAL.GT.0).AND.(JCAL.GT.0)) THEN
               VREFER(ICAL,JCAL)=RTEMP
               VREFER(JCAL,ICAL)=RTEMP
            ELSE
               WRITE (6,'(A)') ' CALIBR: ill-formed group pointer'
            END IF
C     
         ELSE IF (WD(1:4).EQ.'AUTO') THEN
            IF ((ICAL.GT.0).AND.(JCAL.GT.0)) THEN
               DREFER(ICAL,JCAL)=ZERO
               DREFER(JCAL,ICAL)=ZERO
               VREFER(ICAL,JCAL)=ZERO
               VREFER(JCAL,ICAL)=ZERO
            ELSE
               WRITE (6,'(A)') ' CALIBR: ill-formed group pointer'
            END IF
C     
         ELSE IF (WD(1:4).EQ.'ERRS') THEN
            ACTION='ERRS'
C     
         ELSE
            CALL CHKEND('CALIBR>',DONE)
C     
         END IF
C     
      END DO
      DONE= .FALSE.
C     
      IF (CALCNT.EQ.0) THEN
         WRITE(6,'(A,A)')
     &        ' CALIBR: no calibration groups defined.',
     $        'uniform calibration'
         CALL FILL4(CALPTR,NATOM,1)
      END IF
C     
C     check first if any coordinates are in the database
      IF (HPNMAT.EQ.0) THEN 
         WRITE(6,'(A)') ' ARICAL-ERR: no distances accumulated '
      ELSE
C     
C     now set errors or calibrate
C     
         IF (ACTION.EQ.'ERRS') THEN
            CALL NOERRS(HEAP(HPNHGL),HEAP(HPNMAT),
     1           HEAP(HPNORR),HEAP(HPNIPR),HEAP(HPNILS),HEAP(HPNJPR),
     1           HEAP(HPNJLS),HEAP(HPNCND),HEAP(HPNRAV),HEAP(HPNRRV),
     1           HEAP(HPNDIS),HEAP(HPNLOW),HEAP(HPNHIG),HEAP(HPNVOL),
     1           HEAP(HPNPP1),HEAP(HPNPP2),HEAP(HPNHP1),HEAP(HPNHP2),
     1           HEAP(HPNWGH),HEAP(HPNVIO),
     1           HEAP(HPNNSP),HEAP(HPNCV), HEAP(HPNPID))
C     
         ELSE IF (CALMOD.EQ.'LINE') THEN
C     
C     do volume dependent uniform calibration
            CALL CALLIN(CALMOD,HEAP(HPNHGL),CALPTR,
     1           HEAP(HPNMAT),DIAGON,
     1           HEAP(HPNORR),HEAP(HPNIPR),HEAP(HPNILS),HEAP(HPNJPR),
     1           HEAP(HPNJLS),HEAP(HPNCND),HEAP(HPNRAV),HEAP(HPNRRV),
     1           HEAP(HPNDIS),HEAP(HPNLOW),HEAP(HPNHIG),HEAP(HPNVOL),
     1           HEAP(HPNPP1),HEAP(HPNPP2),HEAP(HPNHP1),HEAP(HPNHP2),
     1           HEAP(HPNWGH),HEAP(HPNVIO),
     1           HEAP(HPNNSP),HEAP(HPNCV), HEAP(HPNPID))
C     
         ELSE
C     
C     set up calibraion matrix
C     now do following: go through DREFER and VREFER table.
C     if DREFER=0 get DREFER from structures (hpnmat)
C     if VREFER=0 get VREFER from input average (hpnvol,hpnmat)
C     if auto VREFER and DREFER are 0
C     
            CALL CHPR(HEAP(HPCDIS),HEAP(HPCVOL),HEAP(HPNDIS))
            CALL CALFIL(CALMOD,ERRMOD,HEAP(HPNHGL),CALPTR,
     4           HEAP(HPNMAT),DIAGON,
     $           HEAP(HPCDIS),HEAP(HPCVOL),
     1           HEAP(HPNORR),HEAP(HPNIPR),HEAP(HPNILS),HEAP(HPNJPR),
     1           HEAP(HPNJLS),HEAP(HPNCND),HEAP(HPNRAV),HEAP(HPNRRV),
     1           HEAP(HPNDIS),HEAP(HPNLOW),HEAP(HPNHIG),HEAP(HPNVOL),
     1           HEAP(HPNPP1),HEAP(HPNPP2),HEAP(HPNHP1),HEAP(HPNHP2),
     1           HEAP(HPNWGH),HEAP(HPNVIO),
     1           HEAP(HPNNSP),HEAP(HPNCV), HEAP(HPNPID),HEAP(HPNEXC))
C     
            CALL CHPR(HEAP(HPCDIS),HEAP(HPCVOL),HEAP(HPNDIS))
            WRITE (6,'(A,I5)')
     $           ' CAILBR: Number of calibration groups: ',
     &           CALCNT
            WRITE (6,'(A)') ' CAILBR: reference distances '
            DO I=1,CALCNT
               WRITE (6,'(10E12.3)')
     &              (MAX(RSMALL,DREFER(I,J))**(-ONE/CALEXP),
     $              J=1,CALCNT)
            END DO
            WRITE (6,'(A)') ' CAILBR: reference volumes '
            DO I=1,CALCNT
               WRITE (6,'(10E12.3)') (VREFER(I,J), J=1,CALCNT)
            END DO
            WRITE (6,'(A)') ' CAILBR: calibration factors c=d^-6/v '
            DO I=1,CALCNT
               WRITE (6,'(10E12.3)')
     &              (DREFER(I,J)/MAX(RSMALL,VREFER(I,J)), J=1,CALCNT)
            END DO
            WRITE (6,'(A)')
     $           ' CAILBR: isotropic calibration factors c=d^-6/v '
            DO I=1,CALCNT
               WRITE (6,'(10E12.3)') (CALFAC(I,J), J=1,CALCNT)
            END DO
C     
         END IF
      END IF
C     
      RETURN
      END
C     
C=====================================================================
C     
      SUBROUTINE CALFIL(MODE,ERRMOD,NOEHGL,CALPTR,NOEMAT,HSQC,
     $     NOECDI,NOECVO,
     1     NOEORR,NOEIPR,NOEILS,NOEJPR,NOEJLS,NOECND,
     1     NOERAV,NOERRV,NOEDIS,NOELOW,NOEHIG,NOEVOL,
     1     NOEPP1,NOEPP2,NOEHP1,NOEHP2,NOEWGH,NOEVIO,
     1     NOESTP,NOECV,NOEPID,NOEXCL)
C     
      IMPLICIT NONE
C     I/O
      INCLUDE 'cns.inc'
      INCLUDE 'aria.inc'
      INCLUDE 'noe.inc'
      INCLUDE 'coord.inc'
      INCLUDE 'consta.inc'
      INCLUDE 'comand.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'numbers.inc'
C     
      CHARACTER*4 MODE,ERRMOD
      INTEGER NOEHGL(*), CALPTR(*)
      DOUBLE PRECISION NOEMAT(*),HSQC(*)

C     
C     global NOE arrays on HEAP
C     restraint and atom pointers
      INTEGER NOEORR(*),NOEIPR(*),NOEILS(*),NOEJPR(*),NOEJLS(*)
C     classes
      INTEGER NOECND(*)
C     averages
      DOUBLE PRECISION NOECDI(*),NOECVO(*)
      DOUBLE PRECISION NOERAV(*),NOERRV(*)
C     target distance and errors
      DOUBLE PRECISION NOEDIS(*),NOELOW(*),NOEHIG(*)
C     chemical shifts
      DOUBLE PRECISION NOEPP1(*),NOEPP2(*),NOEHP1(*),NOEHP2(*)
C     volume, weights
      DOUBLE PRECISION NOEVOL(*),NOEWGH(*)
C     number of violations
      INTEGER NOEVIO(*)
C     time average pointer, test set, restraint number
      INTEGER NOESTP(*), NOECV(*), NOEPID(*), NOEXCL(*)
C     local
      DOUBLE PRECISION SQERR, SUMDIS, SQERRM, SUMDISM
      INTEGER I, J, N, L, NSTART, NSTOP, II, JJ
      INTEGER CALNUM, CALNUMM
      INTEGER IAT, JAT, NMAT, IGRP, JGRP, NORR
      DOUBLE PRECISION RN, RNT, NISO, WEIGHT,RN6, DIFFER
      DOUBLE PRECISION CALISO(MAXCAL)
      LOGICAL QFILL, QDIST
C     functions
      LOGICAL FRSTEL
      EXTERNAL FRSTEL
C     
C     begin
C     
      NSTART=1
      NSTOP=NOENUM
C     
C     check which elements of drefer and vrefer are not defined.
C     initialize dcount and vcount to -1 if defined, 0 otherwise.
      QFILL=.FALSE.
      DO I=1,CALCNT
         DO J=1,CALCNT
            IF (DREFER(I,J).LT.RSMALL) THEN
               DCOUNT(I,J)=0
               WRITE(6,'(A,I3,I3,A)')
     &              ' CALIBR: reference distance for ', I,J,
     &              ' set to average '
               QFILL=.TRUE.
            ELSE
               DCOUNT(I,J)=-1
               WRITE(6,'(A,I3,I3,A,E12.3)')
     &              ' CALIBR: reference distance for ', I,J,
     &              ' set to ', DREFER(I,J)
            END IF


            IF (VREFER(I,J).LT.RSMALL) THEN
               VCOUNT(I,J)=0
               WRITE(6,'(A,I3,I3,A)')
     &              ' CALIBR: reference volume for ', I,J,
     &              ' set to average '
               QFILL=.TRUE.
            ELSE
               VCOUNT(I,J)=-1
               WRITE(6,'(A,I3,I3,A,E12.3)')
     &              ' CALIBR: reference volume for ', I,J, ' set to
     &              ', VREFER(I,J)
            END IF
         END DO
      END DO
C     
      NMAT=0
      CALNUM=0
      DO N=NSTART,NSTOP
C     loop over all pairs of atoms belonging to restraint N
C     get r-6 summed distance
         L=0
         RN=ZERO
         DO NORR=NOEORR(N)+1,NOEORR(N+1)
            DO II=NOEIPR(NORR)+1,NOEIPR(NORR+1)
               IAT=NOEILS(II)
               IF (FRSTEL(IAT,NOEHGL)) THEN
                  DO JJ=NOEJPR(NORR)+1,NOEJPR(NORR+1)
                     JAT=NOEJLS(JJ)
                     IF (FRSTEL(JAT,NOEHGL)) THEN
                        L=L+1
C     noemat contains r-6 distances or calculated intensities
                        RN=RN+NOEMAT(NMAT+L)
                     END IF
                  END DO
               END IF
            END DO
         END DO
C     
         RNT=RN
         RN6=RNT**(-SIXTH)
         NOERAV(N)=RN6
C     
         IF ((NOEXCL(N).EQ.0)) THEN
            WRITE(6,'(A,I5,A)') ' NOECAL: excluded peak ',
     $           NOEPID(N), ' not used'
         ELSE
            CALNUM=CALNUM+1
C     
C     now calculate average distances and volumes for each
C     element in vrefer and drefer that is not defined.
C     the volumes of an ambiguous peak are scaled by the
C     distances. r-6 sum distance is temporarily stored in
C     noerrv.
            L=0
            DO NORR=NOEORR(N)+1,NOEORR(N+1)
               DO II=NOEIPR(NORR)+1,NOEIPR(NORR+1)
                  IAT=NOEILS(II)
                  IF (FRSTEL(IAT,NOEHGL)) THEN
                     DO JJ=NOEJPR(NORR)+1,NOEJPR(NORR+1)
                        JAT=NOEJLS(JJ)
                        IF (FRSTEL(JAT,NOEHGL)) THEN
                           L=L+1
                           RN=(NOEMAT(NMAT+L))
C     WRITE(6,'(A,E15.5)') ' CALFIL: average volume:' , RN
                           IGRP=CALPTR(IAT)
                           JGRP=CALPTR(JAT)
C     
C     test if the distance is smaller than the overall cutoff
C     
                           IF ((RN.GT.CALDIS**(-SIX))
     &                          .AND.((NOEVOL(N).GT.RSMALL)
     &                          .OR.(VCOUNT(IGRP,JGRP).LT.0))
     &                          .AND.(DCOUNT(IGRP,JGRP).GE.0)) THEN
                              DREFER(IGRP,JGRP)
     $                             =DREFER(IGRP,JGRP)+RN
                              DCOUNT(IGRP,JGRP)=
     $                             DCOUNT(IGRP,JGRP)+RN/RNT
                              DREFER(JGRP,IGRP)
     $                             =DREFER(IGRP,JGRP)
                              DCOUNT(JGRP,IGRP)
     $                             =DCOUNT(IGRP,JGRP)
                           END IF
C     
C     volumes are accumulated if either the distance criterion is
C     satisfied, or if the reference distance is set explicitely.
C     The reference volume is scaled by the ratio of the -sixth
C     powers of the r6summed distance for an ambiguous peak, and
C     the individual distance.
                           IF ((VCOUNT(IGRP,JGRP).GE.0)
     $                          .AND.(NOEVOL(N).GT.RSMALL)
     &                          .AND.((RN.GT.CALDIS**(-SIX))
     &                          .OR.(DCOUNT(IGRP,JGRP).LT.0)))
     $                          THEN
                              VREFER(IGRP,JGRP)
     $                             =VREFER(IGRP,JGRP)
     &                             +RN/RNT*NOEVOL(N)
                              VCOUNT(IGRP,JGRP)
     $                             =VCOUNT(IGRP,JGRP)+RN/RNT
                              VREFER(JGRP,IGRP)
     $                             =VREFER(IGRP,JGRP)
                              VCOUNT(JGRP,IGRP)
     $                             =VCOUNT(IGRP,JGRP)
                           END IF
                        END IF
                     END DO
                  END IF
               END DO
            END DO
         END IF
         NMAT=NMAT+L
      END DO
      WRITE(6,'(A,I6,A)')
     &     ' NOECAL: ',CALNUM, ' distances calibrated'
C     
      DO I=1,CALCNT
         DO J=1,CALCNT
            DREFER(I,J)=(DREFER(I,J)/(MAX(ONE,DCOUNT(I,J))))
            VREFER(I,J)=(VREFER(I,J)/(MAX(ONE,VCOUNT(I,J))))
            WRITE (6,'(2F15.5)') DCOUNT(I,J), VCOUNT(I,J)
            IF (VREFER(I,J).GT.RSMALL) THEN
               CALFAC(I,J)=DREFER(I,J)/VREFER(I,J)
            ELSE
               CALFAC(I,J)=ZERO
            END IF
         END DO
      END DO
C     
C     now make the calibration factors "isotropic", i.e.
C     C_ab^2 = C_aa.C_bb
C     for that, we search for fixed values in each row of the matrix
C     i.e. vcount and dcount < 0.
C     if we find some, we average over the fixed ones only.
C     if we find none, we average over the whole row.

      IF ((MODE.EQ.'ISOT').AND.(CALCNT.GT.1)) THEN
         CALL CLISOT(CALISO)
C     
C     now we have to re-define the calibration factors.
         DO I=1,CALCNT
            DO J=1,CALCNT
               CALFAC(I,J)=SQRT(CALISO(I)*CALISO(J))
            END DO
         END DO     
      END IF

C     start over again and apply calibration factors and
c     calculate mean error
      CALNUM=0
      SQERR=ZERO
      SUMDIS=ZERO
      CALNUMM=0
      SQERRM=ZERO
      SUMDISM=ZERO
      NMAT=0
      DO N=NSTART,NSTOP
C     
C     apply calibration factor
         RN6=NOERAV(N)
         RNT=RN6**(-SIX)
         NOERRV(N)=ZERO
         L=0
         DO NORR=NOEORR(N)+1,NOEORR(N+1)
            DO II=NOEIPR(NORR)+1,NOEIPR(NORR+1)
               IAT=NOEILS(II)
               IF (FRSTEL(IAT,NOEHGL)) THEN
                  IGRP=CALPTR(IAT)
                  DO JJ=NOEJPR(NORR)+1,NOEJPR(NORR+1)
                     JAT=NOEJLS(JJ)
                     IF (FRSTEL(JAT,NOEHGL)) THEN
                        JGRP=CALPTR(JAT)
                        L=L+1
C     noemat contains r-6 distances
                        RN=NOEMAT(NMAT+L)
                        IF (NOEVOL(N).GT.RSMALL) THEN
                           NOERRV(N)=NOERRV(N)+(RN/RNT)
     &                          *CALFAC(IGRP,JGRP)*NOEVOL(N)
                        END IF
                     END IF
                  END DO
               END IF
            END DO
         END DO
C     
C     get the spin diffusion corrected distance into NOEDIS
C     and the uncorrected distance into NOEHIG and NOELOW
C     do not touch negative volumes 
C     we also need to take care of the case that NOERRV=ZERO
C     which means that there was a definite assignment to a
C     non-"first" atom of an equivalent group.
         IF (NOEVOL(N).GT.RSMALL.AND.NOERRV(N).GT.RSMALL) THEN
            NOEDIS(N)=
     $           (NOECDI(N)/NOECVO(N)*NOERRV(N))**(-ONE/CALEXP)
            IF (NOEXCL(N).NE.0) THEN
               DIFFER=NOEDIS(N)-NOECDI(N)**(-ONE/CALEXP)
               IF (DIFFER.LT.ZERO) THEN
                  SQERR=SQERR+(DIFFER/NOEDIS(N))**2
                  SUMDIS=SUMDIS+NOEDIS(N)**2
                  CALNUM=CALNUM+1
               ELSE
                  SQERRM=SQERRM+(DIFFER/NOEDIS(N))**2
                  SUMDISM=SUMDISM+NOEDIS(N)**2
                  CALNUMM=CALNUMM+1
               END IF
            END IF
         END IF
         NMAT=NMAT+L
      END DO
C     
      SQERR=SQRT(MAX(RSMALL,SQERR/MAX(CALNUM+ZERO,ONE)))
      WRITE(6,'(A,e15.5)')
     &     ' NOECAL: higher relative rms error: ', SQERR
      SQERRM=SQRT(MAX(RSMALL,SQERRM/MAX(CALNUMM+ZERO,ONE)))
      WRITE(6,'(A,e15.5)')
     &     ' NOECAL: lower relative rms error: ', SQERRM
C
C     set error estimates either to rms error, distance or volume
         DO N=NSTART,NSTOP
            NOELOW(N)=NOEDIS(N)
            NOEHIG(N)=NOEDIS(N)
         END DO
      IF (ERRMOD.EQ.'ERRO') THEN
         DO N=NSTART,NSTOP
            IF (NOEVOL(N).GT.RSMALL) NOELOW(N)=NOEDIS(N)*SQERRM
            IF (NOEVOL(N).GT.RSMALL) NOEHIG(N)=NOEDIS(N)*SQERR
         END DO
      ELSE IF (ERRMOD.EQ.'DIST') THEN
         DO N=NSTART,NSTOP
            IF (NOEVOL(N).GT.RSMALL) NOEHIG(N)=NOEDIS(N)
            IF (NOEVOL(N).GT.RSMALL) NOELOW(N)=NOEDIS(N)
         END DO
      ELSE IF (ERRMOD.EQ.'VOLU') THEN
         DO N=NSTART,NSTOP
            IF (NOEVOL(N).GT.RSMALL) NOEHIG(N)=NOERRV(N)**(-ONE/CALEXP)
            IF (NOEVOL(N).GT.RSMALL) NOELOW(N)=NOERRV(N)**(-ONE/CALEXP)
         END DO
      ELSE
         WRITE (6,'(A,A)') ' CALFIL: unknown error mode ',  ERRMOD
      END IF     
C     
      RETURN
      END
C     
C=====================================================================
C     
      SUBROUTINE CHKSEL
     &     (ISLCT,NISLCT,NATOM,CALPTR,CALCNT,ICAL,MAXCAL,QMATCH)
C     
C     
C     Author: Michael Nilges, EMBL, 1994.
C     
      IMPLICIT NONE
C     
C     input/ output
C     ISLCT:           flags for selected atoms
C     NISLCT:          number of selected atoms
C     CALPTR:          pointers to correlation time group
C     CALCNT:          lookup table for correlation times
      INTEGER ISLCT(*),NISLCT,NATOM,CALPTR(*),CALCNT,ICAL,MAXCAL
      LOGICAL QMATCH
C     
C     local
C     ICNT,IATOM:      loop variables (group number,atom number)
      INTEGER ICNT,IATOM,I
      LOGICAL QOVERL,QIDENT,QDISJU
C     functions
      LOGICAL FRSTEL
      EXTERNAL FRSTEL
C     
C     begin
C     
C     check if the groups just defined are disjunct with or
c     identical to
C     any existing groups
C     
      IF (NISLCT.GT.0) THEN
C
      QOVERL=.FALSE.
      QMATCH=.FALSE.
      DO ICNT=1,CALCNT
         QIDENT=.FALSE.
         QDISJU=.FALSE.
         DO IATOM=1,NATOM
            QIDENT=(QIDENT.OR.
     &           ((ISLCT(IATOM).EQ.1).AND.(CALPTR(IATOM).EQ.ICNT)))
            QDISJU=(QDISJU.OR.
     &           ((ISLCT(IATOM).EQ.1).AND.(CALPTR(IATOM).NE.ICNT)))
            QMATCH=(QMATCH.OR.QIDENT)
            QOVERL=(QOVERL.OR.(QIDENT.AND.QDISJU))
            IF (QIDENT) THEN
               ICAL=ICNT
            END IF
         END DO
      END DO
      IF (QOVERL) THEN
         CALL WRNDIE(-1,'CHKSEL',
     &        'groups have to be disjunct or identical')
      ELSE IF (.NOT.QMATCH) THEN
         IF (CALCNT+1.GT.MAXCAL) THEN
            CALL WRNDIE(-1,'CHKSEL',
     &           'MAXCAL exceeded ==> recompile program.')
         ELSE
            CALCNT=CALCNT+1
            ICAL=CALCNT
C     now fill the CALPTR array with pointers
            DO I=1,NATOM
               IF (ISLCT(I).GT.0) THEN
                  CALPTR(I)=ICAL
               END IF
            END DO
         END IF
      END IF
      ELSE
      ICAL=0
      END IF
      RETURN
      END
C     
C=====================================================================
C     
      SUBROUTINE NOERRS(NOEHGL,NOEMAT,
     1     NOEORR,NOEIPR,NOEILS,NOEJPR,NOEJLS,NOECND,
     1     NOERAV,NOERRV,NOEDIS,NOELOW,NOEHIG,NOEVOL,
     1     NOEPP1,NOEPP2,NOEHP1,NOEHP2,NOEWGH,NOEVIO,
     1     NOESTP,NOECV,NOEPID,NOEXCL)
C     
C     estimates error from actual fit of distances to structure
C     author Michael Nilges
C     
      IMPLICIT NONE
C     I/O
      INCLUDE 'cns.inc'
      INCLUDE 'aria.inc'
      INCLUDE 'noe.inc'
      INCLUDE 'coord.inc'
      INCLUDE 'consta.inc'
      INCLUDE 'comand.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'numbers.inc'
C     
      INTEGER NOEHGL(*)
      DOUBLE PRECISION NOEMAT(*)
C     global NOE arrays on HEAP
C     restraint and atom pointers
      INTEGER NOEORR(*),NOEIPR(*),NOEILS(*),NOEJPR(*),NOEJLS(*)
C     classes
      INTEGER NOECND(*)
C     averages
      DOUBLE PRECISION NOERAV(*),NOERRV(*)
C     target distance and errors
      DOUBLE PRECISION NOEDIS(*),NOELOW(*),NOEHIG(*)
C     chemical shifts
      DOUBLE PRECISION NOEPP1(*),NOEPP2(*),NOEHP1(*),NOEHP2(*)
C     volume, weights
      DOUBLE PRECISION NOEVOL(*),NOEWGH(*)
C     number of violations
      INTEGER NOEVIO(*)
C     time average pointer, test set, restraint number
      INTEGER NOESTP(*), NOECV(*), NOEPID(*), NOEXCL(*)
C     local
      DOUBLE PRECISION SQERR, SUMDIS, SQERRM, SUMDISM
      INTEGER N, L, NSTART, NSTOP, II, JJ
      INTEGER CALNUM, CALNUMM
      INTEGER IAT, JAT, NMAT, NORR
      DOUBLE PRECISION RN, RNT
C     functions
      LOGICAL FRSTEL
      EXTERNAL FRSTEL
C     
C     begin
C     
      NSTART=1
      NSTOP=NOENUM
      NMAT=0
      CALNUM=0
      CALNUMM=0
      SQERRM=ZERO
      SQERR=ZERO
      SUMDIS=ZERO
      SUMDISM=ZERO
C     
      DO N=NSTART,NSTOP
C     loop over all pairs of atoms belonging to restraint N
C     get r-6 summed distance
         L=0
         RN=ZERO
         DO NORR=NOEORR(N)+1,NOEORR(N+1)
            DO II=NOEIPR(NORR)+1,NOEIPR(NORR+1)
               IAT=NOEILS(II)
               IF (FRSTEL(IAT,NOEHGL)) THEN
                  DO JJ=NOEJPR(NORR)+1,NOEJPR(NORR+1)
                     JAT=NOEJLS(JJ)
                     IF (FRSTEL(JAT,NOEHGL)) THEN
                        L=L+1
C     noemat contains r-6 distances
                        RN=RN+NOEMAT(NMAT+L)
                     END IF
                  END DO
               END IF
            END DO
         END DO
         RNT=RN
         NOERAV(N)=RNT**(-SIXTH)
         IF (NOEXCL(N).NE.0) THEN
            IF (NOEDIS(N).LT.NOERAV(N)) THEN
               SQERR=SQERR+((NOEDIS(N)-NOERAV(N))/NOEDIS(N))**2
               SUMDIS=SUMDIS+NOEDIS(N)**2
               CALNUM=CALNUM+1
            ELSE
               SQERRM=SQERRM+(NOEDIS(N)-NOERAV(N))**2
               SUMDISM=SUMDISM+NOEDIS(N)**2
               CALNUMM=CALNUMM+1
            END IF
         END IF
      NMAT=NMAT+L
      END DO
C     
      SQERR=SQRT(MAX(RSMALL,SQERR/SUMDIS))
      WRITE(6,'(A,e15.5)')
     &     'NOECAL: lower rms error: ', SQERR
      SQERRM=SQERR
      SQERRM=SQRT(MAX(RSMALL,SQERRM/MAX(SUMDISM,RSMALL)))
      WRITE(6,'(A,e15.5)')
     &     'NOECAL: higher rms error: ', SQERRM
C     set error estimates to distance times mean error
      DO N=NSTART,NSTOP
         NOELOW(N)=NOEDIS(N)*NOEDIS(N)*SQERRM
         NOEHIG(N)=NOEDIS(N)*NOEDIS(N)*SQERR
      END DO
C     
      RETURN
      END
C     
C=====================================================================
C     
      SUBROUTINE CALLIN(MODE,
     &     NOEHGL,CALPTR,NOEMAT,DIAGON,
     1     NOEORR,NOEIPR,NOEILS,NOEJPR,NOEJLS,NOECND,
     1     NOERAV,NOERRV,NOEDIS,NOELOW,NOEHIG,NOEVOL,
     1     NOEPP1,NOEPP2,NOEHP1,NOEHP2,NOEWGH,NOEVIO,
     1     NOESTP,NOECV,NOEPID,NOEXCL)
C     
      IMPLICIT NONE
C     I/O
      INCLUDE 'cns.inc'
      INCLUDE 'noe.inc'
      INCLUDE 'aria.inc'
C     INCLUDE 'coord.inc'
      INCLUDE 'consta.inc'
      INCLUDE 'comand.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'numbers.inc'
C     
      CHARACTER*4 MODE
      INTEGER NOEHGL(*), CALPTR(*)
      DOUBLE PRECISION DIAGON(*), NOEMAT(*)
C     
C     global NOE arrays on HEAP
C     restraint and atom pointers
      INTEGER NOEORR(*),NOEIPR(*),NOEILS(*),NOEJPR(*),NOEJLS(*)
C     classes
      INTEGER NOECND(*)
C     averages
      DOUBLE PRECISION NOERAV(*),NOERRV(*)
C     target distance and errors
      DOUBLE PRECISION NOEDIS(*),NOELOW(*),NOEHIG(*)
C     chemical shifts
      DOUBLE PRECISION NOEPP1(*),NOEPP2(*),NOEHP1(*),NOEHP2(*)
C     volume, weights
      DOUBLE PRECISION NOEVOL(*),NOEWGH(*)
C     number of violations
      INTEGER NOEVIO(*)
C     time average pointer, test set, restraint number
      INTEGER NOESTP(*), NOECV(*), NOEPID(*), NOEXCL(*)
C     local
      DOUBLE PRECISION SUMVOL, SUMDIS
      INTEGER N, L, NSTART, NSTOP, II, JJ
      INTEGER CALNUM
      INTEGER IAT, JAT, NMAT, NORR
      DOUBLE PRECISION RN, RNT, RN6
      DOUBLE PRECISION ACOEFF, BCOEFF, AERR, BERR, CHI2
C     functions
      LOGICAL FRSTEL
      EXTERNAL FRSTEL
C     
C     begin
C     
      NSTART=1
      NSTOP=NOENUM
C     
      NMAT=0
      CALNUM=0
      SUMDIS=ZERO
      SUMVOL=ZERO
      DO N=NSTART,NSTOP
C     loop over all pairs of atoms belonging to restraint N
C     get r-6 summed distance
         L=0
         RN=ZERO
         DO NORR=NOEORR(N)+1,NOEORR(N+1)
            DO II=NOEIPR(NORR)+1,NOEIPR(NORR+1)
               IAT=NOEILS(II)
               IF (FRSTEL(IAT,NOEHGL)) THEN
                  DO JJ=NOEJPR(NORR)+1,NOEJPR(NORR+1)
                     JAT=NOEJLS(JJ)
                     IF (FRSTEL(JAT,NOEHGL)) THEN
                        L=L+1
C     noemat contains r-6 distances
                        RN=RN+NOEMAT(NMAT+L)
                     END IF
C     
                  END DO
               END IF
C     
            END DO
         END DO
C     
         RNT=RN
         RN6=RNT**(-SIXTH)
         NOERAV(N)=RN6
         IF (NOEVOL(N).LE.RSMALL) THEN
            NOERAV(N)=ZERO
         ELSEIF ((NOEXCL(N).EQ.0)) THEN
            CALNUM=CALNUM+1
            NOERAV(N)=RNT
            SUMDIS=SUMDIS+NOERAV(N)
            SUMVOL=SUMVOL+NOEVOL(N)
         ELSE 
            NOERAV(N)=ZERO
         END IF
C     
         NMAT=NMAT+L
      END DO
C     
      WRITE(6,'(A,I6,A)')
     &     ' CALIBR: ',CALNUM, ' distances calibrated'
      WRITE(6,'(A,E15.5)')
     &     ' CALIBR: average calibration factor: ', SUMDIS/CALNUM
      WRITE(6,'(A,E15.5)')
     &     ' CALIBR: average volume: ', SUMVOL/CALNUM
C     
      CALL LINFIT(0,NOENUM,NOEVOL,NOERAV,NOEXCL,
     &     ACOEFF,BCOEFF,AERR,BERR,CHI2)
      WRITE (6,'(A,E15.5,A,E15.5,A)')
     &     ' CALIBR: calibration factors: ', ACOEFF,
     &     ' + ', BCOEFF, ' * Volume.'
      WRITE (6,'(A,E15.5,E15.5,A,E15.5)')
     &     ' CALIBR: errors: ', AERR, BERR, ' Chi2 ', CHI2
C     
C     start over again to apply calibration factors
      DO N=NSTART,NSTOP
         NOEDIS(N)=(ACOEFF+BCOEFF*NOEVOL(N))*NOEVOL(N)
         NOEDIS(N)=NOEDIS(N)**(-SIXTH)
      END DO
C     
      RETURN
      END
C
C=====================================================================
C
      SUBROUTINE LINFIT(S,N,ABSZ,ORDI,FLAGS,
     &                  ACOEFF,BCOEFF,AERR,BERR,CHI2)
C
C linear regression from numerical recipies
C
      IMPLICIT NONE
C
      INCLUDE 'numbers.inc'
C
      INTEGER S,N,FLAGS(N)
      DOUBLE PRECISION ABSZ(N),ORDI(N),ACOEFF,BCOEFF,AERR,BERR,CHI2
      DOUBLE PRECISION SABSZ,SABSZW,SORDI,ST2,T,SWEIGHT
      INTEGER I
      SABSZ=ZERO
      SORDI=ZERO
      ST2=ZERO
      BCOEFF=ZERO
      SWEIGHT=ZERO
      DO I=1,N
         IF ((FLAGS(I).NE.0).AND.(S*ORDI(I).GE.ZERO)) THEN
            SWEIGHT=SWEIGHT+ONE
            SABSZ=SABSZ+ABSZ(I)
            SORDI=SORDI+ORDI(I)
         END IF
      END DO
      SABSZW=SABSZ/SWEIGHT
      DO I=1,N
         IF ((FLAGS(I).NE.0).AND.(S*ORDI(I).GE.ZERO)) THEN
            T=ABSZ(I)-SABSZW
            ST2=ST2+T*T
            BCOEFF=BCOEFF+T*ORDI(I)
         END IF
      END DO
      BCOEFF=BCOEFF/ST2
      ACOEFF=(SORDI-BCOEFF*SABSZ)/SWEIGHT
      AERR=SQRT(((ONE+SABSZ*SABSZ)/(SWEIGHT*ST2))/SWEIGHT)
      BERR=SQRT(ONE/ST2)
      CHI2=ZERO
      DO I=1,N
         IF ((FLAGS(I).NE.0).AND.(S*ORDI(I).GE.ZERO)) THEN
            CHI2=CHI2+(ORDI(I)-ACOEFF-BCOEFF*ABSZ(I))**2
         END IF
      END DO
      AERR=AERR*SQRT(CHI2/(SWEIGHT-TWO))
      BERR=BERR*SQRT(CHI2/(SWEIGHT-TWO))
      RETURN
      END
C
C=====================================================================
C
      SUBROUTINE CLISOT(CALISO)
C     
C     Calculates from a matrix of calibration factors a reduced
C     set that satisfies the assumptions CIJ = sqrt(CI CJ)
C     
C     Author: Michael Nilges
C     
      IMPLICIT NONE
C     I/O 
C     
      INCLUDE 'cns.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'heap.inc'
      INCLUDE 'numbers.inc'
      INCLUDE 'aria.inc'
C      INCLUDE 'noe.inc'
      INCLUDE 'consta.inc'
      DOUBLE PRECISION CALISO(MAXCAL),MCALISO(MAXCAL)
C     local
      DOUBLE PRECISION TARGET, MAXIM, WEIGHT, TOTW
      INTEGER I, J, IER, K
C     
C     begin
C     
C     store current parameters
C     
      MAXIM=ZERO
      DO I=1,CALCNT
         DO J=1,CALCNT
            MAXIM=MAX(MAXIM,CALFAC(I,J))
         END DO
      END DO   
      DO I=1,CALCNT
         DO J=1,CALCNT
            CALFAC(I,J)=CALFAC(I,J)/MAXIM
         END DO
      END DO   

      DO I=1,CALCNT
         CALISO(I)=ZERO
         MCALISO(I)=ONE
      END DO   
      DO K=1,20
         DO I=1,CALCNT
            CALISO(I)=ZERO
            TOTW=ZERO
            DO J=1,CALCNT
               WEIGHT= SQRT(MAX(DCOUNT(I,J),VCOUNT(I,J)))
               CALISO(I)=CALISO(I)+WEIGHT*CALFAC(I,J)**2
     $              /MCALISO(J)
               TOTW=TOTW+WEIGHT
            END DO
            IF (TOTW.LE.ZERO) THEN
               CALISO(I)=ZERO
            ELSE
               CALISO(I)=CALISO(I)/TOTW
            END IF
            WRITE(6, '(I5, E11.3)') K, CALISO(I)
            MCALISO(I)=CALISO(I)
         END DO
      END DO
C
      DO I=1,CALCNT
         CALISO(I)=CALISO(I)*MAXIM
      END DO   
C     
C     
      RETURN
      END

C======================================================================
      SUBROUTINE PRINT
C
C parse PRINT qualifiers
      IMPLICIT NONE
C I/O
      INCLUDE 'cns.inc'
      INCLUDE 'comand.inc'
      INCLUDE 'coord.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'heap.inc'
      INCLUDE 'noe.inc'
C local
      CHARACTER*4 SOBJ
      DOUBLE PRECISION THRESH
C begin
      CALL NEXTA4('PRINT-object=',SOBJ)
      IF (SOBJ.EQ.'THRE') THEN
      CALL NEXTF('THREshold=',THRESH)
      CALL NEXTA4('PRINT-object=',SOBJ)
      ELSE
      THRESH=-0.0001D0
      END IF
C
      IF (SOBJ.EQ.'HELP') THEN
C
      CALL CNSHELP('cns-print')
C
      ELSE IF (SOBJ.EQ.'BOND') THEN
      CALL PRPICK('BOND',THRESH)
      ELSE IF (SOBJ.EQ.'ANGL') THEN
      CALL PRPICK('ANGL',THRESH)
      ELSE IF (SOBJ.EQ.'DIHE') THEN
      CALL PRPICK('DIHE',THRESH)
      ELSE IF (SOBJ.EQ.'IMPR') THEN
      CALL PRPICK('IMPR',THRESH)
      ELSE IF (SOBJ.EQ.'NOE ') THEN
      CALL NOEPRI(THRESH,0,.TRUE.,0)
      IF (NOEICV.GT.0) CALL NOEPRI(THRESH,1,.TRUE.,0)
      ELSE IF (SOBJ.EQ.'CDIH') THEN
      CALL CDIPRI(PUNIT,CNPHI,CNSCA,HEAP(ICIP),HEAP(ICJP),
     &        HEAP(ICKP),HEAP(ICLP),HEAP(ICICP),HEAP(ICCPD),
     &        HEAP(ICCPE),HEAP(ICCPB),HEAP(ICCPC),HEAP(ICCPO),
     &        THRESH,HEAP(HPDCV),0,DIHICV)
      IF (DIHICV.GT.0) THEN
      CALL CDIPRI(PUNIT,CNPHI,CNSCA,HEAP(ICIP),HEAP(ICJP),
     &            HEAP(ICKP),HEAP(ICLP),HEAP(ICICP),HEAP(ICCPD),
     &            HEAP(ICCPE),HEAP(ICCPB),HEAP(ICCPC),HEAP(ICCPO),
     &            THRESH,HEAP(HPDCV),1,DIHICV)
      END IF
      ELSE
      CALL DSPERR('PRINT','unknown value')
      END IF
      RETURN
      END
C======================================================================

      PROGRAM CNS
C
C  Crystallography & NMR System (CNS)
C
C  A program for X-ray crystallographic and solution NMR structure
C  determination.
C
C  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++=+
C  +===============================================================+
C  + Authors: A.T.Brunger, P.D.Adams, G.M.Clore, W.L.DeLano,       +
C  +          P.Gros, R.W.Grosse-Kunstleve, J.-S.Jiang,            +
C  +          J.Kuszewski, M.Nilges, N.S.Pannu, R.J.Read,          +
C  +          L.M.Rice, T.Simonson, G.L.Warren                     +
C  +===============================================================+
C  + Copyright 1997-2007 Yale University                           +
C  +===============================================================+
C  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      IMPLICIT NONE
C
C common (global) variables and constants
      INCLUDE 'cns.inc'
      INCLUDE 'comand.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'param.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'seed.inc'
      INCLUDE 'vector.inc'
      INCLUDE 'timer.inc'
      INCLUDE 'symbol.inc'
      INCLUDE 'update.inc'
      INCLUDE 'version.inc'
C =====
C local
C =====
      INTEGER ICYCLE, I, PROMPTLEN
      LOGICAL QOPEN, QFORM, QWRITE
      DOUBLE PRECISION DUMMY
      DOUBLE COMPLEX CDUMMY
      CHARACTER*12 USERNM
      CHARACTER*14 SYSNM
      CHARACTER*32 HOSTNM
      CHARACTER*11  DATE
      CHARACTER*8  TIME
      CHARACTER*20 PROMPT
C
C =====
C begin
C =====
C
C initialize the file handling facility
      CALL VOPEN(0,'$$INITIAL$$',' ',' ',ERROR)
C
C CHARACTER*4 array CSTACK initialization
      CALL CINIST(.FALSE.)
C
C HEAP initialization and sanity check
      CALL INITHP
      CALL HEAPVFY(ERROR)
      IF (ERROR) THEN
        CALL WRNDIE(-5, 'HEAPVFY', 'FATAL INTERNAL ERROR.')
        CALL DIE
      END IF
      CALL INITHP
C
C initialize command parsing
      CALL INIPRS
      CALL DECLAR( 'CNS_VERSION', 'ST', CNSVERSION, DUMMY, CDUMMY )
      CALL DECLAR( 'CNS_PATCH', 'ST', CNSPATCH, DUMMY, CDUMMY )
C
C initialize machine dependent variables
      CALL SETFPEPS
C
C initialize the interacting group setup
      CALL PIGRSET('INIT')
C
C initialize the nonbonded list
      CALL NBDSET('INIT')
C
C initialize the fast nonbonded setup
      CALL FNBSET('INIT')
C
C initialize the trajectory writing facility
      CALL TRTINI
C
C initialize the parameter learning facility
      CALL PRTINI
C
C torsion angle dynamics
      CALL TORINI
C
C initialize the distance geometry bounds matrix stores
      CALL DGINIT
C=====================================================================
C #if defined(CNS_SOLVE_COMPILE)
C=====================================================================
C initialize ARIA
      CALL ARIINI
C
C initialize j coupling refinement
      CALL COUPINIT
C
C initialize carbon chemical shift stuff
      CALL CSHIFTINIT
C
C initialize the proton chemical shift stuff
      CALL HSHIFTINIT
C
C initialize the 1-bond J coupling stuff
      CALL ONEINIT
C
C initialize the Ramachandran stuff
      CALL RAMAINIT
C
C initialize the angle database stuff
      CALL ANGLEDBINIT
C
C initialize Tensor Anisotropy refinement
C      CALL TENSOINIT
C
C initial susceptibility anisotropy refinement
      CALL VEANINIT
C
C initial susceptibility anisotropy refinement
      CALL SANIINIT
C
C initial diffusion anisotropy refinement
      CALL DANIINIT
C
C rotation search clustering
      CALL CLUSINI
C
C mapyard module
      CALL INIMYCOMMON(.TRUE.)
C
C psearch module
      CALL INIPSTCOMMON(.TRUE.)
C=====================================================================
C #endif
C=====================================================================
C set bond, angle, dihedral, improper type-based parameter update flags
      UPBOND=.TRUE.
      UPANGL=.TRUE.
      UPDIHE=.TRUE.
      UPIMPR=.TRUE.
C
C initialize scalar stores
      DO I=1,MAXSTO
      PTRSTO(I)=0
      LENSTO(I)=0
      END DO
C
C constraints
      CALL CSTRES
C
C dihedral angle restraints
      CALL CDIINI
C
C NOE tables
      CALL NOEINI
C
C XAFS restraints
C      CALL XAFINI
C
C crystallographic restraints
      CALL XRERES
C
C energy term flags and descriptors
      CALL ENEINI
C
C non-crystallographic symmetry operators and counters
      CALL NCSINR
      CALL NCSINS
C
C planarity restraints
      CALL PLNINR
C
C set counter for some ENERGY calls
      ICYCLE=0
C
C RTF
      CALL RTFINI
C
C MTF
      CALL MTFRES
C
C parameters
      CALL PARINI
C
C chebychev poynomials
      CALL CHEINI
C
C message level and program abort level
      WRNLEV=5
      BOMLEV=0
C
C random number generator seed
      SEED=314159.0D0
C
C display and print files are set to system output (default)
      DUNIT=6
      PUNIT=6
C
C journal file unit is set to -1 (switched off)
      PRUNIT=-1
C
C initialize timer
      CALL VINTIM
      TIMER=0
C
C initialize prompt

C=====================================================================
C #if defined(CNS_SOLVE_COMPILE)
C=====================================================================
      PROMPT='CNSsolve>'
C=====================================================================
C #else
C=====================================================================
C      PROMPT='CNSrefine>'
C=====================================================================
C #endif
C=====================================================================
      PROMPTLEN=20
      CALL TRIMM(PROMPT,PROMPTLEN)
C
C write header
      CALL CNSHEADER(DATE,TIME,USERNM,SYSNM,HOSTNM)
C
C Verify FFT: Make sure FFT library actually works
      CALL VFYFFT
C
C Verify numerical code: Make sure a representative routine 
C                        functions correctly
      CALL VFYNUM
C
      WRITE(6,'(1X)')
C
C command parsing
      CALL PUSEND(PROMPT(1:PROMPTLEN))
      DONE=.FALSE.
      DO WHILE (.NOT.DONE)
      CALL NEXTWD(PROMPT(1:PROMPTLEN))
      CALL MISCOM(PROMPT(1:PROMPTLEN),USED)
      IF (.NOT.USED) THEN
C
      IF (WD(1:4).EQ.'HELP') THEN
C
      CALL CNSHELP('cns')
C=====================================================================
C #if defined(CNS_SOLVE_COMPILE)
C=====================================================================
      ELSE IF (WD(1:4).EQ.'ANGL' ) THEN
      CALL READANGLEDB
      ELSE IF (WD(1:4).EQ.'CARB' ) THEN
      CALL READCSHIFT
      ELSE IF ((WD(1:4).EQ.'CONF' ).OR.(WD(1:4).EQ.'RAMA')) THEN
      CALL READRAMA
      ELSE IF (WD(1:4).EQ.'COUP' ) THEN
      CALL READCOUP
      ELSE IF (WD(1:4).EQ.'DANI' ) THEN
      CALL READDANI
      ELSE IF (WD(1:4).EQ.'ONEB' ) THEN
      CALL READONEBOND
C      ELSE IF (WD(1:5).EQ.'TENSO' ) THEN
C      CALL READTENSO
      ELSE IF (WD(1:4).EQ.'SANI' ) THEN
      CALL READSANI
      ELSE IF (WD(1:4).EQ.'VEAN' ) THEN
      CALL READVEAN
      ELSE IF (WD(1:4).EQ.'PROT' ) THEN
      CALL READHSHIFT
      ELSE IF (WD(1:4).EQ.'MIND' ) THEN
      CALL MINDWR
C=====================================================================
C #endif
C=====================================================================
      ELSE IF (WD(1:4).EQ.'ARIA' ) THEN
      CALL ARISET
      ELSE IF (WD(1:4).EQ.'CONN' ) THEN
      CALL CONNEC
      ELSE IF (WD(1:4).EQ.'COOR' ) THEN
      CALL CORMAN
      ELSE IF (WD(1:4).EQ.'DELE' ) THEN
      CALL DELTIC
      ELSE IF (WD(1:4).EQ.'DIST' ) THEN
      CALL DISTAN
      ELSE IF (WD(1:4).EQ.'DO' ) THEN
      CALL SCDO
      ELSE IF (WD(1:4).EQ.'DUPL' ) THEN
      CALL DUPLIC
      ELSE IF (WD(1:4).EQ.'DYNA' ) THEN
      CALL DYNMCS
      ELSE IF (WD(1:4).EQ.'ENER' ) THEN
      CALL PGETE(ICYCLE)
      ELSE IF (WD(1:4).EQ.'FAST' ) THEN
      CALL FNBSET('PARSE')
      ELSE IF (WD(1:3).EQ.'FIX' ) THEN
      CALL FIX
      ELSE IF (WD(1:4).EQ.'FLAG' ) THEN
      CALL EFLAGS('PARSE')
      ELSE IF (WD(1:4).EQ.'IDEN' ) THEN
      CALL SCIDEN
      ELSE IF (WD(1:4).EQ.'IGRO' ) THEN
      CALL PIG
      ELSE IF (WD(1:4).EQ.'MINI' ) THEN
      CALL MINIMI
      ELSE IF (WD(1:4).EQ.'MMDG') THEN
      CALL MMDG
      ELSE IF (WD(1:4).EQ.'MODE') THEN
      CALL MODES
      ELSE IF (WD(1:3).EQ.'NCS') THEN
      CALL NCSPAR
      ELSE IF (WD(1:4).EQ.'NOE ' ) THEN
      CALL NOESET
      ELSE IF (WD(1:4).EQ.'PARA' ) THEN
      CALL PARRDR
      ELSE IF (WD(1:4).EQ.'PATC' ) THEN
      CALL PATSET
      ELSE IF (WD(1:4).EQ.'PICK' ) THEN
      CALL PICK(.FALSE.)
      ELSE IF (WD(1:4).EQ.'PRIN' ) THEN
      CALL PRINT
      ELSE IF (WD(1:4).EQ.'READ' ) THEN
      CALL READD
      ELSE IF (WD(1:4).EQ.'REST' ) THEN
      CALL RSTRAN
      ELSE IF (WD(1:4).EQ.'ROTM' ) THEN
      CALL ROTMAN
      ELSE IF (WD(1:4).EQ.'SEGM' ) THEN
      CALL SEGMNT
      ELSE IF (WD(1:4).EQ.'SHOW' ) THEN
      CALL SCSHOW
      ELSE IF (WD(1:4).EQ.'STRU' ) THEN
      CALL MTFPRS
      ELSE IF (WD(1:4).EQ.'SURF' ) THEN
      CALL SURFAC
      ELSE IF (WD(1:4).EQ.'TEST' ) THEN
      CALL TESTCNS
      ELSE IF (WD(1:4).EQ.'TOPO' ) THEN
      CALL RTFRDR
      ELSE IF (WD(1:4).EQ.'WRIT' ) THEN
      CALL WRITT
C      ELSE IF (WD(1:4).EQ.'XAFS' ) THEN
C      CALL XAFS
      ELSE IF (WD(1:4).EQ.'XRAY' ) THEN
      CALL XRAY
      ELSE IF (WD(1:4).EQ.'?   ' ) THEN
      CALL SHOWAL
      ELSE IF (WD(1:4).EQ.'STOP'.OR.EOF ) THEN
      DONE=.TRUE.
      ENDIND=ENDIND-1
      ELSE
      CALL CHKEND(PROMPT(1:PROMPTLEN),DONE)
      IF (DONE) THEN
      WRITE(6,'(A)')
     &' %CNS-ERR: "END" not allowed. "STOP" terminates program'
      DONE=.FALSE.
      ENDIND=ENDIND+1
      END IF
      END IF
      END IF
      END DO
C
C terminate program
C
C=====================================================================
C #if defined(CNS_SOLVE_COMPILE)
C=====================================================================
C free ARIA lists
      CALL ARIHP(0,0,0)
C free proton chemical shift restraints list
      CALL HSHIFTSHP
C free j-coupling restraints list
      CALL COUPHP
C free carbon chemical shift restraints list
      CALL CARBHP
C free onebond j-coupling restraints list
      CALL ONEHP
C free conf. torsion angle database restraints list
      CALL RAMAHP
C free diffusion anisotropy restraints list
      CALL DANIHP
C free susceptibility anisotropy restraints list
      CALL SANIHP
C free susceptibility anisotropy restraints list
      CALL VEANHP
C free diffusion anisotropy restraints list
C      CALL TENSOHP
C free conf. angle database restraints list
      CALL ANGLEDBFREE
C rotation search clustering
      CALL CLUSFRE
C=====================================================================
C #endif
C=====================================================================
C free dihedral angle restraints list
      CALL CDIHP(0)
C free NOE restraints list
      CALL NOEHP(0)
C free XAFS restraints list
C      CALL XAFHP(0)
C free XRAY atom lists, reflections, and maps
      CALL XRAFRE
      CALL XRAATM(0)
      CALL XRMAPR(-1)
C
C free NCS group lists
      CALL NCSFIN
C
C free PLN group lists
      CALL PLNFIN
C
C free buffer stores
      DO I=1,MAXSTO
      IF (PTRSTO(I).NE.0) CALL FREHP(PTRSTO(I),IREAL8(LENSTO(I)))
      END DO
C
C free nonbonded lists
      DO I=1,NPIGMAX
      CALL RENBND(0,0,0,0,0,0,0,0,0,I)
      ENDDO
C
C free PIG arrays
      CALL PIGRSET('FREE')
C
C free up space for the trajectory writing facility
      CALL TRTFRE
C
C free up space for the parameter learning facility
      CALL PRTFRE
C
C free up torsion angle stuff
      CALL TORHP(0,.TRUE.)
C
C free up space for the distance geometry bounds matrices
      CALL DGRESZ(0)
C
C write info about STACK and HEAP
      CALL PRISTK
      CALL PRINHP
      CALL PRIEND
C
C close all files
      DO I=1,99
      CALL VINQRE('UNIT',WDT,WDTMAX,WDTLEN,QOPEN,QFORM,QWRITE,I)
      IF (QOPEN) CALL VCLOSE(I,'KEEP',ERROR)
      END DO
C
C write info about maximum dynamic memory usage and total CPU time
      CALL PRFINAL
C
      END
C
C======================================================================
C
      SUBROUTINE CNSHEADER(DATE,TIME,USERNM,SYSNM,HOSTNM)
C
      IMPLICIT NONE
C
      INCLUDE 'version.inc'
C I/O
      CHARACTER*11  DATE
      CHARACTER*8  TIME
      CHARACTER*12 USERNM
      CHARACTER*14 SYSNM
      CHARACTER*32 HOSTNM
C local
      INTEGER      HNLEN, TMP, PTRSZ, STLEN
      CHARACTER*(1) CNSPTMP
      CHARACTER*(4) ST
C
C write header
      WRITE(6,'(10X,A)')
     &'============================================================'
      WRITE(6,'(10X,A,58X,A)') '|','|'
      WRITE(6,'(10X,A,12X,A,12X,A)')
     &'|','Crystallography & NMR System (CNS)','|'
C=====================================================================
C #if defined(CNS_SOLVE_COMPILE)
C=====================================================================
      WRITE(6,'(10X,A,25X,A,25X,A)')
     &'|','CNSsolve','|'
C=====================================================================
C #else
C=====================================================================
C      WRITE(6,'(10X,A,24X,A,25X,A)')
C     &'|','CNSrefine','|'
C=====================================================================
C #endif
C=====================================================================
      WRITE(6,'(10X,A,58X,A)') '|','|'
      WRITE(6,'(10X,A)')
     &'============================================================'
      CNSPTMP=CNSPATCH
      IF (CNSPTMP.EQ.'0') THEN
      WRITE(6,'(10X,2A)')
     &' Version: ',CNSVERSION
      ELSE
      WRITE(6,'(10X,4A)')
     &' Version: ',CNSVERSION,' at patch level ',CNSPATCH
      END IF
      WRITE(6,'(10X,A)')
     &' Status: General release with ARIA enhancements'
      WRITE(6,'(10X,A)')
     &'============================================================'
      WRITE(6,'(10X,A,/,10X,A,/,10X,A,/,10X,A)')
     &' Written by: A.T.Brunger, P.D.Adams, G.M.Clore, W.L.DeLano,',
     &'             P.Gros, R.W.Grosse-Kunstleve, J.-S.Jiang,',
     &'             J.Kuszewski, M.Nilges, N.S.Pannu, R.J.Read,',
     &'             L.M.Rice, T.Simonson, G.L.Warren.'
      WRITE(6,'(10X,A)')
     &' Copyright (c) 1997-2007 Yale University'
      WRITE(6,'(10X,A)')
     &'============================================================'
C
      CALL VHOSTNAME(HOSTNM, HNLEN)
      CALL GETSYS(SYSNM,14,TMP)
C
      CALL CNSQPTRSZ(PTRSZ)
      PTRSZ=PTRSZ*8
      STLEN=4
      CALL ENCODI(PTRSZ,ST,4,STLEN)
C
      WRITE(6,'(10X,7A)')
     & ' Running on machine: ',HOSTNM(1:HNLEN),
     & ' (',SYSNM(1:TMP),',',ST(1:STLEN),'-bit)'
C
      CALL GETNAM(USERNM,12,TMP)
      WRITE(6,'(10X,2A)')
     & ' Program started by: ',USERNM(1:TMP)
C
      CALL VTIME(TIME,8,TMP)
      CALL VDATE(DATE,11,TMP)
      WRITE(6,'(10X,4A)')
     & ' Program started at: ',TIME,' on ',DATE(1:TMP)
C
      WRITE(6,'(10X,A)')
     &'============================================================'
C
      WRITE(6,'(1X)')
C
      RETURN
      END
C
C======================================================================
C
